//var componentUtil = {};
/*
 ** Removes properties from the default Values conditionally
 *  Author: Srikkanth
 */
function componentUtil() {
  this.updateDefaultValues = function (defaultValue, component) {
      var that = component;
      //Tooltip
      var excludeXAxisInterval = ["radar","polar","columnBar"];
      if (!_.isUndefined(that.tooltipbackgroundcolor) && (that.tooltipbackgroundcolor() === '' || that.tooltipbackgroundcolor() == 'null')) {
          delete defaultValue.tooltip.backgroundColor;
      }

      if (!_.isUndefined(that.tooltipbordercolor) && (that.tooltipbordercolor() === '' || that.tooltipbordercolor() == 'null')) {
          delete defaultValue.tooltip.borderColor;
      }
      //Zoom Selection
      if (!_.isUndefined(that.zoomselectionareabackgroundcolor) && (that.zoomselectionareabackgroundcolor() === '' || that.zoomselectionareabackgroundcolor() == 'null')) {
          delete defaultValue.chart.selectionMarkerFill;
      }
      //Legend Floating
      if (!_.isUndefined(that.legendfloating) && (that.legendfloating() === false || that.legendfloating() == 'false')) {
          if (defaultValue.legend && defaultValue.legend.x) {
              delete defaultValue.legend.x;
          }
          if (defaultValue.legend && defaultValue.legend.y) {
              delete defaultValue.legend.y;
          }
      }
      //Legend Item Width
      if (!_.isUndefined(that.legenditemwidth) && (that.legenditemwidth() === '' || that.legenditemwidth() == 'null' || that.legenditemwidth() === 0)) {
          if (defaultValue.legend) {
              delete defaultValue.legend.itemWidth;
          }

      }
      //Legend Width
      if (!_.isUndefined(that.legendboxwidth) && (that.legendboxwidth() === '' || that.legendboxwidth() == 'null' || that.legendboxwidth() === 0)) {
          if (defaultValue.legend) {
              delete defaultValue.legend.width;
          }

      }
      // Title Floating
      if (!_.isUndefined(that.titlefloating) && (that.titlefloating() === false || that.titlefloating() == 'false')) {
          delete defaultValue.title.x;
          delete defaultValue.title.y;
      }
      // SubTitle Floating
      if (!_.isUndefined(that.subtitlefloating) && (that.subtitlefloating() === false || that.subtitlefloating() == 'false')) {
          delete defaultValue.subtitle.x;
          delete defaultValue.subtitle.y;
      }

      if (!_.isUndefined(that.exportingmenuitemhoverstylebackgroundcolor) && (that.exportingmenuitemhoverstylebackgroundcolor() === '' || that.exportingmenuitemhoverstylebackgroundcolor() == 'null')) {
          delete defaultValue.navigation.menuItemHoverStyle.background;
      }

      if (_.indexOf(excludeXAxisInterval,that.CID) === -1 && !_.isUndefined(that.xaxistickinterval) && (that.xaxistickinterval() === 0 || that.xaxistickinterval() == 'null' || that.xaxistickinterval() === '')) {
          defaultValue.xAxis.tickInterval = 'auto';
      }

      if (!_.isUndefined(that.yaxistickinterval) && (that.yaxistickinterval() === 0 || that.yaxistickinterval() == 'null' || that.yaxistickinterval() === '' || that.yaxistickinterval() === ' ')) {
          defaultValue.yAxis.tickInterval = null;
      }

      if (!_.isUndefined(that.xaxislabely) && (that.xaxislabely() === 0 || that.xaxislabely() == 'null' || that.xaxislabely() === '')) {
          if (defaultValue.xAxis.labels) {
              delete defaultValue.xAxis.labels.y;
          }
      }

      if (!_.isUndefined(that.xaxistitleoffset) && (that.xaxistitleoffset() === 0 || that.xaxistitleoffset() == 'null' || that.xaxistitleoffset() === '')) {
          if (defaultValue.xAxis.title) {
              delete defaultValue.xAxis.title.offset;
          }
      }

      if (!_.isUndefined(that.yaxistitleoffset) && (that.yaxistitleoffset() == 0 || that.yaxistitleoffset() == 'null' || that.yaxistitleoffset() == '')) {
          // to avoid  yaxis issue for multiple and dual axis chart
          if (defaultValue.yAxis.title) {
              delete defaultValue.yAxis.title.offset;
          }
      }

      if (!_.isUndefined(that.xaxisminortickinterval) && (that.xaxisminortickinterval() === 0 || that.xaxisminortickinterval() == 'null' || that.xaxisminortickinterval() === '')) {
          if(defaultValue.xAxis){
              defaultValue.xAxis.minorTickInterval = 'auto';
          }

      }
  }

  this.callHighCharts = function (component,$component, defaultValue,options) {
      var dependencyObject = options.dependencyObject;
      var vbiCharts = dependencyObject.VbiCharts; // jshint ignore:line
      var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
      var seriesData = options.seriesData;
      var that = component;
      $component.empty();
      //performance fix for IE Performance
      if (that.result() && that.legendenable && that.result().tuples.length > 1000) {
          defaultValue.legend.enabled = false;
          setTimeout(function () {
              $component.highcharts().update({
                  legend: {
                      enabled: that.legendenable()
                  }
              })
          }, 1000); // jshint ignore:line
      }
      var JSONValidator = new trialLibrary();
      var mergedOpts;
      if (that.cssEnabled !== undefined && that.cssEnabled() !== undefined) {
          JSONValidator.setGlobalCSSEnabled(that.cssEnabled());
      }
      if (JSONValidator.IsJsonString(that.chartthemejson()) && that.themeJSONEnabled()) {
          var jsonVal = eval('(' + JSON.parse(JSON.stringify(that.chartthemejson().replace(/(?:\r\n|\r|\n)/g, ''))) + ')'); //jshint ignore:line
          mergedOpts = JSONValidator.mergeOptions(defaultValue, jsonVal, '', that);
      } else {
          mergedOpts = defaultValue;
      }
      if (that.chartthemeenabled() && that.noThemeOptions === undefined) {
          that.defaultMergeOpts = JSONValidator.defOptions(mergedOpts);
      }
      if (that.chartthemeenabled() === true) {
          var cloneDef = $.extend(true, {}, defaultValue);
          that.noThemeOptions = JSONValidator.mergeSeriesOptions(cloneDef, that.defaultMergeOpts, '', that);
      }
      if (mergedOpts.series && seriesLibrary.checkSeriesAndDataExists(mergedOpts.series)) {
          if(that.CID === 'bubble'){
              that.noData = 8;
          }else{
              that.noData = 1;
          }
      }
      seriesLibrary['check_ZeroData']($component, mergedOpts, that);


      var getHighchartsCall = function () {
          if (that.chartenablezoom && that.chartenablezoom()) {
              seriesLibrary['get_Detail_chart']($component, mergedOpts, that);
          } else {
              fastdom.mutate(function () {
                  $component.highcharts(mergedOpts);
              });
          }
          createCommonChart(mergedOpts);
      };

      if (seriesLibrary.isIE()) {
          var lazyLayout = _.debounce(function () {
              if (that.chartenablezoom == undefined ||  that.chartenablezoom!= undefined && !that.chartenablezoom()) {
                $component.highcharts().reflow();
              }
          }, 300);
          $(window).bind('resize', lazyLayout);
          setTimeout(function () {
              getHighchartsCall();
          }, 400);
      } else {
          getHighchartsCall();
      }



      function createCommonChart(mergedOpts) {
          var chartLoadMasterDetail;
          var chartLoad;
          if (that.chartenablezoom && that.chartenablezoom()) {
              chartLoad = $('#detail-container' + that['id']() + '').highcharts();
              chartLoadMasterDetail = $('#master-container' + that['id']() + '').highcharts();
          } else {
              chartLoad = $component.highcharts();
          }
          /**
           *Master Detail changes .
           **/
          if (that.loadingenable() === true) {
              chartLoad && chartLoad.showLoading(that.loadingtext()); // jshint ignore:line
              if (that.chartenablezoom && that.chartenablezoom()) {
                  chartLoadMasterDetail && chartLoadMasterDetail.showLoading(' '); //jshint ignore:line
              }
          } else {
              chartLoad && chartLoad.hideLoading(that.loadingtext()); // jshint ignore:line
              if (that.chartenablezoom && that.chartenablezoom()) {
                  chartLoadMasterDetail && chartLoadMasterDetail.hideLoading(' '); //jshint ignore:line
              }
          }
          /**
           *Adding a separate showLoading for master-container
           **/
          /**
           *Getting the updated DOM Height&width
           *Updated it to highcharts
           *Without altering the "defaultValue"JSON,So the entire
           *Highcharts will not load again..
           **/

          seriesLibrary.createResponciveSmokeScreeen(that, mergedOpts, seriesData);
          //***ResponsiveUI smokeScreen issue **//
          if (that.noData === -1) {
              vbiCharts.createSmokeScreen($component, "No Data Available", 1);
          }
          var seriesLibrarySmokeScreenMessages = {
              2:'Please select a dimension in the Data Utility tool.',
              3:'The data does not have measures.'
          };

          var scatterSmokeScreenMessages = {
              1:'Please place two measures in the column',
              2:'Please add atleast one dimension in the row',
              3:'Please Select X-Axis Measure',
              4:'Please Select Y-Axis Measure',
              5:'Please select a dimension in the Data Utility tool',
              6:'Please enable Data utility and select  dimensions'
          };

          var bubbleSmokeScreenMessages = {
              1:'Please place three measures in the column',
              2:'Please add atleast one dimension in the row',
              3:'Please Select X-Axis Measure',
              4:'Please Select Y-Axis Measure',
              5:'Please Select Bubble Size Measure',
              6:'Please select a dimension in the Data Utility tool.',
              7:'Please enable Data utility and select  dimensions',
          }


          var vbiSmokeScreenNoDataIndicator = 1;
          if(that.CID ==='scatter'){
              vbiSmokeScreenNoDataIndicator =7;
              seriesLibrarySmokeScreenMessages = scatterSmokeScreenMessages;
          }
          if(that.CID ==='bubble'){
              vbiSmokeScreenNoDataIndicator= 8;
              seriesLibrarySmokeScreenMessages = bubbleSmokeScreenMessages;
          }

          if (that.noData === vbiSmokeScreenNoDataIndicator && that.result()) {
              $component.empty();
              vbiCharts.createSmokeScreen($component);
          }

          if(seriesLibrarySmokeScreenMessages[that.noData]){
              seriesLibrary.createSmokeScreen(that.$(), seriesLibrarySmokeScreenMessages[that.noData]);
          }
          //performing check on the conditions and create smoke screen for the errorbar
          if (that.errorCheck === 0) {
              if (that.errorbarenable() === true) {
                  $component.empty();
                  seriesLibrary.createSmokeScreen(that.$(), 'Please assign data source to enable error bar');
                  that.errorCheck = 2;
              }
          }

          if (that.errorCheck === 1) {
              $component.empty();
              seriesLibrary.createSmokeScreen(that.$(), 'Please Choose Series selection and Measures');
              that.errorCheck = 2;
          }

          if (that.errorCheck === 3) {
               $component.empty();
               seriesLibrary.createSmokeScreen(that.$(), 'Please Select the Series');
               that.errorCheck = 2;
           }

          if (that.errorCheck === 4) {
              $component.empty();
              seriesLibrary.createSmokeScreen(that.$(), 'Need atleast one dimension to activate error bar');
              that.errorCheck = 2;
          }

          //performing check on the conditions and create smoke screen for the errorbar ends here
      }
      /**
       *Since We are depending on setTimeout
       *We are creating a function and calling through it
       **/

      //VBX141-2457: when container is resized. As native 'reize' works only with window and not for div resize, resize needs to be detected manually
      seriesLibrary.detectContainerResize(that);

  }

  this.attachBaseGetters=function(component,options) {
  	var dependencyObject = options.dependencyObject;
  	var seriesLibrary = dependencyObject.SeriesLibrary;
  	var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    component.dispKeyTextResultSet = function() {
      	return seriesLibrary.displayKeyResult(component, component.dataRes, seriesLibrary, component.measurechange());
    };

    component.getOnlyKeyFlag = function() {
      return component.ifOnlyKeyVar.toString();
    };

    component.getKeyTextDisplay = function() {
      return component.dispkeytext();
    }; 

    component.getDimensionsNamesForFormatter = function(){
       return vbiNumberFormat.getDimensionsNamesForFormatter(component);
    };

    component.getMeasureMembers = function(JSONType) {
      return seriesLibrary.getMeasureMembers(component, JSONType, component.chartmeasurechange());
    };

    component.getDimensionList = function() {
      var dimname = [];
      var dimindex = [];
      if (component.result() !== undefined && component.result() !== '') {
        try {
          for (var i = 0; i < component.result().dimensions.length; i++) {
            if (component.dataRes.dimensions[i].axis == 'ROWS' && component.dataRes.dimensions[i].containsMeasures !== true) {
              dimname.push(component.result().dimensions[i].text);
              dimindex.push(i);
            }
          }
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return [
        dimname,
        dimindex
      ];
    };

    component.getMemberList = function(dimIndex) {
      var memlist = [];
      if (component.result() !== undefined && component.result() !== '') {
        try {
          for (var i = 0; i < component.result().dimensions[dimIndex].members.length; i++) {
            memlist.push(component.result().dimensions[dimIndex].members[i].text);
          }
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return memlist;
    };

    component.getDimensionAndMeasure = function() {
      var dimensionAndMeasure = [];
      if (component.result() !== undefined && component.result() !== '') {
        for (var i = 1; i < component.result().dimensions.length; i++) {
          dimensionAndMeasure.push(component.result().dimensions[i].text);
        }
      }

      return dimensionAndMeasure;
    };
    /**** getting Highcharts CSS Enabled Value in additional properties ****/
    component.getHighchartsCSSEnabledValue = function() {
      return Highcharts.getOptions().global.cssEnabled;
    };

    /**** getting measures for changing names in additional properties ****/
    component.getMeasures = function() {
      return seriesLibrary.getMeasuresName(component.displaydatasource);
    };

    component.getDimensionPicker = function() {
      $('#dsui_' + component.$()[0].id).show();
      return component.bardatacustomization();
    };

    component.getDataSourceName = function() {
      return component['DATA_SOURCE_ALIAS_REF']();
    };

    component.getbarcustomizationVal = function() {
      return component.bardatacustomization();
    };

    component.checkDimensionExist = function(barDataVal, allDimensions) {
      var newBarDataVal = [];
      for (var i = 0; i < barDataVal.length; i++) {
        if (jQuery.inArray(barDataVal[i], allDimensions) != -1) {
          newBarDataVal.push(barDataVal[i]);
        }
      }

      return newBarDataVal;
    };


    component.getDimensionMembersJson = function(dimIndex, JSONType) {
      return JSON.stringify(seriesLibrary.getDimensionMembersJson(component, dimIndex, JSONType));
    };

    component.getMeasureIndex = function() {
      try {
          if (component.dataRes !== undefined && component.dataRes !== null && component.dataRes !== '') {
          for (var i = 0; i < component.dataRes.dimensions.length; i++) {
            if (component.dataRes.dimensions[i].containsMeasures === true) {
              return '' + i;
            }
          }
        } else {
          return -1;
        }
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }
    };

    component.getDataSourceValue = function() {
      if (component['DATA_SOURCE_ALIAS_REF']()) {
        if (component.getDS === undefined)
         {component.getDS =  component['DATA_SOURCE_ALIAS_REF']();}

        if (component.getDS != component['DATA_SOURCE_ALIAS_REF']()) {
          component.getDS = component['DATA_SOURCE_ALIAS_REF']();
          return false;
        } else
         {return true;}
      } else
        {return true;}
      /**
        *Checking if DS in assigned or not
        *If DS is modified then making the total&sub-total change
        **/
    };

    component.getResultSetDimensions = function() {
      if (component.result() !== undefined && component.result() !== null && component.result() !== '') {
        return JSON.stringify(component.result().dimensions);
      } else {
        return null;
      }
    };

    component.getFullJsonDimensions = function() {
      if (component.fulljson() !== undefined && component.fulljson() !== null && component.fulljson() !== '') {
        return JSON.stringify(component.fulljson().dimensions);
      } else {
        return null;
      }
    };

    component.getDimensionJson = function() {
      // var dimlist =[];
      var dimJson = {};
      if (component.result() !== undefined && component.result() !== '' && component.result() !== null) {
        try {
          var resultSet = component.result().dimensions;
          for (var i = 0; i < resultSet.length; i++) {
            if (resultSet[i].axis == 'ROWS' && resultSet[i].containsMeasures !== true) {
              dimJson[resultSet[i].key] = {
                'text': resultSet[i].text,
                'index': i
              };
            }
          }
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return JSON.stringify(dimJson);
    };

    component.getDynamicCellSelectionData = function(prop) {
      var cellJsonData = component[prop]();
      if (cellJsonData !== undefined && cellJsonData !== null && cellJsonData !== '' && cellJsonData != {}) {
        if (cellJsonData.hasOwnProperty('data') && cellJsonData.data.length !== 0) {
          return cellJsonData.data[0];
        }
      }

      return 0;
    };

    component.getDataSelection = function(){
      var result = component.result();
      var selection = '';
      if(!_.isEmpty(result) && typeof result === 'object' && result.selection){
        selection = JSON.stringify(result.selection);
      }
      return selection;
    };

    component.getComponentName = function() {
      return component.CID;
    };
  }
}