function BoxPlotChartUtil(){
  componentUtil.call(this);

  this.getDefaultValue = function (that, options) {
      var dependencyObject = options.dependencyObject;
      var DataUtilityLib =dependencyObject.dataUtilityLib;//jshint ignore:line
      var vbiContextMenu=dependencyObject.VBIContextMenuLibray;//jshint ignore:line
      var vbiNumberFormat =dependencyObject.VbiNumberFormat;//jshint ignore:line
      var vbiCharts =dependencyObject.VbiCharts;
      var seriesLibrary = dependencyObject.SeriesLibrary;
      var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue;
      var component = that.$();
  var defaultValue = {
      chart:vbiHighchartsDefault.createDefaultObjects('boxplot',that),
      title:vbiHighchartsDefault.createDefaultObjects('commonTitle',that),
      subtitle:vbiHighchartsDefault.createDefaultObjects('commonSubtitle',that),
      credits:vbiHighchartsDefault.createDefaultObjects('commonCredits',that),
      exporting:vbiHighchartsDefault.createDefaultObjects('commonExporting',that),
      navigation:vbiHighchartsDefault.createDefaultObjects('commonNavigation',that),
      xAxis:vbiHighchartsDefault.createDefaultObjects('boxplotxaxis',that,seriesLibrary),
      yAxis: vbiHighchartsDefault.createDefaultObjects('boxplotyaxis',that,seriesLibrary),
      loading:vbiHighchartsDefault.createDefaultObjects('commonLoading',that),
      tooltip:vbiHighchartsDefault.createDefaultObjects('commonTooltip',that),
      legend: vbiHighchartsDefault.createDefaultObjects('commonLegend',that),
      plotOptions: {
        boxplot: {
          lineWidth: that.boxplotplotoptionlineWidth(),
          fillColor: that.boxplotplotoptionfillColor(),
          medianColor: that.boxplotplotoptionmedianColor(),
          medianWidth: that.boxplotplotoptionmedianWidth(),
          stemColor: that.boxplotplotoptionstemColor(),
          stemDashStyle: that.boxplotplotoptionstemDashStyle(),
          stemWidth: that.boxplotplotoptionstemWidth(),
          whiskerColor: that.boxplotplotoptionwhiskerColor(),
          whiskerLength: '20%',
          whiskerWidth: that.boxplotplotoptionwhiskerWidth()
        },
        series: {
          cursor: 'pointer',
          point: {
            events: {
              click: function(event) {
                //    that.selectedvalue(seriesLibrary.createMemberData(that,that.categoriesIndex[this.category],this.series.name));
                try {
                  that.selectedvalue(seriesLibrary.createMemberData(that, that.categoriesIndex[event.point.x], event.point.series.options.key));  //changed = 1;
                } catch (e) {
                }
              },

              select: function() {
                if (!this.series.chart.lassoFlag) {
                  try {
                    that.selectedPoints = component.highcharts().getSelectedPoints();
                    that.selectedPoints.push(this);
                    that.selectedvalues(seriesLibrary.createMembersData(that, that.categoriesIndex, that.selectedPoints,'heatmap').toString());
                    seriesLibrary.onSelectFunction(that);
                    /**
                    *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                    **/
                  } catch (e) {   seriesLibrary.DSXalert(e.message);
                  }

                }
              },

              unselect: function() {
                if (!this.series.chart.lassoFlag) {
                  try {
                    var index = that.selectedPoints.indexOf(this);
                    if (index > -1) {
                      that.selectedPoints.splice(index, 1);
                    }
                    that.selectedvalues(seriesLibrary.createMembersData(that, that.categoriesIndex, that.selectedPoints,'heatmap').toString());
                    if(that.selectedvalues() === ""){
                      that.selectedvalue('');
                    }else{
                      var select = seriesLibrary.createMembersData(that, that.categoriesIndex, that.selectedPoints,'heatmap');
                      that.selectedvalue(select[0]);
                    }

                  /**
                   *Selectedvalue fix in all charts
                   *Multiple Selection getting the last selected value.
                  **/
                  if(that.clearSelect){
                  if(that.selectedvalues() === ""){
                  that.clearSelect = false;}
                  }else{
                  seriesLibrary.onSelectFunction(that);
                  }//clearselection callback issue on Onselect.
                } catch (e) {   seriesLibrary.DSXalert(e.message);
                }
                /**
                *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                **/
              }
              }
            }
          },
          allowPointSelect: that.allowpointselect(),
          connectNulls: that.connectnulls(),
          cropThreshold: that.cropthreshold(),
          //cursor:that.pointcursor(),
          // enableMouseTracking:that.enablemousetracking(),
          //lineWidth:that.linewidth(),
          turboThreshold: that.turbothreshold(),
          marker: {}
        }
      },
      series: that.newseries
    };
    return defaultValue;
  }

  this.attachGetters=function(component,options){

    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    component.getMeasures = function() {
      var measure = [];
      var key = [];
      if (component.datasourcechange !== undefined && component.datasourcechange !== '') {
        for (var i = 0; i < component.datasourcechange.dimensions.length; i++) {
          if (component.datasourcechange.dimensions[i].containsMeasures === true) {
            for (var j = 0; j < component.datasourcechange.dimensions[i].members.length; j++) {
              measure.push(component.datasourcechange.dimensions[i].members[j].text);
              key.push(component.datasourcechange.dimensions[i].members[j].key);
            }
          }
        }
      }

      return measure + '=' + key;
    };

    component.getDropdownName = function() {
      return component.list();
    };

    component.getChartNames = function() {
      return globalVal;
    };

    component.getDataLengthVal = function() {
      if (!component.result()) {
        return 'none';
      } else {
        return 'data';
      }
    };

    component.getoutLier = function() {
      return JSON.stringify(component.trendlinelength());
    };

    component.getDataSeries = function() {
    if (!component.dataRes) { return null; }
      var dataSeries = [];
      var seriesNames = [];
      var seriesKeyNames = [];
      //component.dataRes = component.dispKeyTextResultSet();
      var bardatacustomizationJson = {
        'COLUMNS': [],
        'ROWS': []
      };
      if (component.bardatacustomization() !== '') {
        bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
      }

      try {
        if (component.dataRes === undefined || component.dataRes === '') {
          return null;
        } else if (component.datautility() === true && bardatacustomizationJson['COLUMNS'].length === 0 && bardatacustomizationJson['ROWS'].length === 0) {
          return null;
        }

        if (component.dataRes.dimensions.length === 1 && component.dataRes.dimensions[0].containsMeasures === true) {
          var defaultColor = [
            '#B586DA',
            '#FF6657',
            '#F3A730',
            '#946B66',
            '#B0AD53',
            '#7AC1DE',
            '#F1C337',
            '#566C6C',
            '#A1CC54',
            '#543F1E'
          ];
          var seriesColor = [];
          if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
            seriesColor = [];
          } else {
            seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
          }

          if (component.dataRes.dimensions[0].axis == 'ROWS') {
            for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {
              seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
              seriesNames.push(component.dataRes.dimensions[0].members[i]['picker_text']);
              seriesKeyNames.push(component.dataRes.dimensions[0].members[i].key);
            }
          } else {
            seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
            seriesNames.push('Measures');
            seriesKeyNames.push('Measures');
          }

          dataSeries = [
            seriesNames,
            seriesKeyNames
          ];
          seriesColor.splice(dataSeries.length, seriesColor.length);
          component.dataseriescolor(seriesColor.join());
        } else {
          //  dataSeries = seriesLibrary.createSeriesData(component, 'bar', defaultValueSeriesNames,"ncf");
          dataSeries = seriesLibrary.createSeriesAdditionalProperty(component);
        }
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return dataSeries;
    };

    component.getDataSeriesColor = function() {
      var dataseriescolor = '';
      try {
        dataseriescolor = component.dataseriescolor();
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return dataseriescolor;
    };

    component.getDatUtility = function() {
      var datautility = '';
      try {
        datautility = component.datautility();
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return datautility;
    };

    component.getChartType = function() {
      return 'bar';
    };

    component.isMeasureOnly = function() {
      var len = 0;
      if (component.result() !== undefined && component.result() !== '') {
        try {
          len = component.result().dimensions.length;
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return len;
    };
  
    component.getMeasureMembers = function(JSONType) {
      return seriesLibrary.getMeasureMembers(component, JSONType);
    };

    component.componentDeleted = function() {
      $('#dsui_' + componentID).remove();
    };

    component.getChartFamily = function() {
      return 'box';
    };
  
    component.lassoFireProp = function(selectedPoints) {
      component.selectedvalues(seriesLibrary.createMembersData(component, component.categoriesIndex, selectedPoints,'heatmap').toString());
      //component.changed++;
      component.firePropertiesChanged(['selectedvalues']);
    };

  }
}