function ColumnBarDrilldownChartUtil(){
    componentUtil.call(this);

    this.getDefaultValue = function (that, options) {

        var dependencyObject = options.dependencyObject;
        var vbiCharts = dependencyObject.VbiCharts;
        var seriesLibrary = dependencyObject.SeriesLibrary;
        var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue;
        var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
        var DataUtilityLib = dependencyObject.dataUtilityLib; //jshint ignore:line
        var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
        var thousandsep = that.bulletthousandseparator();
        var decimalsep = that.bulletdecimalseparator();


        //To Avoid offset working even after disabling tile in axis
        var offsetaxis = function (titledisplay, titleoffset, titletext) {
            if (titleoffset === 0 || titleoffset === '' || titletext === ' ') {
                return null;
            } else if (titledisplay === true || titledisplay === "true") {
                return titleoffset;
            } else {
                return null;
            }
        };

        var defaultValue = {
            chart: {
                type: 'column',
                inverted: that.columncharttype().toLowerCase()=="bar",
                className: that.chartcssclassname(),
                events: {
                    click: function (event) {
                        // lassoObj.unselectByClick.call(this,that);
                        if (event.target.textContent === '') {
                            that.fireEvent('chartonclick');
                        }
                    },

                    load: function () {
                        if(vbiContextMenu){vbiContextMenu.highchartsPostProcess();}
                        /*var contextMenuOptions={event:event,
                        enableContextMenu:that.enableContextMenu(),
                        enableDisplayDataButton:that.enableDisplayDataButton(),
                        enableMaximizeButton:that.enableMaximizeButton(),
                        enableMoreActionsButton:that.enableMoreActionsButton()};

                        // //The If condition is fire the charafterload event only once - Fix 1200
                        vbiContextMenu.attachContextMenu(contextMenuOptions);*/

                        //The If condition is fire the charafterload event only once - Fix 1200
                        if (!isLoad) {
                            that.fireEvent('chartafterload');
                            isLoad = true;
                        }

                        if (that.creditsenabled() === true) {
                            this.credits.element.onclick = function () {
                                window.open(that.creditshref(), '_blank'); // <- This is what makes it open in a new window.

                            };
                        }
                    },

                    selection: function (e) {
                        if (e.xAxis) {
                            that.fireEvent('chartonselect');
                        } //disabling the fireEvent while zoom out.
                    },

                    drillupall: function () {
                        var chart = this;
                        var parent = that.drillupArr.pop();
                        var currentSeries = chart.series[0].options.data; //event.seriesOptions.data;
                        var groupedCategories = [];
                        $.each(currentSeries, function (index, value) {
                            groupedCategories.push(value.name);
                        });

                        //event.target.axes[0].setCategories(groupedCategories, false);
                        chart.axes[0].setCategories(groupedCategories, false);
                        seriesLibrary.updateCategoryWidthHeight(that, groupedCategories);

                        seriesLibrary.trackActionFunc(that, "drillup");

                        var i = 0; // Index to consider for getting the level value.
                        if (that.parentondrill()) {
                            i = that.parentnodeplacement() == 'before' ? 1 : 0;
                        }

                        //VBX141-5322: Occurs when parent node has only one member.
                        if(!currentSeries[i] && i==1){
                            i=0;
                        }

                        if (currentSeries[i] && typeof currentSeries[i].level != 'undefined') {
                            var currentLevel = currentSeries[i].level;
                            that.drilldownlevel(Number(currentLevel));
                        }

                        if (that.chartondrillup() !== '') {
                            // try {
                                var ztlPointJson = {};
                                ztlPointJson = $.extend(true, {}, that.ztlSelectedColumnJson[parent.column]);
                                $.extend(true, ztlPointJson, that.ztlSelectedRowJson[parent.row]);
                                //console.log(JSON.stringify(ztlPointJson));
                                that.drillupmember(JSON.stringify(ztlPointJson));

                            // } catch (e) {}
                            that.columncolorChanged++;
                            that.firePropertiesChangedAndEvent(['drilldownlevel', 'drillupmember'], 'chartondrillup');
                        } else {
                            that.columncolorChanged++;
                            that.firePropertiesChanged(['drilldownlevel']);
                        }
                    }
                },
                ignoreHiddenSeries: that.ignorehiddenseries(),
                marginBottom: that.chartmarginbottom() == 'auto' ? null : Number(that.chartmarginbottom()),
                marginLeft: that.chartmarginleft() == 'auto' ? null : Number(that.chartmarginleft()),
                marginRight: that.chartmarginright() == 'auto' ? null : Number(that.chartmarginright()),
                marginTop: that.chartmargintop() == 'auto' ? null : Number(that.chartmargintop()),
                spacingBottom: that.chartpaddingbottom() == 'auto' ? null : Number(that.chartpaddingbottom()),
                spacingLeft: that.chartpaddingleft() == 'auto' ? null : Number(that.chartpaddingleft()),
                spacingRight: that.chartpaddingright() == 'auto' ? null : Number(that.chartpaddingright()),
                spacingTop: that.chartpaddingtop() == 'auto' ? null : Number(that.chartpaddingtop()),
                // spacingLeft: 100,
                pinchType: that.chartpinchtype(),
                zoomType: that.chartzoomtype(),
                panning: that.chartpanning(),
                panKey: that.chartpankey(),
                plotShadow: that.plotshadow(),
                reflow: that.chartflow() || false,
                shadow: that.chartshadow(),
                showaxes: that.showaxes(),
                resetZoomButton: {
                    position: {
                        align: that.zoombuttonalign(),
                        //relativeTo:that.zoombuttonrelativeto(),
                        verticalAlign: that.zoombuttonverticalalign()
                    },
                    theme: {
                        fill: that.resetzoombuttonbackgroundcolor(),
                        r: that.resetzoombuttonradius(),
                        style: {
                            color: that.resetzoombuttontextcolor()
                        },
                        states: {
                            hover: {
                                fill: that.resetzoombuttonhoverbackgroundcolor(),
                                style: {
                                    color: that.resetzoombuttonhovertextcolor()
                                }
                            }
                        }
                    }
                },
                backgroundColor: that.chartbackgroundcolor(),
                borderColor: that.chartbordercolor(),
                borderRadius: that.chartborderradius(),
                borderWidth: that.chartborderwidth(),
                plotBackgroundColor: that.plottransparency() === true ? 'transparent' : that.plotbackgroundcolor(),
                plotBackgroundImage: that.plotbackgroundimage().replace(/ /g, ''),
                plotBorderColor: that.plotbordercolor(),
                plotBorderWidth: that.plotborderwidth(),
                selectionMarkerFill: that.zoomselectionareabackgroundcolor(),
                width: (that.scrollbarenabled() && that.chartwidth() && !x ? that.chartwidth() : null),
                height: (that.scrollbarenabled() && that.chartwidth() && x ? that.chartwidth() : null) // in case of bar chart
            },
            title: vbiHighchartsDefault.createDefaultObjects('commonTitle', that),
            subtitle: vbiHighchartsDefault.createDefaultObjects('commonSubtitle', that),
            credits: vbiHighchartsDefault.createDefaultObjects('commonCredits', that),
            exporting: vbiHighchartsDefault.createDefaultObjects('commonExporting', that),
            navigation: vbiHighchartsDefault.createDefaultObjects('commonNavigation', that),
            loading: vbiHighchartsDefault.createDefaultObjects('commonLoading', that),
            tooltip: vbiHighchartsDefault.createDefaultObjects('commonTooltip', that),
            legend: vbiHighchartsDefault.createDefaultObjects('commonLegend', that),
            xAxis: {
                //type: "category",
                categories: [
                    'Sales-1',
                    'Sales-2',
                    'Sales-3',
                    'Sales-4',
                    'Sales-5'
                ],
                allowDecimals: that.xaxisallowdecimals(),
                alternateGridColor: that.xaxisalternategridcolor(),
                gridLineColor: that.xaxisgridlinecolor(),
                gridLineDashStyle: that.xaxisgridlinedashstyle(),
                gridLineWidth: that.xaxisgridlinewidth(),
                gridZIndex: that.xaxisgridzindex(),
                ceiling: that.xaxisceiling() === '' ? null : _.parseInt(that.xaxisceiling()),
                floor: that.xaxisfloor() === '' ? null : _.parseInt(that.xaxisfloor()),
                lineColor: that.xaxislinecolor(),
                lineWidth: that.xaxislinewidth(),
                minRange: that.xaxisminrange(),
                min: function () {
                    if (that.xaxismin() === '' || that.xaxismin() === null || isNaN(_.parseInt(that.xaxismin()))) {
                        return null;
                    } else if (that['xaxis_min_val'] === null) {
                        return _.parseInt(that.xaxismin());
                    } else if (_.parseInt(that.xaxismin()) >= _.parseInt(that['xaxis_min_val']) && _.parseInt(that.xaxismin()) < _.parseInt(that['xaxis_max_val'])) {
                        return _.parseInt(that.xaxismin());
                    }

                    return null;
                }
                (),
                //that.xaxismin() == '' ? null : _.parseInt(that.xaxismin()),
                max: function () {
                    if (that.xaxismax() === '' || that.xaxismax() === null || isNaN(_.parseInt(that.xaxismax()))) {
                        return null;
                    } else if (that['xaxis_max_val'] === null) {
                        return _.parseInt(that.xaxismax());
                    } else if (_.parseInt(that.xaxismax()) <= _.parseInt(that['xaxis_max_val']) && _.parseInt(that.xaxismax()) > _.parseInt(that['xaxis_min_val'])) {
                        return _.parseInt(that.xaxismax());
                    }

                    return null;
                }
                (),
                //that.xaxismax() == ''? null : _.parseInt(that.xaxismax()),
                maxPadding: that.xaxismaxpadding() === '' ? null : _.parseInt(that.xaxismaxpadding()),
                minPadding: that.xaxisminpadding() === '' ? null : _.parseInt(that.xaxisminpadding()),
                opposite: that.xaxisopposite(),
                offset: that.xaxisoffset(),
                reversed: that.xaxisreversed() === true,
                showEmpty: that.xaxisshowempty(),
                showFirstLabel: that.xaxisshowfirstlabel(),
                showLastLabel: that.xaxisshowlastlabel(),
                dateTimeLabelFormats: {},
                minTickInterval: that.xaxismintickinterval(),
                tickColor: that.xaxistickcolor(),
                tickInterval: that.xaxistickinterval(),
                tickLength: that.xaxisticklength(),
                tickPosition: that.xaxistickposition(),
                tickWidth: that.xaxistickwidth(),
                tickmarkPlacement: that.xaxistickmarkplacement(),
                labels: {
                    reserveSpace: that.xaxisreservespace(),
                    align: that.xaxislabelalign(),
                    enabled: that.xaxislabelenabled(),
                    format: that.xaxislabelprefix() + that.xaxislabelformat() + that.xaxislabelsuffix(),
                    //overflow:that.xaxislabeloverflow(),
                    rotation: that.xaxislabelrotation(),
                    // distance:that.xaxislabeldistance(),
                    staggerLines: that.xaxislabelstaggerline() === '' ? null : _.parseInt(that.xaxislabelstaggerline()),
                    maxStaggerLines: that.xaxislabelmaxstaggerline() === '' ? null : _.parseInt(that.xaxislabelmaxstaggerline()),
                    step: that.xaxislabelstep() === 0 ? null : that.xaxislabelstep(),
                    x: that.xaxislabelx(),
                    y: that.xaxislabely(),
                    zIndex: that.xaxislabelzindex(),
                    style: {
                        fontFamily: that.globalfont() ? that.fontfamily() : that.xaxislabelfontfamily()
                    },
                    events: {
                        click: function () {
                            seriesLibrary.axisClickEvent(this, that);
                        }
                    }
                },
                title: {
                    text: that.xaxistitletext(),
                    align: that.xaxistitlealign(),
                    rotation: that.xaxistitlerotation(),
                    offset: offsetaxis(that.xaxistitleenabled(), that.xaxistitleoffset(), that.xaxistitletext()),
                    margin: that.xaxistitlemargin(),
                    style: {
                        color: that.xaxistitlecolor(),
                        fontWeight: that.xaxistitlefontweight(),
                        textDecoration: that.xaxistitlefontweight(),
                        fontSize: that.xaxistitlefontsize() + 'px',
                        fontFamily: that.xaxistitlefontfamily(),
                        display: that.xaxistitleenabled() === true ? 'block' : 'none'
                    }
                },
                plotBands: [{
                        color: that.xaxisplotbandenabled() === true ? that.xaxisplotbandcolor() : null,
                        borderColor: that.xaxisplotbandenabled() === true ? that.xaxisplotbandbordercolor() : null,
                        borderWidth: that.xaxisplotbandborderwidth(),
                        from: that.xaxisplotbandfrom() - 0.5,
                        to: that.xaxisplotbandto() + 0.5,
                        zIndex: that.xaxisplotbandzindex(),
                        events: {
                            click: function (/*event*/) {
                                that.fireEvent('xaxisplotbandonclick');
                            }
                        },
                        label: {
                            style: {
                                color: that.xaxisplotbandlabelcolor(),
                                fontWeight: that.xaxisplotbandlabelfontweight(),
                                textDecoration: that.xaxisplotbandlabelfontweight(),
                                fontSize: that.xaxisplotbandlabelfontsize() + 'px',
                                fontFamily: that.xaxisplotbandlabelfontfamily(),
                                display: that.xaxisplotbandlabelenabled() === true ? 'block' : 'none'
                            },
                            text: that.xaxisplotbandlabeltext(),
                            align: that.xaxisplotbandlabelalign(),
                            rotation: that.xaxisplotbandlabelrotation(),
                            textAlign: that.xaxisplotbandlabeltextalign(),
                            //useHTML:that.xaxisplotbandlabelusehtml(),
                            verticalAlign: that.xaxisplotbandlabelverticalalign(),
                            x: that.xaxisplotbandlabelxposition() === 'null' ? null : _.parseInt(that.xaxisplotbandlabelxposition()),
                            y: that.xaxisplotbandlabelyposition() === '' ? null : _.parseInt(that.xaxisplotbandlabelyposition())
                        }
                    }
                ],
                plotLines: [{
                        color: that.xaxisplotlineenabled() === true ? that.xaxisplotlinecolor() : null,
                        dashStyle: that.xaxisplotlinedashstyle(),
                        width: that.xaxisplotlinewidth(),
                        value: that.xaxisplotlinevalue(),
                        zIndex: that.xaxisplotlinezindex(),
                        label: {
                            style: {
                                color: that.xaxisplotlinelabelcolor(),
                                fontWeight: that.xaxisplotlinelabelfontweight(),
                                textDecoration: that.xaxisplotlinelabelfontweight(),
                                fontSize: that.xaxisplotlinelabelfontsize() + 'px',
                                fontFamily: that.xaxisplotlinelabelfontfamily(),
                                display: that.xaxisplotlinelabelenabled() === true ? 'block' : 'none'
                            },
                            text: that.xaxisplotlinelabeltext(),
                            align: that.xaxisplotlinelabelalign(),
                            rotation: that.xaxisplotlinelabelrotation(),
                            textAlign: that.xaxisplotlinelabeltextalign(),
                            verticalAlign: that.xaxisplotlinelabelverticalalign(),
                            x: that.xaxisplotlinelabelxposition() === 'null' ? null : _.parseInt(that.xaxisplotlinelabelxposition()),
                            y: that.xaxisplotlinelabelyposition() === 'null' ? null : _.parseInt(that.xaxisplotlinelabelyposition())
                        }
                    }
                ]
            },
            yAxis: {
                allowDecimals: that.yaxisallowdecimals(),
                alternateGridColor: that.yaxisalternategridcolor(),
                gridLineColor: that.yaxisgridlinecolor(),
                gridLineDashStyle: that.yaxisgridlinedashstyle(),
                gridLineWidth: that.yaxisgridlinewidth(),
                gridZIndex: that.yaxisgridzindex(),
                lineColor: that.yaxislinecolor(),
                lineWidth: that.yaxislinewidth(),
                minTickInterval: that.yaxismintickinterval(),
                minorGridLineColor: that.yaxisminorgridlinecolor(),
                minorGridLineDashStyle: that.yaxisminorgridlinedashstyle(),
                minorGridLineWidth: that.yaxisminorgridlinewidth(),
                minorTickColor: that.yaxisminortickcolor(),
                minorTickInterval: that.yaxisminortickinterval() === '' ? 'auto' : _.parseInt(that.yaxisminortickinterval()),
                minorTickLength: that.yaxisminorticklength(),
                minorTickPosition: that.yaxisminortickposition(),
                minorTickWidth: that.yaxisminortickwidth(),
                tickColor: that.yaxistickcolor(),
                tickInterval: that.yaxistickinterval() === '' ? null : _.parseInt(that.yaxistickinterval()),
                tickLength: that.yaxisticklength(),
                tickPosition: that.yaxistickposition(),
                tickWidth: that.yaxistickwidth(),
                tickmarkPlacement: that.yaxistickmarkplacement(),
                dateTimeLabelFormats: {},
                ceiling: that.yaxisceiling() === '' ? null : _.parseInt(that.yaxisceiling()),
                floor: that.yaxisfloor() === '' ? null : _.parseInt(that.yaxisfloor()),
                min: that.yaxismin() === '' ? null : _.parseInt(that.yaxismin()),
                max: that.yaxismax() === '' ? null : _.parseInt(that.yaxismax()),
                maxPadding: that.yaxismaxpadding() === '' ? null : parseFloat(that.yaxismaxpadding()),
                minPadding: that.yaxisminpadding() === '' ? null : parseFloat(that.yaxisminpadding()),
                minRange: that.yaxisminrange(),
                offset: that.yaxisoffset(),
                opposite: that.yaxisopposite(),
                reversed: that.yaxisreversed() === true,
                showEmpty: that.yaxisshowempty(),
                showFirstLabel: that.yaxisshowfirstlabel(),
                showLastLabel: that.yaxisshowlastlabel(),
                labels: {
                    align: that.yaxislabelalign(),
                    enabled: that.yaxislabelenabled(),
                    formatter: function () {
                        return vbiHighchartsDefault['Yaxis_autoscale_formatter'](that, this);
                    },
                    rotation: that.yaxislabelrotation(),
                    staggerLines: that.yaxislabelstaggerline() === '' ? null : _.parseInt(that.yaxislabelstaggerline()),
                    maxStaggerLines: that.yaxislabelmaxstaggerline() === '' ? null : _.parseInt(that.yaxislabelmaxstaggerline()),
                    step: that.yaxislabelstep() === 0 ? null : that.yaxislabelstep(),
                    x: that.yaxislabelx(),
                    y: that.yaxislabely(),
                    zIndex: that.yaxislabelzindex(),
                    style: {
                        color: that.yaxislabelcolor(),
                        fontWeight: that.yaxislabelfontweight(),
                        textDecoration: that.yaxislabelfontweight(),
                        fontSize: that.yaxislabelfontsize() + 'px',
                        fontFamily: that.yaxislabelfontfamily()
                    },
                    events: {
                        click: function () {
                            seriesLibrary.axisClickEvent(this, that);
                        }
                    }
                },
                title: {
                    text: that.yaxistitletext(),
                    align: that.yaxistitlealign(),
                    rotation: that.yaxistitlerotation(),
                    offset: offsetaxis(that.yaxistitleenabled(), that.yaxistitleoffset(), that.yaxistitletext()),
                    margin: that.yaxistitlemargin(),
                    style: {
                        color: that.yaxistitlecolor(),
                        fontWeight: that.yaxistitlefontweight(),
                        textDecoration: that.yaxistitlefontweight(),
                        fontSize: that.yaxistitlefontsize() + 'px',
                        fontFamily: that.yaxistitlefontfamily(),
                        display: that.yaxistitleenabled() === true ? 'block' : 'none'
                    }
                },
                plotBands: [{
                        color: that.yaxisplotbandenabled() === true ? that.yaxisplotbandcolor() : null,
                        borderColor: that.yaxisplotbandenabled() === true ? that.yaxisplotbandbordercolor() : null,
                        borderWidth: that.yaxisplotbandborderwidth(),
                        from: that.yaxisplotbandfrom(),
                        to: that.yaxisplotbandto(),
                        zIndex: that.yaxisplotbandzindex(),
                        events: {
                            click: function (/*event*/) {
                                that.fireEvent('yaxisplotbandonclick');
                            }
                        },
                        label: {
                            style: {
                                color: that.yaxisplotbandlabelcolor(),
                                fontWeight: that.yaxisplotbandlabelfontweight(),
                                textDecoration: that.yaxisplotbandlabelfontweight(),
                                fontSize: that.yaxisplotbandlabelfontsize() + 'px',
                                fontFamily: that.yaxisplotbandlabelfontfamily(),
                                display: that.yaxisplotbandlabelenabled() === true ? 'block' : 'none'
                            },
                            text: that.yaxisplotbandlabeltext(),
                            align: that.yaxisplotbandlabelalign(),
                            rotation: that.yaxisplotbandlabelrotation(),
                            textAlign: that.yaxisplotbandlabeltextalign(),
                            verticalAlign: that.yaxisplotbandlabelverticalalign(),
                            x: that.yaxisplotbandlabelxposition() === 'null' ? null : _.parseInt(that.yaxisplotbandlabelxposition()),
                            y: that.yaxisplotbandlabelyposition() === 'null' ? null : _.parseInt(that.yaxisplotbandlabelyposition())
                        }
                    }
                ],
                plotLines: [{
                        color: that.yaxisplotlineenabled() === true ? that.yaxisplotlinecolor() : null,
                        dashStyle: that.yaxisplotlinedashstyle(),
                        width: that.yaxisplotlinewidth(),
                        value: that.yaxisplotlinevalue(),
                        zIndex: that.yaxisplotlinezindex(),
                        label: {
                            verticalAlign: that.yaxisplotlinelabelverticalalign(),
                            style: {
                                color: that.yaxisplotlinelabelcolor(),
                                fontWeight: that.yaxisplotlinelabelfontweight(),
                                textDecoration: that.yaxisplotlinelabelfontweight(),
                                fontSize: that.yaxisplotlinelabelfontsize() + 'px',
                                fontFamily: that.yaxisplotlinelabelfontfamily(),
                                display: that.yaxisplotlinelabelenabled() === true ? 'block' : 'none'
                            },
                            text: that.yaxisplotlinelabeltext(),
                            align: that.yaxisplotlinelabelalign(),
                            rotation: that.yaxisplotlinelabelrotation(),
                            textAlign: that.yaxisplotlinelabeltextalign(),
                            x: that.yaxisplotlinelabelxposition() === 'null' ? null : _.parseInt(that.yaxisplotlinelabelxposition()),
                            y: that.yaxisplotlinelabelyposition() === 'null' ? null : _.parseInt(that.yaxisplotlinelabelyposition())
                        }
                    }
                ]
            },

            plotOptions: {
                series: {
                    borderWidth: 0,
                    cursor: 'pointer',
                    pointWidth: that.pointwidth() == 'auto' ? null : _.parseInt(that.pointwidth()),
                    pointPadding: that.pointpadding(),
                    point: {
                        events: {
                            click: function (event) {
                                if (that.customAction === null) {
                                    seriesLibrary._pointClickEvent(event, that);
                                } else {
                                    seriesLibrary.pointTriggeredClick(event, that);
                                }

                            }
                        }
                    },
                    allowPointSelect: that.allowpointselect(),
                    connectNulls: that.connectnulls(),
                    cropThreshold: that.cropthreshold(),
                    turboThreshold: that.turbothreshold(),
                    dataLabels: {
                        allowOverlap: that.allowoverlap(),
                        enabled: that.datalabelenabled(),
                        align: that.datalabelalign() == 'default' ? null : that.datalabelalign(),
                        crop: that.datalabelcrop(),
                        backgroundColor: that.datalabelbackgroundcolor(),
                        useHTML: false,
                        borderColor: that.datalabelbordercolor(),
                        borderRadius: that.datalabelborderradius(),
                        borderWidth: that.datalabelborderwidth(),
                        padding: that.datalabelpadding(),
                        rotation: that.datalabelrotation(),
                        shadow: that.datalabelshadow(),
                        verticalAlign: that.datalabelverticalalign() == 'default' ? null : that.datalabelverticalalign(),
                        inside: that.datalabelinside(),
                        x: that.datalabelx(),
                        y: that.datalabely(),
                        formatter: function () {
                            return that.datalabelprefix() + ' ' + Highcharts.numberFormat(this.y, that.decimal(), decimalsep, thousandsep) + ' ' + that.datalabelsuffix();
                        },

                        style: {
                            textShadow: false,
                            color: that.datalabeltextcolor(),
                            fontWeight: that.datalabelfontweight(),
                            textDecoration: that.datalabelfontweight(),
                            fontSize: that.datalabelfontsize() + 'px',
                            fontFamily: that.globalfont() === true ? that.fontfamily() : that.datalabelfontfamily()
                        }
                    },
                    marker: {}
                }
            },
            series: [{
                    name: 'Sales',
                    data: options.seriesData,
                    unitOfMeasure: '',
                    colorByPoint: true
                }
            ],
            drilldown: {
                activeAxisLabelStyle: {
                    color: that.xaxislabelcolor(),
                    fontWeight: that.xaxislabelfontweight(),
                    textDecoration: that.xaxislabelfontweight(),
                    fontSize: that.xaxislabelfontsize() + 'px',
                    fontFamily: that.globalfont() === true ? that.fontfamily() : that.xaxislabelfontfamily()
                },
                activeDataLabelStyle: {
                    cursor: that.drilldowndatalabelcursor(),
                    color: that.datalabeltextcolor(),
                    fontWeight: that.datalabelfontweight(),
                    textDecoration: that.datalabelfontweight(),
                    fontSize: that.datalabelfontsize() + 'px',
                    fontFamily: that.globalfont() === true ? that.fontfamily() : that.datalabelfontfamily()
                },
                drillUpButton: {
                    theme: {
                        style: {
                            fontFamily: that.globalfont() === true ? this.fontfamily() : 'Lucida Grande, Lucida Sans Unicode, Arial, Helvetica, sans-serif'
                        }
                    },
                    position: {
                        x: that.drilldownbuttonx(),
                        y: that.drilldownbuttony(),
                        align: that.drilldownbuttonalign(),
                        verticalAlign: that.drilldownbuttonverticalalign()
                    }
                },
                series: options.drilldownSeries
            }
        };
        return defaultValue;
    };

    this.getSampleDataSeries = function () {
        var seriesData = [{
            name: 'Sales-1',
            y: 95,
            color: '#B8DC5A',
            drilldown: 'Sales-1'
        }, {
            name: 'Sales-2',
            y: 203,
            color: '#588EC0',
            drilldown: 'Sales-2'
        }, {
            name: 'Sales-3',
            y: 150,
            color: '#00ffff',
            drilldown: 'Sales-3'
        }, {
            name: 'Sales-4',
            y: 300,
            color: '#7BB6EF',
            drilldown: 'Sales-4'
        }];
        return seriesData;
    }

    this.getSampleDrillDownDataSeries = function () {
        var drilldownSeries = [{
            name: 'Sales-1',
            id: 'Sales-1',
            color: '#B8DC5A',
            data: [
                [
                    'Sales-1.1',
                    30
                ],
                [
                    'Sales-1.2',
                    20
                ],
                [
                    'Sales-1.3',
                    45
                ]
            ]
        }, {
            name: 'Sales-2',
            id: 'Sales-2',
            color: '#588EC0',
            data: [
                [
                    'Sales-2.1',
                    50
                ],
                [
                    'Sales-2.2',
                    100
                ],
                [
                    'Sales-2.3',
                    53
                ]
            ]
        }, {
            name: 'Sales-3',
            id: 'Sales-3',
            color: '#00ffff',
            data: [
                [
                    'Sales-3.1',
                    45
                ],
                [
                    'Sales-3.2',
                    65
                ],
                [
                    'Sales-3.3',
                    40
                ]
            ]
        }, {
            name: 'Sales-4',
            id: 'Sales-4',
            color: '#7BB6EF',
            data: [
                [
                    'Sales-4.1',
                    75
                ],
                [
                    'Sales-4.2',
                    90
                ],
                [
                    'Sales-4.3',
                    135
                ]
            ]
        }];
        return drilldownSeries;
    }

    this.attachGetters=function(component,options){

        this.attachBaseGetters(component,options);

        var dependencyObject = options.dependencyObject;
        var seriesLibrary = dependencyObject.SeriesLibrary;
        var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
        var DataUtilityLib = dependencyObject.dataUtilityLib; //jshint ignore:line

        component.isDataSourceStructureModified = function () {
            if (component.result() && component.oldResultSet) {
                var ds = component.result(),
                dsOld = component.oldResultSet,
                dsDimensions = ds.dimensions,
                dsOldDimensions = dsOld.dimensions;
                if (dsDimensions.length !== dsOldDimensions.length) {
                    return true;
                } else {
                    for (var i = 0, len = dsDimensions.length; i < len; i++) {
                        if (dsDimensions[i].key != dsOldDimensions[i].key || dsDimensions[i].axis != dsOldDimensions[i].axis) {
                            return true;
                        }
                    }
                }

                return false;
            }
            return 'NA';
        };

        component.setDataUtilityFormattedResultSet = function(){
            component.dataRes = DataUtilityLib.CallUtility();
            component.dataRes = component.dispKeyTextResultSet();
        };

        component.dataUtilityAggregation = function(dataArray){
            var data = [];
            var aggregationType = DataUtilityLib.getAggregationType() || 'sum';
            data.push(dataArray);
            return DataUtilityLib.aggregationResult(data, aggregationType)[0];
        };
        //Function to get Series Name
        component.getDataSeries = function () {
            if (!component.dataRes) {
                return null;
            }
            component.dataRes = component.dispKeyTextResultSet();
            //var seriesNames = [];
            //var seriesKeyNames = [];
            /*var defaultColor = [
            '#B586DA',
            '#FF6657',
            '#F3A730',
            '#946B66',
            '#B0AD53',
            '#7AC1DE',
            '#F1C337',
            '#566C6C',
            '#A1CC54',
            '#543F1E'
            ];*/
            var seriesColor = [];
            if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
                seriesColor = [];
            } else {
                seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
            }

            if (component.dataRes === undefined || component.dataRes === '')
                // If data source not available
            {
                return null;
            } else if (JSON.stringify(component.dataRes.dimensions).indexOf('containsMeasures') == -1) {
                return null;
            } else {
                var dataSeries = seriesLibrary.createSeriesAdditionalProperty(component);
                return dataSeries;
            }
        };

        component.getDataSeriesColor = function () {
            var dataseriescolor = '';
            try {
                dataseriescolor = component.dataseriescolor();
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }

            return dataseriescolor;
        };
        component.getDatUtility = function () {
            var datautility = '';
            try {
                datautility = component.datautility();
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }

            return datautility;
        };

        component.getChartType = function () {
            return 'bardd';
        };

        component.getMeasureMembers = function () {
            return seriesLibrary.getMeasureMembers(component);
        };

        component.componentDeleted = function () {
            $('#dsui_' + componentID).remove();
        };

        component.getMeasuresNamesForFormatter = function () {
            return vbiNumberFormat.getMeasuresNamesForFormatter(component);
        };

        component.getMeasureJson = function () {
            var measureJson = {};
            if (component.result() !== undefined && component.result() !== null && component.result() !== '') {
                for (var i = 0; i < component.result().dimensions.length; i++) {
                    if ('containsMeasures' in component.result().dimensions[i]) {
                        $.each(component.result().dimensions[i].members, function (key, value) {
                            measureJson[value.key] = {
                                text: value.text,
                                index: key
                            };
                        });

                        break;
                    }
                }
            }
            return JSON.stringify(measureJson);
        };

    }
}