function CombinationChartUtil(){
  componentUtil.call(this);

  this.getSampleDataSeries = function() {
    var seriesData = [
      {
        type: "column",
        name: "Actual",
        color: "#588EC0",
        data: [95, 203, 110, 220, 203, 297, 250, 170, 248, 160, 170, 267]
      },
      {
        type: "line",
        name: "Budget",
        data: [240, 301, 159, 110, 240, 166, 145, 100, 130, 180, 135, 153],
        color: "#CC9B73",
        marker: {
          lineWidth: 1,
          lineColor: "#A5D22D",
          fillColor: "#eee"
        }
      }
    ];
    return seriesData;
  };
  this.getDefaultValue=function(that,options){
    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
    var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue; // jshint ignore:line
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
    var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
    var lassoObj = SeriesLibrary.prototype.lasso;
    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
    var component = that.$();
    var thousandsep = that.progressthousandseparator();
    var decimalsep = that.progressdecimalseparator();
    var isExportEnable=that.exportingsymbolenabled();
    if(that.enableMoreActionsButton && isExportEnable)
    {
        isExportEnable=!that.enableMoreActionsButton() &&   !that.enableContextMenu();
    }
    
    //To Avoid offset working even after disabling tile in axis
    var offsetaxis = function(titledisplay, titleoffset, titletext) {
      if (titleoffset == "" || titletext == " ") {
        //jshint ignore:line
        return null;
      } else if (titledisplay === true) {
        return titleoffset;
      } else {
        return null;
      }
    };

    var defaultValue = {
      chart: {
        type: options.columnType,
        inverted: that.chartinverted(),
        alignTicks: that.chartalignticks(),
        marginBottom:
          that.chartmarginbottom() == "auto"
            ? null
            : Number(that.chartmarginbottom()),
        marginLeft:
          that.chartmarginleft() == "auto"
            ? null
            : Number(that.chartmarginleft()),
        marginRight:
          that.chartmarginright() == "auto"
            ? null
            : Number(that.chartmarginright()),
        marginTop:
          that.chartmargintop() == "auto" ? null : Number(that.chartmargintop()),
        spacingBottom:
          that.chartpaddingbottom() == "auto"
            ? null
            : Number(that.chartpaddingbottom()),
        spacingLeft:
          that.chartpaddingleft() == "auto"
            ? null
            : Number(that.chartpaddingleft()),
        spacingRight:
          that.chartpaddingright() == "auto"
            ? null
            : Number(that.chartpaddingright()),
        spacingTop:
          that.chartpaddingtop() == "auto"
            ? null
            : Number(that.chartpaddingtop()),
        //   animation: that.result() ?that.result().tuples.length>1000?false:that.chartanimation() :that.chartanimation(),
        className: that.chartcssclassname(),
        events: {
          click: function(event) {
            //jshint ignore:line
            lassoObj.unselectByClick.call(this, that);
            if (event.target.textContent === "") {
              that.fireEvent("chartonclick");
            }
          },

          load: function() {
            if (vbiContextMenu) {
              vbiContextMenu.highchartsPostProcess();
            }
            /*var contextMenuOptions={event:event,
                          enableContextMenu:that.enableContextMenu(),
                          enableDisplayDataButton:that.enableDisplayDataButton(),
                          enableMaximizeButton:that.enableMaximizeButton(),
                          enableMoreActionsButton:that.enableMoreActionsButton()};

    //The If condition is fire the charafterload event only once - Fix 1200
    vbiContextMenu.attachContextMenu(contextMenuOptions);*/

            //The If condition is fire the charafterload event only once - Fix 1200
            if (!isLoad) {
              that.fireEvent("chartafterload");
              isLoad = true;
            }

            if (that.creditsenabled() === true) {
              this.credits.element.onclick = function() {
                window.open(
                  that.creditshref(),
                  "_blank" // <- This is what makes it open in a new window.
                );
              };
            }
          },

          selection: function(e) {
            var retVal = lassoObj.selectPointsByDrag.call(this, e, that);
            if (this.lasso == "lasso" || this.lasso == "rlasso") {
              that.fireEvent("chartonpointclick");
            } else {
              if (e.xAxis) {
                that.fireEvent("chartonselect"); //disabling the fireEvent while zoom out.
              }
            }

            return retVal;
          }
        },
        ignoreHiddenSeries: that.ignorehiddenseries(),
        pinchType: that.chartpinchtype(),
        zoomType: that.chartzoomtype(),
        panning: that.chartpanning(),
        panKey: that.chartpankey(),
        //'shift',
        plotShadow: that.plotshadow(),
        reflow: that.chartflow() || false,
        shadow: that.chartshadow(),
        showaxes: that.showaxes(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            relativeTo: that.zoombuttonrelativeto(),
            verticalAlign: that.zoombuttonverticalalign()
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: { color: that.resetzoombuttontextcolor() },
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: { color: that.resetzoombuttonhovertextcolor() }
              }
            }
          }
        },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor:
          that.plottransparency() === true
            ? "transparent"
            : that.plotbackgroundcolor(),
        plotBackgroundImage: that.plotbackgroundimage(),
        plotBorderColor: that.plotbordercolor(),
        plotBorderWidth: that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor()
      },
      title: vbiHighchartsDefault.createDefaultObjects("commonTitle", that),
      subtitle: vbiHighchartsDefault.createDefaultObjects("commonSubtitle", that),
      credits: vbiHighchartsDefault.createDefaultObjects("commonCredits", that),
      exporting: {
        buttons: {
          contextButton: {
            enabled: isExportEnable,
            align: that.exportingsymbolalign(),
            verticalAlign: that.exportingsymbolverticalalign(),
            symbol: that.exportingsymbol(),
            symbolFill: that.exportingsymbolfill(),
            symbolSize: that.exportingsymbolsize(),
            symbolStroke: that.exportingsymbolstroke(),
            symbolStrokeWidth: that.exportingsymbolstrokewidth(),
            height:
              that.exportingsymbolheight() === "auto"
                ? 20
                : _.parseInt(that.exportingsymbolheight()),
            width:
              that.exportingsymbolwidth() === "auto"
                ? 24
                : _.parseInt(that.exportingsymbolwidth()),
            x:
              that.exportingxposition() == "auto"
                ? 0
                : _.parseInt(that.exportingxposition()),
            y:
              that.exportingyposition() == "auto"
                ? 0
                : _.parseInt(that.exportingyposition()),
            menuItems: that.chartthemeenabled()
              ? Highcharts.getOptions().exporting.buttons.contextButton.menuItems
              : Highcharts.getOptions().exporting.buttons.contextButton.menuItems.slice(
                  0,
                  10
                ),
            theme: {
              r: that.exportingsymbolradius(),
              fill:
                that.exportingsymbolbackgroundfill() === ""
                  ? null
                  : that.exportingsymbolbackgroundfill(),
              states: {
                hover: { fill: that.exportingsymbolhoverbackgroundfill() }
              }
            }
          }
        },
        filename: that.exportedfilename(),
        sourceWidth: that.exportedchartwidth(),
        sourceHeight: that.exportedchartheight(),
        scale: that.exportedchartscale()
      },
      navigation: vbiHighchartsDefault.createDefaultObjects(
        "commonNavigation",
        that
      ),
      xAxis: {
        categories: [
          "Jan",
          "Feb",
          "Mar",
          "Apr",
          "May",
          "Jun",
          "Jul",
          "Aug",
          "Sep",
          "Oct",
          "Nov",
          "Dec"
        ],
        allowDecimals: that.xaxisallowdecimals(),
        alternateGridColor: that.xaxisalternategridcolor(),
        maxPadding: that.xaxismaxpadding(),
        minPadding: that.xaxisminpadding(),
        gridLineColor: that.xaxisgridlinecolor(),
        gridLineDashStyle: that.xaxisgridlinedashstyle(),
        gridLineWidth: that.xaxisgridlinewidth(),
        gridZIndex: that.xaxisgridzindex(),
        ceiling:
          that.xaxisceiling() === "" ? null : _.parseInt(that.xaxisceiling()),
        floor: that.xaxisfloor() === "" ? null : _.parseInt(that.xaxisfloor()),
        lineColor: that.xaxislinecolor(),
        lineWidth: that.xaxislinewidth(),
        minRange: that.xaxisminrange(),
        min: that.xaxismin() === "" ? null : _.parseInt(that.xaxismin()),
        max: that.xaxismax() === "" ? null : _.parseInt(that.xaxismax()),
        opposite: that.xaxisopposite(),
        offset: that.xaxisoffset(),
        reversed: that.xaxisreversed() === true,
        showEmpty: that.xaxisshowempty(),
        showFirstLabel: that.xaxisshowfirstlabel(),
        showLastLabel: that.xaxisshowlastlabel(),
        dateTimeLabelFormats: {},
        minTickInterval: that.xaxismintickinterval(),
        startOnTick: that.xaxisstartontick(),
        endOnTick: that.xaxisendontick(),
        tickColor: that.xaxistickcolor(),
        tickInterval: that.xaxistickinterval(),
        tickLength: that.xaxisticklength(),
        tickPosition: that.xaxistickposition(),
        tickWidth: that.xaxistickwidth(),
        tickmarkPlacement: that.xaxistickmarkplacement(),
        labels: {
          reserveSpace: that.xaxisreservespace(),
          align: that.xaxislabelalign(),
          enabled: that.xaxislabelenabled(),
          format:
            that.xaxislabelprefix() +
            that.xaxislabelformat() +
            that.xaxislabelsuffix(),
          //overflow:that.xaxislabeloverflow(),
          rotation: that.xaxislabelrotation(),
          //distance:that.xaxislabeldistance(),
          staggerLines:
            that.xaxislabelstaggerline() === ""
              ? null
              : _.parseInt(that.xaxislabelstaggerline()),
          maxStaggerLines:
            that.xaxislabelmaxstaggerline() === ""
              ? null
              : _.parseInt(that.xaxislabelmaxstaggerline()),
          step: that.xaxislabelstep() === 0 ? null : that.xaxislabelstep(),
          x: that.xaxislabelx(),
          y: that.xaxislabely(),
          zIndex: that.xaxislabelzindex(),
          style: {
            color: that.xaxislabelcolor(),
            fontWeight: that.xaxislabelfontweight(),
            textDecoration: that.xaxislabelfontweight(),
            fontSize: that.xaxislabelfontsize() + "px",
            fontFamily: that.xaxislabelfontfamily()
          },
          events: {
            click: function() {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
          //useHTML : true
        },
        title: {
          text: that.xaxistitletext(),
          align: that.xaxistitlealign(),
          rotation: that.xaxistitlerotation(),
          offset: offsetaxis(
            that.xaxistitleenabled(),
            that.xaxistitleoffset(),
            that.xaxistitletext()
          ),
          margin: that.xaxistitlemargin(),
          style: {
            color: that.xaxistitlecolor(),
            fontWeight: that.xaxistitlefontweight(),
            textDecoration: that.xaxistitlefontweight(),
            fontSize: that.xaxistitlefontsize() + "px",
            fontFamily: that.xaxistitlefontfamily(),
            display: that.xaxistitleenabled() === true ? "block" : "none"
          }
        },
        plotBands: [
          {
            /* style:{
                  play:that.xaxisplotbandenabled()==true?'block':'none'
                  */
            color: that.xaxisplotbandcolor(),
            borderColor: that.xaxisplotbandbordercolor(),
            borderWidth: that.xaxisplotbandborderwidth(),
            from: that.xaxisplotbandfrom(),
            to: that.xaxisplotbandto(),
            zIndex: that.xaxisplotbandzindex(),
            events: {
              click: function(event) {
                //jshint ignore:line
                that.fireEvent("xaxisplotbandonclick");
              }
            },
            label: {
              style: {
                color: that.xaxisplotbandlabelcolor(),
                fontWeight: that.xaxisplotbandlabelfontweight(),
                textDecoration: that.xaxisplotbandlabelfontweight(),
                fontSize: that.xaxisplotbandlabelfontsize() + "px",
                fontFamily: that.xaxisplotbandlabelfontfamily(),
                display: that.xaxisplotbandlabelenabled() ? "block" : "none"
              },
              text: that.xaxisplotbandlabeltext(),
              align: that.xaxisplotbandlabelalign(),
              rotation: that.xaxisplotbandlabelrotation(),
              textAlign: that.xaxisplotbandlabeltextalign(),
              //useHTML:that.xaxisplotbandlabelusehtml(),
              verticalAlign: that.xaxisplotbandlabelverticalalign(),
              x:
                that.xaxisplotbandlabelxposition() === "null"
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelxposition()),
              y:
                that.xaxisplotbandlabelyposition() === "null"
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelyposition())
            }
          }
        ],
        plotLines: [
          {
            /* style:{
                  play:that.xaxisplotlineenabled()==true?'block':'none'
                  */
            color:
              that.xaxisplotlineenabled() === true
                ? that.xaxisplotlinecolor()
                : null,
            dashStyle: that.xaxisplotlinedashstyle(),
            width: that.xaxisplotlinewidth(),
            value: that.xaxisplotlinevalue(),
            zIndex: that.xaxisplotlinezindex(),
            label: {
              style: {
                color: that.xaxisplotlinelabelcolor(),
                fontWeight: that.xaxisplotlinelabelfontweight(),
                textDecoration: that.xaxisplotlinelabelfontweight(),
                fontSize: that.xaxisplotlinelabelfontsize() + "px",
                fontFamily: that.xaxisplotlinelabelfontfamily(),
                display: that.xaxisplotlinelabelenabled() ? "block" : "none"
              },
              text: that.xaxisplotlinelabeltext(),
              //align: that.xaxisplotlinelabelalign(),
              rotation: that.xaxisplotlinelabelrotation(),
              textAlign:
                that.xaxisplotlinelabelalign() == "left"
                  ? "right"
                  : that.xaxisplotlinelabelalign() == "right" ? "left" : "center",
              verticalAlign: that.xaxisplotlinelabelverticalalign(),
              x:
                that.xaxisplotlinelabelxposition() === "null"
                  ? null
                  : _.parseInt(that.xaxisplotlinelabelxposition()),
              y:
                that.xaxisplotlinelabelyposition() === "null"
                  ? null
                  : _.parseInt(that.xaxisplotlinelabelyposition())
            }
          }
        ]
      },
      yAxis: {
        allowDecimals: that.yaxisallowdecimals(),
        alternateGridColor: that.yaxisalternategridcolor(),
        showFirstLabel: that.yaxisshowfirstlabel(),
        showLastLabel: that.yaxisshowlastlabel(),
        gridLineColor: that.yaxisgridlinecolor(),
        gridLineDashStyle: that.yaxisgridlinedashstyle(),
        gridLineWidth: that.yaxisgridlinewidth(),
        gridZIndex: that.yaxisgridzindex(),
        lineColor: that.yaxislinecolor(),
        lineWidth: that.yaxislinewidth(),
        minorGridLineColor: that.yaxisminorgridlinecolor(),
        minorGridLineDashStyle: that.yaxisminorgridlinedashstyle(),
        minorGridLineWidth: that.yaxisminorgridlinewidth(),
        minorTickColor: that.yaxisminortickcolor(),
        minorTickInterval:
          that.yaxisminortickinterval() == "null"
            ? "auto"
            : _.parseInt(that.yaxisminortickinterval()),
        minorTickLength: that.yaxisminorticklength(),
        minorTickPosition: that.yaxisminortickposition(),
        minorTickWidth: that.yaxisminortickwidth(),
        tickColor: that.yaxistickcolor(),
        tickInterval:
          that.yaxistickinterval() === ""
            ? null
            : _.parseInt(that.yaxistickinterval()),
        tickLength: that.yaxisticklength(),
        tickPosition: that.yaxistickposition(),
        tickWidth: that.yaxistickwidth(),
        /*
                      tickColor:that.yaxistickcolor(),
                      tickInterval:that.yaxistickinterval()=='1'?'auto':_.parseInt(that.yaxistickinterval()),
                      tickLength:that.yaxisticklength(),
                      tickPosition:that.yaxistickposition(),
                      tickWidth:that.yaxistickwidth(),
                      tickmarkPlacement:that.yaxistickmarkplacement(),
                    */
        ceiling:
          that.yaxisceiling() === "" ? null : _.parseInt(that.yaxisceiling()),
        floor: that.yaxisfloor() === "" ? null : _.parseInt(that.yaxisfloor()),
        endOnTick: that.yaxisendontick(),
        min: that.yaxismin() === "" ? null : _.parseInt(that.yaxismin()),
        max: that.yaxismax() === "" ? null : _.parseInt(that.yaxismax()),
        maxPadding:
          that.yaxismaxpadding() === ""
            ? null
            : parseFloat(that.yaxismaxpadding()),
        minPadding:
          that.yaxisminpadding() === ""
            ? null
            : parseFloat(that.yaxisminpadding()),
        opposite: that.yaxisopposite(),
        minRange: that.yaxisminrange(),
        offset: that.yaxisoffset(),
        reversed: that.yaxisreversed() === true,
        showEmpty: that.yaxisshowempty(),
        //startOnTick:that.yaxisstartontick(),
        title: {
          text: that.yaxistitletext(),
          align: that.yaxistitlealign(),
          rotation: that.yaxistitlerotation(),
          offset: offsetaxis(
            that.yaxistitleenabled(),
            that.yaxistitleoffset(),
            that.yaxistitletext()
          ),
          margin: that.yaxistitlemargin(),
          style: {
            color: that.yaxistitlecolor(),
            fontWeight: that.yaxistitlefontweight(),
            textDecoration: that.yaxistitlefontweight(),
            fontSize: that.yaxistitlefontsize() + "px",
            fontFamily: that.yaxistitlefontfamily(),
            display: that.yaxistitleenabled() === true ? "block" : "none"
          }
        },
        labels: {
          rotation: that.yaxislabelrotation(),
          formatter: function() {
            return vbiHighchartsDefault["Yaxis_autoscale_formatter"](that, this);
          },
          staggerLines:
            that.yaxislabelstaggerline() === ""
              ? null
              : _.parseInt(that.yaxislabelstaggerline()),
          maxStaggerLines:
            that.yaxislabelmaxstaggerline() === ""
              ? null
              : _.parseInt(that.yaxislabelmaxstaggerline()),
          step: that.yaxislabelstep() === 0 ? null : that.yaxislabelstep(),
          x: that.yaxislabelx(),
          y: that.yaxislabely(),
          zIndex: that.yaxislabelzindex(),
          align: that.yaxislabelalign(),
          enabled: that.yaxislabelenabled(),
          style: {
            color: that.yaxislabelcolor(),
            fontWeight: that.yaxislabelfontweight(),
            textDecoration: that.yaxislabelfontweight(),
            fontSize: that.yaxislabelfontsize() + "px",
            fontFamily: that.yaxislabelfontfamily()
          },
          events: {
            click: function() {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        plotBands: [
          {
            /* style:{
                y:that.yaxisplotbandenabled()==true?'block':'none'
                */
            color: that.yaxisplotbandcolor(),
            from: that.yaxisplotbandfrom(),
            to: that.yaxisplotbandto(),
            zIndex: that.yaxisplotbandzindex(),
            events: {
              click: function(event) {
                that.fireEvent("yaxisplotbandonclick");
              }
            },
            label: {
              style: {
                color: that.yaxisplotbandlabelcolor(),
                fontWeight: that.yaxisplotbandlabelfontweight(),
                textDecoration: that.yaxisplotbandlabelfontweight(),
                fontSize: that.yaxisplotbandlabelfontsize() + "px",
                fontFamily: that.yaxisplotbandlabelfontfamily(),
                display: that.yaxisplotbandlabelenabled() ? "block" : "none"
              },
              text: that.yaxisplotbandlabeltext(),
              align: that.yaxisplotbandlabelalign(),
              rotation: that.yaxisplotbandlabelrotation(),
              textAlign: that.yaxisplotbandlabeltextalign(),
              //useHTML:that.xaxisplotbandlabelusehtml(),
              verticalAlign: that.yaxisplotbandlabelverticalalign(),
              x: that.xaxisplotbandlabelxposition(),
              y: that.xaxisplotbandlabelyposition()
            }
          }
        ],
        plotLines: [
          {
            /* style:{
                  ay:that.yaxisplotlineenabled()==true?'block':'none'
                  */
            color: that.yaxisplotlinecolor(),
            dashStyle: that.yaxisplotlinedashstyle(),
            width: that.yaxisplotlinewidth(),
            value: that.yaxisplotlinevalue(),
            zIndex: that.yaxisplotlinezindex(),
            label: {
              style: {
                color: that.yaxisplotlinelabelcolor(),
                fontWeight: that.yaxisplotlinelabelfontweight(),
                textDecoration: that.yaxisplotlinelabelfontweight(),
                fontSize: that.yaxisplotlinelabelfontsize() + "px",
                fontFamily: that.yaxisplotlinelabelfontfamily(),
                display: that.yaxisplotlinelabelenabled() ? "block" : "none"
              },
              text: that.yaxisplotlinelabeltext(),
              //align: that.yaxisplotlinelabelalign(),
              rotation: that.yaxisplotlinelabelrotation(),
              textAlign:
                that.yaxisplotlinelabelalign() == "left"
                  ? "right"
                  : that.yaxisplotlinelabelalign() == "right" ? "left" : "center",
              //useHTML:that.xaxisplotbandlabelusehtml(),
              verticalAlign: that.yaxisplotlinelabelverticalalign()
            }
          }
        ]
      },
      loading: vbiHighchartsDefault.createDefaultObjects("commonLoading", that),
      tooltip: {
        useHTML: true,
        valueDecimals: that.tooltipvaluedecimals(),
        valuePrefix: that.tooltipvalueprefix(),
        valueSuffix: that.tooltipvaluesuffix(),
        animation: that.tooltipanimation() || false,
        crosshairs: that.tooltipcrosshair(),
        enabled: that.tooltipenable(),
        followPointer: that.tooltipfollowpointer(),
        followTouchMove: that.tooltipfollowtouchmove(),
        hideDelay: that.tooltiphidedelay(),
        shadow: that.tooltipshadow(),
        shape: that.tooltipshape(),
        shared: that.tooltipshared(),
        snap: that.tooltipsnap(),
        headerFormat:
          "<p style='display:block;font-size:" +
          that.tooltipfontsize() +
          "px;line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em'>{point.key}</p>",
        backgroundColor: that.tooltipbackgroundcolor(),
        borderColor: that.tooltipbordercolor(),
        borderRadius: that.tooltipborderradius(),
        borderWidth: that.tooltipborderwidth(),
        style: {
          color: that.tooltipcolor(),
          fontWeight: that.tooltipfontweight(),
          textDecoration: that.tooltipfontweight(),
          fontSize: that.tooltipfontsize() + "px",
          fontFamily: that.tooltipfontfamily()
        }
      },
      legend: {
        width: that.legendboxwidth(),
        enabled: that.legendenable(),
        backgroundColor: that.legendbackgroundcolor(),
        borderColor: that.legendbordercolor(),
        borderRadius: that.legendborderradius(),
        borderWidth: that.legendborderwidth(),
        align: that.legendalign(),
        floating: that.legendfloating(),
        itemDistance: that.legenditemdistance(),
        itemMarginBottom: that.legenditemmarginbottom(),
        itemMarginTop: that.legenditemmargintop(),
        itemWidth:
          that.legenditemwidth() == "auto"
            ? null
            : Number(that.legenditemwidth()),
        //width:that.legendwidth(),
        labelFormat: that.legendlabelformat(),
        layout: that.legendlayout(),
        lineHeight: that.legendlineheight(),
        margin: that.legendmargin(),
        padding: that.legendpadding(),
        reversed: that.legendreversed(),
        rtl: that.legendsymboltoright(),
        shadow: that.legendshadow(),
        symbolHeight: that.legendsymbolheight(),
        symbolPadding: that.legendsymbolpadding(),
        symbolRadius: that.legendsymbolradius(),
        symbolWidth: that.legendsymbolwidth(),
        x: that.legendxposition(),
        y: that.legendyposition(),
        verticalAlign: that.legendverticalalign(),
        title: {
          text: that.legendtitletext(),
          style: {
            color: that.legendtitlecolor(),
            fontWeight: that.legendtitlefontweight(),
            textDecoration: that.legendtitlefontweight(),
            fontSize: that.legendtitlefontsize() + "px",
            fontFamily: that.legendtitlefontfamily()
          }
        },
        itemHiddenStyle: { color: that.legenditemhiddenstylecolor() },
        itemHoverStyle: { color: that.legenditemhoverstylecolor() },
        itemStyle: {
          color: that.legenditemstylecolor(),
          fontSize: that.legenditemfontsize() + "px",
          fontWeight: that.legenditemfontweight(),
          textDecoration: that.legenditemfontweight(),
          fontFamily: that.legenditemfontfamily()
        },
        navigation: {
          activeColor: that.legendnavigationactivecolor(),
          animation: that.legendnavigationanimation(),
          arrowSize: that.legendnavigationarrowsize(),
          inactiveColor: that.legendnavigationinactivecolor(),
          style: {
            fontWeight: that.legendnavigationfontweight(),
            textDecoration: that.legendnavigationfontweight(),
            color: that.legendnavigationcolor(),
            fontSize: that.legendnavigationfontsize(),
            fontFamily: that.legendnavigationfontfamily()
          }
        }
      },
      plotOptions: {
        series: {
          borderWidth: 0,
          allowPointSelect: that.allowpointselect(),
          connectNulls: that.connectnulls(),
          cropThreshold: that.cropthreshold(),
          minPointLength: 3,
          cursor: that.pointcursor(),
          enableMouseTracking: that.enablemousetracking(),
          lineWidth: that.linewidth(),
          turboThreshold: that.turbothreshold(),
          shadow: that.seriesshadow(),
          //negativeColor:that.negativecolor(),
          point: {
            events: {
              click: function(event) {
                try {
                  that.selectedvalue(
                    seriesLibrary.createMemberData(
                      that,
                      that.categoriesIndex[event.point.index],
                      event.point.series.options.key
                    )
                  );
                } catch (e) {}
                //that.that.colorChanged = 1;
                that.charttype(this.series.type);
              },

              select: function() {
                if (!this.series.chart.lassoFlag) {
                  try {
                    that.selectedPoints = component
                      .highcharts()
                      .getSelectedPoints();
                    that.selectedPoints.push(this);
                    that.selectedvalues(
                      seriesLibrary
                        .createMembersData(
                          that,
                          that.categoriesIndex,
                          that.selectedPoints
                        )
                        .toString()
                    );
                    seriesLibrary.onSelectFunction(that);
                  } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                  }
                }
              },

              unselect: function() {
                if (!this.series.chart.lassoFlag) {
                  try {
                    var index = that.selectedPoints.indexOf(this);
                    if (index > -1) {
                      that.selectedPoints.splice(index, 1);
                    }
                    that.selectedvalues(
                      seriesLibrary
                        .createMembersData(
                          that,
                          that.categoriesIndex,
                          that.selectedPoints
                        )
                        .toString()
                    );
                    if (that.selectedvalues() === "") {
                      that.selectedvalue("");
                    } else {
                      var select = seriesLibrary.createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints
                      );
                      that.selectedvalue(select[0]);
                    }
                    /**
                                       *Selectedvalue fix in all charts
                                       *Multiple Selection getting the last selected value.
                                       **/
                    if (that.clearSelect) {
                      if (that.selectedvalues() === "") {
                        that.clearSelect = false;
                      }
                    } else {
                      seriesLibrary.onSelectFunction(that);
                    } //clearselection callback issue on Onselect.
                  } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                  }
                }
              }
            }
          },
          dataLabels: {
            allowOverlap: that.allowoverlap(),
            enabled: that.datalabelenabled(),
            align: that.datalabelalign(),
            crop: that.datalabelcrop(),
            //defer: that.datalabeldefer(),
            backgroundColor: that.datalabelbackgroundcolor(),
            useHTML: false,
            borderColor: that.datalabelbordercolor(),
            borderRadius: that.datalabelborderradius(),
            borderWidth: that.datalabelborderwidth(),
            padding: that.datalabelpadding(),
            rotation: that.datalabelrotation(),
            shadow: that.datalabelshadow(),
            verticalAlign: that.datalabelverticalalign(),
            inside: that.datalabelinside(),
            x: that.datalabelx(),
            y: that.datalabely(),
            formatter: function() {
              if (
                that.customdatalabel() !== "" &&
                Object.keys(JSON.parse(that.customdatalabel() || "{}")).length &&
                this.point.series.name.toLocaleLowerCase().indexOf("result") ==
                  -1 &&
                this.key.name.toLocaleLowerCase().indexOf("result") == -1
              ) {
                return vbiNumberFormat.barFamilyFormatterDataLabel(
                  this,
                  that,
                  decimalsep,
                  thousandsep,
                  false
                );
              } else {
                return vbiNumberFormat.barFamilyDataLabelFormatter(
                  this,
                  that,
                  decimalsep,
                  thousandsep,
                  false
                );
              }
            },
            style: {
              textShadow: false,
              color: that.datalabeltextcolor(),
              fontWeight: that.datalabelfontweight(),
              textDecoration: that.datalabelfontweight(),
              fontSize: that.datalabelfontsize() + "px",
              fontFamily:
                that.globalfont() == true
                  ? that.fontfamily()
                  : that.datalabelfontfamily() //jshint ignore:line
            }
          },
          marker: {
            fillColor: that.markerfillcolor(),
            lineColor: that.markerlinecolor(),
            lineWidth: that.markerlinewidth(),
            radius: that.markerradius()
          }
        },
        errorbar: {
          turboThreshold: 1000
        }
      },
      series: options.seriesData
    };
    return defaultValue;
  };

  this.attachGetters=function(component,options){

    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    //Measure validation function for errorbar to check whether measure is in row and if the column contains more than two dimension
    component.measureValidation = function() {
        var returnValue = false;
        var measureinrow = false;
        try {
            for (var i = 0; i < component.result().dimensions.length; i++) {
                if (component.result().dimensions[i].containsMeasures === true && component.result().dimensions[i].axis == 'ROWS') {
                    measureinrow = true;
                }
            }

            if (measureinrow === true) {
                returnValue = false;
            } else {
                returnValue = true;
            } //return true;
        } catch (e) {
            seriesLibrary.DSXalert(e.message);
        }

        return returnValue + ''; //callruntime handler won't handle object and boolean hence return string
    };

    var onSelectFunction = function(component) {
        if (component.keyTimer) {
            clearTimeout(component.keyTimer);
        }

        component.keyTimer = setTimeout(function() {
            component.firePropertiesChangedAndEvent([
                'selectedvalue',
                'charttype',
                'selectedvalues'
            ], 'chartonpointclick');
        }, 200);
    };

    component.fulldataseries = function() {
        return JSON.stringify(seriesLibrary.createErrorbar());
    };

    component.errorbardata = function() {
        //alert(new seriesLibrary.createErrorbar());
        /*  var completedJson=seriesLibrary.getMeasuresName(component.fulljson()).split('=');
          var key=completedJson[0].split(',');
          var name=completedJson[1].split(',');
          var completeMeasure=[];
          completeMeasure.push(key,name);
        //  return  JSON.stringify(new seriesLibrary.createErrorbar()); */
        var completedJson = seriesLibrary.getMeasuresName(component.fulljson()).split('=');
        var completemeasurenames = [];
        var key = completedJson[1].split(',');
        var name = completedJson[0].split(',');
        var measurenamechange;
        if (component.chartmeasurechange() !== '' && component.chartmeasurechange() !== undefined && component.chartmeasurechange() !== null) {
            measurenamechange = JSON.parse(component.chartmeasurechange());
        } else {
            measurenamechange = {};
        }

        for (var i = 0; i < key.length; i++) {
            var measure = {};
            measure.uniquekey = key[i];
            if (measurenamechange[key[i]] !== '' && measurenamechange[key[i]] !== undefined) {
                measure.name = measurenamechange[key[i]];
            } else {
                measure.name = name[i];
            }

            completemeasurenames.push(measure);
        }

        return JSON.stringify(completemeasurenames);
    };

    component.errocheckvaluechange = function() {
        component.errorCheck = 1;
    };

    component.seriesdata = function() {
        var chartJson = seriesLibrary.getMeasuresName(component.result()).split('=');
        var chartmeasurenames = [];
        var key = chartJson[1].split(',');
        var name = chartJson[0].split(',');
        var measurenamechange;
        if (component.chartmeasurechange() !== '' && component.chartmeasurechange() !== undefined && component.chartmeasurechange() !== null) {
            measurenamechange = JSON.parse(component.chartmeasurechange());
        } else {
            measurenamechange = {};
        }

        for (var i = 0; i < key.length; i++) {
            var measure = {};
            measure.uniquekey = key[i];
            if (measurenamechange[key[i]] !== '' && measurenamechange[key[i]] !== undefined) {
                measure.name = measurenamechange[key[i]];
            } else {
                measure.name = name[i];
            }

            chartmeasurenames.push(measure);
        }

        return JSON.stringify(chartmeasurenames); //return  JSON.stringify(new seriesLibrary.defaultvalueseries());
    };

    component.seriesstyledata = function() {
        return JSON.stringify(new seriesLibrary.defaultvalueseries());
    };

        component.createIdenical = function(defaultValue) {
            var entireData = [];
            for (var i = 0; i < defaultValue.series.length; i++) {
        if(defaultValue.series[i].data){
                for (var j = 0; j < defaultValue.series[i].data.length; j++) {
                    if (defaultValue.series[i].type == 'errorbar') {
                        entireData.push(defaultValue.series[i].data[j][0] || 0);
                        entireData.push(defaultValue.series[i].data[j][1] || 0);
                    } else {
                        entireData.push(defaultValue.series[i].data[j].y || 0);
                    }
                }
        }
            }

            if (entireData.length > 0) {
                minimumValue = entireData.reduce(function(p, v) {
                    return p < v ? p : v;
                });

                maximumValue = entireData.reduce(function(p, v) {
                    return p > v ? p : v;
                });
                /*
                 * Getting all the value in a array
                 * sorting minimum and maximum value in it.
                 */
                if (minimumValue === undefined) {
                    minimumValue = 0;
                    maximumValue = 250;
                }

                var listGroup = component['list']();
                var minimumVal = Math.floor(minimumValue).toFixed(component.decimal());
                var maximumVal = Math.ceil(maximumValue).toFixed(component.decimal());
                var restart = component['chartRestart']();

                /* jshint ignore:start */
                if (WhatIfLibrary !== undefined && listGroup != '' || restart != 0) {
                    var testingArrayTemp = component['testingArray']();
                    var datasourceAssigned = component['DATA_SOURCE_ALIAS_REF']();
                    var chartId = component['id']();
                    WhatIfLibrary.register(chartId, {
                        type: 'Chart',
                        name: 'Combination Chart',
                        category: 'charts',
                        data_source: datasourceAssigned,
                        custom_function: {
                            custom_id_min_value: minimumVal,
                            custom_id_max_value: maximumVal,
                            custom_id_groupId: testingArrayTemp,
                            custom_id_SelectedValue: listGroup
                        }
                    }, component);
                }
                /* jshint ignore:end */


                /*
                 * Getting the minimum and maximum value and pushing it to whatifAnalyser(updating).
                 * and also grouping name.
                 */
                /* jshint ignore:start */
                component.globalVal.push('None');
                for (var i in WhatIfLibrary.charts) {
                    if (WhatIfLibrary.charts[i].custom_function !== undefined) {
                        var gettingArray = WhatIfLibrary.charts[i].custom_function.custom_id_groupId;
                        for (var j = 0; j < gettingArray.split(',').length; j++) {
                            var localTest = gettingArray.split(',');
                            if (component.globalVal.indexOf(localTest[j]) == -1) {
                                component.globalVal.push(localTest[j]);
                            }
                        }
                    }
                }
                /* jshint ignore:end */


                seriesLibrary.creatIndenticalScaling(component, defaultValue, minimumVal, maximumVal, WhatIfLibrary);
                //identicalScaling Fix
                if (listGroup != '' || restart != 0) {  // jshint ignore:line
                    if (listGroup != 'None') {
                        this.callHighCharts(component,component, defaultValue,{dependencyObject:dependencyObject,seriesData:seriesData});//jshint ignore:line
                    }
                }
            } //To stop the events
        };

        component.getDropdownName = function() {
            return component.list();
        };

        component.getChartNames = function() {
            return component.globalVal;
        };

        component.getDataSeriesColor = function() {
            var dataseriescolor = '';
            try {
                dataseriescolor = component.dataseriescolor();
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }

            return dataseriescolor;
        };

        component.getDatUtility = function() {
            var datautility = '';
            try {
                datautility = component.datautility();
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }

            return datautility;
        };

        component.getChartType = function() {
            return 'combination';
        };

        component.getDataSeries = function() {
  if (!component.dataRes) { return null; }
            var dataSeries = [];
            var seriesNames = [];
            var seriesKeyNames = [];
            component.dataRes = component.dispKeyTextResultSet();
            var bardatacustomizationJson = {
                'COLUMNS': [],
                'ROWS': []
            };
            if (component.bardatacustomization() !== '') {
                bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
            }

            try {
                if (component.dataRes === undefined || component.dataRes === '') {
                    // return null;
                } else if (component.datautility() === true && bardatacustomizationJson['COLUMNS'].length === 0 && bardatacustomizationJson['ROWS'].length === 0) {
                    return null;
                }

                if (component.dataRes.dimensions.length == 1 && component.dataRes.dimensions[0].containsMeasures === true) {
                    var defaultColor = [
                        '#B586DA',
                        '#FF6657',
                        '#F3A730',
                        '#946B66',
                        '#B0AD53',
                        '#7AC1DE',
                        '#F1C337',
                        '#566C6C',
                        '#A1CC54',
                        '#543F1E'
                    ];
                    var seriesColor = [];
                    if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
                        seriesColor = [];
                    } else {
                        seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
                    }

                    if (component.dataRes.dimensions[0].axis == 'COLUMNS') {
                        for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {
                            seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
                            seriesNames.push(component.dataRes.dimensions[0].members[i].picker_text);  //jshint ignore:line
                            seriesKeyNames.push(component.dataRes.dimensions[0].members[i].key);
                        }
                    } else {
                        seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
                        seriesNames.push('Measures');
                        seriesKeyNames.push('Measures');
                    }

                    dataSeries = [
                        seriesNames,
                        seriesKeyNames
                    ];
                    seriesColor.splice(dataSeries.length, seriesColor.length);
                    component.dataseriescolor(seriesColor.join());
                } else {
                    //  dataSeries = seriesLibrary.createSeriesData(component, 'bar', component.defaultValueSeriesNames,"ncf");
                    dataSeries = seriesLibrary.createSeriesAdditionalProperty(component);
                }
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }

            return dataSeries;
        };

        component.isMeasureOnly = function() {
            var len = 0;
            if (component.result() !== undefined && component.result() !== '') {
                try {
                    len = component.result().dimensions.length;
                } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                }
            }

            return len;
        };

        component.getLegendNames = function(dimIndex) {    //jshint ignore:line
            var charttype = [];
            var leglist = [];
            var legcolors = [];
            var leglistkey = [];
            if (component.result() !== undefined && component.result() !== '') {
                try {
                    for (var i = 0; i < component.defaultValueSeriesNames.series.length; i++) {
                        if (component.defaultValueSeriesNames.series[i].name.indexOf('Trendline') == -1 && component.defaultValueSeriesNames.series[i].type != 'errorbar') {
                            leglist.push(component.defaultValueSeriesNames.series[i].name);
                            charttype.push(component.defaultValueSeriesNames.series[i].type);
                            legcolors.push(component.defaultValueSeriesNames.series[i].color);
                            leglistkey.push(component.defaultValueSeriesNames.series[i].uniquekey); //Making changes because same series-name causing problem VBX141-3099
                        }
                    }
                } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                }
            }

            return [
                leglist,
                charttype,
                legcolors,
                leglistkey
            ];
        };

        component.getDimensionAndMeasure = function() {
            var dimensionAndMeasure = [];
            if (component.dataRes !== undefined && component.dataRes !== '')
            // if (component.dataRes !== undefined && component.dataRes != "")
            {
                for (var i = 1; i < component.dataRes.dimensions.length; i++) {
                    dimensionAndMeasure.push(component.dataRes.dimensions[i].text);
                }
            }

            return dimensionAndMeasure;
        };

        component.componentDeleted = function() {
            $('#dsui_' + componentID).remove();

            function triggerDelete() {
                var chartId = component['id']();
                if (WhatIfLibrary !== undefined) {
                    for (var i in WhatIfLibrary.charts) {
                        if (i === chartId) {
                            //Removing current instances from WhatIfLibrary
                            delete WhatIfLibrary.charts[i];
                            delete WhatIfLibrary.instances[i];
                        }
                    }
                    /*
                     *Deleting the Removed chart from the WhatIfLibrary
                     *Manually Removed
                     *WhatIfLibrary is removing only after window.refresh Hence removing Manually
                     */
                    for (var i in WhatIfLibrary.charts) {
                        if (sap.zen.Dispatcher.instance.getRootControlForComponentId(i) !== undefined) {
                            var instance = WhatIfLibrary.getInstance(i);
                            if (instance.list() !== '' || instance.list() != 'None') {
                                instance.afterUpdate();
                            }
                        }
                        /*
                         *Trigger afterUpdate of the charts which are grouped
                         *Auto-AfterUpdate is not getting trigged
                         */
                    }
                }
            }

            setTimeout(triggerDelete, 200); //getRootControlForComponentId need a setTimeout
        };

        component.isAllStacked = function(dimIndex) {      //jshint ignore:line
            var allStacked = 'true';
            if (component.result() !== undefined && component.result() !== '') {
                try {
                    for (var i = 0; i < component.defaultValueSeriesNames.series.length; i++) {
                        if (component.defaultValueSeriesNames.series[i].stacking === '') {
                            allStacked = 'false';
                            break;
                        }
                    }
                } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                }
            }

            return allStacked;
        };

        component.getChartFamily = function() {
            return 'bar';
        };

        component.getMeasuresNamesForFormatter = function(){
            return vbiNumberFormat.getMeasuresNamesForFormatter(component);
        };

        component.lassoFireProp = function(selectedPoints) {
            component.selectedvalues(seriesLibrary.createMembersData(component, component.categoriesIndex, selectedPoints).toString());
            //component.colorChanged++;
            component.firePropertiesChanged(['selectedvalues']);
        };

  }

}