function FixedColumnChartUtil(){
  componentUtil.call(this);

  this.getSampleDataSeries = function() {
    var seriesData = [
      {
        name: "Employees",
        color: "rgba(165,170,217,1)",
        data: [150, 73, 20],
        pointPadding: 0.3,
        pointPlacement: -0.2
      },
      {
        name: "Employees Optimized",
        color: "rgba(126,86,134,.9)",
        data: [140, 90, 40],
        pointPadding: 0.4,
        pointPlacement: -0.2
      },
      {
        name: "Profit",
        color: "rgba(248,161,63,1)",
        data: [183.6, 178.8, 198.5],
        pointPadding: 0.3,
        pointPlacement: 0.2
      },
      {
        name: "Profit Optimized",
        color: "rgba(186,60,61,.9)",
        data: [203.6, 198.8, 208.5],
        pointPadding: 0.4,
        pointPlacement: 0.2
      }
    ];

    return seriesData;
  };
  this.getDefaultValue=function(that,options){
    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
    var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue; // jshint ignore:line
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
    var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
    var lassoObj = SeriesLibrary.prototype.lasso;
    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
    var component = that.$();
    var thousandsep = that.progressthousandseparator();
    var decimalsep = that.progressdecimalseparator();

    //To Avoid offset working even after disabling tile in axis
    var offsetaxis = function(titledisplay, titleoffset, titletext) {
      if (titleoffset == "" || titletext === " ") {
        //jshint ignore:line
        return null;
      } else if (titledisplay === true) {
        return titleoffset;
      } else {
        return null;
      }
    };
    //resolving ternaries here *phew*
    var tmarginBottom = null;
    var tmarginLeft = null;
    var tmarginRight = null;
    var tmarginTop = null;
    var tspacingBottom = null;
    var tspacingLeft = null;
    var tspacingRight = null;
    var tspacingTop = null;

    var tXCeiling = _.parseInt(that.xaxisceiling(), 10);
    var tXFloor = _.parseInt(that.xaxisfloor(), 10);
    var tXMin = _.parseInt(that.xaxismin(), 10);
    var tXMax = _.parseInt(that.xaxismax(), 10);
    var tXMaxPadding = _.parseInt(that.xaxismaxpadding(), 10);
    var tXMinPadding = _.parseInt(that.xaxisminpadding(), 10);
    var tXStaggerLines = _.parseInt(that.xaxislabelstaggerline(), 10);
    var tXMaxStaggerLines = _.parseInt(that.xaxislabelmaxstaggerline(), 10);
    var tXDisplay = "none";
    var tXColor = null;
    var tXBorderColor = null;
    var tXDisplayBand = "none";
    var tXXBand = _.parseInt(that.xaxisplotbandlabelxposition(), 10);
    var tXYBand = _.parseInt(that.xaxisplotbandlabelyposition(), 10);
    var tXDisplayLine = "none";
    var tXLineColor = null;
    var tXXLine = _.parseInt(that.xaxisplotlinelabelxposition(), 10);
    var tXYLine = _.parseInt(that.xaxisplotlinelabelyposition(), 10);

    var tYMinorTickInterval = _.parseInt(that.yaxisminortickinterval(), 10);
    var tYTickInterval = _.parseInt(that.yaxistickinterval(), 10);
    var tYCeling = _.parseInt(that.yaxisceiling(), 10);
    var tYFloor = _.parseInt(that.yaxisfloor(), 10);
    var tYMaxPadding = parseFloat(that.yaxismaxpadding(), 10);
    var tYMinPadding = parseFloat(that.yaxisminpadding(), 10);
    var tYStaggerLines = _.parseInt(that.yaxislabelstaggerline(), 10);
    var tYMaxStaggerLines = _.parseInt(that.yaxislabelmaxstaggerline(), 10);
    var tYDisplay = "none";
    var tYColorBand = null;
    var tYBorderColorBand = null;
    var tYDisplayBand = "none";
    var tYXBand = _.parseInt(that.yaxisplotbandlabelxposition(), 10);
    var tYYBand = _.parseInt(that.yaxisplotbandlabelyposition(), 10);
    var tYColorLine = null;
    var tYDisplayLine = "none";
    var tYXLine = _.parseInt(that.yaxisplotlinelabelxposition(), 10);
    var tYYLine = _.parseInt(that.yaxisplotlinelabelyposition(), 10);
    var tFontFamily = that.datalabelfontfamily();

    var tplotBackgroundColor = that.plotbackgroundcolor();

    if (that.chartmarginbottom() !== "auto") {
      tmarginBottom = _.parseInt(that.chartmarginbottom(), 10);
    }

    if (that.chartmarginleft() !== "auto") {
      tmarginLeft = _.parseInt(that.chartmarginleft(), 10);
    }

    if (that.chartmarginright() !== "auto") {
      tmarginRight = _.parseInt(that.chartmarginright(), 10);
    }

    if (that.chartmargintop() !== "auto") {
      tmarginTop = _.parseInt(that.chartmargintop(), 10);
    }

    if (that.chartpaddingbottom() !== "auto") {
      tspacingBottom = _.parseInt(that.chartpaddingbottom(), 10);
    }

    if (that.chartpaddingleft() !== "auto") {
      tspacingLeft = _.parseInt(that.chartpaddingleft(), 10);
    }

    if (that.chartpaddingright() !== "auto") {
      tspacingRight = _.parseInt(that.chartpaddingright(), 10);
    }

    if (that.chartpaddingtop() !== "auto") {
      tspacingTop = _.parseInt(that.chartpaddingtop(), 10);
    }

    if (that.plottransparency() === true) {
      tplotBackgroundColor = "transparent";
    }

    //ceiling: that.xaxisceiling() === "" ? null : _.parseInt(that.xaxisceiling()),
    if (that.xaxisceiling() === "") {
      tXCeiling = null;
    }

    //floor: that.xaxisfloor() === "" ? null : _.parseInt(that.xaxisfloor()),
    if (that.xaxisfloor() === "") {
      tXFloor = null;
    }

    //min: that.xaxismin() === "" ? null : _.parseInt(that.xaxismin()),
    if (that.xaxismin() === "") {
      tXMin = null;
    }

    //max: that.xaxismax() === "" ? null : _.parseInt(that.xaxismax()),
    if (that.xaxismax() === "") {
      tXMax = null;
    }

    //maxPadding: that.xaxismaxpadding() === "" ? null : _.parseInt(that.xaxismaxpadding()),
    if (that.xaxismaxpadding() === "") {
      tXMaxPadding = null;
    }

    //minPadding: that.xaxisminpadding() === "" ? null : _.parseInt(that.xaxisminpadding()),
    if (that.xaxisminpadding() === "") {
      tXMinPadding = null;
    }

    //staggerLines: that.xaxislabelstaggerline() === "" ? null : _.parseInt(that.xaxislabelstaggerline()),
    if (that.xaxislabelstaggerline() === "") {
      tXStaggerLines = null;
    }

    //maxStaggerLines: that.xaxislabelmaxstaggerline() === "" ? null : _.parseInt(that.xaxislabelmaxstaggerline()),
    if (that.xaxislabelmaxstaggerline() === "") {
      tXMaxStaggerLines = null;
    }

    //display: that.xaxistitleenabled() === true ? "block" : "none"
    if (that.xaxistitleenabled() === true) {
      tXDisplay = "block";
    }

    //color: that.xaxisplotbandenabled() === true ? that.xaxisplotbandcolor() : null,
    if (that.xaxisplotbandenabled() === true) {
      tXColor = that.xaxisplotbandcolor();
    }

    //borderColor: that.xaxisplotbandenabled() === true ? that.xaxisplotbandbordercolor() : null,
    if (that.xaxisplotbandenabled() === true) {
      tXBorderColor = that.xaxisplotbandbordercolor();
    }

    //display: that.xaxisplotbandlabelenabled() === true ? "block" : "none"
    if (that.xaxisplotbandlabelenabled() === true) {
      tXDisplayBand = "block";
    }

    //x: that.xaxisplotbandlabelxposition() === "null" ? null : _.parseInt(that.xaxisplotbandlabelxposition()),
    if (that.xaxisplotbandlabelxposition() === "null") {
      tXXBand = null;
    }

    //y: that.xaxisplotbandlabelyposition() === "" ? null : _.parseInt(that.xaxisplotbandlabelyposition())
    if (that.xaxisplotbandlabelyposition() === "") {
      tXYBand = null;
    }

    //display: that.xaxisplotlinelabelenabled() === true ? "block" : "none"
    if (that.xaxisplotlinelabelenabled() === true) {
      tXDisplayLine = "block";
    }

    //color: that.xaxisplotlineenabled() === true ? that.xaxisplotlinecolor() : null,
    if (that.xaxisplotlineenabled() === true) {
      tXLineColor = that.xaxisplotlinecolor();
    }

    //x: that.xaxisplotlinelabelxposition() === "null" ? null : _.parseInt(that.xaxisplotlinelabelxposition()),
    if (that.xaxisplotlinelabelxposition() === "null") {
      tXXLine = null;
    }

    //y: that.xaxisplotlinelabelyposition() === "null" ? null : _.parseInt(that.xaxisplotlinelabelyposition())
    if (that.xaxisplotlinelabelyposition() === "null") {
      tXYLine = null;
    }

    //minorTickInterval: that.yaxisminortickinterval() === "" ? "auto" : _.parseInt(that.yaxisminortickinterval()),
    if (that.yaxisminortickinterval() === "") {
      tYMinorTickInterval = "auto";
    }

    //tickInterval: that.yaxistickinterval() === "" ? null : _.parseInt(that.yaxistickinterval()),
    if (that.yaxistickinterval() === "") {
      tYTickInterval = null;
    }

    //ceiling: that.yaxisceiling() === "" ? null : _.parseInt(that.yaxisceiling()),
    if (that.yaxisceiling() === "") {
      tYCeling = null;
    }

    //floor: that.yaxisfloor() === "" ? null : _.parseInt(that.yaxisfloor()),
    if (that.yaxisfloor() === "") {
      tYFloor = null;
    }

    //maxPadding: that.yaxismaxpadding() === "" ? null : parseFloat(that.yaxismaxpadding()),
    if (that.yaxismaxpadding() === "") {
      tYMaxPadding = null;
    }

    //minPadding: that.yaxisminpadding() === "" ? null : parseFloat(that.yaxisminpadding()),
    if (that.yaxisminpadding() === "") {
      tYMinPadding = null;
    }

    //staggerLines: that.yaxislabelstaggerline() === "" ? null : _.parseInt(that.yaxislabelstaggerline()),
    if (that.yaxislabelstaggerline() === "") {
      tYStaggerLines = null;
    }

    //maxStaggerLines: that.yaxislabelmaxstaggerline() === "" ? null : _.parseInt(that.yaxislabelmaxstaggerline()),
    if (that.yaxislabelmaxstaggerline() === "") {
      tYMaxStaggerLines = null;
    }

    //display: that.yaxistitleenabled() === true ? "block" : "none"
    if (that.yaxistitleenabled() === true) {
      tYDisplay = "block";
    }

    //color: that.yaxisplotbandenabled() === true ? that.yaxisplotbandcolor() : null,
    if (that.yaxisplotbandenabled() === true) {
      tYColorBand = that.yaxisplotbandcolor();
    }

    //borderColor: that.yaxisplotbandenabled() === true ? that.yaxisplotbandbordercolor() : null,
    if (that.yaxisplotbandenabled() === true) {
      tYBorderColorBand = that.yaxisplotbandbordercolor();
    }

    //display: that.yaxisplotbandlabelenabled() === true ? "block" : "none"
    if (that.yaxisplotbandlabelenabled() === true) {
      tYDisplayBand = "block";
    }

    //x: that.yaxisplotbandlabelxposition() === "null" ? null : _.parseInt(that.yaxisplotbandlabelxposition()),
    if (that.yaxisplotbandlabelxposition() === "null") {
      tYXBand = null;
    }

    //y: that.yaxisplotbandlabelyposition() === "null" ? null : _.parseInt(that.yaxisplotbandlabelyposition())
    if (that.yaxisplotbandlabelyposition() === "null") {
      tYYBand = null;
    }

    //color: that.yaxisplotlineenabled() === true ? that.yaxisplotlinecolor() : null,
    if (that.yaxisplotlineenabled() === true) {
      tYColorLine = that.yaxisplotlinecolor();
    }

    //display: that.yaxisplotlinelabelenabled() === true ? "block" : "none"
    if (that.yaxisplotlinelabelenabled() === true) {
      tYDisplayLine = "block";
    }

    //x: that.yaxisplotlinelabelxposition() === "null" ? null : _.parseInt(that.yaxisplotlinelabelxposition()),
    if (that.yaxisplotlinelabelxposition() === "null") {
      tYXLine = null;
    }

    //y: that.yaxisplotlinelabelyposition() === "null" ? null : _.parseInt(that.yaxisplotlinelabelyposition())
    if (that.yaxisplotlinelabelyposition() === "null") {
      tYYLine = null;
    }

    //fontFamily: that.globalfont() === true ? that.fontfamily() : that.datalabelfontfamily()
    if (that.globalfont() === true) {
      tFontFamily = that.fontfamily();
    }
    var defaultValue = {
      chart: {
        type: "column",
        inverted: that.fixedcolumncharttype() == "column",
        //alignTicks:that.chartalignticks(),//applicable in multiple axes
        className: that.chartcssclassname(),
        events: {
          click: function(event) {
            lassoObj.unselectByClick.call(this, that);
            if (event.target.textContent === "") {
              that.fireEvent("chartonclick");
            }
          },

          load: function() {
            if (vbiContextMenu) {
              vbiContextMenu.highchartsPostProcess();
            }
            //The If condition is fire the charafterload event only once - Fix 1200
            if (!isLoad) {
              that.fireEvent("chartafterload");
              isLoad = true;
            }

            if (that.creditsenabled() === true) {
              this.credits.element.onclick = function() {
                window.open(
                  that.creditshref(),
                  "_blank" // <- This is what makes it open in a new window.
                );
              };
            }
          },

          selection: function(e) {
            var retVal = lassoObj.selectPointsByDrag.call(this, e, that);
            if (this.lasso === "lasso" || this.lasso === "rlasso") {
              that.fireEvent("chartonpointclick");
            } else {
              if (e.xAxis) {
                that.fireEvent("chartonselect"); //disabling the fireEvent while zoom out.
              }
            }

            return retVal;
          }
        },
        ignoreHiddenSeries: that.ignorehiddenseries(),
        marginBottom: tmarginBottom,
        marginLeft: tmarginLeft,
        marginRight: tmarginRight,
        marginTop: tmarginTop,
        spacingBottom: tspacingBottom,
        spacingLeft: tspacingLeft,
        spacingRight: tspacingRight,
        spacingTop: tspacingTop,
        //spacingLeft: 100,
        pinchType: that.chartpinchtype(),
        zoomType: that.chartzoomtype(),
        panning: that.chartpanning(),
        panKey: that.chartpankey(),
        plotShadow: that.plotshadow(),
        reflow: that.chartflow() || false,
        shadow: that.chartshadow(),
        showaxes: that.showaxes(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            //relativeTo:that.zoombuttonrelativeto(),
            verticalAlign: that.zoombuttonverticalalign()
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: {
              color: that.resetzoombuttontextcolor()
            },
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: {
                  color: that.resetzoombuttonhovertextcolor()
                }
              }
            }
          }
        },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor: tplotBackgroundColor,
        plotBackgroundImage: that.plotbackgroundimage(),
        plotBorderColor: that.plotbordercolor(),
        plotBorderWidth: that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor()
      },
      title: vbiHighchartsDefault.createDefaultObjects("commonTitle", that),
      subtitle: vbiHighchartsDefault.createDefaultObjects("commonSubtitle", that),
      credits: vbiHighchartsDefault.createDefaultObjects("commonCredits", that),
      exporting: vbiHighchartsDefault.createDefaultObjects(
        "commonExporting",
        that
      ),
      navigation: vbiHighchartsDefault.createDefaultObjects(
        "commonNavigation",
        that
      ),
      xAxis: {
        categories: ["Seattle HQ", "San Francisco", "Tokyo"],
        allowDecimals: that.xaxisallowdecimals(),
        alternateGridColor: that.xaxisalternategridcolor(),
        gridLineColor: that.xaxisgridlinecolor(),
        gridLineDashStyle: that.xaxisgridlinedashstyle(),
        gridLineWidth: that.xaxisgridlinewidth(),
        gridZIndex: that.xaxisgridzindex(),
        ceiling: tXCeiling,
        floor: tXFloor,
        lineColor: that.xaxislinecolor(),
        lineWidth: that.xaxislinewidth(),
        minRange: that.xaxisminrange(),
        min: tXMin,
        max: tXMax,
        maxPadding: tXMaxPadding,
        minPadding: tXMinPadding,
        opposite: that.xaxisopposite(),
        offset: that.xaxisoffset(),
        reversed: that.xaxisreversed() === true,
        showEmpty: that.xaxisshowempty(),
        showFirstLabel: that.xaxisshowfirstlabel(),
        showLastLabel: that.xaxisshowlastlabel(),
        dateTimeLabelFormats: {},
        minTickInterval: that.xaxismintickinterval(),
        //startOnTick: that.xaxisstartontick(),
        //endOnTick: that.xaxisendontick(),
        tickColor: that.xaxistickcolor(),
        tickInterval: that.xaxistickinterval(),
        tickLength: that.xaxisticklength(),
        tickPosition: that.xaxistickposition(),
        tickWidth: that.xaxistickwidth(),
        tickmarkPlacement: that.xaxistickmarkplacement(),
        labels: {
          reserveSpace: that.xaxisreservespace(),
          align: that.xaxislabelalign(),
          enabled: that.xaxislabelenabled(),
          format:
            that.xaxislabelprefix() +
            that.xaxislabelformat() +
            that.xaxislabelsuffix(),
          //overflow:that.xaxislabeloverflow(),
          rotation: that.xaxislabelrotation(),
          //distance:that.xaxislabeldistance(),
          staggerLines: tXStaggerLines,
          maxStaggerLines: tXMaxStaggerLines,
          step: that.xaxislabelstep(),
          x: that.xaxislabelx(),
          y: that.xaxislabely(),
          zIndex: that.xaxislabelzindex(),
          style: {
            color: that.xaxislabelcolor(),
            fontWeight: that.xaxislabelfontweight(),
            textDecoration: that.xaxislabelfontweight(),
            fontSize: that.xaxislabelfontsize() + "px",
            fontFamily: that.xaxislabelfontfamily()
          },
          events: {
            click: function() {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        title: {
          text: that.xaxistitletext(),
          align: that.xaxistitlealign(),
          rotation: that.xaxistitlerotation(),
          offset: offsetaxis(
            that.xaxistitleenabled(),
            that.xaxistitleoffset(),
            that.xaxistitletext()
          ),
          margin: that.xaxistitlemargin(),
          style: {
            color: that.xaxistitlecolor(),
            fontWeight: that.xaxistitlefontweight(),
            textDecoration: that.xaxistitlefontweight(),
            fontSize: that.xaxistitlefontsize() + "px",
            fontFamily: that.xaxistitlefontfamily(),
            display: tXDisplay
          }
        },
        plotBands: [
          {
            /* style:{
                      :that.xaxisplotbandenabled()==true?"block":"none"
                  */
            color: tXColor,
            borderColor: tXBorderColor,
            borderWidth: that.xaxisplotbandborderwidth(),
            from: that.xaxisplotbandfrom() - 0.5,
            to: that.xaxisplotbandto() + 0.5,
            zIndex: that.xaxisplotbandzindex(),
            events: {
              click: function() {
                that.fireEvent("xaxisplotbandonclick");
              }
            },
            label: {
              style: {
                color: that.xaxisplotbandlabelcolor(),
                fontWeight: that.xaxisplotbandlabelfontweight(),
                textDecoration: that.xaxisplotbandlabelfontweight(),
                fontSize: that.xaxisplotbandlabelfontsize() + "px",
                fontFamily: that.xaxisplotbandlabelfontfamily(),
                display: tXDisplayBand
              },
              text: that.xaxisplotbandlabeltext(),
              align: that.xaxisplotbandlabelalign(),
              rotation: that.xaxisplotbandlabelrotation(),
              textAlign: that.xaxisplotbandlabeltextalign(),
              //useHTML:that.xaxisplotbandlabelusehtml(),
              verticalAlign: that.xaxisplotbandlabelverticalalign(),
              x: tXXBand,
              y: tXYBand
            }
          }
        ],
        plotLines: [
          {
            color: tXLineColor,
            dashStyle: that.xaxisplotlinedashstyle(),
            width: that.xaxisplotlinewidth(),
            value: that.xaxisplotlinevalue(),
            zIndex: that.xaxisplotlinezindex(),
            label: {
              style: {
                color: that.xaxisplotlinelabelcolor(),
                fontWeight: that.xaxisplotlinelabelfontweight(),
                textDecoration: that.xaxisplotlinelabelfontweight(),
                fontSize: that.xaxisplotlinelabelfontsize() + "px",
                fontFamily: that.xaxisplotlinelabelfontfamily(),
                display: tXDisplayLine
              },
              text: that.xaxisplotlinelabeltext(),
              align: that.xaxisplotlinelabelalign(),
              rotation: that.xaxisplotlinelabelrotation(),
              textAlign: that.xaxisplotlinelabeltextalign(),
              verticalAlign: that.xaxisplotlinelabelverticalalign(),
              x: tXXLine,
              y: tXYLine
            }
          }
        ]
      },
      yAxis: {
        allowDecimals: that.yaxisallowdecimals(),
        alternateGridColor: that.yaxisalternategridcolor(),
        gridLineColor: that.yaxisgridlinecolor(),
        gridLineDashStyle: that.yaxisgridlinedashstyle(),
        gridLineWidth: that.yaxisgridlinewidth(),
        gridZIndex: that.yaxisgridzindex(),
        lineColor: that.yaxislinecolor(),
        lineWidth: that.yaxislinewidth(),
        minTickInterval: that.yaxismintickinterval(),
        minorGridLineColor: that.yaxisminorgridlinecolor(),
        minorGridLineDashStyle: that.yaxisminorgridlinedashstyle(),
        minorGridLineWidth: that.yaxisminorgridlinewidth(),
        minorTickColor: that.yaxisminortickcolor(),
        minorTickInterval: tYMinorTickInterval,
        minorTickLength: that.yaxisminorticklength(),
        minorTickPosition: that.yaxisminortickposition(),
        minorTickWidth: that.yaxisminortickwidth(),
        tickColor: that.yaxistickcolor(),
        tickInterval: tYTickInterval,
        tickLength: that.yaxisticklength(),
        tickPosition: that.yaxistickposition(),
        tickWidth: that.yaxistickwidth(),
        tickmarkPlacement: that.yaxistickmarkplacement(),
        dateTimeLabelFormats: {},
        ceiling: tYCeling,
        floor: tYFloor,
        min: that.yaxismin() === "" ? null : _.parseInt(that.yaxismin()),
        max: that.yaxismax() === "" ? null : _.parseInt(that.yaxismax()),
        maxPadding: tYMaxPadding,
        minPadding: tYMinPadding,
        minRange: that.yaxisminrange(),
        offset: that.yaxisoffset(),
        opposite: that.yaxisopposite(),
        reversed: that.yaxisreversed() === true,
        showEmpty: that.yaxisshowempty(),
        showFirstLabel: that.yaxisshowfirstlabel(),
        showLastLabel: that.yaxisshowlastlabel(),
        //          startOnTick: that.yaxisstartontick(),
        //          endOnTick: that.yaxisendontick(),
        labels: {
          align: that.yaxislabelalign(),
          enabled: that.yaxislabelenabled(),
          formatter: function() {
            return vbiHighchartsDefault["Yaxis_autoscale_formatter"](that, this);
          },
          rotation: that.yaxislabelrotation(),
          staggerLines: tYStaggerLines,
          maxStaggerLines: tYMaxStaggerLines,
          step: that.yaxislabelstep(),
          x: that.yaxislabelx(),
          y: that.yaxislabely(),
          zIndex: that.yaxislabelzindex(),
          style: {
            color: that.yaxislabelcolor(),
            fontWeight: that.yaxislabelfontweight(),
            textDecoration: that.yaxislabelfontweight(),
            fontSize: that.yaxislabelfontsize() + "px",
            fontFamily: that.yaxislabelfontfamily()
          },
          events: {
            click: function() {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        title: {
          text: that.yaxistitletext(),
          align: that.yaxistitlealign(),
          rotation: that.yaxistitlerotation(),
          offset: offsetaxis(
            that.yaxistitleenabled(),
            that.yaxistitleoffset(),
            that.yaxistitletext()
          ),
          margin: that.yaxistitlemargin(),
          style: {
            color: that.yaxistitlecolor(),
            fontWeight: that.yaxistitlefontweight(),
            textDecoration: that.yaxistitlefontweight(),
            fontSize: that.yaxistitlefontsize() + "px",
            fontFamily: that.yaxistitlefontfamily(),
            display: tYDisplay
          }
        },
        plotBands: [
          {
            color: tYColorBand,
            borderColor: tYBorderColorBand,
            borderWidth: that.yaxisplotbandborderwidth(),
            from: that.yaxisplotbandfrom(),
            to: that.yaxisplotbandto(),
            zIndex: that.yaxisplotbandzindex(),
            events: {
              click: function() {
                that.fireEvent("yaxisplotbandonclick");
              }
            },
            label: {
              style: {
                color: that.yaxisplotbandlabelcolor(),
                fontWeight: that.yaxisplotbandlabelfontweight(),
                textDecoration: that.yaxisplotbandlabelfontweight(),
                fontSize: that.yaxisplotbandlabelfontsize() + "px",
                fontFamily: that.yaxisplotbandlabelfontfamily(),
                display: tYDisplayBand
              },
              text: that.yaxisplotbandlabeltext(),
              align: that.yaxisplotbandlabelalign(),
              rotation: that.yaxisplotbandlabelrotation(),
              textAlign: that.yaxisplotbandlabeltextalign(),
              verticalAlign: that.yaxisplotbandlabelverticalalign(),
              x: tYXBand,
              y: tYYBand
            }
          }
        ],
        plotLines: [
          {
            color: tYColorLine,
            dashStyle: that.yaxisplotlinedashstyle(),
            width: that.yaxisplotlinewidth(),
            value: that.yaxisplotlinevalue(),
            zIndex: that.yaxisplotlinezindex(),
            label: {
              verticalAlign: that.yaxisplotlinelabelverticalalign(),
              style: {
                color: that.yaxisplotlinelabelcolor(),
                fontWeight: that.yaxisplotlinelabelfontweight(),
                textDecoration: that.yaxisplotlinelabelfontweight(),
                fontSize: that.yaxisplotlinelabelfontsize() + "px",
                fontFamily: that.yaxisplotlinelabelfontfamily(),
                display: tYDisplayLine
              },
              text: that.yaxisplotlinelabeltext(),
              align: that.yaxisplotlinelabelalign(),
              rotation: that.yaxisplotlinelabelrotation(),
              textAlign: that.yaxisplotlinelabeltextalign(),
              x: tYXLine,
              y: tYYLine
            }
          }
        ]
      },
      loading: vbiHighchartsDefault.createDefaultObjects("commonLoading", that),
      tooltip: {
        useHTML: true,
        animation: that.tooltipanimation() || false,
        crosshairs: that.tooltipcrosshair(),
        enabled: that.tooltipenable(),
        followPointer: that.tooltipfollowpointer(),
        followTouchMove: that.tooltipfollowtouchmove(),
        hideDelay: that.tooltiphidedelay(),
        shadow: that.tooltipshadow(),
        shape: that.tooltipshape(),
        shared: that.tooltipshared(),
        snap: that.tooltipsnap(),
        valueDecimals: that.tooltipvaluedecimals(),
        valuePrefix: that.tooltipvalueprefix(),
        valueSuffix: that.tooltipvaluesuffix(),
        headerFormat:
          '<p style="display:block;line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em">{point.key}</p>',
        backgroundColor: that.tooltipbackgroundcolor(),
        borderColor: that.tooltipbordercolor(),
        borderRadius: that.tooltipborderradius(),
        borderWidth: that.tooltipborderwidth(),
        //  formatter: function() {
        //      return seriesLibrary.barFamilyTooltip(this,that,decimalseptool,thousandseptool);
        //     },

        style: {
          color: that.tooltipcolor(),
          fontWeight: that.tooltipfontweight(),
          textDecoration: that.tooltipfontweight(),
          fontSize: that.tooltipfontsize() + "px",
          fontFamily: that.tooltipfontfamily()
        }
      },
      legend: vbiHighchartsDefault.createDefaultObjects("commonLegend", that),
      plotOptions: {
        series: {
          cursor: "pointer",
          minPointLength: that.minimumpointlength(),
          point: {
            events: {
              click: function(event) {
                try {
                  that.selectedvalue(
                    seriesLibrary.createMemberData(
                      that,
                      that.categoriesIndex[event.point.index],
                      event.point.series.options.key
                    )
                  );
                } catch (e) {}
              },

              select: function() {
                if (!this.series.chart.lassoFlag) {
                  try {
                    if (that.chartenablezoom()) {
                      that.selectedPoints = $("#detail-container" + that.id())
                        .highcharts()
                        .getSelectedPoints();
                    } else {
                      that.selectedPoints = component.highcharts().getSelectedPoints();
                    }
                    that.selectedPoints.push(this);
                    that.selectedvalues(
                      seriesLibrary
                        .createMembersData(
                          that,
                          that.categoriesIndex,
                          that.selectedPoints
                        )
                        .toString()
                    );
                    seriesLibrary.onSelectFunction(that);
                  } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                  }
                }
                /**
                               *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                               **/
              },

              unselect: function() {
                if (!this.series.chart.lassoFlag) {
                  try {
                    // var unselectedPoints;
                    // if (that.chartenablezoom()){
                    // unselectedPoints = $("#detail-container" + that.id() + "").highcharts().getSelectedPoints();
                    // } else {
                    // unselectedPoints = component.highcharts().getSelectedPoints();
                    // }
                    var index = that.selectedPoints.indexOf(this);
                    if (index > -1) {
                      that.selectedPoints.splice(index, 1);
                    }
                    that.selectedvalues(
                      seriesLibrary
                        .createMembersData(
                          that,
                          that.categoriesIndex,
                          that.selectedPoints
                        )
                        .toString()
                    );
                    if (that.selectedvalues() === "") {
                      that.selectedvalue("");
                    } else {
                      var select = seriesLibrary.createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints
                      );
                      that.selectedvalue(select[0]);
                    }
                    /**
                                       *Selectedvalue fix in all charts
                                       *Multiple Selection getting the last selected value.
                                       **/
                    if (that.clearSelect) {
                      if (that.selectedvalues() === "") {
                        that.clearSelect = false;
                      }
                    } else {
                      seriesLibrary.onSelectFunction(that);
                    } //clearselection callback issue on Onselect.
                  } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                  }
                  /**
                                   *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                                   **/
                }
              }
            }
          },
          //pointPlacement:that.xaxistickmarkplacement(),
          borderWidth: 0,
          grouping: false,
          allowPointSelect: that.allowpointselect(),
          connectNulls: that.connectnulls(),
          cropThreshold: that.cropthreshold(),
          turboThreshold: that.turbothreshold(),
          dataLabels: {
            enabled: that.datalabelenabled(),
            align: that.datalabelalign(),
            crop: that.datalabelcrop(),
            //defer: that.datalabeldefer(),
            backgroundColor: that.datalabelbackgroundcolor(),
            useHTML: false,
            borderColor: that.datalabelbordercolor(),
            borderRadius: that.datalabelborderradius(),
            borderWidth: that.datalabelborderwidth(),
            padding: that.datalabelpadding(),
            rotation: that.datalabelrotation(),
            shadow: that.datalabelshadow(),
            verticalAlign: that.datalabelverticalalign(),
            inside: that.datalabelinside(),
            x: that.datalabelx(),
            y: that.datalabely(),
            formatter: function() {
              if (
                that.customdatalabel() !== "" &&
                Object.keys(JSON.parse(that.customdatalabel() || "{}")).length &&
                this.point.series.name.toLocaleLowerCase().indexOf("result") ==
                  -1 &&
                this.key.name.toLocaleLowerCase().indexOf("result") == -1
              ) {
                return vbiNumberFormat.barFamilyFormatterDataLabel(
                  this,
                  that,
                  decimalsep,
                  thousandsep,
                  false
                );
              } else {
                return vbiNumberFormat.barFamilyDataLabelFormatter(
                  this,
                  that,
                  decimalsep,
                  thousandsep,
                  false
                );
              }
            },

            style: {
              textShadow: false,
              color: that.datalabeltextcolor(),
              fontWeight: that.datalabelfontweight(),
              textDecoration: that.datalabelfontweight(),
              fontSize: that.datalabelfontsize() + "px",
              fontFamily: tFontFamily
            }
          },
          marker: {}
        }
      },
      series: [
        {
          data: that.newseries
        }
      ]
    };
    return defaultValue;
  };

  this.attachGetters=function(component,options){

    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    //Measure validation function for errorbar to check whether measure is in row and if the column contains more than two dimension
    component.measureValidation = function () {
        var returnValue = false;
        var measureinrow = false;
        try {
            for (ix = 0; ix < component.result().dimensions.length; ix += 1) {
                if (component.result().dimensions[ix].containsMeasures === true && component.result().dimensions[ix].axis === "ROWS") {
                    measureinrow = true;
                }
            }

            if (measureinrow === true) {
                returnValue = false;
            } else {
                returnValue = true;
            } //return true;
        } catch (e) {
            seriesLibrary.DSXalert(e.message);
        }
        return returnValue + ""; //callruntime handler won"t handle object and boolean hence return string
    };

    component.createIdentical = function (defaultValue) {
        var entireData = [];
        for (ix = 0; ix < defaultValue.series.length; ix += 1) {
      if(defaultValue.series[ix].data){
            for (jy = 0; jy < defaultValue.series[ix].data.length; jy += 1) {
                entireData.push(defaultValue.series[ix].data[jy].y || 0);
            }
      }
        }

        if (entireData.length > 0) {

            component.minimumValue = entireData.reduce(function (p, v) {
                if (p < v) {
                    return p;
                }
                return v;
            });

            component.maximumValue = entireData.reduce(function (p, v) {
                if (p > v) {
                    return p;
                }
                return v;
            });

            if (component.maximumValue === undefined) {
                component.minimumValue = 0;
                component.maximumValue = 250;
            }
            /*
             * If no data-source selected.
             */
            var listGroup = component.list();
            var restart = component.chartRestart();
            var customMin = component.groupingyaxismin();
            var customMax = component.groupingyaxismax();
            var testingArrayTemp = component.testingArray();
            var minimumVal = Math.floor(component.minimumValue).toFixed(component.datavaluedecimals());
            var maximumVal = Math.ceil(component.maximumValue).toFixed(component.datavaluedecimals());
            var datasourceAssigned = component.DATA_SOURCE_ALIAS_REF();
            var chartId = component.id();
            if ((WhatIfLibrary != undefined) && (listGroup != "" || restart != 0)) { /* jshint ignore: line */
                WhatIfLibrary.register(chartId, {
                    type: "Chart",
                    name: "Fixed Placement Chart",
                    category: "charts",
                    'data_source': datasourceAssigned,
                    'custom_function': {
                        'custom_id_min_value': minimumVal,
                        'custom_id_max_value': maximumVal,
                        'custom_id_groupId': testingArrayTemp,
                        'custom_id_SelectedValue': listGroup,
                        'custom_id_min': customMin,
                        'custom_id_max': customMax
                    }
                }, component);
            }
            /*
             * Getting the minimum and maximum value and pushing it to whatifAnalyser(updating).
             * and also grouping name.
             */
            component.globalVal.push("None");
            var localTest;
            Object.keys(WhatIfLibrary.charts).forEach(function (obj) {
                if (WhatIfLibrary.charts[obj]['custom_function'] !== undefined) {
                    var gettingArray = WhatIfLibrary.charts[obj]['custom_function']['custom_id_groupId'];
                    for (jy = 0; jy < gettingArray.split(",").length; jy += 1) {
                        localTest = gettingArray.split(",");
                        if (component.globalVal.indexOf(localTest[jy]) === -1) {
                            component.globalVal.push(localTest[jy]);
                        }
                    }
                }
            });

            //var tempMax = component.minimumValue;
            //var tempMin = component.maximumValue;
            seriesLibrary.creatIndenticalScaling(component, defaultValue, minimumVal, maximumVal, WhatIfLibrary);
            //identicalScaling Fix
            if (listGroup != "" || restart != 0) { // jshint ignore:line
                if (listGroup !== "None") {
                    componentUtil.callHighCharts(component,component, defaultValue,{dependencyObject:dependencyObject,seriesData:seriesData});//jshint ignore:line
                }
            }
        } //To stop the events
    };

    component.getDropdownName = function () {
        return component.list();
    };

    component.getDataSeries = function () {
        var dataSeries = [];
        var seriesNames = [];
        var seriesKeyNames = [];
        //component.dataRes = component.dispKeyTextResultSet();
        var bardatacustomizationJson = {
            "COLUMNS": [],
            "ROWS": []
        };
        if (component.bardatacustomization() !== "") {
            bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
        }

        try {
            if (component.dataRes === undefined || component.dataRes === "") {
                return null;
            }
            if (component.datautility() === true && bardatacustomizationJson.COLUMNS.length === 0 && bardatacustomizationJson.ROWS.length === 0) {
                return null;
            }

            if (component.dataRes.dimensions.length === 1 && component.dataRes.dimensions[0].containsMeasures === true) {
                var defaultColor = [
                    "#B586DA",
                    "#FF6657",
                    "#F3A730",
                    "#946B66",
                    "#B0AD53",
                    "#7AC1DE",
                    "#F1C337",
                    "#566C6C",
                    "#A1CC54",
                    "#543F1E"
                ];
                var seriesColor = [];
                if (component.dataseriescolor() === "" || component.dataseriescolor() === undefined) {
                    seriesColor = [];
                } else {
                    seriesColor = seriesColor.concat(component.dataseriescolor().split(","));
                }

                if (component.dataRes.dimensions[0].axis === "COLUMNS") {
                    for (ix = 0; ix < component.dataRes.dimensions[0].members.length; ix += 1) {
                        seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
                        seriesNames.push(component.dataRes.dimensions[0].members[ix]['picker_text']);
                        seriesKeyNames.push(component.dataRes.dimensions[0].members[ix].key);
                    }
                } else {
                    seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
                    seriesNames.push("Measures");
                    seriesKeyNames.push("Measures");
                }

                dataSeries = [
                    seriesNames,
                    seriesKeyNames
                ];
                seriesColor.splice(dataSeries[0].length, seriesColor.length);
                component.dataseriescolor(seriesColor.join());
            } else {
                //  dataSeries = seriesLibrary.createSeriesData(component, "bar", defaultValueSeriesNames,"ncf");
                dataSeries = seriesLibrary.createSeriesAdditionalProperty(component, "bar");
            }
        } catch (e) {
            seriesLibrary.DSXalert(e.message);
        }

        return dataSeries;
    };

    component.getDataSeriesColor = function () {
        var dataseriescolor = "";
        try {
            dataseriescolor = component.dataseriescolor();
        } catch (e) {
            seriesLibrary.DSXalert(e.message);
        }

        return dataseriescolor;
    };

    component.getDatUtility = function () {
        var datautility = "";
        try {
            datautility = component.datautility();
        } catch (e) {
            seriesLibrary.DSXalert(e.message);
        }

        return datautility;
    };

    component.getChartType = function () {
        return "bar";
    };

    component.getChartNames = function () {
        return component.globalVal;
    };

    component.getDataLengthVal = function () {
        return JSON.stringify(component.result());
    };

    component.isMeasureOnly = function () {
        var len = 0;
        if (component.result() !== undefined && component.result() !== "") {
            try {
                len = component.result().dimensions.length;
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }
        }

        return len;
    };

    component.getMeasuresNamesForFormatter = function(){
      return vbiNumberFormat.getMeasuresNamesForFormatter(component);
    };

    component.getDimensionList = function () {
        // var dimlist =[];
        var dimname = [];
        var dimindex = [];
        if (component.result() !== undefined && component.result() !== "") {
            try {
                for (ix = 0; ix < component.result().dimensions.length; ix += 1) {
                    if (component.dataRes.dimensions[ix].axis === "ROWS" && component.dataRes.dimensions[ix].containsMeasures !== true) {
                        dimname.push(component.result().dimensions[ix].text);
                        dimindex.push(ix);
                    }
                }
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }
        }

        return [
            dimname,
            dimindex
        ];
    };

    component.getDimensionAndMeasure = function () {
        var dimensionAndMeasure = [];
        if (component.dataRes !== undefined && component.dataRes !== "") {
            // if (component.dataRes !== undefined && component.dataRes !== "")
            for (ix = 1; ix < component.dataRes.dimensions.length; ix += 1) {
                dimensionAndMeasure.push(component.dataRes.dimensions[ix].text);
            }
        }
        //        alert("dimensionAndMeasure : "+JSON.stringify(dimensionAndMeasure));
        return dimensionAndMeasure;
    };

    component.componentDeleted = function () {
        $("#dsui_" + componentID).remove();

        function triggerDelete() {
            var chartId = component.id();
            if (WhatIfLibrary !== undefined) {
                Object.keys(WhatIfLibrary.charts).forEach(function (obj) {
                    if (obj === chartId) {
                        //Removing current instances from WhatIfLibrary
                        delete WhatIfLibrary.charts[obj];
                        delete WhatIfLibrary.instances[obj];
                    }
                });
                /*
                 *Deleting the Removed chart from the WhatIfLibrary
                 *Manually Removed
                 *WhatIfLibrary is removing only after window.refresh Hence removing Manually
                 */
                Object.keys(WhatIfLibrary.charts).forEach(function (obj) {
                    if (sap.zen.Dispatcher.instance.getRootControlForComponentId(obj) !== undefined) {
                        var instance = WhatIfLibrary.getInstance(obj);
                        if (instance.list() !== "" || instance.list() !== "None") {
                            instance.afterUpdate();
                        }
                    }
                    /*
                     *Trigger afterUpdate of the charts which are grouped
                     *Auto-AfterUpdate is not getting trigged
                     */
                });
            }
        }

        setTimeout(triggerDelete, 200); //getRootControlForComponentId need a setTimeout
    };

    component['getTrendline_add'] = function () {
        return component.yaxisstartontick();
    };

    component['getTrendline_json'] = function () {
        return component.testingArrayjson().toString();
    };

    component.getTrendlineColor = function () {
        if (component.trendcolorpickervalue()) {
            return component.trendcolorpickervalue();
        } else {
            return false;
        }
    };

    component.getChartFamily = function () {
        return "bar";
    };

    component.lassoFireProp = function (selectedPoints) {
        component.selectedvalues(seriesLibrary.createMembersData(component, component.categoriesIndex, selectedPoints).toString());
      //  component.changed += 1;
        component.firePropertiesChanged(["selectedvalues"]);
    };

    component.getCatCount = function () {
        return component.getCount;
    };

  }
}