function FunnelPyramidDrilldownChartUtil(){
  componentUtil.call(this);

  this.getSampleDataSeries = function() {
    var seriesData = [
      {
        name: "Northeast",
        y: 47,
        color: "#7BB6EF",
        drilldown: "Northeast"
      },
      {
        name: "Midwest",
        y: 28.8,
        color: "#A3A3A3",
        drilldown: "Midwest"
      },
      {
        name: "South",
        y: 14.8,
        color: "#99E395",
        drilldown: "South"
      },
      {
        name: "West",
        y: 9.4,
        color: "#F8AA6B",
        drilldown: "West"
      },
      {
        name: "Central",
        y: 7.4,
        color: "#C098A6",
        drilldown: "Central"
      }
    ];
    return seriesData;
  };

  this.getSampleDrillDownDataSeries = function() {
    var drilldownData = [
      {
        name: "Northeast",
        id: "Northeast",
        data: [["New York", 23], ["New Jersey", 16], ["Maine", 8]]
      },
      {
        name: "Midwest",
        id: "Midwest",
        data: [["Ohio", 14], ["Kansas", 10], ["Missouri", 4.8]]
      },
      {
        name: "South",
        id: "South",
        data: [["Florida", 8.8], ["Alabama", 6]]
      },
      {
        name: "West",
        id: "West",
        data: [["Arizona", 7], ["California", 2.4]]
      },
      {
        name: "Central",
        id: "Central",
        data: [["Colorado", 4.1], ["Nebraska ", 2.3], ["Iowa ", 1]]
      }
    ];
    return drilldownData;
  };
  this.getDefaultValue=function(that,options){
    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
    var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue; // jshint ignore:line
    var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
    var component = that.$();
    var thousandsep = that.bulletthousandseparator();
    var decimalsep = that.bulletdecimalseparator();
    var defaultValue = {
      chart: {
        type: that
          .funnelcharttypedd()
          .toLowerCase()
          .split("-")[0],
        //animation: that.result() ?that.result().tuples.length>1000?false:that.chartanimation() :that.chartanimation(),
        className: that.chartcssclassname(),
        events: {
          click: function() {
            that.fireEvent("chartonclick");
          },

          drillup: function(event) {
            var parent = that.drillupArr.pop();
            var currentSeries = event.seriesOptions.data;
            var i = 0; // Index to consider for getting the level value.
            seriesLibrary.trackActionFunc(that, "drillup");
            if (that.parentondrill()) {
              i = that.parentnodeplacement() == "before" ? 1 : 0;
            }

            //VBX141-5322: Occurs when parent node has only one member.
            if (!currentSeries[i] && i == 1) {
              i = 0;
            }

            if (
              currentSeries[i] &&
              typeof currentSeries[i].level != "undefined"
            ) {
              var currentLevel = currentSeries[i].level;
              that.drilldownlevel(Number(currentLevel));
            }

            if (that.chartondrillup() !== "") {
              try {
                var ztlPointJson = {};
                ztlPointJson = $.extend(
                  true,
                  {},
                  that.ztlSelectedColumnJson[parent.column]
                );
                $.extend(true, ztlPointJson, that.ztlSelectedRowJson[parent.row]);
                that.drillupmember(JSON.stringify(ztlPointJson));
              } catch (e) {}
              that.columncolorChanged++;
              that.firePropertiesChangedAndEvent(
                ["drilldownlevel", "drillupmember"],
                "chartondrillup"
              );
            } else {
              that.columncolorChanged++;
              that.firePropertiesChanged(["drilldownlevel"]);
            }
          },

          load: function() {
            if (vbiContextMenu) {
              vbiContextMenu.highchartsPostProcess();
            }

            //The If condition is fire the charafterload event only once - Fix 1200
            if (!isLoad) {
              that.fireEvent("chartafterload");
              isLoad = true;
            }

            if (that.creditsenabled() === true) {
              this.credits.element.onclick = function() {
                window.open(
                  that.creditshref(),
                  "_blank" // <- This is what makes it open in a new window.
                );
              };
            }
          }
        },
        marginBottom:
          that.chartmarginbottom() == "auto"
            ? null
            : Number(that.chartmarginbottom()),
        marginLeft:
          that.chartmarginleft() == "auto"
            ? null
            : Number(that.chartmarginleft()),
        marginRight:
          that.chartmarginright() == "auto"
            ? null
            : Number(that.chartmarginright()),
        marginTop:
          that.chartmargintop() == "auto" ? null : Number(that.chartmargintop()),
        spacingBottom:
          that.chartpaddingbottom() == "auto"
            ? null
            : Number(that.chartpaddingbottom()),
        spacingLeft:
          that.chartpaddingleft() == "auto"
            ? null
            : Number(that.chartpaddingleft()),
        spacingRight:
          that.chartpaddingright() == "auto"
            ? null
            : Number(that.chartpaddingright()),
        spacingTop:
          that.chartpaddingtop() == "auto"
            ? null
            : Number(that.chartpaddingtop()),
        plotShadow: that.plotshadow(),
        reflow: that.chartflow() || false,
        shadow: that.chartshadow(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            relativeTo: that.zoombuttonrelativeto(),
            verticalAlign: that.zoombuttonverticalalign()
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: {
              color: that.resetzoombuttontextcolor()
            },
            //
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: {
                  color: that.resetzoombuttonhovertextcolor()
                }
              }
            }
          }
        },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor:
          that.plottransparency() === true
            ? "transparent"
            : that.plotbackgroundcolor(),
        plotBackgroundImage: that.plotbackgroundimage(),
        plotBorderColor: that.plotbordercolor(),
        plotBorderWidth: that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor()
      },
      title: vbiHighchartsDefault.createDefaultObjects("commonTitle", that),
      subtitle: vbiHighchartsDefault.createDefaultObjects("commonSubtitle", that),
      credits: vbiHighchartsDefault.createDefaultObjects("commonCredits", that),
      exporting: vbiHighchartsDefault.createDefaultObjects(
        "commonExporting",
        that
      ),
      navigation: vbiHighchartsDefault.createDefaultObjects(
        "commonNavigation",
        that
      ),
      loading: vbiHighchartsDefault.createDefaultObjects("commonLoading", that),
      tooltip: vbiHighchartsDefault.createDefaultObjects("commonTooltip", that),
      legend: vbiHighchartsDefault.createDefaultObjects("commonLegend", that),
      plotOptions: {
        series: {
          showInLegend: that.legendenable(),
          borderColor: that.funnelbordercolor(),
          borderWidth: that.funnelborderwidth(),
          allowPointSelect: that.allowpointselect(),
          turboThreshold: that.turbothreshold(),
          cursor: that.pointcursor(),
          enableMouseTracking: that.enablemousetracking(),
          lineWidth: that.linewidth(),
          shadow: that.seriesshadow(),
          point: {
            events: {
              click: function(event) {
                if (that.customAction === null) {
                  seriesLibrary._pointClickEvent(event, that);
                } else {
                  seriesLibrary.pointTriggeredClick(event, that);
                }
              }
            }
          },
          width: that.funnelwidth(),
          height: that.funnelheight(),
          states: {
            hover: {
              enabled: that.funnelhoverenable(),
              brightness: that.funnelhoverbrightness()
            }
          },
          dataLabels: {
            enabled: that.datalabelenabled(),
            align: that.datalabelalign(),
            crop: that.datalabelcrop(),
            //defer: that.datalabeldefer(),
            backgroundColor: that.datalabelbackgroundcolor(),
            useHTML: false,
            borderColor: that.datalabelbordercolor(),
            borderRadius: that.datalabelborderradius(),
            borderWidth: that.datalabelborderwidth(),
            padding: that.datalabelpadding(),
            distance: Number(that.datalabeldistance()),
            rotation: that.datalabelrotation(),
            shadow: that.datalabelshadow(),
            verticalAlign: that.datalabelverticalalign(),
            x: that.datalabelx(),
            y: that.datalabely(),
            formatter: function() {
              return (
                that.datalabelprefix() +
                " " +
                Highcharts.numberFormat(
                  this.y,
                  that.decimal(),
                  decimalsep,
                  thousandsep
                ) +
                " " +
                that.datalabelsuffix()
              );
            },

            style: {
              color: that.datalabeltextcolor(),
              fontWeight: that.datalabelfontweight(),
              textDecoration: that.datalabelfontweight(),
              fontFamily:
                that.globalfont() === true
                  ? this.fontfamily()
                  : that.datalabelfontfamily(),
              fontSize: that.datalabelfontsize() + "px"
            }
          }
        },
        funnel: {
          point: {
            events: {
              click: function(event) {
                if (that.customAction === null) {
                  seriesLibrary._pointClickEvent(event, that);
                } else {
                  seriesLibrary.pointTriggeredClick(event, that);
                }
              }
            }
          }
        },
        pyramid: {
          point: {
            events: {
              click: function(event) {
                if (that.customAction === null) {
                  seriesLibrary._pointClickEvent(event, that);
                } else {
                  seriesLibrary.pointTriggeredClick(event, that);
                }
              }
            }
          }
        }
      },
      series: [
        {
          name: "Stats",
          data: options.seriesData
        }
      ],
      drilldown: {
        activeDataLabelStyle: {
          cursor: that.drilldowndatalabelcursor(),
          color: that.datalabeltextcolor(),
          fontWeight: that.datalabelfontweight(),
          textDecoration: that.datalabelfontweight(),
          fontFamily:
            that.globalfont() === true
              ? this.fontfamily()
              : that.datalabelfontfamily(),
          fontSize: that.datalabelfontsize() + "px"
        },
        drillUpButton: {
          theme: {
            style: {
              fontFamily:
                that.globalfont() === true
                  ? this.fontfamily()
                  : "Lucida Grande, Lucida Sans Unicode, Arial, Helvetica, sans-serif"
            }
          },
          position: {
            x: that.drilldownbuttonx(),
            y: that.drilldownbuttony(),
            align: that.drilldownbuttonalign(),
            verticalAlign: that.drilldownbuttonverticalalign()
          }
        },
        series: options.drilldownData
      }
    };
    return defaultValue;
  }

  this.attachGetters=function(component,options){

    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
    var DataUtilityLib = dependencyObject.dataUtilityLib; //jshint ignore:line

    component.isDataSourceStructureModified = function () {
        if (component.result() && component.oldResultSet) {
            var ds = component.result(),
            dsOld = component.oldResultSet,
            dsDimensions = ds.dimensions,
            dsOldDimensions = dsOld.dimensions;
            if (dsDimensions.length !== dsOldDimensions.length) {
                return true;
            } else {
                for (var i = 0, len = dsDimensions.length; i < len; i++) {
                    if (dsDimensions[i].key != dsOldDimensions[i].key || dsDimensions[i].axis != dsOldDimensions[i].axis) {
                        return true;
                    }
                }
            }

            return false;
        }
        return 'NA';
    };

    component.dataUtilityAggregation = function(dataArray){
        var data = [];
        var aggregationType = DataUtilityLib.getAggregationType() || 'sum';
        data.push(dataArray);
        return DataUtilityLib.aggregationResult(data, aggregationType)[0];
    };

    component.getDataSeriesColor = function() {
        return component.dataseriescolor();
    };
    //Function to get Series Name
    component.getDataSeries = function() {
if (!component.dataRes) { return null; }
        component.dataRes = component.dispKeyTextResultSet();
        // var seriesNames = [];
        // var seriesKeyNames = [];
        var defaultColor = [
            '#B586DA',
            '#FF6657',
            '#F3A730',
            '#946B66',
            '#B0AD53',
            '#7AC1DE',
            '#F1C337',
            '#566C6C',
            '#A1CC54',
            '#543F1E'
        ];
        var seriesColor = [];
        if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
            seriesColor = [];
        } else {
            seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
        }

        if (component.dataRes === undefined || component.dataRes === '')
        // If data source not available
        {
            return null;
        } else {
            if (component.enablehierarchydrilldown() === true && JSON.stringify(component.result()).indexOf('HIERARCHY_NODE') != -1) {
                var seriesName = [];
                var seriesKey = [];
                if (seriesLibrary.getNumberOfRowsColumns(component, 'ROWS') >= 1) {
                    for (var j = 0; j < component.dataRes.dimensions.length; j++) {
                        if (JSON.stringify(component.dataRes.dimensions[j]).indexOf('HIERARCHY_NODE') != -1) {
                            var selectedDimension = j;
                            for (var i = 0; i < component.dataRes.dimensions[selectedDimension].members.length; i++) {
                                if (component.showtotaldatabase() || component.dataRes.dimensions[selectedDimension].members[i].type != 'RESULT') {
                                    if (component.includerootnodes() === true && typeof component.dataRes.dimensions[selectedDimension].members[i].level == 'undefined' || component.includerootnodes() === false && typeof component.dataRes.dimensions[selectedDimension].members[i].level != 'undefined' && component.dataRes.dimensions[selectedDimension].members[i].level == 1) {
                                        seriesLibrary.getSeriesColors(component, seriesColor, seriesName.length, defaultColor);
                                        seriesName.push(component.dataRes.dimensions[selectedDimension].members[i]["picker_text"]);
                                        seriesKey.push(component.result().dimensions[selectedDimension].members[i].key);
                                    }
                                }
                            }

                            break;
                        }
                    }

                    if (component.showtotals()) {
                        seriesLibrary.getSeriesColors(component, seriesColor, seriesName.length, defaultColor);
                        seriesName.push('Total');
                        seriesKey.push('Total');
                    }

                    seriesColor.splice(seriesName.length, seriesColor.length);
                    component.dataseriescolor(seriesColor.join());
                    return [
                        seriesName,
                        seriesKey
                    ];
                }
            } else {
                var measureDimensionIndex = component.getMeasureIndex();
                var measureInRow = component.dataRes.dimensions[measureDimensionIndex].axis == 'ROWS' ? true : false;
                var selectedRowdimIndexes = [];
                var selectedColumndimIndexes = [];
                var seriesName = [];
                var seriesKey = [];
                var bardatacustomizationJson = {
                    'COLUMNS': [],
                    'ROWS': []
                };
                if (component.bardatacustomization() !== '') {
                    bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
                }

                if (measureInRow) {
                    selectedRowdimIndexes.push(measureDimensionIndex);
                    if (component.datautility()) {
                        if (bardatacustomizationJson['COLUMNS'].length !== 0) {
                            $.each(bardatacustomizationJson['COLUMNS'], function(index, value) {
                                selectedColumndimIndexes.push(_.parseInt(value.index));
                            });
                        } else if (bardatacustomizationJson['ROWS'].length !== 0) {
                            $.each(bardatacustomizationJson['ROWS'], function(index, value) {
                                selectedColumndimIndexes.push(_.parseInt(value.index));
                            });
                        }

                        if (selectedColumndimIndexes.length < 2) {
                            return null;
                        }
                    } else {
                        for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                            if (component.dataRes.dimensions[i].axis == 'COLUMNS') {
                                selectedColumndimIndexes.push(i);
                            }
                        }

                        if (selectedColumndimIndexes.length === 0) {
                            for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                                if (component.dataRes.dimensions[i].axis == 'ROWS' && !component.dataRes.dimensions[i].hasOwnProperty('containsMeasures')) {
                                    selectedColumndimIndexes.push(i);
                                }
                            }
                        }

                        if (selectedColumndimIndexes.length < 2) {
                            return null;
                        }
                    }
                } else {
                    selectedColumndimIndexes.push(measureDimensionIndex);
                    if (component.datautility()) {
                        if (bardatacustomizationJson['ROWS'].length !== 0) {
                            $.each(bardatacustomizationJson['ROWS'], function(index, value) {
                                selectedRowdimIndexes.push(_.parseInt(value.index));
                            });
                        } else if (bardatacustomizationJson['COLUMNS'].length !== 0) {
                            $.each(bardatacustomizationJson['COLUMNS'], function(index, value) {
                                selectedRowdimIndexes.push(_.parseInt(value.index));
                            });
                        }

                        if (selectedRowdimIndexes.length < 2) {
                            return null;
                        }
                    } else {
                        for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                            if (component.dataRes.dimensions[i].axis == 'ROWS' && !component.dataRes.dimensions[i].hasOwnProperty('containsMeasures')) {
                                selectedRowdimIndexes.push(i);
                            }
                        }

                        if (selectedRowdimIndexes.length === 0) {
                            for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                                if (component.dataRes.dimensions[i].axis == 'COLUMNS' && !component.dataRes.dimensions[i].hasOwnProperty('containsMeasures')) {
                                    selectedRowdimIndexes.push(i);
                                }
                            }
                        }

                        if (selectedRowdimIndexes.length < 2) {
                            return null;
                        }
                    }
                }

                var rowDim = measureInRow ? selectedColumndimIndexes[0] : selectedRowdimIndexes[0];
                for (var i = 0, mem = component.dataRes.dimensions[rowDim].members; i < mem.length; i++) {
                    if (component.showtotaldatabase() || mem[i].type != 'RESULT') {
                        seriesLibrary.getSeriesColors(component, seriesColor, seriesName.length, defaultColor);
                        seriesName.push(mem[i].text);
                        seriesKey.push(mem[i].key);
                    }
                }

                if (component.showtotals()) {
                    seriesLibrary.getSeriesColors(component, seriesColor, seriesName.length, defaultColor);
                    seriesName.push('Total');
                    seriesKey.push('Total');
                }
                //alert("seriesName="+seriesName);
                seriesColor.splice(seriesName.length, seriesColor.length);
                component.dataseriescolor(seriesColor.join());
                return [
                    seriesName,
                    seriesKey
                ];
            }
        }
    };

    component.getMeasuresNamesForFormatter = function(){
        return vbiNumberFormat.getMeasuresNamesForFormatter(component);
    };

    component.componentDeleted = function() {
        $('#dsui_' + componentID).remove();
    };

    component.getDimensionAndMeasure = function() {
        var dimensionAndMeasure = [];
        if (component.dataRes !== undefined && component.dataRes !== '')
        // if (component.dataRes !== undefined && component.dataRes != "")
        {
            for (var i = 1; i < component.dataRes.dimensions.length; i++) {
                dimensionAndMeasure.push(component.dataRes.dimensions[i].text);
            }
        }

        return dimensionAndMeasure;
    };

    component.setDataUtilityFormattedResultSet = function(){
        component.dataRes = DataUtilityLib.CallUtility();
        component.dataRes = component.dispKeyTextResultSet();
    };

    component.getChartType = function() {
        return 'funneldd';
    };

    component.getMeasureJson = function() {
        var measureJson = {};
        if (component.result() !== undefined && component.result() !== null && component.result() !== '') {
            for (var i = 0; i < component.result().dimensions.length; i++) {
                if (component.result().dimensions[i].containsMeasures === true) {
                    $.each(component.result().dimensions[i].members, function(key, value) {
                        measureJson[value.key] = {
                            text: value.text,
                            index: key
                        };
                    });

                    break;
                }
            }
        }
        return JSON.stringify(measureJson);
    };
  }
}