function HeatMapChartUtil(){
  componentUtil.call(this);

  this.getSampleDataSeries = function() {
    var seriesData = [
      {
        name: "Sales per employee",
        data: [
          [0, 0, 10],
          [0, 1, 19],
          [0, 2, 8],
          [0, 3, 24],
          [0, 4, 67],
          [1, 0, 92],
          [1, 1, 58],
          [1, 2, 78],
          [1, 3, 117],
          [1, 4, 48],
          [2, 0, 35],
          [2, 1, 15],
          [2, 2, 123],
          [2, 3, 64],
          [2, 4, 52],
          [3, 0, 72],
          [3, 1, 132],
          [3, 2, 114],
          [3, 3, 19],
          [3, 4, 16],
          [4, 0, 38],
          [4, 1, 5],
          [4, 2, 8],
          [4, 3, 117],
          [4, 4, 115],
          [5, 0, 88],
          [5, 1, 32],
          [5, 2, 12],
          [5, 3, 6],
          [5, 4, 120],
          [6, 0, 13],
          [6, 1, 44],
          [6, 2, 88],
          [6, 3, 98],
          [6, 4, 96],
          [7, 0, 31],
          [7, 1, 1],
          [7, 2, 82],
          [7, 3, 32],
          [7, 4, 30],
          [8, 0, 85],
          [8, 1, 97],
          [8, 2, 123],
          [8, 3, 64],
          [8, 4, 84],
          [9, 0, 47],
          [9, 1, 114],
          [9, 2, 31],
          [9, 3, 48],
          [9, 4, 91]
        ]
      }
    ];
    return seriesData;
  };

  this.getDefaultValue=function(that,options){
    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
    var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue; // jshint ignore:line
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
    var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
    var component = that.$();
    var thousandsep = that.progressthousandseparator();
    var decimalsep = that.progressdecimalseparator();
    var isExportEnable = that.exportingsymbolenabled();
    if (that.enableMoreActionsButton && isExportEnable) {
      isExportEnable =
        !that.enableMoreActionsButton() && !that.enableContextMenu();
    }

    //To Avoid offset working even after disabling tile in axis
    var offsetaxis = function(titledisplay, titleoffset, titletext) {
      if (titleoffset == "" || titletext == " ") {
        //jshint ignore:line
        return null;
      } else if (titledisplay === true) {
        return titleoffset;
      } else {
        return null;
      }
    };
    var exportMenuItems = Highcharts.getOptions().exporting.buttons.contextButton.menuItems.slice(0);
    exportMenuItems.splice(7,4);  // Removing Lasso options from export menu
    var loadingfont = that.loadingfontweight().split(':');
    var datalabelalign  = function(){
      switch (that.datalabelalign()) {
        case 'left':
          return 'right';
        case 'right':
          return 'left';
        case 'center':
          return 'center';
      }
    };//VBX141-6465
    var defaultValue = {
      chart: {
        type: "heatmap",
        inverted: that.chartinverted(),
        //alignTicks:that.chartalignticks(),//applicable in multiple axes
        className: that.chartcssclassname(),
        events: {
          click: function(event) {
            if (event.target.textContent == "") {
              //jshint ignore:line
              that.fireEvent("chartonclick");
            }
          },

          load: function() {
            if (vbiContextMenu) {
              vbiContextMenu.highchartsPostProcess();
            }
            //The If condition is fire the charafterload event only once - Fix 1200
            if (!isLoad) {
              that.fireEvent("chartafterload");
              isLoad = true;
            }

            if (that.creditsenabled() === true) {
              this.credits.element.onclick = function() {
                window.open(that.creditshref(), "_blank"); // <- This is what makes it open in a new window.
              };
            }
          },

          selection: function(event) {
            if (event.xAxis) {
              that.fireEvent("chartonselect");
            } //disabling the fireEvent while zoom out.
          }
        },
        ignoreHiddenSeries: that.ignorehiddenseries(),
        marginBottom:
          that.chartmarginbottom() == "auto"
            ? null
            : Number(that.chartmarginbottom()),
        marginLeft:
          that.chartmarginleft() == "auto"
            ? null
            : Number(that.chartmarginleft()),
        marginRight:
          that.chartmarginright() == "auto"
            ? null
            : Number(that.chartmarginright()),
        marginTop:
          that.chartmargintop() == "auto" ? null : Number(that.chartmargintop()),
        spacingBottom:
          that.chartpaddingbottom() == "auto"
            ? null
            : Number(that.chartpaddingbottom()),
        spacingLeft:
          that.chartpaddingleft() == "auto"
            ? null
            : Number(that.chartpaddingleft()),
        spacingRight:
          that.chartpaddingright() == "auto"
            ? null
            : Number(that.chartpaddingright()),
        spacingTop:
          that.chartpaddingtop() == "auto"
            ? null
            : Number(that.chartpaddingtop()),
        // spacingLeft: 100,
        pinchType: that.chartpinchtype(),
        zoomType: that.chartzoomtype(),
        panning: that.chartpanning(),
        panKey: that.chartpankey(),
        plotShadow: that.plotshadow(),
        reflow: that.chartflow() || false,
        shadow: that.chartshadow(),
        showaxes: that.showaxes(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            //relativeTo:that.zoombuttonrelativeto(),
            verticalAlign: that.zoombuttonverticalalign()
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: { color: that.resetzoombuttontextcolor() },
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: { color: that.resetzoombuttonhovertextcolor() }
              }
            }
          }
        },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor:
          that.plottransparency() === true
            ? "transparent"
            : that.plotbackgroundcolor(),
        plotBackgroundImage: that.plotbackgroundimage(),
        plotBorderColor: that.plotbordercolor(),
        plotBorderWidth: that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor()
      },
      title: {
        align: that.titlealign(),
        floating: that.titlefloating(),
        margin: that.titlemargin() === "" ? null : that.titlemargin(),
        text: that.titletext(),
        x: that.titlex() === "" ? null : _.parseInt(that.titlex()),
        y: that.titley() === "" ? null : _.parseInt(that.titley()),
        verticalAlign:
          that.titleverticalalign() == "auto" ? null : that.titleverticalalign(),
        style: {
          color: that.titlecolor(),
          fontWeight: that.titlefontweight(),
          textDecoration: that.titlefontweight(),
          fontSize: that.titlefontsize() + "px",
          fontFamily: that.titlefontfamily(),
          display: that.titleenable() === true ? "block" : "none"
        }
      },
      subtitle: {
        align: that.subtitlealign(),
        floating: that.subtitlefloating(),
        text: that.subtitletext(),
        x: that.subtitlex() === "" ? null : that.subtitlex(),
        y:
          that.subtitley() === ""
            ? null
            : that.subtitleverticalalign() == "bottom"
              ? Number(that.subtitley()) - 2
              : Number(that.subtitley()),
        verticalAlign:
          that.subtitleverticalalign() == "auto"
            ? null
            : that.subtitleverticalalign(),
        style: {
          color: that.subtitlecolor(),
          fontWeight: that.subtitlefontweight(),
          textDecoration: that.subtitlefontweight(),
          fontSize: that.subtitlefontsize() + "px",
          fontFamily: that.subtitlefontfamily(),
          display: that.subtitleenable() === true ? "block" : "none"
        }
      },
      credits: {
        enabled: that.creditsenabled(),
        href: that.creditshref(),
        position: {
          align: that.creditsalign(),
          verticalAlign: that.creditsverticalalign(),
          x: that.creditsxposition(),
          y: that.creditsyposition()
        },
        text: that.creditstext(),
        style: {
          color: that.creditstextcolor(),
          fontSize: that.creditsfontsize() + "px",
          fontFamily: that.creditsfontfamily(),
          fontWeight: that.creditsfontweight(),
          cursor: that.creditscursor()
        }
      },
      exporting: {
        buttons: {
          contextButton: {
            enabled: isExportEnable,
            align: that.exportingsymbolalign(),
            verticalAlign: that.exportingsymbolverticalalign(),
            symbol: that.exportingsymbol(),
            //symbol:'url(http://upload.wikimedia.org/wikipedia/commons/0/0c/White_and_yellow_flower.JPG)',
            symbolFill: that.exportingsymbolfill(),
            symbolSize: that.exportingsymbolsize(),
            symbolStroke: that.exportingsymbolstroke(),
            symbolStrokeWidth: that.exportingsymbolstrokewidth(),
            height:
              that.exportingsymbolheight() == "auto"
                ? 20
                : _.parseInt(that.exportingsymbolheight()),
            width:
              that.exportingsymbolwidth() == "auto"
                ? 24
                : _.parseInt(that.exportingsymbolwidth()),
            symbolX:
              that.exportingsymbolxposition() == "auto"
                ? 12
                : _.parseInt(that.exportingsymbolxposition()),
            symbolY:
              that.exportingsymbolyposition() == "auto"
                ? 10
                : _.parseInt(that.exportingsymbolyposition()),
            x:
              that.exportingxposition() == "auto"
                ? 0
                : _.parseInt(that.exportingxposition()),
            y:
              that.exportingyposition() == "auto"
                ? 0
                : _.parseInt(that.exportingyposition()),
            menuItems: that.chartthemeenabled()
              ? exportMenuItems
              : exportMenuItems.slice(0, 6),
            theme: {
              r: that.exportingsymbolradius(),
              fill:
                that.exportingsymbolbackgroundfill() === ""
                  ? null
                  : that.exportingsymbolbackgroundfill(),
              states: {
                hover: { fill: that.exportingsymbolhoverbackgroundfill() }
              }
            }
          }
        },
        filename: that.exportedfilename(),
        sourceWidth: that.exportedchartwidth(),
        sourceHeight: that.exportedchartheight(),
        scale: that.exportedchartscale()
      },
      navigation: {
        menuStyle: { background: that.exportingmenustylebackgroundcolor() },
        menuItemStyle: {
          color: that.exportingmenuitemstyletextcolor(),
          fontWeight: that.exportingmenuitemstylefontweight(),
          textDecoration: that.exportingmenuitemstylefontweight()
        },
        menuItemHoverStyle: {
          background: that.exportingmenuitemhoverstylebackgroundcolor(),
          color: that.exportingmenuitemhoverstyletextcolor(),
          fontWeight: that.exportingmenuitemhoverstylefontweight(),
          textDecoration: that.exportingmenuitemhoverstylefontweight()
        }
      },
      xAxis: {
        categories: [
          "Jan",
          "Feb",
          "Mar",
          "Apr",
          "May",
          "Jun",
          "Jul",
          "Aug",
          "Sep",
          "Oct",
          "Nov",
          "Dec"
        ],
        allowDecimals: that.xaxisallowdecimals(),
        alternateGridColor: that.xaxisalternategridcolor(),
        gridLineColor: that.xaxisgridlinecolor(),
        gridLineDashStyle: that.xaxisgridlinedashstyle(),
        gridLineWidth: that.xaxisgridlinewidth(),
        gridZIndex: that.xaxisgridzindex(),
        ceiling:
          that.xaxisceiling() === "" ? null : _.parseInt(that.xaxisceiling()),
        floor: that.xaxisfloor() === "" ? null : _.parseInt(that.xaxisfloor()),
        lineColor: that.xaxislinecolor(),
        lineWidth: that.xaxislinewidth(),
        minRange: that.xaxisminrange(),
        min: that.xaxismin() === "" ? null : _.parseInt(that.xaxismin()),
        max: that.xaxismax() === "" ? null : _.parseInt(that.xaxismax()),
        maxPadding:
          that.xaxismaxpadding() === ""
            ? null
            : _.parseInt(that.xaxismaxpadding()),
        minPadding:
          that.xaxisminpadding() === ""
            ? null
            : _.parseInt(that.xaxisminpadding()),
        opposite: that.xaxisopposite(),
        offset: that.xaxisoffset(),
        reversed: that.xaxisreversed() === true,
        showEmpty: that.xaxisshowempty(),
        showFirstLabel: that.xaxisshowfirstlabel(),
        showLastLabel: that.xaxisshowlastlabel(),
        dateTimeLabelFormats: {},
        minTickInterval: that.xaxismintickinterval(),
        //          startOnTick: that.xaxisstartontick(),
        //          endOnTick: that.xaxisendontick(),
        tickColor: that.xaxistickcolor(),
        tickInterval: that.xaxistickinterval(),
        tickLength: that.xaxisticklength(),
        tickPosition: that.xaxistickposition(),
        tickWidth: that.xaxistickwidth(),
        tickmarkPlacement: that.xaxistickmarkplacement(),
        labels: {
          align: that.xaxislabelalign(),
          enabled: that.xaxislabelenabled(),
          format:
            that.xaxislabelprefix() +
            that.xaxislabelformat() +
            that.xaxislabelsuffix(),
          //overflow:that.xaxislabeloverflow(),
          rotation: that.xaxislabelrotation(),
          // distance:that.xaxislabeldistance(),
          staggerLines:
            that.xaxislabelstaggerline() === ""
              ? null
              : _.parseInt(that.xaxislabelstaggerline()),
          maxStaggerLines:
            that.xaxislabelmaxstaggerline() === ""
              ? null
              : _.parseInt(that.xaxislabelmaxstaggerline()),
          step: that.xaxislabelstep(),
          x: that.xaxislabelx(),
          y: that.xaxislabely(),
          zIndex: that.xaxislabelzindex(),
          style: {
            color: that.xaxislabelcolor(),
            fontWeight: that.xaxislabelfontweight(),
            textDecoration: that.xaxislabelfontweight(),
            fontSize: that.xaxislabelfontsize() + "px",
            fontFamily: that.xaxislabelfontfamily()
          },
          events: {
            click: function() {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        title: {
          text: that.xaxistitletext(),
          align: that.xaxistitlealign(),
          rotation: that.xaxistitlerotation(),
          offset: offsetaxis(
            that.xaxistitleenabled(),
            that.xaxistitleoffset(),
            that.xaxistitletext()
          ),
          margin: that.xaxistitlemargin(),
          style: {
            color: that.xaxistitlecolor(),
            fontWeight: that.xaxistitlefontweight(),
            textDecoration: that.xaxistitlefontweight(),
            fontSize: that.xaxistitlefontsize() + "px",
            fontFamily: that.xaxistitlefontfamily(),
            display: that.xaxistitleenabled() === true ? "block" : "none"
          }
        },
        plotBands: [
          {
            /* style:{

  :that.xaxisplotbandenabled()==true?'block':'none'
  */
            color:
              that.xaxisplotbandenabled() === true
                ? that.xaxisplotbandcolor()
                : null,
            borderColor:
              that.xaxisplotbandenabled() === true
                ? that.xaxisplotbandbordercolor()
                : null,
            borderWidth: that.xaxisplotbandborderwidth(),
            from: that.xaxisplotbandfrom() - 0.5,
            to: that.xaxisplotbandto() + 0.5,
            zIndex: that.xaxisplotbandzindex(),
            events: {
              click: function(event) {
                that.fireEvent("xaxisplotbandonclick");
              }
            },
            label: {
              style: {
                color: that.xaxisplotbandlabelcolor(),
                fontWeight: that.xaxisplotbandlabelfontweight(),
                textDecoration: that.xaxisplotbandlabelfontweight(),
                fontSize: that.xaxisplotbandlabelfontsize() + "px",
                fontFamily: that.xaxisplotbandlabelfontfamily(),
                display:
                  that.xaxisplotbandlabandlabelenabled() === true
                    ? "block"
                    : "none"
              },
              text: that.xaxisplotbandlabeltext(),
              align: that.xaxisplotbandlabelalign(),
              rotation: that.xaxisplotbandlabelrotation(),
              textAlign: that.xaxisplotbandlabeltextalign(),
              //useHTML:that.xaxisplotbandlabelusehtml(),
              verticalAlign: that.xaxisplotbandlabelverticalalign(),
              x:
                that.xaxisplotbandlabelxposition() == "null"
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelxposition()),
              y:
                that.xaxisplotbandlabelyposition() === ""
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelyposition())
            }
          }
        ],
        plotLines: [
          {
            color:
              that.xaxisplotlineenabled() === true
                ? that.xaxisplotlinecolor()
                : null,
            dashStyle: that.xaxisplotlinedashstyle(),
            width: that.xaxisplotlinewidth(),
            value: that.xaxisplotlinevalue(),
            zIndex: that.xaxisplotlinezindex(),
            label: {
              style: {
                color: that.xaxisplotlinelabelcolor(),
                fontWeight: that.xaxisplotlinelabelfontweight(),
                textDecoration: that.xaxisplotlinelabelfontweight(),
                fontSize: that.xaxisplotlinelabelfontsize() + "px",
                fontFamily: that.xaxisplotlinelabelfontfamily(),
                display:
                  that.xaxisplotlinelabelenabled() === true ? "block" : "none"
              },
              text: that.xaxisplotlinelabeltext(),
              align: that.xaxisplotlinelabelalign(),
              rotation: that.xaxisplotlinelabelrotation(),
              textAlign: that.xaxisplotlinelabeltextalign(),
              verticalAlign: that.xaxisplotlinelabelverticalalign(),
              x:
                that.xaxisplotlinelabelxposition() == "null"
                  ? null
                  : _.parseInt(that.xaxisplotlinelabelxposition()),
              y:
                that.xaxisplotlinelabelyposition() == "null"
                  ? null
                  : _.parseInt(that.xaxisplotlinelabelyposition())
            }
          }
        ]
      },
      yAxis: {
        categories: ["Monday", "Tuesday", "Wednesday", "Thursday", "Friday"],
        allowDecimals: that.yaxisallowdecimals(),
        alternateGridColor: that.yaxisalternategridcolor(),
        gridLineColor: that.yaxisgridlinecolor(),
        gridLineDashStyle: that.yaxisgridlinedashstyle(),
        gridLineWidth: that.yaxisgridlinewidth(),
        gridZIndex: that.yaxisgridzindex(),
        lineColor: that.yaxislinecolor(),
        lineWidth: that.yaxislinewidth(),
        minTickInterval: that.yaxismintickinterval(),
        minorGridLineColor: that.yaxisminorgridlinecolor(),
        minorGridLineDashStyle: that.yaxisminorgridlinedashstyle(),
        minorGridLineWidth: that.yaxisminorgridlinewidth(),
        minorTickColor: that.yaxisminortickcolor(),
        minorTickInterval:
          that.yaxisminortickinterval() === ""
            ? "auto"
            : _.parseInt(that.yaxisminortickinterval()),
        minorTickLength: that.yaxisminorticklength(),
        minorTickPosition: that.yaxisminortickposition(),
        minorTickWidth: that.yaxisminortickwidth(),
        tickColor: that.yaxistickcolor() || "#CCC",
        tickInterval:
          that.yaxistickinterval() === ""
            ? null
            : _.parseInt(that.yaxistickinterval()),
        tickLength: that.yaxisticklength(),
        tickPosition: that.yaxistickposition(),
        tickWidth: that.yaxistickwidth(),
        tickmarkPlacement: that.yaxistickmarkplacement(),
        dateTimeLabelFormats: {},
        ceiling:
          that.yaxisceiling() === "" ? null : _.parseInt(that.yaxisceiling()),
        floor: that.yaxisfloor() === "" ? null : _.parseInt(that.yaxisfloor()),
        min: that.yaxismin() === "" ? null : _.parseInt(that.yaxismin()),
        max: that.yaxismax() === "" ? null : _.parseInt(that.yaxismax()),
        maxPadding:
          that.yaxismaxpadding() === ""
            ? null
            : parseFloat(that.yaxismaxpadding()),
        minPadding:
          that.yaxisminpadding() === ""
            ? null
            : parseFloat(that.yaxisminpadding()),
        minRange: that.yaxisminrange(),
        offset: that.yaxisoffset(),
        opposite: that.yaxisopposite(),
        reversed: that.yaxisreversed() === true,
        showEmpty: that.yaxisshowempty(),
        showFirstLabel: that.yaxisshowfirstlabel(),
        showLastLabel: that.yaxisshowlastlabel(),
        //          startOnTick: that.yaxisstartontick(),
        //          endOnTick: that.yaxisendontick(),
        labels: {
          align: that.yaxislabelalign(),
          enabled: that.yaxislabelenabled(),
          formatter: function() {
            return vbiHighchartsDefault["Yaxis_autoscale_formatter"](that, this); //jshint ignore:line
          },
          rotation: that.yaxislabelrotation(),
          staggerLines:
            that.yaxislabelstaggerline() === ""
              ? null
              : _.parseInt(that.yaxislabelstaggerline()),
          maxStaggerLines:
            that.yaxislabelmaxstaggerline() === ""
              ? null
              : _.parseInt(that.yaxislabelmaxstaggerline()),
          step: that.yaxislabelstep(),
          x: that.yaxislabelx(),
          y: that.yaxislabely(),
          zIndex: that.yaxislabelzindex(),
          style: {
            color: that.yaxislabelcolor(),
            fontWeight: that.yaxislabelfontweight(),
            textDecoration: that.yaxislabelfontweight(),
            fontSize: that.yaxislabelfontsize() + "px",
            fontFamily: that.yaxislabelfontfamily()
          },
          events: {
            click: function() {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        title: {
          text: that.yaxistitletext(),
          align: that.yaxistitlealign(),
          rotation: that.yaxistitlerotation(),
          offset: offsetaxis(
            that.yaxistitleenabled(),
            that.yaxistitleoffset(),
            that.yaxistitletext()
          ),
          margin: that.yaxistitlemargin(),
          style: {
            color: that.yaxistitlecolor(),
            fontWeight: that.yaxistitlefontweight(),
            textDecoration: that.yaxistitlefontweight(),
            fontSize: that.yaxistitlefontsize() + "px",
            fontFamily: that.yaxistitlefontfamily(),
            display: that.yaxistitleenabled() === true ? "block" : "none"
          }
        },
        plotBands: [
          {
            color:
              that.yaxisplotbandenabled() === true
                ? that.yaxisplotbandcolor()
                : null,
            borderColor:
              that.yaxisplotbandenabled() === true
                ? that.yaxisplotbandbordercolor()
                : null,
            borderWidth: that.yaxisplotbandborderwidth(),
            from: that.yaxisplotbandfrom(),
            to: that.yaxisplotbandto(),
            zIndex: that.yaxisplotbandzindex(),
            events: {
              click: function(event) {
                //jshint ignore:line
                that.fireEvent("yaxisplotbandonclick");
              }
            },
            label: {
              style: {
                color: that.yaxisplotbandlabelcolor(),
                fontWeight: that.yaxisplotbandlabelfontweight(),
                textDecoration: that.yaxisplotbandlabelfontweight(),
                fontSize: that.yaxisplotbandlabelfontsize() + "px",
                fontFamily: that.yaxisplotbandlabelfontfamily(),
                display:
                  that.yaxisplotbandlabelenabled() === true ? "block" : "none"
              },
              text: that.yaxisplotbandlabeltext(),
              align: that.yaxisplotbandlabelalign(),
              rotation: that.yaxisplotbandlabelrotation(),
              textAlign: that.yaxisplotbandlabeltextalign(),
              verticalAlign: that.yaxisplotbandlabelverticalalign(),
              x:
                that.yaxisplotbandlabelxposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotbandlabelxposition()),
              y:
                that.yaxisplotbandlabelyposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotbandlabelyposition())
            }
          }
        ],
        plotLines: [
          {
            color:
              that.yaxisplotlineenabled() === true
                ? that.yaxisplotlinecolor()
                : null,
            dashStyle: that.yaxisplotlinedashstyle(),
            width: that.yaxisplotlinewidth(),
            value: that.yaxisplotlinevalue(),
            zIndex: that.yaxisplotlinezindex(),
            label: {
              verticalAlign: that.yaxisplotlinelabelverticalalign(),
              style: {
                color: that.yaxisplotlinelabelcolor(),
                fontWeight: that.yaxisplotlinelabelfontweight(),
                textDecoration: that.yaxisplotlinelabelfontweight(),
                fontSize: that.yaxisplotlinelabelfontsize() + "px",
                fontFamily: that.yaxisplotlinelabelfontfamily(),
                display:
                  that.yaxisplotlinelabelenabled() === true ? "block" : "none"
              },
              text: that.yaxisplotlinelabeltext(),
              align: that.yaxisplotlinelabelalign(),
              rotation: that.yaxisplotlinelabelrotation(),
              textAlign: that.yaxisplotlinelabeltextalign(),
              x:
                that.yaxisplotlinelabelxposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotlinelabelxposition()),
              y:
                that.yaxisplotlinelabelyposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotlinelabelyposition())
            }
          }
        ]
      },
      loading: {
        labelStyle: {
          fontSize: "18px",
          fontWeight: loadingfont[0],
          fontStyle: loadingfont[1],
          color: that.loadingcolor()
        },
        style: {
          backgroundColor: that.loadingstylebackgroundcolor(),
          opacity: Number(that.loadingopacity()),
          textAlign: that.loadingtextalign()
        }
      },
      tooltip: {
        useHTML: true,
        animation: that.tooltipanimation() || false,
        //                    crosshairs: that.tooltipcrosshair(),
        enabled: that.tooltipenable(),
        followPointer: that.tooltipfollowpointer(),
        followTouchMove: that.tooltipfollowtouchmove(),
        hideDelay: that.tooltiphidedelay(),
        shadow: that.tooltipshadow(),
        shape: that.tooltipshape(),
        shared: that.tooltipshared(),
        snap: that.tooltipsnap(),
        valueDecimals: that.tooltipvaluedecimals(),
        valuePrefix: that.tooltipvalueprefix(),
        valueSuffix: that.tooltipvaluesuffix(),
        backgroundColor: that.tooltipbackgroundcolor(),
        borderColor: that.tooltipbordercolor(),
        borderRadius: that.tooltipborderradius(),
        borderWidth: that.tooltipborderwidth(),
        style: {
          color: that.tooltipcolor(),
          fontWeight: that.tooltipfontweight(),
          textDecoration: that.tooltipfontweight(),
          fontSize: that.tooltipfontsize() + "px",
          fontFamily: that.tooltipfontfamily()
        }
      },
      legend: {
        enabled: that.legendenable(),
        backgroundColor: that.legendbackgroundcolor(),
        borderColor: that.legendbordercolor(),
        borderRadius: that.legendborderradius(),
        borderWidth: that.legendborderwidth(),
        align: that.legendalign(),
        floating: that.legendfloating(),
        itemDistance: that.legenditemdistance(),
        itemMarginBottom: that.legenditemmarginbottom(),
        itemMarginTop: that.legenditemmargintop(),
        itemWidth:
          that.legenditemwidth() == "auto"
            ? null
            : Number(that.legenditemwidth()),
        width: that.legendboxwidth(),
        labelFormat: that.legendlabelformat(),
        layout: that.legendlayout(),
        lineHeight: that.legendlineheight(),
        margin: that.legendmargin(),
        padding: that.legendpadding(),
        reversed: that.legendreversed(),
        rtl: that.legendsymboltoright(),
        shadow: that.legendshadow(),
        symbolHeight: that.legendsymbolheight(),
        symbolPadding: that.legendsymbolpadding(),
        symbolRadius: that.legendsymbolradius(),
        symbolWidth: that.legendsymbolwidth(),
        x: that.legendxposition(),
        y: that.legendyposition(),
        verticalAlign: that.legendverticalalign(),
        itemHiddenStyle: { color: that.legenditemhiddenstylecolor() },
        itemHoverStyle: { color: that.legenditemhoverstylecolor() },
        itemStyle: {
          color: that.legenditemstylecolor(),
          fontSize: that.legenditemfontsize() + "px",
          fontWeight: that.legenditemfontweight(),
          textDecoration: that.legenditemfontweight(),
          fontFamily: that.legenditemfontfamily()
        },
        title: {
          text: that.legendtitletext(),
          style: {
            color: that.legendtitlecolor(),
            fontWeight: that.legendtitlefontweight(),
            textDecoration: that.legendtitlefontweight(),
            fontSize: that.legendtitlefontsize() + "px",
            fontFamily: that.legendtitlefontfamily()
          }
        },
        navigation: {
          activeColor: that.legendnavigationactivecolor(),
          animation: that.legendnavigationanimation(),
          arrowSize: that.legendnavigationarrowsize(),
          inactiveColor: that.legendnavigationinactivecolor(),
          style: {
            fontWeight: that.legendnavigationfontweight(),
            textDecoration: that.legendnavigationfontweight(),
            color: that.legendnavigationcolor(),
            fontSize: that.legendnavigationfontsize() + "px",
            fontFamily: that.legendnavigationfontfamily()
          }
        },
        useHTML: false
      },
      colorAxis: {
        min:
          that.coloraxismin() == "auto" ? null : _.parseInt(that.coloraxismin()),
        max:
          that.coloraxismax() == "auto" ? null : _.parseInt(that.coloraxismax()),
        minColor: that.coloraxismincolor(),
        maxColor: that.coloraxismaxcolor()
      },
      plotOptions: {
        series: {
          borderWidth: that.seriesborderwidth(),
          borderColor: that.seriesbordercolor(),
          cursor: "pointer",
          pointWidth:
            that.pointwidth() == "auto" ? null : _.parseInt(that.pointwidth()),
          pointPadding: that.pointpadding(),
          allowPointSelect: that.allowpointselect(),
          connectNulls: that.connectnulls(),
          cropThreshold: that.cropthreshold(),
          turboThreshold: that.turbothreshold(),
          states: {
            select: {
              color: "#CCCCCC"
            }
          },
          point: {
            events: {
              click: function(event) {
                //that.selectedvalue(seriesLibrary.createMemberData(that,that.categoriesIndex[this.category],this.series.name));
                that.selectedvalue(
                  seriesLibrary.createMemberData(
                    that,
                    that.categoriesIndex[event.point.x],
                    event.point.series.options.key[event.point.y]
                  )
                );
              },

              select: function() {
                try {
                  that.selectedPoints = component.highcharts().getSelectedPoints();
                  that.selectedPoints.push(this);
                  that.selectedvalues(
                    seriesLibrary
                      .createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints,
                        "heatmap"
                      )
                      .toString()
                  );
                  seriesLibrary.onSelectFunction(that);
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }

                /**
                    *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                    **/
              },

              unselect: function() {
                try {
                  var index = that.selectedPoints.indexOf(this);
                  if (index > -1) {
                    that.selectedPoints.splice(index, 1);
                  }

                  that.selectedvalues(
                    seriesLibrary
                      .createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints,
                        "heatmap"
                      )
                      .toString()
                  );
                  if (that.selectedvalues() === "") {
                    that.selectedvalue("");
                  } else {
                    var select = seriesLibrary.createMembersData(
                      that,
                      that.categoriesIndex,
                      that.selectedPoints,
                      "heatmap"
                    );
                    that.selectedvalue(select[0]);
                  }
                  /**
                       *Selectedvalue fix in all charts
                       *Multiple Selection getting the last selected value.
                      **/
                  if (that.clearSelect) {
                    if (that.selectedvalues() === "") {
                      that.clearSelect = false;
                    }
                  } else {
                    seriesLibrary.onSelectFunction(that);
                  } //clearselection callback issue on Onselect.
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }
                /**
                    *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                    **/
              }
            }
          }
        },
        heatmap: {
          dataLabels: {
            enabled: that.datalabelenabled(),
            align: datalabelalign(),
            crop: that.datalabelcrop(),
            //defer: that.datalabeldefer(),
            backgroundColor: that.datalabelbackgroundcolor(),
            useHTML: false,
            borderColor: that.datalabelbordercolor(),
            borderRadius: that.datalabelborderradius(),
            borderWidth: that.datalabelborderwidth(),
            padding: that.datalabelpadding(),
            rotation: that.datalabelrotation(),
            shadow: that.datalabelshadow(),
            verticalAlign: that.datalabelverticalalign(),
            x: that.datalabelx() == "null" ? null : _.parseInt(that.datalabelx()),
            y: that.datalabelx() == "null" ? null : _.parseInt(that.datalabelx()),
            formatter: function() {
              /* if (that.datavaluedecimals() != 'auto') {
                     return that.datalabelprefix() + '' + Highcharts.numberFormat(this.point.value, that.decimal(), decimalsep, thousandsep) + '' + that.datalabelsuffix();
                   } else {*/
              if (
                that.customdatalabel() !== "" &&
                Object.keys(JSON.parse(that.customdatalabel() || "{}")).length
              ) {
                return vbiNumberFormat.barFamilyFormatterDataLabel(
                  this,
                  that,
                  decimalsep,
                  thousandsep,
                  false
                );
              } else {
                return vbiNumberFormat.heatMapDatalabel(
                  this,
                  that,
                  decimalsep,
                  thousandsep,
                  false
                );
                //return that.datalabelprefix() + ' ' + Highcharts.numberFormat(this.point.value,that.decimal(), decimalsep, thousandsep) + ' ' + that.datalabelsuffix();
              }
              // }
            },

            style: {
              textShadow: false,
              color: that.datalabeltextcolor(),
              fontWeight: that.datalabelfontweight(),
              textDecoration: that.datalabelfontweight(),
              fontSize: that.datalabelfontsize() + "px",
              fontFamily:
                that.globalfont() === true
                  ? this.fontfamily()
                  : that.datalabelfontfamily()
            }
          },
          marker: {}
        }
      },
      series: [{ data: options.seriesData }]
    };
    return defaultValue;
  };

  this.attachGetters=function(component,options){

    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    component.getMeasuresNamesForFormatter = function(){
        return vbiNumberFormat.getMeasuresNamesForFormatter(component);
    };

  component.getDataSeries = function() {
  if (!component.dataRes) { return null; }
    var dataSeries = [];
    var seriesNames = [];
    var seriesKeyNames = [];
    component.dataRes = component.dispKeyTextResultSet();
    var bardatacustomizationJson = {
      'COLUMNS': [],
      'ROWS': []
    };
    if (component.bardatacustomization() !== '') {
      bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
    }

    try {
      if (component.dataRes === undefined || component.dataRes == '') {   //jshint ignore:line
        return null;
      } else if (component.datautility() === true && bardatacustomizationJson['COLUMNS'].length == 0 && bardatacustomizationJson['ROWS'].length == 0) {  //jshint ignore:line
        return null;
      }

      if (component.dataRes.dimensions.length == 1 && component.dataRes.dimensions[0].containsMeasures === true) {
        var defaultColor = [
          '#B586DA',
          '#FF6657',
          '#F3A730',
          '#946B66',
          '#B0AD53',
          '#7AC1DE',
          '#F1C337',
          '#566C6C',
          '#A1CC54',
          '#543F1E'
        ];
        var seriesColor = [];
        if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
          seriesColor = [];
        } else {
          seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
        }

        if (component.dataRes.dimensions[0].axis == 'ROWS') {
          for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {
            seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
            seriesNames.push(component.dataRes.dimensions[0].members[i].text);
            seriesKeyNames.push(component.dataRes.dimensions[0].members[i].key);
          }
        } else {
          seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
          seriesNames.push('Measures');
          seriesKeyNames.push('Measures');
        }

        dataSeries = [
          seriesNames,
          seriesKeyNames
        ];
        seriesColor.splice(dataSeries[0].length, seriesColor.length);
        component.dataseriescolor(seriesColor.join());
      } else {
        //  dataSeries = seriesLibrary.createSeriesData(component, 'bar', defaultValueSeriesNames,"ncf");
        dataSeries = seriesLibrary.createSeriesAdditionalProperty(component);
      }
    } catch (e) {   seriesLibrary.DSXalert(e.message);  }

    return dataSeries;
  };

  component.getDataSeriesColor = function() {
    var dataseriescolor = '';
    try {
      dataseriescolor = component.dataseriescolor();
    } catch (e) {   seriesLibrary.DSXalert(e.message);
    }

    return dataseriescolor;
  };

  component.getDatUtility = function() {
    var datautility = '';
    try {
      datautility = component.datautility();
    } catch (e) {   seriesLibrary.DSXalert(e.message); }

    return datautility;
  };

  component.getChartType = function() {
    return 'HeatMap';
  };

    component.getDataSeries = function() {
  if (!component.dataRes) { return null; }
    var dataSeries = [];
    var seriesNames = [];
    var seriesKeyNames = [];
    component.dataRes = component.dispKeyTextResultSet();
    var bardatacustomizationJson = {
      'COLUMNS': [],
      'ROWS': []
    };
    if (component.bardatacustomization() !== '') {
      bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
    }

    try {
      if (component.dataRes === undefined || component.dataRes == '') {   //jshint ignore:line
        return null;
      } else if (component.datautility() === true && bardatacustomizationJson['COLUMNS'].length == 0 && bardatacustomizationJson['ROWS'].length == 0) {  //jshint ignore:line
        return null;
      }

      if (component.dataRes.dimensions.length == 1 && component.dataRes.dimensions[0].containsMeasures === true) {
        var defaultColor = [
          '#B586DA',
          '#FF6657',
          '#F3A730',
          '#946B66',
          '#B0AD53',
          '#7AC1DE',
          '#F1C337',
          '#566C6C',
          '#A1CC54',
          '#543F1E'
        ];
        var seriesColor = [];
        if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
          seriesColor = [];
        } else {
          seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
        }

        if (component.dataRes.dimensions[0].axis == 'ROWS') {
          for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {
            seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
            seriesNames.push(component.dataRes.dimensions[0].members[i].text);
            seriesKeyNames.push(component.dataRes.dimensions[0].members[i].key);
          }
        } else {
          seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
          seriesNames.push('Measures');
          seriesKeyNames.push('Measures');
        }

        dataSeries = [
          seriesNames,
          seriesKeyNames
        ];
        seriesColor.splice(dataSeries[0].length, seriesColor.length);
        component.dataseriescolor(seriesColor.join());
      } else {
        //  dataSeries = seriesLibrary.createSeriesData(component, 'bar', defaultValueSeriesNames,"ncf");
        dataSeries = seriesLibrary.createSeriesAdditionalProperty(component);
      }
    } catch (e) {   seriesLibrary.DSXalert(e.message);  }

    return dataSeries;
  };

  component.getDataSeriesColor = function() {
    var dataseriescolor = '';
    try {
      dataseriescolor = component.dataseriescolor();
    } catch (e) {   seriesLibrary.DSXalert(e.message);
    }

    return dataseriescolor;
  };

  component.getDatUtility = function() {
    var datautility = '';
    try {
      datautility = component.datautility();
    } catch (e) {   seriesLibrary.DSXalert(e.message); }

    return datautility;
  };

  component.getChartType = function() {
    return 'HeatMap';
  };

  component.getMeasureMembers = function() {
    return seriesLibrary.getMeasureMembers(component);
  };

  component.componentDeleted = function() {
    $('#dsui_' + componentID).remove();
  };

  }
}