function PolarChartUtil(){
  componentUtil.call(this);

  this.getSampleDataSeries = function() {
    var seriesData = [
      {
        name: "North",
        data: [100, 210, 90, 250, 270, 200, 170, 150, 210, 147, 115, 290],
        color: "#588EC0"
      },
      {
        name: "South",
        data: [240, 360, 200, 70, 110, 135, 180, 60, 239, 178, 263, 190],
        color: "#737173"
      },
      {
        name: "East",
        data: [148, 210, 250, 270, 215, 290, 330, 179, 130, 206, 340, 263],
        color: "#CE9F79"
      },
      {
        name: "West",
        data: [209, 130, 150, 128, 350, 330, 196, 72, 180, 196, 280, 225],
        color: "#FF9933"
      }
    ];

    return seriesData;
  };
  this.getDefaultValue=function(that,options){
    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
    var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue; // jshint ignore:line
    var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
    var component = that.$();
    //To Avoid offset working even after disabling tile in axis
    var offsetaxis = function(titledisplay, titleoffset, titletext) {
      if (titleoffset == "" || titletext == " ") {
        //jshint ignore:line
        return null;
      } else if (titledisplay === true) {
        return titleoffset;
      } else {
        return null;
      }
    };
    var defaultValue = {
      chart: {
        polar: true,
        type: options.chartType,
        inverted: false,
        className: that.chartcssclassname(),
        events: {
          click: function(event) {
            if (event.target.textContent === "") {
              that.fireEvent("chartonclick");
            }
          },

          load: function() {
            if (vbiContextMenu) {
              vbiContextMenu.highchartsPostProcess();
            }
            if (!isLoad) {
              that.fireEvent("chartafterload");
              isLoad = true;
            }

            if (that.creditsenabled() === true) {
              this.credits.element.onclick = function() {
                window.open(
                  that.creditshref(),
                  "_blank" // <- This is what makes it open in a new window.
                );
              };
            }
          },

          selection: function(e) {
            if (e.xAxis) {
              that.fireEvent("chartonselect"); //disabling the fireEvent while zoom out.
            }
          }
        },
        ignoreHiddenSeries: that.ignorehiddenseries(),
        marginBottom:
          that.chartmarginbottom() == "auto"
            ? null
            : Number(that.chartmarginbottom()),
        marginLeft:
          that.chartmarginleft() == "auto"
            ? null
            : Number(that.chartmarginleft()),
        marginRight:
          that.chartmarginright() == "auto"
            ? null
            : Number(that.chartmarginright()),
        marginTop:
          that.chartmargintop() == "auto" ? null : Number(that.chartmargintop()),
        spacingBottom:
          that.chartpaddingbottom() == "auto"
            ? null
            : Number(that.chartpaddingbottom()),
        spacingLeft:
          that.chartpaddingleft() == "auto"
            ? null
            : Number(that.chartpaddingleft()),
        spacingRight:
          that.chartpaddingright() == "auto"
            ? null
            : Number(that.chartpaddingright()),
        spacingTop:
          that.chartpaddingtop() == "auto"
            ? null
            : Number(that.chartpaddingtop()),
        pinchType: that.chartpinchtype(),
        zoomType: that.chartzoomtype(),
        panning: that.chartpanning(),
        panKey: that.chartpankey(),
        plotShadow: that.plotshadow(),
        reflow: that.chartflow() || false,
        shadow: that.chartshadow(),
        showaxes: that.showaxes(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            verticalAlign: that.zoombuttonverticalalign()
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: { color: that.resetzoombuttontextcolor() },
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: { color: that.resetzoombuttonhovertextcolor() }
              }
            }
          }
        },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor:
          that.plottransparency() === true
            ? "transparent"
            : that.plotbackgroundcolor(),
        plotBackgroundImage: that.plotbackgroundimage(),
        plotBorderColor: that.plotbordercolor(),
        plotBorderWidth: that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor()
      },
      title: vbiHighchartsDefault.createDefaultObjects("commonTitle", that),
      subtitle: vbiHighchartsDefault.createDefaultObjects("commonSubtitle", that),
      credits: vbiHighchartsDefault.createDefaultObjects("commonCredits", that),
      exporting: vbiHighchartsDefault.createDefaultObjects(
        "commonExporting",
        that
      ),
      navigation: vbiHighchartsDefault.createDefaultObjects(
        "commonNavigation",
        that
      ),
      xAxis: {
        //polar
        categories: [
          "Jan",
          "Feb",
          "Mar",
          "Apr",
          "May",
          "Jun",
          "Jul",
          "Aug",
          "Sep",
          "Oct",
          "Nov",
          "Dec"
        ],
        allowDecimals: that.xaxisallowdecimals(),
        alternateGridColor: that.xaxisalternategridcolor(),
        //polar
        /* gridLineColor: that.xaxisgridlinecolor(),
             gridLineDashStyle: that.xaxisgridlinedashstyle(),
             gridLineWidth: that.xaxisgridlinewidth(),*/
        gridZIndex: that.xaxisgridzindex(),
        ceiling:
          that.xaxisceiling() === "" ? null : _.parseInt(that.xaxisceiling()),
        floor: that.xaxisfloor() === "" ? null : _.parseInt(that.xaxisfloor()),
        lineColor: that.xaxislinecolor(),
        //polar
        lineWidth: that.xaxislinewidth(),
        minRange: that.xaxisminrange(),
        //    min: that.xaxismin() == '' ? null : _.parseInt(that.xaxismin()),
        //    max: that.xaxismax() == '' ? null : _.parseInt(that.xaxismax()),
        maxPadding:
          that.xaxismaxpadding() === ""
            ? null
            : _.parseInt(that.xaxismaxpadding()),
        minPadding:
          that.xaxisminpadding() === ""
            ? null
            : _.parseInt(that.xaxisminpadding()),
        opposite: that.xaxisopposite(),
        offset: that.xaxisoffset(),
        //  reversed: that.xaxisreversed() === true,
        showEmpty: that.xaxisshowempty(),
        showFirstLabel: that.xaxisshowfirstlabel(),
        showLastLabel: that.xaxisshowlastlabel(),
        dateTimeLabelFormats: {},

        tickmarkPlacement: "on",
        labels: {
          align: that.xaxislabelalign(),
          enabled: that.xaxislabelenabled(),
          format:
            that.xaxislabelprefix() +
            " " +
            that.xaxislabelformat() +
            " " +
            that.xaxislabelsuffix(),
          rotation: that.xaxislabelrotation(),
          staggerLines:
            that.xaxislabelstaggerline() === ""
              ? null
              : _.parseInt(that.xaxislabelstaggerline()),
          maxStaggerLines:
            that.xaxislabelmaxstaggerline() === ""
              ? null
              : _.parseInt(that.xaxislabelmaxstaggerline()),
          step: that.xaxislabelstep(),
          x: that.xaxislabelx(),
          y: that.xaxislabely(),
          zIndex: that.xaxislabelzindex(),
          style: {
            color: that.xaxislabelcolor(),
            fontWeight: that.xaxislabelfontweight(),
            textDecoration: that.xaxislabelfontweight(),
            fontSize: that.xaxislabelfontsize() + "px",
            fontFamily: that.xaxislabelfontfamily()
          },
          events: {
            click: function() {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        title: {
          text: that.xaxistitletext(),
          align: that.xaxistitlealign(),
          rotation: that.xaxistitlerotation(),
          offset: that.xaxistitleoffset(),
          margin: that.xaxistitlemargin(),
          style: {
            color: that.xaxistitlecolor(),
            fontWeight: that.xaxistitlefontweight(),
            textDecoration: that.xaxistitlefontweight(),
            fontSize: that.xaxistitlefontsize() + "px",
            fontFamily: that.xaxistitlefontfamily(),
            display: that.xaxistitleenabled() === true ? "block" : "none"
          }
        },
        plotBands: [
          {
            color:
              that.xaxisplotbandenabled() === true
                ? that.xaxisplotbandcolor()
                : null,
            borderColor:
              that.xaxisplotbandenabled() === true
                ? that.xaxisplotbandbordercolor()
                : null,
            borderWidth: that.xaxisplotbandborderwidth(),
            from: that.xaxisplotbandfrom(),
            to: that.xaxisplotbandto(),
            zIndex: that.xaxisplotbandzindex(),
            events: {
              click: function() {
                that.fireEvent("xaxisplotbandonclick");
              }
            },
            label: {
              style: {
                color: that.xaxisplotbandlabelcolor(),
                fontWeight: that.xaxisplotbandlabelfontweight(),
                textDecoration: that.xaxisplotbandlabelfontweight(),
                fontSize: that.xaxisplotbandlabelfontsize() + "px",
                fontFamily: that.xaxisplotbandlabelfontfamily(),
                display:
                  that.xaxisplotbandlabelenabled() === true ? "block" : "none"
              },
              text: that.xaxisplotbandlabeltext(),
              align: that.xaxisplotbandlabelalign(),
              rotation: that.xaxisplotbandlabelrotation(),
              textAlign: that.xaxisplotbandlabeltextalign(),
              verticalAlign: that.xaxisplotbandlabelverticalalign(),
              x:
                that.xaxisplotbandlabelxposition() === ""
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelxposition()),
              y:
                that.xaxisplotbandlabelyposition() === ""
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelyposition())
            }
          }
        ],
        plotLines: [
          {
            color:
              that.xaxisplotlineenabled() === true
                ? that.xaxisplotlinecolor()
                : null,
            dashStyle: that.xaxisplotlinedashstyle(),
            width: that.xaxisplotlinewidth(),
            value: that.xaxisplotlinevalue(),
            zIndex: that.xaxisplotlinezindex(),
            label: {
              style: {
                color: that.xaxisplotlinelabelcolor(),
                fontWeight: that.xaxisplotlinelabelfontweight(),
                textDecoration: that.xaxisplotlinelabelfontweight(),
                fontSize: that.xaxisplotlinelabelfontsize() + "px",
                fontFamily: that.xaxisplotlinelabelfontfamily(),
                display:
                  that.xaxisplotlinelabelenabled() === true ? "block" : "none"
              },
              text: that.xaxisplotlinelabeltext(),
              align: that.xaxisplotlinelabelalign(),
              rotation: that.xaxisplotlinelabelrotation(),
              textAlign: that.xaxisplotlinelabeltextalign(),
              verticalAlign: that.xaxisplotlinelabelverticalalign(),
              x:
                that.xaxisplotlinelabelxposition() == "null"
                  ? null
                  : _.parseInt(that.xaxisplotlinelabelxposition()),
              y:
                that.xaxisplotlinelabelyposition() == "null"
                  ? null
                  : _.parseInt(that.xaxisplotlinelabelyposition())
            }
          }
        ]
      },
      yAxis: {
        allowDecimals: that.yaxisallowdecimals(),
        alternateGridColor: that.yaxisalternategridcolor(),
        gridLineColor: that.yaxisgridlinecolor(),
        gridLineDashStyle: that.yaxisgridlinedashstyle(),
        gridLineWidth: that.yaxisgridlinewidth(),
        gridZIndex: that.yaxisgridzindex(),
        lineColor: that.yaxislinecolor(),
        //polar
        lineWidth: that.yaxislinewidth(),
        minorGridLineColor: that.yaxisminorgridlinecolor(),
        minorGridLineDashStyle: that.yaxisminorgridlinedashstyle(),
        minorGridLineWidth: that.yaxisminorgridlinewidth(),
        minorTickInterval:
          that.radarminorgridlineinterval() === ""
            ? null
            : that.radarminorgridlineinterval(),
        tickInterval:
          that.yaxistickinterval() === 0 || that.yaxistickinterval() === ""
            ? null
            : _.parseInt(that.yaxistickinterval()),
        tickmarkPlacement: "on",
        dateTimeLabelFormats: {},
        ceiling:
          that.yaxisceiling() === "" ? null : _.parseInt(that.yaxisceiling()),
        floor: that.yaxisfloor() === "" ? null : _.parseInt(that.yaxisfloor()),
        min: that.yaxismin() === "" ? null : _.parseInt(that.yaxismin()),
        max: that.yaxismax() === "" ? null : _.parseInt(that.yaxismax()),
        maxPadding:
          that.yaxismaxpadding() === ""
            ? null
            : parseFloat(that.yaxismaxpadding()),
        minPadding:
          that.yaxisminpadding() === ""
            ? null
            : parseFloat(that.yaxisminpadding()),
        minRange: that.yaxisminrange(),
        showEmpty: that.yaxisshowempty(),
        showFirstLabel: that.yaxisshowfirstlabel(),
        showLastLabel: that.yaxisshowlastlabel(),
        title: {
          text: that.yaxistitletext(),
          align: that.yaxistitlealign(),
          rotation: that.yaxistitlerotation(),
          offset: offsetaxis(
            that.yaxistitleenabled(),
            that.yaxistitleoffset(),
            that.yaxistitletext()
          ),
          margin: that.yaxistitlemargin(),
          style: {
            color: that.yaxistitlecolor(),
            fontWeight: that.yaxistitlefontweight(),
            textDecoration: that.yaxistitlefontweight(),
            fontSize: that.yaxistitlefontsize() + "px",
            fontFamily: that.yaxistitlefontfamily(),
            display: that.yaxistitleenabled() === true ? "block" : "none"
          }
        },
        labels: {
          align: that.yaxislabelalign(),
          enabled: that.yaxislabelenabled(),
          formatter: function() {
            return vbiHighchartsDefault["Yaxis_autoscale_formatter"](that, this); // jshint ignore:line
          },
          rotation: that.yaxislabelrotation(),
          staggerLines:
            that.yaxislabelstaggerline() === ""
              ? null
              : _.parseInt(that.yaxislabelstaggerline()),
          maxStaggerLines:
            that.yaxislabelmaxstaggerline() === ""
              ? null
              : _.parseInt(that.yaxislabelmaxstaggerline()),
          step: that.yaxislabelstep(),
          x: that.yaxislabelx(),
          y: that.yaxislabely(),
          zIndex: that.yaxislabelzindex(),
          style: {
            color: that.yaxislabelcolor(),
            fontWeight: that.yaxislabelfontweight(),
            textDecoration: that.yaxislabelfontweight(),
            fontSize: that.yaxislabelfontsize() + "px",
            fontFamily: that.yaxislabelfontfamily()
          },
          events: {
            click: function() {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        plotBands: [
          {
            color:
              that.yaxisplotbandenabled() === true
                ? that.yaxisplotbandcolor()
                : null,
            borderColor:
              that.yaxisplotbandenabled() === true
                ? that.yaxisplotbandbordercolor()
                : null,
            borderWidth: that.yaxisplotbandborderwidth(),
            from: that.yaxisplotbandfrom(),
            to: that.yaxisplotbandto(),
            zIndex: that.yaxisplotbandzindex(),
            events: {
              click: function() {
                that.fireEvent("yaxisplotbandonclick");
              }
            },
            label: {
              style: {
                color: that.yaxisplotbandlabelcolor(),
                fontWeight: that.yaxisplotbandlabelfontweight(),
                textDecoration: that.yaxisplotbandlabelfontweight(),
                fontSize: that.yaxisplotbandlabelfontsize() + "px",
                fontFamily: that.yaxisplotbandlabelfontfamily(),
                display:
                  that.yaxisplotbandlabelenabled() === true ? "block" : "none"
              },
              text: that.yaxisplotbandlabeltext(),
              align: that.yaxisplotbandlabelalign(),
              rotation: that.yaxisplotbandlabelrotation(),
              textAlign: that.yaxisplotbandlabeltextalign(),
              verticalAlign: that.yaxisplotbandlabelverticalalign(),
              x:
                that.yaxisplotbandlabelxposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotbandlabelxposition()),
              y:
                that.yaxisplotbandlabelyposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotbandlabelyposition())
            }
          }
        ],
        plotLines: [
          {
            color:
              that.yaxisplotlineenabled() === true
                ? that.yaxisplotlinecolor()
                : null,
            dashStyle: that.yaxisplotlinedashstyle(),
            width: that.yaxisplotlinewidth(),
            value: that.yaxisplotlinevalue(),
            zIndex: that.yaxisplotlinezindex(),
            label: {
              style: {
                color: that.yaxisplotlinelabelcolor(),
                fontWeight: that.yaxisplotlinelabelfontweight(),
                textDecoration: that.yaxisplotlinelabelfontweight(),
                fontSize: that.yaxisplotlinelabelfontsize() + "px",
                fontFamily: that.yaxisplotlinelabelfontfamily(),
                display:
                  that.yaxisplotlinelabelenabled() === true ? "block" : "none"
              },
              text: that.yaxisplotlinelabeltext(),
              align: that.yaxisplotlinelabelalign(),
              rotation: that.yaxisplotlinelabelrotation(),
              textAlign: that.yaxisplotlinelabeltextalign(),
              verticalAlign: that.yaxisplotlinelabelverticalalign(),
              x:
                that.yaxisplotlinelabelxposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotlinelabelxposition()),
              y:
                that.yaxisplotlinelabelyposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotlinelabelyposition())
            }
          }
        ]
      },
      loading: vbiHighchartsDefault.createDefaultObjects("commonLoading", that),
      tooltip: vbiHighchartsDefault.createDefaultObjects("commonTooltip", that),
      legend: vbiHighchartsDefault.createDefaultObjects("commonLegend", that),
      plotOptions: {
        series: {
          stacking: options.chartType == "bar" ? "normal" : "",
          borderWidth: 0,
          cursor: "pointer",
          //allowPointSelect: true,
          point: {
            events: {
              click: function(event) {
                try {
                  that.selectedvalue(
                    seriesLibrary.createMemberData(
                      that,
                      that.categoriesIndex[event.point.index],
                      event.point.series.options.key
                    )
                  );
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }
              },

              select: function() {
                try {
                  that.selectedPoints = component.highcharts().getSelectedPoints();
                  that.selectedPoints.push(this);
                  that.selectedvalues(
                    seriesLibrary
                      .createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints
                      )
                      .toString()
                  );
                  seriesLibrary.onSelectFunction(that);
                  /**
                      *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                      **/
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }
              },

              unselect: function() {
                try {
                  // var unselectedPoints = component.highcharts().getSelectedPoints();
                  var index = that.selectedPoints.indexOf(this);
                  if (index > -1) {
                    that.selectedPoints.splice(index, 1);
                  }

                  that.selectedvalues(
                    seriesLibrary
                      .createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints
                      )
                      .toString()
                  );
                  if (that.selectedvalues() === "") {
                    that.selectedvalue("");
                  } else {
                    var select = seriesLibrary.createMembersData(
                      that,
                      that.categoriesIndex,
                      that.selectedPoints
                    );
                    that.selectedvalue(select[0]);
                  }
                  /**
                       *Selectedvalue fix in all charts
                       *Multiple Selection getting the last selected value.
                      **/
                  if (that.clearSelect) {
                    if (that.selectedvalues() === "") {
                      that.clearSelect = false;
                    }
                  } else {
                    seriesLibrary.onSelectFunction(that);
                  } //clearselection callback issue on Onselect.

                  /**
                      *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                      **/
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }
              }
            }
          }
        },
        area: {
          animation: that.result()
            ? that.result().tuples.length > 1000 ? false : that.chartanimation()
            : that.chartanimation(),
          //initial animation
          allowPointSelect: that.allowpointselect(),
          connectNulls: that.connectnulls(),
          cropThreshold: that.cropthreshold(),
          turboThreshold: that.turbothreshold(),
          pointPlacement: options.chartType == "column" ? "between" : null,
          dataLabels: {
            allowOverlap: that.allowoverlap(),
            enabled: that.datalabelenabled(),
            align: that.datalabelalign(),
            crop: that.datalabelcrop(),
            //defer: that.datalabeldefer(),
            backgroundColor: that.datalabelbackgroundcolor(),
            useHTML: false,
            borderColor: that.datalabelbordercolor(),
            borderRadius: that.datalabelborderradius(),
            borderWidth: that.datalabelborderwidth(),
            padding: that.datalabelpadding(),
            rotation: that.datalabelrotation(),
            shadow: that.datalabelshadow(),
            verticalAlign: that.datalabelverticalalign(),
            x: that.datalabelx(),
            y: that.datalabely(),
            style: {
              textShadow: false,
              color: that.datalabeltextcolor(),
              fontWeight: that.datalabelfontweight(),
              textDecoration: that.datalabelfontweight(),
              fontSize: that.datalabelfontsize() + "px",
              fontFamily:
                that.globalfont() === true
                  ? that.fontfamily()
                  : that.datalabelfontfamily()
            }
          } /*marker: {
                  fillColor: that.markerfillcolor(),
                  lineColor: that.markerlinecolor(),
                  lineWidth: that.markerlinewidth(),
                  radius: that.markerradius(),
                  states: {
                      hover: {
                          fillColor: that.markerhoverfillcolor(),
                          lineColor: that.markerhoverlinecolor(),
                          lineWidth: that.markerhoverlinewidth(),
                          radius: that.markerhoverradius(),
                          lineWidthPlus: that.markerhoverlinewidthplus(),
                          radiusPlus: that.markerhoverradiusplus()
                      },
                      select: {
                          fillColor: that.markerselectfillcolor(),
                          lineColor: that.markerselectlinecolor(),
                          lineWidth: that.markerselectlinewidth(),
                          radius: that.markerselectradius()
                      }
                  }
              }*/
        }
      },
      series: that.newseries
    };
    return defaultValue;
  };

  this.attachGetters=function(component,options){

    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    component.measureValidation = function() {
        var returnValue = false;
        var measureinrow = false;
        try {
          for (var i = 0; i < component.result().dimensions.length; i++) {
            if (component.result().dimensions[i].containsMeasures === true && component.result().dimensions[i].axis == 'ROWS') {
              measureinrow = true;
            }
          }

          if (measureinrow === true) {
            returnValue = false;
          } else {
            returnValue = true;
          }  //return true;
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }

        return returnValue + '';  //callruntime handler won't handle object and boolean hence return string
      };
    component.getDropdownName = function() {
      return component.list();
    };

    component.getChartNames = function() {
      return component.globalVal;
    };

    component.getDataLengthVal = function() {
      return JSON.stringify(component.result());
    };

    component.getMeasuresNamesForFormatter = function(){
        return vbiNumberFormat.getMeasuresNamesForFormatter(component);
    };

      component.getDataSeries = function() {
  if (!component.dataRes) { return null; }
    var dataSeries = [];
    var seriesNames = [];
    var seriesKeyNames = [];
    component.dataRes = component.dispKeyTextResultSet();
    var bardatacustomizationJson = {
      'COLUMNS': [],
      'ROWS': []
    };
    if (component.bardatacustomization() !== '') {
      bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
    }

    try {
      if (component.dataRes === undefined || component.dataRes === '') {
        return null;
      } else if (component.datautility() === true && bardatacustomizationJson['COLUMNS'].length === 0 && bardatacustomizationJson['ROWS'].length === 0) {
        return null;
      }

      if (component.dataRes.dimensions.length === 1 && component.dataRes.dimensions[0].containsMeasures === true) {
        var defaultColor = [
          '#B586DA',
          '#FF6657',
          '#F3A730',
          '#946B66',
          '#B0AD53',
          '#7AC1DE',
          '#F1C337',
          '#566C6C',
          '#A1CC54',
          '#543F1E'
        ];
        var seriesColor = [];
        if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
          seriesColor = [];
        } else {
          seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
        }

        if (component.dataRes.dimensions[0].axis == 'COLUMNS') {
          for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {
            seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
            seriesNames.push(component.dataRes.dimensions[0].members[i].picker_text); // jshint ignore:line
            seriesKeyNames.push(component.dataRes.dimensions[0].members[i].key);
          }
        } else {
          seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
          seriesNames.push('Measures');
          seriesKeyNames.push('Measures');
        }

        dataSeries = [
          seriesNames,
          seriesKeyNames
        ];
        seriesColor.splice(dataSeries[0].length, seriesColor.length);
        component.dataseriescolor(seriesColor.join());
      } else {
        //  dataSeries = seriesLibrary.createSeriesData(component, 'bar', component.defaultValueSeriesNames,"ncf");
        dataSeries = seriesLibrary.createSeriesAdditionalProperty(component, 'bar');
      }
    } catch (e) {   seriesLibrary.DSXalert(e.message);
    }

    return dataSeries;
  };

      component.getDataSeriesColor = function() {
        var dataseriescolor = '';
        try {
          dataseriescolor = component.dataseriescolor();
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }

        return dataseriescolor;
      };

      component.getDatUtility = function() {
        var datautility = '';
        try {
          datautility = component.datautility();
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }

        return datautility;
      };

      component.getChartType = function() {
        return 'bar';
      };

      component.isMeasureOnly = function() {
        var len = 0;
        if (component.result() !== undefined && component.result() !== '') {
          try {
            len = component.result().dimensions.length;
          } catch (e) {   seriesLibrary.DSXalert(e.message);
          }
        }

        return len;
      };

      component.getLegendNames = function() {
      var leglist = [];
      var charttype = [];
      var legcolors = [];
      var leglistkey = [];
      if (component.result() !== undefined && component.result() !== '') {
        try {
          for (var i = 0; i < component.defaultValueSeriesNames.series.length; i++) {
            leglist.push(component.defaultValueSeriesNames.series[i].name);
            charttype.push(chartType);
            legcolors.push(component.defaultValueSeriesNames.series[i].color);
            leglistkey.push(component.defaultValueSeriesNames.series[i].uniquekey);//Making changes because same series-name causing problem VBX141-3099
          }
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return [
        leglist,
        charttype,
        legcolors,
        leglistkey
      ];
    };

    component.componentDeleted = function() {
      $('#dsui_' + componentID).remove();
    };

    component.getChartFamily = function() {
      return 'bar';
    };
  }

}
