function ScatterChartUtil(){
    componentUtil.call(this);

    this.getSampleDataSeries = function () {
        var seriesData = [

            {
                name: 'Budget',
                data: [

                    {
                        name: 'Point 1',
                        x: 97,
                        y: 36
                    },

                    {
                        name: 'Point 2',
                        x: 94,
                        y: 74
                    },
                    {
                        name: 'Point 3',
                        x: 68,
                        y: 76
                    },
                    {
                        name: 'Point 4',
                        x: 64,
                        y: 87
                    },
                    {
                        name: 'Point 5',
                        x: 68,
                        y: 27
                    },
                    {
                        name: 'Point 6',
                        x: 74,
                        y: 99
                    },
                    {
                        name: 'Point 7',
                        x: 7,
                        y: 93
                    },
                    {
                        name: 'Point 8',
                        x: 51,
                        y: 69
                    },
                    {
                        name: 'Point 9',
                        x: 38,
                        y: 23
                    },
                    {
                        name: 'Point 10',
                        x: 57,
                        y: 86
                    }
                ],
                color: '#588EC0'
            },
            {
                name: 'Forecast',
                data: [{
                        name: 'Point 11',
                        x: 25,
                        y: 10
                    },
                    {
                        name: 'Point 12',
                        x: 2,
                        y: 75
                    },
                    {
                        name: 'Point 13',
                        x: 11,
                        y: 54
                    },
                    {
                        name: 'Point 14',
                        x: 86,
                        y: 55
                    },
                    {
                        name: 'Point 15',
                        x: 5,
                        y: 3
                    },
                    {
                        name: 'Point 16',
                        x: 90,
                        y: 63
                    },
                    {
                        name: 'Point 17',
                        x: 91,
                        y: 33
                    },
                    {
                        name: 'Point 18',
                        x: 97,
                        y: 3
                    },
                    {
                        name: 'Point 19',
                        x: 15,
                        y: 67
                    },
                    {
                        name: 'Point 20',
                        x: 54,
                        y: 25
                    }
                ],
                color: '#FF9E5E'
            },
            {
                name: 'Actual',
                data: [{
                        name: 'Point 21',
                        x: 47,
                        y: 47
                    },
                    {
                        name: 'Point 22',
                        x: 20,
                        y: 12
                    },
                    {
                        name: 'Point 23',
                        x: 6,
                        y: 76
                    },
                    {
                        name: 'Point 24',
                        x: 38,
                        y: 30
                    },
                    {
                        name: 'Point 25',
                        x: 57,
                        y: 98
                    },
                    {
                        name: 'Point 26',
                        x: 61,
                        y: 17
                    },
                    {
                        name: 'Point 27',
                        x: 83,
                        y: 60
                    },
                    {
                        name: 'Point 28',
                        x: 67,
                        y: 78
                    },
                    {
                        name: 'Point 29',
                        x: 64,
                        y: 12
                    },
                    {
                        name: 'Point 30',
                        x: 30,
                        y: 77
                    }
                ],
                color: '#C6E06D'
            }
        ];
        return seriesData;

    }

    this.attachGetters=function(component,options){
        this.attachBaseGetters(component,options);

        var dependencyObject = options.dependencyObject;
        var seriesLibrary = dependencyObject.SeriesLibrary;
        var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

        component.createxternalDimensionsfulljson = function(component) {
            var tempDimension = component['fulljson']();
            var dimeKey;
            if (tempDimension.dimensions) {
            if ('externalDimensions' in tempDimension && tempDimension.dimensions.length > 1) {
            tempDimension.dimensions[0].containsMeasures = true;
            //Adding Dummy Contain Measure
            for (var i = 0; i < tempDimension.externalDimensions.length; i++) {
              if (tempDimension.externalDimensions[i].containsMeasures) {
                dimeKey = i;
              }
            }
            //Getting externalDimensions-KeyFirgure Location.
            for (var j = 0; j < tempDimension.dimensions[0].members.length; j++) {
              tempDimension.dimensions[0].members[j].scalingFactor = tempDimension.externalDimensions[dimeKey].members[0].scalingFactor;
              tempDimension.dimensions[0].members[j].formatString = tempDimension.externalDimensions[dimeKey].members[0].formatString;
            }  //Adding Measure Key Attributes to first-dimension value
            }  //If externalDimensions is in JSON.
            else {
            var tempcontainsMeasures = false;
            for (var i = 0; i < tempDimension.dimensions.length; i++) {
              if ('containsMeasures' in tempDimension.dimensions[i]) {
                tempcontainsMeasures = true;
              }
            }

            if (!tempcontainsMeasures && tempDimension.dimensions.length > 1) {
              tempDimension.dimensions[0].containsMeasures = true;
              //Adding Dummy Contain Measure
              tempDimension.dimensions[0].noMeasure = true;
              for (var j = 0; j < tempDimension.dimensions[0].members.length; j++) {
                tempDimension.dimensions[0].members[j].scalingFactor = '';
                tempDimension.dimensions[0].members[j].formatString = '';
              }  //Adding Measure Key Attributes to first-dimension value
            }
            }
            }
        };

        component.dispKeyTextResultSet = function() {
        if (component.result() === null||component.result() === undefined || component.result() === '' || component.result().data === undefined) {
          return undefined;
        } else {

         //Hiearchy key formattting for conditional formatting
        if(component.dataRes !== undefined){
           $.each(component.dataRes.dimensions, function(index, value) {
             var isMeasure = value.containsMeasures === undefined ? false : true;
               $.each(value.members, function(i, m) {
                if (isMeasure !== true && m.type != 'RESULT' || component.showtotaldatabase()) {
                   seriesLibrary.checkifOnlyKey(m);
                }
              });
             });
        }

          ifOnlyKeyVar = 0;
          var jsonResultSetStr = JSON.stringify(component.dataRes);
          // component is done to avoid reference to original resultset
          var jsonResultSet = {};
          jsonResultSet = jQuery.parseJSON(jsonResultSetStr);
          var dispKeyText = component.dispkeytext();
          $.each(jsonResultSet.dimensions, function(index, value) {
            var isMeasure = value.containsMeasures === undefined ? false : true;
            value['picker_text'] = seriesLibrary.getTextForDimWindow(value);
            value.text = seriesLibrary.dispKeyText(value, dispKeyText, isMeasure);
            var isKeyonly = 1;
            $.each(value.members, function(i, m) {
              if (isMeasure !== true && m.type != 'RESULT' && isKeyonly == 1) {
                isKeyonly = seriesLibrary.checkifOnlyKey(m);
              }
              if(m.text === null){
                m.text = '';
              }
              m['picker_text'] = seriesLibrary.getTextForDimWindow(m);
              m.text = seriesLibrary.dispKeyText(m, dispKeyText, isMeasure);
            });

            if (!isMeasure) {
              component.keysArray.push(isKeyonly);
            }
          });

         // var value = 1;
          var oneSize = component.keysArray.filter(function(value) {
            return value == 1;
          }).length;
          if (oneSize > 0) {
            ifOnlyKeyVar = 1;
            if (component.dispkeytext() != 'default') {
              component.dispkeytext('default');
              return component.dispKeyTextResultSet();
            }
          }
          //alert(JSON.stringify(jsonResultSet.dimensions));
          return jsonResultSet;
        }
      };

      component.getOnlyKeyFlag = function() {
        return ifOnlyKeyVar.toString();
      };

      component.createIdentical = function(defaultValue) {
        var entireData = [];
        for (var i = 0; i < defaultValue.series.length; i++) {
            if(defaultValue.series[i].data){
          for (var j = 0; j < defaultValue.series[i].data.length; j++) {
            entireData.push(defaultValue.series[i].data[j].y || 0);
          }
            }
        }

        if (entireData.length > 0) {
          if (entireData && entireData.length > 0) {
            component.minimumValue = entireData.reduce(function(p, v) {
            return p < v ? p : v;
          });

            component.maximumValue = entireData.reduce(function(p, v) {
            return p > v ? p : v;
          });
          }
          /*
                  * Getting all the value in a array
                  * sorting minimum and maximum value in it.
                  */
          if (component.minimumValue === undefined) {
            component.minimumValue = 0;
            component.maximumValue = 250;
          }

          var restart = component['chartRestart']();
          var testingArrayTemp = component['testingArray']();
          var minimumVal = Math.floor(component.minimumValue).toFixed(component.datavaluedecimals());
          var maximumVal = Math.ceil(component.maximumValue).toFixed(component.datavaluedecimals());
          var listGroup = component['list']();
          var datasourceAssigned = component['DATA_SOURCE_ALIAS_REF']();
          var chartId = component['id']();
          var customMin= component['groupingyaxismin']();
          var customMax = component['groupingyaxismax']();
          if (WhatIfLibrary != undefined && listGroup != '' || restart != 0) { /* jshint ignore: line */
            WhatIfLibrary.register(chartId, {
            type: 'Chart',
            name: 'Scatter Chart',
            category: 'charts',
            "data_source": datasourceAssigned,
            "custom_function": {
              "custom_id_min_value": minimumVal,
              "custom_id_max_value": maximumVal,
              "custom_id_groupId": testingArrayTemp,
              "custom_id_SelectedValue": listGroup,
              "custom_id_min":customMin,
              "custom_id_max":customMax
            }
          }, component);
          }
          /*
                  * Getting the minimum and maximum value and pushing it to whatifAnalyser(updating).
                  * and also grouping name.
                  */
          component.globalVal.push('None');
          for (var i in WhatIfLibrary.charts) {
            if (WhatIfLibrary.charts[i]["custom_function"] !== undefined) {
              var gettingArray = WhatIfLibrary.charts[i]["custom_function"]["custom_id_groupId"];
              for (var j = 0; j < gettingArray.split(',').length; j++) {
                var localTest = gettingArray.split(',');
                if (component.globalVal.indexOf(localTest[j]) == -1) {
                  component.globalVal.push(localTest[j]);
                }
              }
            }
          }

         // var tempMax = component.minimumValue;
         // var tempMin = component.maximumValue;
          seriesLibrary.creatIndenticalScaling(component, defaultValue, minimumVal, maximumVal, WhatIfLibrary);
          //identicalScaling Fix
          if (listGroup != '' || restart != 0) { // jshint ignore:line
            if (listGroup != 'None') {
             componentUtil.callHighCharts(component,component, defaultValue,{dependencyObject:dependencyObject,seriesData:seriesData});//jshint ignore:line
            }
          }
        }  //To stop the events
      };


      component.dataManipulation = function() {
        var seriesColor = component.dataseriescolor().split(',');
        var seriesData = [{}];
        var count = 0;
        var memberArray = vbiCharts.getMemberArray(component.dataRes, 'text', 0);
        //actual expected
        seriesData[0].name = memberArray[0];
        seriesData[0].data = [];
        var data = vbiCharts.getResultColumnArray(component.dataRes, 'text', 0);
        var members = vbiCharts.getResultColumnArray(component.dataRes, 'text', 1);
        for (var i = 0; i < data.length; i += memberArray.length) {
          seriesData[0].data.push({
            name: members[i],
            y: data[i],
            color: '#' + seriesColor[count]
          });
          count++;
        }

        return seriesData;
      };

      component.getDataSeriesColor = function() {
        return component.dataseriescolor();
      };

      component.isResultAvailable = function() {
        if (component.dataRes !== undefined && component.dataRes !== '' && component.dataRes !== 0) {
          if (component.keyfigureLength < 2) {
            return false;
          } else if (!component.isDimensionAvailable) {
            return false;
          } else {
            return true;
          }
        }

        return false;
      };

      component.clearbardatacustomization = function() {
        component.datautility(false);
        component.bardatacustomization('');
        component.firePropertiesChanged(['bardatacustomization']);
      };
      component.getDiminsionCount = function(){
         var rowSelected = [];
         if (component.dataRes !== undefined && component.dataRes !== '' && component.dataRes !== 0) {
            var rowSelected = [];
              for (var i = 0; i < component.dataRes.dimensions.length; i++) {
              if (component.dataRes.dimensions[i].axis == 'ROWS' && component.dataRes.dimensions[i].containsMeasures !== true) {
                rowSelected.push({index:i});
                if(!component.showtotaldatabase() && component.datautility() !== true){
                  break;
                }
              }
            }
          }
          return rowSelected.length;

      };

    //Function to get Series Name
    component.getDataSeries = function() {
    var seriesName = [];
    var seriesKey = [];

    try {
      if (component.dataRes !== undefined && component.dataRes !== '' && component.dataRes !== 0) {
        var rowSelected = [];
          for (var i = 0; i < component.dataRes.dimensions.length; i++) {
          if (component.dataRes.dimensions[i].axis == 'ROWS' && component.dataRes.dimensions[i].containsMeasures !== true) {
            rowSelected.push({index:i});
            if(!component.showtotaldatabase() && component.datautility() !== true){
              break;
            }
          }
        }

        if (component.keyfigureLength < 2) {
          component.noData = 1;//jshint ignore:line
        } else if (!component.isDimensionAvailable) {
          component.noData = 2;//jshint ignore:line
        } else if (rowSelected.length <= 0) {
          component.noData = 5;//jshint ignore:line
        } else {
          var measureJson = JSON.parse(component.getMeasureJson());
          if (component.xaxismeasure() === null || component.xaxismeasure() === undefined || component.xaxismeasure() === '' || measureJson[component.xaxismeasure()] === undefined) {
            component.xaxismeasure(component.dataRes.dimensions[component.keyfigureIndex].members[0].key);
          }

          if (component.yaxismeasure() === null || component.yaxismeasure() === undefined || component.yaxismeasure() === '' || measureJson[component.yaxismeasure()] === undefined) {
            component.yaxismeasure(component.dataRes.dimensions[component.keyfigureIndex].members[1].key);
          }

          if (rowSelected.length > 0) {
            var selectedRowIndex = -1;
            selectedRowIndex = rowSelected[0].index;

            if (selectedRowIndex != -1) {
              for (var i = 0; i < component.dataRes.dimensions[selectedRowIndex].members.length; i++) {
                if (component.dataRes.dimensions[selectedRowIndex].members[i].type != 'RESULT' || component.showtotaldatabase()) {
                  seriesName.push(component.dataRes.dimensions[selectedRowIndex].members[i].text);
                  seriesKey.push(component.dataRes.dimensions[selectedRowIndex].members[i].key);
                }
              }
            }
          }

          component.noData = 0;//jshint ignore:line
        }
      }
    } catch (err) {
    }
    if (component.showtotal() === true) {
            seriesName.push('Total Result');
            seriesKey.push('Total Result');
    }

    if (component.noData !== 0) {//jshint ignore:line
      seriesName = [];
      seriesKey = [];
      component.dataseriescolor('');
    //  component.bardatacustomization('');
    }

    return [
      seriesName,
      seriesKey
    ];
    };

    component.getMeasureMembers = function() {
    return seriesLibrary.getMeasureMembers(component);
    };

    component.isMeasureOnly = function() {
    var len = 0;
    if (component.result() !== undefined && component.result() !== '') {
      try {
        len = component.result().dimensions.length;
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }
    }

    return len;
    };

    component.getDropdownName = function() {
    return component.list();
    };

    component.getDataLengthVal = function() {
    return JSON.stringify(component.result());
    };

    component.getMeasureJson = function() {
    var measureJson = {};
    for (var i = 0; i < component.result().dimensions.length; i++) {
      if ('containsMeasures' in component.result().dimensions[i]) {
        $.each(component.dataRes.dimensions[i].members, function(key, value) {
          measureJson[value.key] = {
            text: value.text,
            index: key
          };
        });

        break;
      }
    }

    return JSON.stringify(measureJson);
    };

    component.componentDeleted = function() {
    $('#dsui_' + componentID).remove();
    function triggerDelete() {
      var chartId = component['id']();
      if (WhatIfLibrary !== undefined) {
        for (var i in WhatIfLibrary.charts) {
          if (i === chartId) {
            //Removing current instances from WhatIfLibrary
            delete WhatIfLibrary.charts[i];
            delete WhatIfLibrary.instances[i];
          }
        }
        /*
                          *Deleting the Removed chart from the WhatIfLibrary
                          *Manually Removed
                          *WhatIfLibrary is removing only after window.refresh Hence removing Manually
                          */
        for (var i in WhatIfLibrary.charts) {
          if (sap.zen.Dispatcher.instance.getRootControlForComponentId(i) !== undefined) {
            var instance = WhatIfLibrary.getInstance(i);
            if (instance.list() !== '' || instance.list() != 'None') {
              instance.afterUpdate();
            }
          }  /*
                            *Trigger afterUpdate of the charts which are grouped
                            *Auto-AfterUpdate is not getting trigged
                            */
        }
      }
    }

    setTimeout(triggerDelete, 200);  //getRootControlForComponentId need a setTimeout
    };

    component.getChartType = function() {
    return 'scatter';
    };

    component["getTrendline_add"] = function() {
    return component.yaxisstartontick();
    };

    component["getTrendline_json"] = function() {
    return component.testingArrayjson().toString();
    };

    component.getTrendlineColor = function(){
    if(component.trendcolorpickervalue()){
      return component.trendcolorpickervalue();
    }
    else{
       return false;
    }

    };

    component.getMeasuresNamesForFormatter = function(){
      return vbiNumberFormat.getMeasuresNamesForFormatter(component);
    };

    component.getChartFamily = function() {
    return 'scatter';
    };

    component.lassoFireProp = function(selectedPoints) {
    component.selectedvalues(seriesLibrary.createMembersData(component, undefined, selectedPoints).toString());
    //columncolorChanged++;
    component.firePropertiesChanged(['selectedvalues']);
    };

    component.getChartNames = function() {
        return component.globalVal;
    };


}
}