function SuperCombinationChartUtil(){
  componentUtil.call(this);

  this.getSampleDataSeries = function() {
    var seriesData = [
      {
        type: "column",
        name: "Jane",
        data: [3, 2, 1, 3, 4]
      },
      {
        type: "column",
        name: "John",
        data: [2, 3, 5, 7, 6]
      },
      {
        type: "column",
        name: "Joe",
        data: [4, 3, 3, 9, 0]
      },
      {
        type: "spline",
        name: "Average",
        data: [3, 2.67, 3, 6.33, 3.33],
        marker: {
          lineWidth: 2,
          lineColor: Highcharts.getOptions().colors[3] //  fillColor: 'white'
        }
      },
      {
        type: "pie",
        name: "Total consumption",
        data: [
          {
            name: "Jane",
            y: 13,
            color: Highcharts.getOptions().colors[0] // Jane's color
          },
          {
            name: "John",
            y: 23,
            color: Highcharts.getOptions().colors[1] // John's color
          },
          {
            name: "Joe",
            y: 19,
            color: Highcharts.getOptions().colors[2] // Joe's color
          }
        ],
        center: [100, 80],
        size: 100,
        showInLegend: false
      }
    ];
    return seriesData;
  };

  this.getDefaultValue=function(that,options){
    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
    var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue; // jshint ignore:line
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
    var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
    var lassoObj = SeriesLibrary.prototype.lasso;
    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
    var component = that.$();
    var thousandsep = that.progressthousandseparator();
    var decimalsep = that.progressdecimalseparator();
    var isExportEnable = that.exportingsymbolenabled();
    if (that.enableMoreActionsButton && isExportEnable) {
      isExportEnable =
        !that.enableMoreActionsButton() && !that.enableContextMenu();
    }
    var onSelectFunction = function(that){
      if (that.keyTimer) {
        clearTimeout(that.keyTimer);
      }

      that.keyTimer = setTimeout(function() {
        that.firePropertiesChangedAndEvent([
      'selectedvalue',
      'selectedvalues'
      ], 'chartonpointclick');
    }, 200);
    var currSelectedPie=false;
  /* As discussed with Devaraj From the above line supercombinationcharttype property is removed because it causing the issue with
     hasPropertyChanged function.If you want to add the supercombinationcharttype then u need to handle the hasPropertyChanged function in the serieslibrary also
  */
    };
    //To Avoid offset working even after disabling tile in axis
    var offsetaxis = function(titledisplay, titleoffset, titletext) {
      if (titleoffset == "" || titletext == " ") {
        //jshint ignore:line
        return null;
      } else if (titledisplay === true) {
        return titleoffset;
      } else {
        return null;
      }
    };
    var defaultValue = {
      chart: {
        type: that.supercombinationcharttype().toLowerCase(),
        inverted: that.chartinverted(),
        alignTicks: that.chartalignticks(),
        marginBottom:
          that.chartmarginbottom() == "auto"
            ? null
            : Number(that.chartmarginbottom()),
        marginLeft:
          that.chartmarginleft() == "auto"
            ? null
            : Number(that.chartmarginleft()),
        marginRight:
          that.chartmarginright() == "auto"
            ? null
            : Number(that.chartmarginright()),
        marginTop:
          that.chartmargintop() == "auto" ? null : Number(that.chartmargintop()),
        spacingBottom:
          that.chartpaddingbottom() == "auto"
            ? null
            : Number(that.chartpaddingbottom()),
        spacingLeft:
          that.chartpaddingleft() == "auto"
            ? null
            : Number(that.chartpaddingleft()),
        spacingRight:
          that.chartpaddingright() == "auto"
            ? null
            : Number(that.chartpaddingright()),
        spacingTop:
          that.chartpaddingtop() == "auto"
            ? null
            : Number(that.chartpaddingtop()),
        //   animation: that.result() ?that.result().tuples.length>1000?false:that.chartanimation() :that.chartanimation(),
        className: that.chartcssclassname(),
        events: {
          click: function(event) {
            lassoObj.unselectByClick.call(this, that);
            if (event.target.textContent === "") {
              that.fireEvent("chartonclick");
            }
          },

          load: function() {
            if (vbiContextMenu) {
              vbiContextMenu.highchartsPostProcess();
            }
            //The If condition is fire the charafterload event only once - Fix 1200
            if (!isLoad) {
              that.fireEvent("chartafterload");
              isLoad = true;
            }

            if (that.creditsenabled() === true) {
              this.credits.element.onclick = function() {
                window.open(
                  that.creditshref(),
                  "_blank" // <- This is what makes it open in a new window.
                );
              };
            }
          },

          selection: function(e) {
            var retVal = lassoObj.selectPointsByDrag.call(this, e, that);
            if (this.lasso == "lasso" || this.lasso == "rlasso") {
              that.fireEvent("chartonpointclick");
            } else {
              if (e.xAxis) {
                that.fireEvent("chartonselect");
              } //disabling the fireEvent while zoom out.
            }
            return retVal;
          }
        },
        ignoreHiddenSeries: that.ignorehiddenseries(),
        pinchType: that.chartpinchtype(),
        zoomType: that.chartzoomtype(),
        panning: that.chartpanning(),
        panKey: that.chartpankey(),
        //'shift',
        plotShadow: that.plotshadow(),
        reflow: that.chartflow() || false,
        shadow: that.chartshadow(),
        showaxes: that.showaxes(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            relativeTo: that.zoombuttonrelativeto(),
            verticalAlign: that.zoombuttonverticalalign()
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: { color: that.resetzoombuttontextcolor() },
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: { color: that.resetzoombuttonhovertextcolor() }
              }
            }
          }
        },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor:
          that.plottransparency() === true
            ? "transparent"
            : that.plotbackgroundcolor(),
        plotBackgroundImage: that.plotbackgroundimage().replace(/ /g, ""),
        plotBorderColor: that.plotbordercolor(),
        plotBorderWidth: that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor()
      },
      title: vbiHighchartsDefault.createDefaultObjects("commonTitle", that),
      subtitle: vbiHighchartsDefault.createDefaultObjects("commonSubtitle", that),
      credits: vbiHighchartsDefault.createDefaultObjects("commonCredits", that),
      exporting: {
        buttons: {
          contextButton: {
            enabled: isExportEnable,
            align: that.exportingsymbolalign(),
            verticalAlign: that.exportingsymbolverticalalign(),
            symbol: that.exportingsymbol(),
            symbolFill: that.exportingsymbolfill(),
            symbolSize: that.exportingsymbolsize(),
            symbolStroke: that.exportingsymbolstroke(),
            symbolStrokeWidth: that.exportingsymbolstrokewidth(),
            height:
              that.exportingsymbolheight() == "auto"
                ? 20
                : _.parseInt(that.exportingsymbolheight()),
            width:
              that.exportingsymbolwidth() == "auto"
                ? 24
                : _.parseInt(that.exportingsymbolwidth()),
            symbolX:
              that.exportingsymbolxposition() == "auto"
                ? 12
                : _.parseInt(that.exportingsymbolxposition()),
            symbolY:
              that.exportingsymbolyposition() == "auto"
                ? 10
                : _.parseInt(that.exportingsymbolyposition()),
            x:
              that.exportingxposition() == "auto"
                ? 0
                : _.parseInt(that.exportingxposition()),
            y:
              that.exportingyposition() == "auto"
                ? 0
                : _.parseInt(that.exportingyposition()),
            menuItems: that.chartthemeenabled()
              ? Highcharts.getOptions().exporting.buttons.contextButton.menuItems
              : Highcharts.getOptions().exporting.buttons.contextButton.menuItems.slice(
                  0,
                  10
                ),
            theme: {
              r: that.exportingsymbolradius(),
              fill:
                that.exportingsymbolbackgroundfill() === ""
                  ? null
                  : that.exportingsymbolbackgroundfill(),
              states: {
                hover: { fill: that.exportingsymbolhoverbackgroundfill() }
              }
            }
          }
        },
        filename: that.exportedfilename(),
        sourceWidth: that.exportedchartwidth(),
        sourceHeight: that.exportedchartheight(),
        scale: that.exportedchartscale()
      },
      navigation: vbiHighchartsDefault.createDefaultObjects(
        "commonNavigation",
        that
      ),
      xAxis: {
        categories: ["Apples", "Oranges", "Pears", "Bananas", "Plums"],
        allowDecimals: that.xaxisallowdecimals(),
        alternateGridColor: that.xaxisalternategridcolor(),
        maxPadding: that.xaxismaxpadding(),
        minPadding: that.xaxisminpadding(),
        gridLineColor: that.xaxisgridlinecolor(),
        gridLineDashStyle: that.xaxisgridlinedashstyle(),
        gridLineWidth: that.xaxisgridlinewidth(),
        gridZIndex: that.xaxisgridzindex(),
        ceiling:
          that.xaxisceiling() === "" ? null : _.parseInt(that.xaxisceiling()),
        floor: that.xaxisfloor() === "" ? null : _.parseInt(that.xaxisfloor()),
        lineColor: that.xaxislinecolor(),
        lineWidth: that.xaxislinewidth(),
        minRange: that.xaxisminrange(),
        min: (function() {
          if (
            that.xaxismin() === "" ||
            that.xaxismin() === null ||
            isNaN(_.parseInt(that.xaxismin()))
          ) {
            return null;
          } else if (that.xaxisMinVal === null) {
            return _.parseInt(that.xaxismin());
          } else if (
            _.parseInt(that.xaxismin()) >= _.parseInt(that.xaxisMinVal) &&
            _.parseInt(that.xaxismin()) < _.parseInt(that.xaxisMaxVal)
          ) {
            return _.parseInt(that.xaxismin());
          }

          return null;
        })(),
        //that.xaxismin() === '' ? null : _.parseInt(that.xaxismin()),
        max: (function() {
          if (
            that.xaxismax() === "" ||
            that.xaxismax() === null ||
            isNaN(_.parseInt(that.xaxismax()))
          ) {
            return null;
          } else if (that.xaxisMaxVal === null) {
            return _.parseInt(that.xaxismax());
          } else if (
            _.parseInt(that.xaxismax()) <= _.parseInt(that.xaxisMaxVal) &&
            _.parseInt(that.xaxismax()) > _.parseInt(that.xaxisMinVal)
          ) {
            return _.parseInt(that.xaxismax());
          }

          return null;
        })(),
        //that.xaxismax() === ''? null : _.parseInt(that.xaxismax()),
        opposite: that.xaxisopposite(),
        offset: that.xaxisoffset(),
        reversed: that.xaxisreversed() === true,
        showEmpty: that.xaxisshowempty(),
        showFirstLabel: that.xaxisshowfirstlabel(),
        showLastLabel: that.xaxisshowlastlabel(),
        dateTimeLabelFormats: {},
        minTickInterval: that.xaxismintickinterval(),
        startOnTick: that.xaxisstartontick(),
        endOnTick: that.xaxisendontick(),
        tickColor: that.xaxistickcolor(),
        tickInterval: that.xaxistickinterval(),
        tickLength: that.xaxisticklength(),
        tickPosition: that.xaxistickposition(),
        tickWidth: that.xaxistickwidth(),
        tickmarkPlacement: that.xaxistickmarkplacement(),
        labels: {
          align: that.xaxislabelalign(),
          enabled: that.xaxislabelenabled(),
          format:
            that.xaxislabelprefix() +
            that.xaxislabelformat() +
            that.xaxislabelsuffix(),
          //overflow:that.xaxislabeloverflow(),
          rotation: that.xaxislabelrotation(),
          //distance:that.xaxislabeldistance(),
          staggerLines:
            that.xaxislabelstaggerline() === ""
              ? null
              : _.parseInt(that.xaxislabelstaggerline()),
          maxStaggerLines:
            that.xaxislabelmaxstaggerline() === ""
              ? null
              : _.parseInt(that.xaxislabelmaxstaggerline()),
          step: that.xaxislabelstep() === 0 ? null : that.xaxislabelstep(),
          x: that.xaxislabelx(),
          y: that.xaxislabely(),
          zIndex: that.xaxislabelzindex(),
          style: {
            color: that.xaxislabelcolor(),
            fontWeight: that.xaxislabelfontweight(),
            textDecoration: that.xaxislabelfontweight(),
            fontSize: that.xaxislabelfontsize() + "px",
            fontFamily: that.xaxislabelfontfamily()
          },
          events: {
            click: function() {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        title: {
          text: that.xaxistitletext(),
          align: that.xaxistitlealign(),
          rotation: that.xaxistitlerotation(),
          offset: offsetaxis(
            that.xaxistitleenabled(),
            that.xaxistitleoffset(),
            that.xaxistitletext()
          ),
          margin: that.xaxistitlemargin(),
          style: {
            color: that.xaxistitlecolor(),
            fontWeight: that.xaxistitlefontweight(),
            textDecoration: that.xaxistitlefontweight(),
            fontSize: that.xaxistitlefontsize() + "px",
            fontFamily: that.xaxistitlefontfamily(),
            display: that.xaxistitleenabled() === true ? "block" : "none"
          }
        },
        plotBands: [
          {
            color:
              that.xaxisplotbandenabled() === true
                ? that.xaxisplotbandcolor()
                : null,
            borderColor:
              that.xaxisplotbandenabled() === true
                ? that.xaxisplotbandbordercolor()
                : null,
            borderWidth: that.xaxisplotbandborderwidth(),
            from: that.xaxisplotbandfrom(),
            to: that.xaxisplotbandto(),
            zIndex: that.xaxisplotbandzindex(),
            events: {
              click: function() {
                that.fireEvent("xaxisplotbandonclick");
              }
            },
            label: {
              style: {
                color: that.xaxisplotbandlabelcolor(),
                fontWeight: that.xaxisplotbandlabelfontweight(),
                textDecoration: that.xaxisplotbandlabelfontweight(),
                fontSize: that.xaxisplotbandlabelfontsize() + "px",
                fontFamily: that.xaxisplotbandlabelfontfamily(),
                display:
                  that.xaxisplotbandlabelenabled() === true ? "block" : "none"
              },
              text: that.xaxisplotbandlabeltext(),
              align: that.xaxisplotbandlabelalign(),
              rotation: that.xaxisplotbandlabelrotation(),
              textAlign: that.xaxisplotbandlabeltextalign(),
              //useHTML:that.xaxisplotbandlabelusehtml(),
              verticalAlign: that.xaxisplotbandlabelverticalalign(),
              x:
                that.xaxisplotbandlabelxposition() == "null"
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelxposition()),
              y:
                that.xaxisplotbandlabelyposition() == "null"
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelyposition())
            }
          }
        ],
        plotLines: [
          {
            color:
              that.xaxisplotlineenabled() === true
                ? that.xaxisplotlinecolor()
                : null,
            dashStyle: that.xaxisplotlinedashstyle(),
            width: that.xaxisplotlinewidth(),
            value: that.xaxisplotlinevalue(),
            zIndex: that.xaxisplotlinezindex(),
            label: {
              style: {
                color: that.xaxisplotlinelabelcolor(),
                fontWeight: that.xaxisplotlinelabelfontweight(),
                textDecoration: that.xaxisplotlinelabelfontweight(),
                fontSize: that.xaxisplotlinelabelfontsize() + "px",
                fontFamily: that.xaxisplotlinelabelfontfamily(),
                display:
                  that.xaxisplotlinelabelenabled() === true ? "block" : "none"
              },
              text: that.xaxisplotlinelabeltext(),
              align: that.xaxisplotlinelabelalign(),
              rotation: that.xaxisplotlinelabelrotation(),
              textAlign: that.xaxisplotlinelabeltextalign(),
              verticalAlign: that.xaxisplotlinelabelverticalalign(),
              x:
                that.xaxisplotlinelabelxposition() == "null"
                  ? null
                  : _.parseInt(that.xaxisplotlinelabelxposition()),
              y:
                that.xaxisplotlinelabelyposition() == "null"
                  ? null
                  : _.parseInt(that.xaxisplotlinelabelyposition())
            }
          }
        ]
      },
      yAxis: {
        allowDecimals: that.yaxisallowdecimals(),
        alternateGridColor: that.yaxisalternategridcolor(),
        showFirstLabel: that.yaxisshowfirstlabel(),
        showLastLabel: that.yaxisshowlastlabel(),
        gridLineColor: that.yaxisgridlinecolor(),
        gridLineDashStyle: that.yaxisgridlinedashstyle(),
        gridLineWidth: that.yaxisgridlinewidth(),
        gridZIndex: that.yaxisgridzindex(),
        lineColor: that.yaxislinecolor(),
        lineWidth: that.yaxislinewidth(),
        minorGridLineColor: that.yaxisminorgridlinecolor(),
        minorGridLineDashStyle: that.yaxisminorgridlinedashstyle(),
        minorGridLineWidth: that.yaxisminorgridlinewidth(),
        minorTickColor: that.yaxisminortickcolor(),
        minorTickInterval:
          that.yaxisminortickinterval() == "null"
            ? "auto"
            : _.parseInt(that.yaxisminortickinterval()),
        minorTickLength: that.yaxisminorticklength(),
        minorTickPosition: that.yaxisminortickposition(),
        minorTickWidth: that.yaxisminortickwidth(),
        tickColor: that.yaxistickcolor(),
        tickInterval:
          that.yaxistickinterval() === ""
            ? null
            : _.parseInt(that.yaxistickinterval()),
        tickLength: that.yaxisticklength(),
        tickPosition: that.yaxistickposition(),
        tickWidth: that.yaxistickwidth(),
        /*
                                        tickColor:that.yaxistickcolor(),
                                        tickInterval:that.yaxistickinterval()==='1'?'auto':_.parseInt(that.yaxistickinterval()),
                                        tickLength:that.yaxisticklength(),
                                        tickPosition:that.yaxistickposition(),
                                        tickWidth:that.yaxistickwidth(),
                                        tickmarkPlacement:that.yaxistickmarkplacement(),
                                 */
        ceiling:
          that.yaxisceiling() === "" ? null : _.parseInt(that.yaxisceiling()),
        floor: that.yaxisfloor() === "" ? null : _.parseInt(that.yaxisfloor()),
        endOnTick: that.yaxisendontick(),
        min: (function() {
          if (
            that.yaxismin() === "" ||
            that.yaxismin() === null ||
            isNaN(_.parseInt(that.yaxismin()))
          ) {
            return null;
          } else if (
            that.yaxisMinVal === null ||
            isNaN(that.yaxisMaxVal) ||
            isNaN(that.yaxisMinVal)
          ) {
            return _.parseInt(that.yaxismin());
          } else if (
            _.parseInt(that.yaxismin()) >= _.parseInt(that.yaxisMinVal) &&
            _.parseInt(that.yaxismin()) < _.parseInt(that.yaxisMaxVal)
          ) {
            return _.parseInt(that.yaxismin());
          }

          return null;
        })(),
        //that.yaxismin() == '' ? null : _.parseInt(that.yaxismin()),
        max: (function() {
          if (
            that.yaxismax() === "" ||
            that.yaxismax() === null ||
            isNaN(_.parseInt(that.yaxismax()))
          ) {
            return null;
          } else if (
            that.yaxisMaxVal === null ||
            isNaN(that.yaxisMaxVal) ||
            isNaN(that.yaxisMinVal)
          ) {
            return _.parseInt(that.yaxismax());
          } else if (
            _.parseInt(that.yaxismax()) <= _.parseInt(that.yaxisMaxVal) &&
            _.parseInt(that.yaxismax()) > _.parseInt(that.yaxisMinVal)
          ) {
            return _.parseInt(that.yaxismax());
          }

          return null;
        })(),
        //that.yaxismax() === '' ? null : _.parseInt(that.yaxismax()),
        maxPadding:
          that.yaxismaxpadding() === ""
            ? null
            : parseFloat(that.yaxismaxpadding()),
        minPadding:
          that.yaxisminpadding() === ""
            ? null
            : parseFloat(that.yaxisminpadding()),
        opposite: that.yaxisopposite(),
        minRange: that.yaxisminrange(),
        offset: that.yaxisoffset(),
        reversed: that.yaxisreversed() === true,
        showEmpty: that.yaxisshowempty(),
        //startOnTick:that.yaxisstartontick(),
        title: {
          text: that.yaxistitletext(),
          align: that.yaxistitlealign(),
          rotation: that.yaxistitlerotation(),
          offset: offsetaxis(
            that.yaxistitleenabled(),
            that.yaxistitleoffset(),
            that.yaxistitletext()
          ),
          margin: that.yaxistitlemargin(),
          style: {
            color: that.yaxistitlecolor(),
            fontWeight: that.yaxistitlefontweight(),
            textDecoration: that.yaxistitlefontweight(),
            fontSize: that.yaxistitlefontsize() + "px",
            fontFamily: that.yaxistitlefontfamily(),
            display: that.yaxistitleenabled() === true ? "block" : "none"
          }
        },
        labels: {
          rotation: that.yaxislabelrotation(),
          formatter: function() {
            return vbiHighchartsDefault["Yaxis_autoscale_formatter"](that, this);
          },
          staggerLines:
            that.yaxislabelstaggerline() === ""
              ? null
              : _.parseInt(that.yaxislabelstaggerline()),
          maxStaggerLines:
            that.yaxislabelmaxstaggerline() === ""
              ? null
              : _.parseInt(that.yaxislabelmaxstaggerline()),
          step: that.yaxislabelstep() === 0 ? null : that.yaxislabelstep(),
          x: that.yaxislabelx(),
          y: that.yaxislabely(),
          zIndex: that.yaxislabelzindex(),
          align: that.yaxislabelalign(),
          enabled: that.yaxislabelenabled(),
          style: {
            color: that.yaxislabelcolor(),
            fontWeight: that.yaxislabelfontweight(),
            textDecoration: that.yaxislabelfontweight(),
            fontSize: that.yaxislabelfontsize() + "px",
            fontFamily: that.yaxislabelfontfamily()
          },
          events: {
            click: function() {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        plotBands: [
          {
            color:
              that.yaxisplotbandenabled() === true
                ? that.yaxisplotbandcolor()
                : null,
            borderColor:
              that.yaxisplotbandenabled() === true
                ? that.yaxisplotbandbordercolor()
                : null,
            borderWidth: that.yaxisplotbandborderwidth(),
            from: that.yaxisplotbandfrom(),
            to: that.yaxisplotbandto(),
            zIndex: that.yaxisplotbandzindex(),
            events: {
              click: function() {
                that.fireEvent("yaxisplotbandonclick");
              }
            },
            label: {
              style: {
                color: that.yaxisplotbandlabelcolor(),
                fontWeight: that.yaxisplotbandlabelfontweight(),
                textDecoration: that.yaxisplotbandlabelfontweight(),
                fontSize: that.yaxisplotbandlabelfontsize() + "px",
                fontFamily: that.yaxisplotbandlabelfontfamily(),
                display:
                  that.yaxisplotbandlabelenabled() === true ? "block" : "none"
              },
              text: that.yaxisplotbandlabeltext(),
              align: that.yaxisplotbandlabelalign(),
              rotation: that.yaxisplotbandlabelrotation(),
              textAlign: that.yaxisplotbandlabeltextalign(),
              //useHTML:that.xaxisplotbandlabelusehtml(),
              verticalAlign: that.yaxisplotbandlabelverticalalign(),
              x: that.xaxisplotbandlabelxposition(),
              y: that.xaxisplotbandlabelyposition()
            }
          }
        ],
        plotLines: [
          {
            color:
              that.yaxisplotlineenabled() === true
                ? that.yaxisplotlinecolor()
                : null,
            dashStyle: that.yaxisplotlinedashstyle(),
            width: that.yaxisplotlinewidth(),
            value: that.yaxisplotlinevalue(),
            zIndex: that.yaxisplotlinezindex(),
            label: {
              style: {
                color: that.yaxisplotlinelabelcolor(),
                fontWeight: that.yaxisplotlinelabelfontweight(),
                textDecoration: that.yaxisplotlinelabelfontweight(),
                fontSize: that.yaxisplotlinelabelfontsize() + "px",
                fontFamily: that.yaxisplotlinelabelfontfamily(),
                display:
                  that.yaxisplotlinelabelenabled() === true ? "block" : "none"
              },
              text: that.yaxisplotlinelabeltext(),
              align: that.yaxisplotlinelabelalign(),
              rotation: that.yaxisplotlinelabelrotation(),
              textAlign: that.yaxisplotlinelabeltextalign(),
              //useHTML:that.xaxisplotbandlabelusehtml(),
              verticalAlign: that.yaxisplotlinelabelverticalalign()
            }
          }
        ]
      },
      loading: vbiHighchartsDefault.createDefaultObjects(
        "commonNavigation",
        that
      ),
      tooltip: {
        useHTML: true,
        animation: that.tooltipanimation() || false,
        crosshairs: that.tooltipcrosshair(),
        enabled: that.tooltipenable(),
        followPointer: that.tooltipfollowpointer(),
        followTouchMove: that.tooltipfollowtouchmove(),
        hideDelay: that.tooltiphidedelay(),
        shadow: that.tooltipshadow(),
        shape: that.tooltipshape(),
        shared: that.tooltipshared(),
        snap: that.tooltipsnap(),
        valueDecimals: that.tooltipvaluedecimals(),
        valuePrefix: that.tooltipvalueprefix(),
        valueSuffix: that.tooltipvaluesuffix(),
        //headerFormat: '<p style=\'display:block;line-height: 1;margin-top: 0.5em; margin-bottom: 0.5em;margin-left:1em\'>{point.key}</p>',
        backgroundColor: that.tooltipbackgroundcolor(),
        borderColor: that.tooltipbordercolor(),
        borderRadius: that.tooltipborderradius(),
        borderWidth: that.tooltipborderwidth(),
        headerFormat:
          '<p style="font-size:' +
          that.tooltipfontsize() +
          "px" +
          '">{point.key}</p>',
        style: {
          color: that.tooltipcolor(),
          fontWeight: that.tooltipfontweight(),
          textDecoration: that.tooltipfontweight(),
          fontSize: that.tooltipfontsize() + "px",
          fontFamily: that.tooltipfontfamily()
        }
      },
      legend: {
        width: that.legendboxwidth(),
        enabled: that.legendenable(),
        backgroundColor: that.legendbackgroundcolor(),
        borderColor: that.legendbordercolor(),
        borderRadius: that.legendborderradius(),
        borderWidth: that.legendborderwidth(),
        align: that.legendalign(),
        floating: that.legendfloating(),
        itemDistance: that.legenditemdistance(),
        itemMarginBottom: that.legenditemmarginbottom(),
        itemMarginTop: that.legenditemmargintop(),
        itemWidth:
          that.legenditemwidth() == "auto"
            ? null
            : Number(that.legenditemwidth()),
        //width:that.legendwidth(),
        labelFormat: that.legendlabelformat(),
        layout: that.legendlayout(),
        lineHeight: that.legendlineheight(),
        margin: that.legendmargin(),
        padding: that.legendpadding(),
        reversed: that.legendreversed(),
        rtl: that.legendsymboltoright(),
        shadow: that.legendshadow(),
        symbolHeight: that.legendsymbolheight(),
        symbolPadding: that.legendsymbolpadding(),
        symbolRadius: that.legendsymbolradius(),
        symbolWidth: that.legendsymbolwidth(),
        x: that.legendxposition(),
        y: that.legendyposition(),
        verticalAlign: that.legendverticalalign(),
        title: {
          text: that.legendtitletext(),
          style: {
            color: that.legendtitlecolor(),
            fontWeight: that.legendtitlefontweight(),
            textDecoration: that.legendtitlefontweight(),
            fontSize: that.legendtitlefontsize() + "px",
            fontFamily: that.legendtitlefontfamily()
          }
        },
        itemHiddenStyle: { color: that.legenditemhiddenstylecolor() },
        itemHoverStyle: { color: that.legenditemhoverstylecolor() },
        itemStyle: {
          color: that.legenditemstylecolor(),
          fontSize: that.legenditemfontsize() + "px",
          fontWeight: that.legenditemfontweight(),
          textDecoration: that.legenditemfontweight(),
          fontFamily: that.legenditemfontfamily()
        },
        navigation: {
          activeColor: that.legendnavigationactivecolor(),
          animation: that.legendnavigationanimation(),
          arrowSize: that.legendnavigationarrowsize(),
          inactiveColor: that.legendnavigationinactivecolor(),
          style: {
            fontWeight: that.legendnavigationfontweight(),
            textDecoration: that.legendnavigationfontweight(),
            color: that.legendnavigationcolor(),
            fontSize: that.legendnavigationfontsize(),
            fontFamily: that.legendnavigationfontfamily()
          }
        },
        useHTML: false
      },
      plotOptions: {
        series: {
          allowPointSelect: that.allowpointselect(),
          connectNulls: that.connectnulls(),
          cropThreshold: that.cropthreshold(),
          cursor: that.pointcursor(),
          enableMouseTracking: that.enablemousetracking(),
          lineWidth: that.linewidth(),
          turboThreshold: that.turbothreshold(),
          shadow: that.seriesshadow(),
          //negativeColor:that.negativecolor(),
          point: {
            events: {
              click: function(event) {
                if (this.category !== undefined) {
                  try {
                    that.selectedvalue(
                      seriesLibrary.createMemberData(
                        that,
                        that.categoriesIndex[event.point.index],
                        event.point.series.options.key
                      )
                    );
                  } catch (e) {}
                } else {
                  currSelectedPie = true;
                }
                //that.that.colorChanged = 1;
                that.supercombinationcharttype(this.series.type);
              },

              select: function() {
                if (!this.series.chart.lassoFlag) {
                  try {
                    that.selectedPoints = component.highcharts().getSelectedPoints();
                    that.selectedPoints.push(this);
                    that.selectedvalues(
                      seriesLibrary
                        .createMembersData(
                          that,
                          that.categoriesIndex,
                          that.selectedPoints
                        )
                        .toString()
                    );
                    onSelectFunction(that);
                  } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                  }
                }
              },

              unselect: function() {
                if (!this.series.chart.lassoFlag) {
                  try {
                    // var unselectedPoints = component.highcharts().getSelectedPoints();
                    var index = that.selectedPoints.indexOf(this);
                    if (index > -1) {
                      that.selectedPoints.splice(index, 1);
                    }

                    that.selectedvalues(
                      seriesLibrary
                        .createMembersData(
                          that,
                          that.categoriesIndex,
                          that.selectedPoints
                        )
                        .toString()
                    );
                    if (that.selectedvalues() === "") {
                      that.selectedvalue("");
                    } else {
                      if (!currSelectedPie) {
                        var select = seriesLibrary.createMembersData(
                          that,
                          that.categoriesIndex,
                          that.selectedPoints
                        );
                        that.selectedvalue(select[0]);
                      } else {
                        that.selectedvalue("");
                        currSelectedPie = false;
                      }
                    }
                    /**
                         *Selectedvalue fix in all charts
                         *Multiple Selection getting the last selected value.
                        **/
                    if (that.clearSelect) {
                      if (that.selectedvalues() === "") {
                        that.clearSelect = false;
                      }
                    } else {
                      onSelectFunction(that);
                    } //clearselection callback issue on Onselect.
                  } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                  }
                }
              }
            }
          },
          dataLabels: {
            allowOverlap: that.allowoverlap(),
            enabled: that.datalabelenabled(),
            align: that.datalabelalign(),
            crop: that.datalabelcrop(),
            //defer: that.datalabeldefer(),
            backgroundColor: that.datalabelbackgroundcolor(),
            useHTML: false,
            borderColor: that.datalabelbordercolor(),
            borderRadius: that.datalabelborderradius(),
            borderWidth: that.datalabelborderwidth(),
            padding: that.datalabelpadding(),
            rotation: that.datalabelrotation(),
            shadow: that.datalabelshadow(),
            verticalAlign: that.datalabelverticalalign(),
            inside: that.datalabelinside(),
            x: that.datalabelx(),
            y: that.datalabely(),
            formatter: function() {
              try {
                if (
                  that.customdatalabel() !== "" &&
                  Object.keys(JSON.parse(that.customdatalabel() || "{}")).length
                ) {
                  if (
                    this.point.series.userOptions.name == "Average" ||
                    this.x === undefined
                  ) {
                    return vbiNumberFormat.barFamilyDataLabelFormatter(
                      this,
                      that,
                      decimalseptool,
                      thousandseptool,
                      false
                    );
                  } else {
                    return vbiNumberFormat.barFamilyFormatterDataLabel(
                      this,
                      that,
                      decimalseptool,
                      thousandseptool,
                      false
                    );
                  }
                } else {
                  return vbiNumberFormat.barFamilyDataLabelFormatter(
                    this,
                    that,
                    decimalsep,
                    thousandsep,
                    false
                  );
                }
              } catch (e) {}

              // if (that.datavaluedecimals() != 'auto') {
              //   return that.datalabelprefix() + ' ' + Highcharts.numberFormat(this.y, that.decimal(), decimalsep, thousandsep) + ' ' + that.datalabelsuffix();
              // } else {
              //   return that.datalabelprefix() + ' ' + Highcharts.numberFormat(this.y, that.decimal(), decimalsep, thousandsep) + ' ' + that.datalabelsuffix();
              // }
            },

            style: {
              textShadow: false,
              color: that.datalabeltextcolor(),
              fontWeight: that.datalabelfontweight(),
              textDecoration: that.datalabelfontweight(),
              fontSize: that.datalabelfontsize() + "px",
              fontFamily:
                that.globalfont() === true
                  ? that.fontfamily()
                  : that.datalabelfontfamily()
            }
          },
          marker: {}
        }
      },
      series: options.seriesData
    };
    return defaultValue;
  };

  this.attachGetters=function(component,options){

    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    //Measure validation function for errorbar to check whether measure is in row and if the column contains more than two dimension
    component.measureValidation = function() {
      var returnValue = false;
      var measureinrow = false;
      try {
        for (var i = 0; i < component.result().dimensions.length; i++) {
          if (component.result().dimensions[i].containsMeasures === true && component.result().dimensions[i].axis == 'ROWS') {
            measureinrow = true;
          }
        }

        if (measureinrow === true) {
          returnValue = false;
        } else {
          returnValue = true;
        }  //return true;
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return returnValue + '';  //callruntime handler won't handle object and boolean hence return string
    };

    component.seriesstyledata = function() {
      return JSON.stringify(new seriesLibrary.defaultvalueseries());
    };

    component.getMeasuresNamesForFormatter = function(){
        return vbiNumberFormat.getMeasuresNamesForFormatter(component);
    };

    component.getChartNames = function() {
      return component.globalVal;
    };

    component.getDataSeriesColor = function() {
      var dataseriescolor = '';
      try {
        dataseriescolor = component.dataseriescolor();
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return dataseriescolor;
    };

    component.getDatUtility = function() {
      var datautility = '';
      try {
        datautility = component.datautility();
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return datautility;
    };

    component.getChartType = function() {
      return 'supercombination';
    };

    component.getDataSeries = function() {
    if (!component.dataRes) { return null; }
      var dataSeries = [];
      var seriesNames = [];
      var seriesKeyNames = [];
      //component.dataRes = component.dispKeyTextResultSet();
      var bardatacustomizationJson = {
        'COLUMNS': [],
        'ROWS': []
      };
      if (component.bardatacustomization() !== '') {
        bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
      }

      try {
        if (component.dataRes === undefined || component.dataRes === '') {
          return null;
        } else if (component.datautility() === true && bardatacustomizationJson['COLUMNS'].length === 0 && bardatacustomizationJson['ROWS'].length === 0) {
          return null;
        }

        if (component.dataRes.dimensions.length === 1 && component.dataRes.dimensions[0].containsMeasures === true) {
          var defaultColor = [
            '#B586DA',
            '#FF6657',
            '#F3A730',
            '#946B66',
            '#B0AD53',
            '#7AC1DE',
            '#F1C337',
            '#566C6C',
            '#A1CC54',
            '#543F1E'
          ];
          var seriesColor = [];
          if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
            seriesColor = [];
          } else {
            seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
          }

          if (component.dataRes.dimensions[0].axis == 'COLUMNS') {
            for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {
              seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
              seriesNames.push(component.dataRes.dimensions[0].members[i]['picker_text']);
              seriesKeyNames.push(component.dataRes.dimensions[0].members[i].key);
            }
            if(component.seriesaverage()){
              seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
              seriesNames.push('Average');
              seriesKeyNames.push('Average');
            }
          } else {
            seriesLibrary.getSeriesColors(component, seriesColor, seriesNames.length, defaultColor);
            seriesNames.push('Measures');
            seriesKeyNames.push('Measures');
          }

          dataSeries = [
            seriesNames,
            seriesKeyNames
          ];
          seriesColor.splice(dataSeries[0].length, seriesColor.length);
          component.dataseriescolor(seriesColor.join());
        } else {
          //  dataSeries = seriesLibrary.createSeriesData(component, 'bar', component.component.defaultValueSeriesNames,"ncf");
          dataSeries = seriesLibrary.createSeriesAdditionalProperty(component, 'bar');
        }
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return dataSeries;
    };

    component.isMeasureOnly = function() {
      var len = 0;
      if (component.result() !== undefined && component.result() !== '') {
        try {
          len = component.result().dimensions.length;
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return len;
    };

    component.getDimensionList = function() {
      // var dimlist =[];
      var dimname = [];
      var dimindex = [];
      if (component.result() !== undefined && component.result() !== '') {
        try {
          for (var i = 0; i < component.result().dimensions.length; i++) {
            if (component.dataRes.dimensions[i].axis == 'ROWS' && component.dataRes.dimensions[i].containsMeasures !== true) {
              dimname.push(component.result().dimensions[i].text);
              dimindex.push(i);
            }
          }
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return [
        dimname,
        dimindex
      ];
    };

    component.getLegendNames = function(dimIndex) {
      var leglist = [];
      var charttype = [];
      var legcolors = [];
      var leglistkey = [];
      var lekey=[];
      if (component.result() !== undefined && component.result() !== '') {
        try {
          //alert(JSON.stringify(component.component.defaultValueSeriesNames.series[0]));
          for (var i = 0; i < component.defaultValueSeriesNames.series.length; i++) {
            if (component.defaultValueSeriesNames.series[i].name.indexOf('Trendline') === -1) {//VBX141-7435
              leglist.push(component.defaultValueSeriesNames.series[i].name);
              charttype.push(component.defaultValueSeriesNames.series[i].type);
              legcolors.push(component.defaultValueSeriesNames.series[i].color);
              leglistkey.push(component.defaultValueSeriesNames.series[i].uniquekey);//Making changes because same series-name causing problem VBX141-3099
              var keys =component.defaultValueSeriesNames.series[i].key.split("-");
              var temp='';
              for(var j=0;j<keys.length;j++){
                var dimIndex = keys[j].split(":")[0];
                var memIndex = keys[j].split(":")[1];
                temp = temp + component.result().dimensions[dimIndex].members[memIndex].key + "-";
              }
              lekey.push(temp.slice(0,temp.length-1));
            }
          }
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return [
        leglist,
        charttype,
        legcolors,
        leglistkey,
        lekey
      ];
    };

    component.getChartFamily = function() {
      return 'bar';
    };
  
    component.lassoFireProp = function(selectedPoints) {
      component.selectedvalues(seriesLibrary.createMembersData(component, component.categoriesIndex, selectedPoints).toString());
      //component.colorChanged++;
      component.firePropertiesChanged(['selectedvalues']);
    };

    component.identicalScale = function(defaultValue) {
      if (component.list() !== '' && component.list() != 'None') {
        var maximum = [];
        maximum.push(component.minimumValue);
        maximum.push(component.maximumValue);
        for (var i in WhatIfLibrary.charts) {
          if (WhatIfLibrary.charts[i]['custom_function']['custom_id_SelectedValue'] == component.list()) {
            maximum.push(WhatIfLibrary.charts[i]['custom_function']['custom_id_min_value']);
            maximum.push(WhatIfLibrary.charts[i]['custom_function']['custom_id_max_value']);
          }
        }

        var maxx = maximum.reduce(function(p, v) {
          return p > v ? p : v;
        });

        maxx = Math.round(maxx);
        var minx = maximum.reduce(function(p, v) {
          return p < v ? p : v;
        });

        minx = Math.round(minx);
        if (defaultValue.yAxis.max != maxx && defaultValue.yAxis.min != minx) {
          for (var i in WhatIfLibrary.charts) {
            var instance = WhatIfLibrary.getInstance(i);

            if (!instance) {
              return;
            }
            //Check if instance exists
            if (WhatIfLibrary.charts[i]['custom_function']['custom_id_SelectedValue'] == component.list()) {
              instance.yaxismin(minx);
              instance.yaxismax(maxx);
              instance.afterUpdate();
            }
          }
        }
      }
      /*
             * Pushing the value in the chart if the grouping chart has the same Name
             */
    };

  };
}