function TreeMapUtil(){
  componentUtil.call(this);

  this.getSampleDataSeries = function() {
    var seriesData = [
      {
        name: "A",
        value: 6,
        colorValue: 1
      },
      {
        name: "B",
        value: 6,
        colorValue: 2
      },
      {
        name: "C",
        value: 4,
        colorValue: 3
      },
      {
        name: "D",
        value: 3,
        colorValue: 4
      },
      {
        name: "E",
        value: 2,
        colorValue: 5
      },
      {
        name: "F",
        value: 2,
        colorValue: 6
      },
      {
        name: "G",
        value: 1,
        colorValue: 7
      }
    ];

    return seriesData;
  };

  this.getDefaultValue=function(that,options){
    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
    var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
    var component = that.$();
    var thousandsep = that.progressthousandseparator();
    var decimalsep = that.progressdecimalseparator();
    var thousandseptool = that.tooltipthousandseparator();
    var decimalseptool = that.tooltipdecimalseparator();

    var isExportEnable = that.exportingsymbolenabled();
    if (that.enableMoreActionsButton && isExportEnable) {
      isExportEnable =
        !that.enableMoreActionsButton() && !that.enableContextMenu();
    }
    var treechoroplethcolor = that.brewerflag();
    var treetype = that.treechoroplethColorDataType();
    var colormin;
    var colormax;
    //console.log(that.brewerflag());
    if (that.treeColorType() == 'custom') {
        if (treetype && treechoroplethcolor !== '' && treechoroplethcolor !== undefined && treechoroplethcolor != 'SelectProperties') {
            colormin = that.colorBrewer[treechoroplethcolor]['8'][0];
            colormax = that.colorBrewer[treechoroplethcolor]['8'][7];
        } else {
            colormin = that.coloraxismincolor();
            colormax = that.coloraxismaxcolor();
        }
    } else {
        colormin = that.coloraxismincolor();
        colormax = that.coloraxismaxcolor();
    }
    var subtitley;
    if (that.subtitleverticalalign() == 'bottom') {
        subtitley = Number(that.subtitley()) - 2;
    } else {
        subtitley = Number(that.subtitley());
    }
    var exportMenuItems = Highcharts.getOptions().exporting.buttons.contextButton.menuItems.slice(0);
    exportMenuItems.splice(7, 4); // Removing Lasso options from export menu
    var loadingfont = that.loadingfontweight().split(':');
    var defaultValue = {
      chart: {
        type: "treemap",
        inverted: that.chartinverted(),
        //alignTicks:that.chartalignticks(),//applicable in multiple axes
        className: that.chartcssclassname(),
        events: {
          click: function(event) {
            if (event.toElement.innerHTML === "") {
              that.fireEvent("chartonclick");
            }
          },

          load: function() {
            if (vbiContextMenu) {
              vbiContextMenu.highchartsPostProcess();
            }
            //The If condition is fire the charafterload event only once - Fix 1200
            if (!isLoad) {
              that.fireEvent("chartafterload");
              isLoad = true;
            }

            if (that.creditsenabled() === true) {
              this.credits.element.onclick = function() {
                window.open(
                  that.creditshref(),
                  "_blank" // <- This is what makes it open in a new window.
                );
              };
            }
          },

          selection: function(event) {
            if (event.xAxis) {
              that.fireEvent("chartonselect");
            } //disabling the fireEvent while zoom out.
          }
        },
        ignoreHiddenSeries: that.ignorehiddenseries(),
        marginBottom:
          that.chartmarginbottom() == "auto"
            ? null
            : Number(that.chartmarginbottom()),
        marginLeft:
          that.chartmarginleft() == "auto"
            ? null
            : Number(that.chartmarginleft()),
        marginRight:
          that.chartmarginright() == "auto"
            ? null
            : Number(that.chartmarginright()),
        marginTop:
          that.chartmargintop() == "auto" ? null : Number(that.chartmargintop()),
        spacingBottom:
          that.chartpaddingbottom() == "auto"
            ? null
            : Number(that.chartpaddingbottom()),
        spacingLeft:
          that.chartpaddingleft() == "auto"
            ? null
            : Number(that.chartpaddingleft()),
        spacingRight:
          that.chartpaddingright() == "auto"
            ? null
            : Number(that.chartpaddingright()),
        spacingTop:
          that.chartpaddingtop() == "auto"
            ? null
            : Number(that.chartpaddingtop()),
        // spacingLeft: 100,
        pinchType: that.chartpinchtype(),
        zoomType: that.chartzoomtype(),
        panning: that.chartpanning(),
        panKey: that.chartpankey(),
        plotShadow: that.plotshadow(),
        reflow: that.chartflow() || false,
        shadow: that.chartshadow(),
        showaxes: that.showaxes(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            //relativeTo:that.zoombuttonrelativeto(),
            verticalAlign: that.zoombuttonverticalalign(),
            x: -10,
            y: -15
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: {
              color: that.resetzoombuttontextcolor()
            },
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: {
                  color: that.resetzoombuttonhovertextcolor()
                }
              }
            }
          }
        },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor:
          that.plottransparency() === true
            ? "transparent"
            : that.plotbackgroundcolor(),
        plotBackgroundImage: that.plotbackgroundimage(),
        plotBorderColor:
          that.plotbordercolor() == "rgba(255, 255, 255, 0)" ||
          that.plotbordercolor() === ""
            ? null
            : that.plotbordercolor(),
        plotBorderWidth:
          that.plotbordercolor() === "" ||
          that.plotbordercolor() === null ||
          that.plotbordercolor() == "rgba(255, 255, 255, 0)"
            ? null
            : that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor()
      },
      lang: {
        noData: ""
      },
      title: {
        align: that.titlealign(),
        floating: that.titlefloating(),
        margin: that.titlemargin() === "" ? null : that.titlemargin(),
        text: that.titletext(),
        x: that.titlex() === "" ? null : _.parseInt(that.titlex()),
        y: that.titley() === "" ? null : _.parseInt(that.titley()),
        verticalAlign:
          that.titleverticalalign() == "auto" ? null : that.titleverticalalign(),
        style: {
          color: that.titlecolor(),
          fontWeight: that.titlefontweight(),
          textDecoration: that.titlefontweight(),
          fontSize: that.titlefontsize() + "px",
          fontFamily: that.titlefontfamily(),
          display: that.titleenable() === true ? "block" : "none"
        }
      },
      subtitle: {
        align: that.subtitlealign(),
        floating: that.subtitlefloating(),
        text: that.subtitletext(),
        x: that.subtitlex() === "" ? null : that.subtitlex(),
        y: that.subtitley() === "" ? null : subtitley,
        verticalAlign:
          that.subtitleverticalalign() == "auto"
            ? null
            : that.subtitleverticalalign(),
        style: {
          color: that.subtitlecolor(),
          fontWeight: that.subtitlefontweight(),
          textDecoration: that.subtitlefontweight(),
          fontSize: that.subtitlefontsize() + "px",
          fontFamily: that.subtitlefontfamily(),
          display: that.subtitleenable() === true ? "block" : "none"
        }
      },
      credits: {
        enabled: that.creditsenabled(),
        href: that.creditshref(),
        position: {
          align: that.creditsalign(),
          verticalAlign: that.creditsverticalalign(),
          x: that.creditsxposition(),
          y:
            that.creditsverticalalign() == "top"
              ? that.creditsyposition() + 15
              : that.creditsyposition()
        },
        text: that.creditstext(),
        style: {
          color: that.creditstextcolor(),
          fontSize: that.creditsfontsize() + "px",
          fontFamily: that.creditsfontfamily(),
          fontWeight: that.creditsfontweight(),
          cursor: that.creditscursor()
        }
      },

      exporting: {
        buttons: {
          contextButton: {
            enabled: isExportEnable,
            align: that.exportingsymbolalign(),
            verticalAlign: that.exportingsymbolverticalalign(),
            symbol: that.exportingsymbol(),
            //symbol:'url(http://upload.wikimedia.org/wikipedia/commons/0/0c/White_and_yellow_flower.JPG)',
            symbolFill: that.exportingsymbolfill(),
            symbolSize: that.exportingsymbolsize(),
            symbolStroke: that.exportingsymbolstroke(),
            symbolStrokeWidth: that.exportingsymbolstrokewidth(),
            height:
              that.exportingsymbolheight() == "auto"
                ? 20
                : _.parseInt(that.exportingsymbolheight()),
            width:
              that.exportingsymbolwidth() == "auto"
                ? 24
                : _.parseInt(that.exportingsymbolwidth()),
            symbolX:
              that.exportingsymbolxposition() == "auto"
                ? 12
                : _.parseInt(that.exportingsymbolxposition()),
            symbolY:
              that.exportingsymbolyposition() == "auto"
                ? 10
                : _.parseInt(that.exportingsymbolyposition()),
            x:
              that.exportingxposition() == "auto"
                ? 0
                : _.parseInt(that.exportingxposition()),
            y:
              that.exportingyposition() == "auto"
                ? 0
                : _.parseInt(that.exportingyposition()),
            menuItems: that.chartthemeenabled()
              ? exportMenuItems
              : exportMenuItems.slice(0, 6),
            theme: {
              r: that.exportingsymbolradius(),
              fill:
                that.exportingsymbolbackgroundfill() === ""
                  ? null
                  : that.exportingsymbolbackgroundfill(),
              states: {
                hover: {
                  fill: that.exportingsymbolhoverbackgroundfill()
                }
              }
            }
          }
        },
        filename: that.exportedfilename(),
        sourceWidth: that.exportedchartwidth(),
        sourceHeight: that.exportedchartheight(),
        scale: that.exportedchartscale()
      },
      navigation: {
        menuStyle: {
          background: that.exportingmenustylebackgroundcolor()
        },
        menuItemStyle: {
          color: that.exportingmenuitemstyletextcolor(),
          fontWeight: that.exportingmenuitemstylefontweight(),
          textDecoration: that.exportingmenuitemstylefontweight()
        },
        menuItemHoverStyle: {
          background: that.exportingmenuitemhoverstylebackgroundcolor(),
          color: that.exportingmenuitemhoverstyletextcolor(),
          fontWeight: that.exportingmenuitemhoverstylefontweight(),
          textDecoration: that.exportingmenuitemhoverstylefontweight()
        }
      },
      loading: {
        labelStyle: {
          fontSize: "18px",
          fontWeight: loadingfont[0],
          fontStyle: loadingfont[1],
          color: that.loadingcolor()
        },
        style: {
          backgroundColor: that.loadingstylebackgroundcolor(),
          opacity: Number(that.loadingopacity()),
          textAlign: that.loadingtextalign()
        }
      },
      tooltip: {
        animation: that.tooltipanimation() || false,
        //                    crosshairs: that.tooltipcrosshair(),
        enabled: that.tooltipenable(),
        followPointer: that.tooltipfollowpointer(),
        followTouchMove: that.tooltipfollowtouchmove(),
        hideDelay: that.tooltiphidedelay(),
        shadow: that.tooltipshadow(),
        shape: that.tooltipshape(),
        shared: that.tooltipshared(),
        snap: that.tooltipsnap(),
        valueDecimals: that.tooltipvaluedecimals(),
        valuePrefix: that.tooltipvalueprefix(),
        valueSuffix: that.tooltipvaluesuffix(),
        formatter: function() {
          if (
            that.customtooltip() !== "" &&
            !that.tooltipshared() &&
            Object.keys(JSON.parse(that.customtooltip() || "{}")).length &&
            this.point.series.name.toLocaleLowerCase().indexOf("result") == -1 &&
            this.key.name.toLocaleLowerCase().indexOf("result") == -1
          ) {
            return vbiNumberFormat.barFamilyTooltipFormatter(
              this,
              that,
              decimalseptool,
              thousandseptool,
              false
            );
          } else {
            var seriesNameforTreemeasure1 = "";
            var seriesNameforTreemeasure2 = "";
            var keyvalformeasure1 = "";
            var keyvalformeasure2 = "";
            if (
              that.dataRes !== undefined &&
              that.dataRes !== null &&
              that.dataRes !== ""
            ) {
              var xaxisname;
              if (that.chartmeasurechange()) {
                xaxisname = JSON.parse(that.chartmeasurechange());
              }

              for (var i = 0; i < that.dataRes.dimensions.length; i++) {
                if (that.dataRes.dimensions[i].containsMeasures === true) {
                  for (
                    var j = 0;
                    j < that.dataRes.dimensions[i].members.length;
                    j++
                  ) {
                    if (
                      that.chartmeasurechange() &&
                      xaxisname[that.dataRes.dimensions[i].members[j].key]
                    ) {
                      if (
                        that.treecolormeasure() ==
                        that.dataRes.dimensions[i].members[j].key
                      ) {
                        seriesNameforTreemeasure1 =
                          xaxisname[that.dataRes.dimensions[i].members[j].key];
                        keyvalformeasure1 =
                          that.dataRes.dimensions[i].members[j].key;
                      }
                      if (
                        that.treesizemeasure() ==
                        that.dataRes.dimensions[i].members[j].key
                      ) {
                        seriesNameforTreemeasure2 =
                          xaxisname[that.dataRes.dimensions[i].members[j].key];
                        keyvalformeasure2 =
                          that.dataRes.dimensions[i].members[j].key;
                      }
                    } else {
                      if (
                        that.treecolormeasure() ==
                        that.dataRes.dimensions[i].members[j].key
                      ) {
                        seriesNameforTreemeasure1 =
                          that.dataRes.dimensions[i].members[j].text;
                        keyvalformeasure1 =
                          that.dataRes.dimensions[i].members[j].key;
                      }
                      if (
                        that.treesizemeasure() ==
                        that.dataRes.dimensions[i].members[j].key
                      ) {
                        seriesNameforTreemeasure2 =
                          that.dataRes.dimensions[i].members[j].text;
                        keyvalformeasure2 =
                          that.dataRes.dimensions[i].members[j].key;
                      }
                    }
                  }
                }
              }
            }

            var value;
            var colorVal;
            var measure1val = "",
              measure2val = "";
            if (this.point.node.children.length === 0) {
              value = this.point.options.value;
              if (this.point.options.colorValue !== undefined) {
                colorVal = this.point.options.colorValue;
                var tooltiparr2 = seriesLibrary.tooltipScaling(
                  "",
                  colorVal,
                  that,
                  keyvalformeasure2
                );
                if (
                  that.dataRes &&
                  that.numberFormatDefinitionTooltip() === "initialView"
                ) {
                  measure2val =
                    (tooltiparr2[0] || "") +
                    " (Color) : " +
                    vbiNumberFormat.processTooltipInitialView(
                      this,
                      that,
                      keyvalformeasure2,
                      false,
                      colorVal
                    );
                } else {
                  measure2val =
                    (tooltiparr2[0] || "") +
                    " (Color) : " +
                    vbiNumberFormat.processData(
                      that,
                      this,
                      keyvalformeasure2,
                      false,
                      decimalseptool,
                      thousandseptool,
                      false,
                      colorVal
                    );
                }
                //measure2val = (tooltiparr2[0] || '') + tooltiparr2[4] + ' ' + tooltiparr2[2] + ' (Color) : ' + that.tooltipvalueprefix() + ' ' + '<b>' + Highcharts.numberFormat(tooltiparr2[1], that.tooltipvaluedecimals(), decimalseptool, thousandseptool) + '</b> ' + that.tooltipvaluesuffix() + '<br/>';
              }
            } else {
              value = this.point.node.childrenTotal;
            }
            var tooltiparr1 = seriesLibrary.tooltipScaling(
              "",
              value,
              that,
              keyvalformeasure1
            );
            if (
              that.dataRes &&
              that.numberFormatDefinitionTooltip() === "initialView"
            ) {
              measure1val =
                (tooltiparr1[0] || "") +
                " (Size) : " +
                vbiNumberFormat.processTooltipInitialView(
                  this,
                  that,
                  keyvalformeasure1,
                  false,
                  value
                );
            } else {
              measure1val =
                (tooltiparr1[0] || "") +
                " (Size) : " +
                vbiNumberFormat.processData(
                  that,
                  this,
                  keyvalformeasure1,
                  false,
                  decimalseptool,
                  thousandseptool,
                  false,
                  value
                );
            }

            var parent = this.point.parenttext ? this.point.parenttext + "/" : "";
            return (
              '<span style="color:' +
              this.color +
              '">\u25CF</span> ' +
              parent +
              this.point.name +
              " : <br/>" +
              measure1val +
              "<br/>" +
              measure2val
            );
          }
        },

        backgroundColor: that.tooltipbackgroundcolor(),
        borderColor: that.tooltipbordercolor(),
        borderRadius: that.tooltipborderradius(),
        borderWidth: that.tooltipborderwidth(),
        style: {
          color: that.tooltipcolor(),
          fontWeight: that.tooltipfontweight(),
          textDecoration: that.tooltipfontweight(),
          fontSize: that.tooltipfontsize() + "px",
          fontFamily: that.tooltipfontfamily()
        }
      },
      legend: {
        enabled:
          that.treeColorType() === "seriescolor" ? false : that.legendenable(),
        backgroundColor: that.legendbackgroundcolor(),
        borderColor: that.legendbordercolor(),
        borderRadius: that.legendborderradius(),
        borderWidth: that.legendborderwidth(),
        align: that.legendalign(),
        floating: that.legendfloating(),
        itemDistance: that.legenditemdistance(),
        itemMarginBottom: that.legenditemmarginbottom(),
        itemMarginTop: that.legenditemmargintop(),
        itemWidth:
          that.legenditemwidth() == "auto"
            ? null
            : Number(that.legenditemwidth()),
        width: that.legendboxwidth(),
        labelFormat: that.legendlabelformat(),
        layout: that.legendlayout(),
        lineHeight: that.legendlineheight(),
        margin: that.legendmargin(),
        padding: that.legendpadding(),
        reversed: that.legendreversed(),
        rtl: that.legendsymboltoright(),
        shadow: that.legendshadow(),
        symbolHeight: that.legendsymbolheight(),
        symbolPadding: that.legendsymbolpadding(),
        symbolRadius: that.legendsymbolradius(),
        symbolWidth: that.legendsymbolwidth(),
        x: that.treelegendxposition(),
        y: that.treelegendyposition(),
        verticalAlign: that.legendverticalalign(),
        itemHiddenStyle: {
          color: that.legenditemhiddenstylecolor()
        },
        itemHoverStyle: {
          color: that.legenditemhoverstylecolor()
        },
        itemStyle: {
          color: that.legenditemstylecolor(),
          fontSize: that.legenditemfontsize() + "px",
          fontWeight: that.legenditemfontweight(),
          textDecoration: that.legenditemfontweight(),
          fontFamily: that.legenditemfontfamily()
        },
        title: {
          text: that.legendtitletext(),
          style: {
            color: that.legendtitlecolor(),
            fontWeight: that.legendtitlefontweight(),
            textDecoration: that.legendtitlefontweight(),
            fontSize: that.legendtitlefontsize() + "px",
            fontFamily: that.legendtitlefontfamily()
          }
        },

        navigation: {
          activeColor: that.legendnavigationactivecolor(),
          animation: that.legendnavigationanimation(),
          arrowSize: that.legendnavigationarrowsize(),
          inactiveColor: that.legendnavigationinactivecolor(),
          style: {
            fontWeight: that.legendnavigationfontweight(),
            textDecoration: that.legendnavigationfontweight(),
            color: that.legendnavigationcolor(),
            fontSize: that.legendnavigationfontsize() + "px",
            fontFamily: that.legendnavigationfontfamily()
          }
        }
      },
      colorAxis: {
        min:
          that.coloraxismin() == "auto" ? null : _.parseInt(that.coloraxismin()),
        max:
          that.coloraxismax() == "auto" ? null : _.parseInt(that.coloraxismax()),
        minColor: colormin,
        maxColor: colormax
      },
      plotOptions: {
        series: {
          turboThreshold: 0,
          allowPointSelect: that.allowpointselect(),
          //borderWidth: that.seriesborderwidth(),
          borderColor: that.seriesbordercolor(),
          cursor: "pointer",
          pointWidth:
            that.pointwidth() == "auto" ? null : _.parseInt(that.pointwidth()),
          pointPadding: that.pointpadding(),
          point: {
            events: {
              click: function(event) {
                that.selectedvalue(
                  seriesLibrary.createMemberData(
                    that,
                    that.categoriesIndex[event.point.x],
                    ""
                  )
                );
              },
              select: function() {
                try {
                  that.selectedPoints = component.highcharts().getSelectedPoints();
                  that.selectedPoints.push(this);
                  that.selectedvalues(
                    seriesLibrary
                      .createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints
                      )
                      .toString()
                  );
                  seriesLibrary.onSelectFunction(that);
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }
                /**
                               *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                               **/
              },

              unselect: function() {
                try {
                  //var unselectedPoints = component.highcharts().getSelectedPoints();
                  var index = that.selectedPoints.indexOf(this);
                  if (index > -1) {
                    that.selectedPoints.splice(index, 1);
                  }

                  that.selectedvalues(
                    seriesLibrary
                      .createMembersData(
                        that,
                        that.categoriesIndex,
                        that.selectedPoints,
                        "treemap"
                      )
                      .toString()
                  );
                  if (that.selectedvalues() === "") {
                    that.selectedvalue("");
                  } else {
                    var select = seriesLibrary.createMembersData(
                      that,
                      that.categoriesIndex,
                      that.selectedPoints,
                      "treemap"
                    );
                    that.selectedvalue(select[0]);
                  }
                  /**
                                   *Selectedvalue fix in all charts
                                   *Multiple Selection getting the last selected value.
                                   **/
                  if (that.clearSelect) {
                    if (that.selectedvalues() === "") {
                      that.clearSelect = false;
                    }
                  } else {
                    seriesLibrary.onSelectFunction(that);
                  } //clearselection callback issue on Onselect.
                } catch (e) {
                  seriesLibrary.DSXalert(e.message);
                }
                /**
                               *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                               **/
              }
            }
          }
        }
      },
      series: [
        {
          layoutAlgorithm: that.chartlayouttype(),
          alternateStartingDirection: true,
          borderDashStyle: that.treemaplinestyle(),
          borderWidth: that.seriesborderwidth(),
          borderColor: that.seriesbordercolor(),
          levels: [
            {
              level: 1,
              dataLabels: {
                enabled: true,
                align: that.treemaplev1labelalign(),
                verticalAlign: that.treemaplev1labelverticalalign(),
                crop: that.datalabelcrop(),
                backgroundColor: that.datalabelbackgroundcolor(),
                useHTML: false,
                borderColor: that.datalabelbordercolor(),
                borderRadius: that.datalabelborderradius(),
                borderWidth: that.datalabelborderwidth(),
                padding: that.datalabelpadding(),
                rotation: that.datalabelrotation(),
                shadow: that.datalabelshadow(),
                x: that.treedatalabelx(),
                y: that.treedatalabely(),
                formatter: function() {
                  if (that.datalabelenabled() === true) {
                    if (
                      that.customdatalabel() !== "" &&
                      Object.keys(JSON.parse(that.customdatalabel() || "{}"))
                        .length &&
                      this.point.series.name
                        .toLocaleLowerCase()
                        .indexOf("result") == -1 &&
                      this.key.name.toLocaleLowerCase().indexOf("result") == -1
                    ) {
                      return vbiNumberFormat.barFamilyFormatterDataLabel(
                        this,
                        that,
                        decimalsep,
                        thousandsep,
                        false
                      );
                    } else {
                      var value;
                      if (this.point.node.children.length === 0) {
                        value = this.point.options.value;
                      } else {
                        value = this.point.node.childrenTotal;
                      }
                      if (that.numberFormatDefinition() === "initialView") {
                        return (
                          this.point.name +
                          " " +
                          vbiNumberFormat.processDataLabelInitialView(
                            this,
                            that,
                            that.treecolormeasure(),
                            value
                          )
                        );
                      } else {
                        return (
                          this.point.name +
                          " " +
                          vbiNumberFormat.processDataLabel(
                            that,
                            this,
                            that.treecolormeasure(),
                            false,
                            decimalsep,
                            thousandsep,
                            false,
                            value
                          )
                        );
                      }
                    }

                    // if (that.datavaluedecimals() != 'auto') {
                    //     return this.point.name + ' ' + ScalingandUnitinDS[0] + ' ' + ScalingandUnitinDS[1] + ' ' + that.datalabelprefix() + ' ' + Highcharts.numberFormat(value, that.decimal(), decimalsep, thousandsep) + ' ' + that.datalabelsuffix();
                    // } else {
                    //     return this.point.name + ' ' + ScalingandUnitinDS[0] + ' ' + ScalingandUnitinDS[1] + ' ' + that.datalabelprefix() + ' ' + Highcharts.numberFormat(value, that.decimal(), decimalsep, thousandsep) + ' ' + that.datalabelsuffix();
                    // }
                  } else {
                    return this.point.name;
                  }
                },

                style: {
                  fontSize: that.treemaplev1labelfontsize() + "px",
                  fontWeight: that.treemaplev1labelfontweight(),
                  fontFamily: that.treemaplev1labelfontfamily(),
                  color: that.treemaplev1labeltextcolor()
                }
              }
            },
            {
              level: 2,
              dataLabels: {
                enabled: true,
                align: that.treemaplev2labelalign(),
                verticalAlign: that.treemaplev2labelverticalalign(),
                crop: that.datalabelcrop(),
                backgroundColor: that.datalabelbackgroundcolor(),
                useHTML: false,
                borderColor: that.datalabelbordercolor(),
                borderRadius: that.datalabelborderradius(),
                borderWidth: that.datalabelborderwidth(),
                padding: that.datalabelpadding(),
                rotation: that.datalabelrotation(),
                shadow: that.datalabelshadow(),
                x: that.treedatalabelx(),
                y: that.treedatalabely(),
                formatter: function() {
                  if (that.datalabelenabled() === true) {
                    if (
                      that.customdatalabel() !== "" &&
                      Object.keys(JSON.parse(that.customdatalabel() || "{}"))
                        .length &&
                      this.point.series.name
                        .toLocaleLowerCase()
                        .indexOf("result") == -1 &&
                      this.key.name.toLocaleLowerCase().indexOf("result") == -1
                    ) {
                      return vbiNumberFormat.barFamilyFormatterDataLabel(
                        this,
                        that,
                        decimalsep,
                        thousandsep,
                        false
                      );
                    } else {
                      var ScalingandUnitinDS = that.getScalingandUnitinDS();
                      var value;
                      if (this.point.node.children.length === 0) {
                        value = this.point.options.value;
                      } else {
                        value = this.point.node.childrenTotal;
                      }

                      if (that.datavaluedecimals() != "auto") {
                        return (
                          this.point.name +
                          " " +
                          ScalingandUnitinDS[0] +
                          " " +
                          ScalingandUnitinDS[1] +
                          " " +
                          that.datalabelprefix() +
                          " " +
                          Highcharts.numberFormat(
                            value,
                            that.decimal(),
                            decimalsep,
                            thousandsep
                          ) +
                          " " +
                          that.datalabelsuffix()
                        );
                      } else {
                        return (
                          this.point.name +
                          " " +
                          ScalingandUnitinDS[0] +
                          " " +
                          ScalingandUnitinDS[1] +
                          " " +
                          that.datalabelprefix() +
                          " " +
                          Highcharts.numberFormat(
                            value,
                            that.decimal(),
                            decimalsep,
                            thousandsep
                          ) +
                          " " +
                          that.datalabelsuffix()
                        );
                      }
                    }
                  } else {
                    return this.point.name;
                  }
                },

                style: {
                  fontSize: that.treemaplev2labelfontsize() + "px",
                  fontWeight: that.treemaplev2labelfontweight(),
                  fontFamily: that.treemaplev2labelfontfamily(),
                  color: that.treemaplev2labeltextcolor()
                }
              }
            }
          ],
          data: options.seriesData
        }
      ]
    };
    return defaultValue;
  };

  this.attachGetters=function(component,options){

    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    component.getChartFamily = function() {
        return 'treemap';
    };

    component.isMeasureOnly = function() {
        var len = 0;
        if (component.result() !== undefined && component.result() !== '') {
            try {
                len = component.result().dimensions.length;
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }
        }

        return len;
    };

    component.getDimensionList = function() {
        // var dimlist =[];
        var dimensions = [];
        if (component.result() !== undefined && component.result() !== '') {
            try {
                for (var i = 0; i < component.result().dimensions.length; i++) {
                    dimensions.push(component.result().dimensions[i].text);
                }
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }
        }

        return dimensions;
    };

    component.getMeasureMembersKeyAndText = function() {
        var measureMemberKeys = [];
        var measureMemberText = [];
        if (component.dataRes !== undefined && component.dataRes !== '') {
            try {
                var mesIndex = component.getMeasureIndex();
                for (var i = 0; i < component.dataRes.dimensions[mesIndex].members.length; i++) {
                    measureMemberKeys.push(component.dataRes.dimensions[mesIndex].members[i].key);
                    measureMemberText.push(component.dataRes.dimensions[mesIndex].members[i]['picker_text']);
                }
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }
        }

        return [
            measureMemberText,
            measureMemberKeys
        ];
    };

    component.getColorMesureIndex = function() {
        try {
            if (component.dataRes !== undefined && component.dataRes !== null && component.dataRes !== '') {
                var getMeasureArr = component.getMeasureArr();
                var treecolormeasureindex = getMeasureArr.indexOf(component.treesizemeasure());
                return treecolormeasureindex;
            }
        } catch (e) {
            seriesLibrary.DSXalert(e.message);
        }
    };

    component.getMeasureJson = function() {
        try {
            if (component.dataRes !== undefined && component.dataRes !== null && component.dataRes !== '') {
                var measureJson = {};
                for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                    if ('containsMeasures' in component.dataRes.dimensions[i]) {
                        $.each(component.dataRes.dimensions[i].members, function(key, value) {
                            measureJson[value.key] = {
                                text: value.text,
                                index: key
                            };
                        });

                        break;
                    }
                }

                return JSON.stringify(measureJson);
            }
        } catch (e) {
            seriesLibrary.DSXalert(e.message);
        }
    };

    component.getMeasureArr = function() {
        var seriesName = [];
        //var seriesKey = [];
        for (var i = 0; i < component.dataRes.dimensions.length; i++) {
            if ('containsMeasures' in component.dataRes.dimensions[i]) {
                $.each(component.dataRes.dimensions[i].members, function(key, value) {
                    seriesName.push(value.key);

                });

                break;
            }
        }

        return seriesName;
    };

    component.getDataSeries = function() {
  if (!component.dataRes) { return null; }
        var seriesName = [];
        var seriesKey = [];

        if (component.dataRes !== undefined && component.dataRes !== '') {
            var bardatacustomizationJson = {
                'COLUMNS': [],
                'ROWS': []
            };
            if (component.bardatacustomization() !== '') {
                bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
            }

            try {
                if (component.dataRes.dimensions.length === 1 && component.dataRes.dimensions[0].containsMeasures === true) {
                    for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {
                        seriesName.push(component.dataRes.dimensions[0].members[i]['text']);
                        seriesKey.push(component.dataRes.dimensions[0].members[i].key);
                    }

                } else {
                    var checkArray = [];
                    var measureDimIndex = -1;
                    var colCountval = 0;
                    var rowCountval = 0;
                    for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                        if (component.dataRes.dimensions[i].containsMeasures === true) {
                            measureDimIndex = i;
                            continue;
                        } else {
                            if (component.dataRes.dimensions[i].axis == 'COLUMNS') {
                                colCountval++;
                            } else if (component.dataRes.dimensions[i].axis == 'ROWS') {
                                rowCountval++;
                            }
                        }
                    }

                    var dimMesJson = {};
                    var memIndexArray = [];
                    var measureIndex;
                    if (component.measurelist() === '' || component.measurelist() === undefined || component.measurelist() === null) {
                        measureIndex = 0;
                    } else {
                        var measureMembersArr = component.getMeasureMembersKeyAndText(component);
                        measureIndex = measureMembersArr[1].indexOf(component.measurelist());
                        if (measureIndex == -1) {
                            measureIndex = 0;
                        }
                    }
                    var bardataJSON = {
                        'COLUMNS': [],
                        'ROWS': []
                    };
                    var defaultView = false;
                    if ((colCountval > 2 || rowCountval > 2) && component.datautility() === false) {
                        for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                            if (colCountval > 2) {
                                if (bardataJSON.COLUMNS.length === 2) {
                                    continue;
                                }
                                if (i != measureDimIndex) {
                                    bardataJSON.COLUMNS.push({
                                        'index': i,
                                        'text': component.dataRes.dimensions[i].text,
                                        'key': component.dataRes.dimensions[i].key
                                    });
                                    defaultView = true;
                                }
                            } else {
                                if (bardataJSON.ROWS.length == 2) {
                                    continue;
                                }
                                if (i != measureDimIndex) {
                                    bardataJSON.ROWS.push({
                                        'index': i,
                                        'text': component.dataRes.dimensions[i].text,
                                        'key': component.dataRes.dimensions[i].key
                                    });
                                    defaultView = true;
                                }
                            }

                        }

                    }

                    // if (!component.datautility() && defaultView === false) { //normal default view
                        var rowIndex = component.dataRes['axis_columns'][0].indexOf(-1);
                        if (rowIndex !== -1) {
                            for (var i = rowIndex; i < component.dataRes.dimensions.length; i++) {
                                if (!component.dataRes.dimensions[i].containsMeasures) {
                                    memIndexArray.push(i);
                                }
                            }
                        } else {
                            rowIndex = component.dataRes.dimensions.length;
                        }

                        if (memIndexArray.length === 0) {
                            for (var i = 0; i < rowIndex; i++) {
                                if (!component.dataRes.dimensions[i].containsMeasures) {
                                    memIndexArray.push(i);
                                }
                            }
                        }

                        dimMesJson = {
                            'mesIndex': 0,
                            'dimIndexArray': memIndexArray,
                            'dimensionAxis': 'rows'
                        };
                    // } else { //Data utility enabled
                    //     if (component.bardatacustomization() !== '' && component.datautility() === true) {
                    //         bardataJSON = JSON.parse(component.bardatacustomization());
                    //     }

                    //     if (bardataJSON['ROWS'].length > 0) {
                    //         for (var i = 0; i < bardataJSON['ROWS'].length; i++) {
                    //             memIndexArray.push(bardataJSON['ROWS'][i].index);
                    //         }

                    //         dimMesJson = {
                    //             'mesIndex': measureIndex,
                    //             'dimIndexArray': memIndexArray,
                    //             'dimensionAxis': 'rows'
                    //         };
                    //     } else if (bardataJSON['COLUMNS'].length > 0) {
                    //         for (var i = 0; i < bardataJSON['COLUMNS'].length; i++) {
                    //             memIndexArray.push(bardataJSON['COLUMNS'][i].index);
                    //         }

                    //         dimMesJson = {
                    //             'mesIndex': measureIndex,
                    //             'dimIndexArray': memIndexArray,
                    //             'dimensionAxis': 'columns'
                    //         };
                    //     }

                    // }

                    var dimMesIndexJson = dimMesJson;
                    for (var i = 0; i < component.dataRes.data.length; i++) {
                        var y = '';
                        var x;
                        var categories = [];
                        var categoriesKey = [];
                        var execute = true;
                        if (component.dataRes.tuples[i][measureDimIndex] == dimMesIndexJson.mesIndex) {

                            for (var j = 0; j < dimMesIndexJson.dimIndexArray.length; j++) {
                                y = y + '' + component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]];
                                categories.push(component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]].members[component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]]]['text']);
                                categoriesKey.push(component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]].members[component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]]].key);
                                for (var k = 0; k < component.dataRes.dimensions.length; k++) {
                                    if (component.dataRes.dimensions[k].members[component.dataRes.tuples[i][k]].type == 'RESULT') {
                                        execute = false;
                                    }
                                }

                            }

                            if (execute) {
                                if (checkArray.indexOf(y) == -1) {
                                    seriesName.push(categories.join('\\'));
                                    seriesKey.push(categoriesKey.join('\\'));
                                    x = y;
                                    checkArray.push(y);
                                }
                            }
                        }
                    }
                }
            } catch (e) {
                seriesLibrary.DSXalert(e.message);
            }

            if (component.showtotal() === true) {
                seriesName.push('Total Result');
                seriesKey.push('Total Result');
            }

        }

        return [seriesName, seriesKey];
    };

    component.getDataSeriesColor = function() {
        var dataseriescolor = '';
        try {
                if(component.dataseriescolor()){
                    dataseriescolor = component.dataseriescolor();
                }else{
                    dataseriescolor = [
                                        '#B586DA',
                                        '#FF6657',
                                        '#F3A730',
                                        '#946B66',
                                        '#B0AD53',
                                        '#7AC1DE',
                                        '#F1C337',
                                        '#566C6C',
                                        '#A1CC54',
                                        '#543F1E'
                                    ].join(",");
                }
        } catch (e) {
            seriesLibrary.DSXalert(e.message);
        }

        return dataseriescolor;
    };

  component.getMeasuresNamesForFormatter = function(){
      return vbiNumberFormat.getMeasuresNamesForFormatter(component);
  };

    component.getDatUtility = function() {
        var datautility = '';
        try {
            datautility = component.datautility();
        } catch (e) {
            seriesLibrary.DSXalert(e.message);
        }

        return datautility;
    };

    component.getChartType = function() {
        return 'TreeMap';
    };

    component.getDimensionAndMeasure = function() {
        var dimensionAndMeasure = [];
        if (component.dataRes !== undefined && component.dataRes !== '') {

            for (var i = 1; i < component.dataRes.dimensions.length; i++) {
                dimensionAndMeasure.push(component.dataRes.dimensions[i].text);
            }

        }

        return dimensionAndMeasure;
    };

    component.getMeasureMembers = function() {
      return seriesLibrary.getMeasureMembers(component);
    };

    component.getScalingandUnitinDS = function() {
        var seriesNameforTreemeasure1;
        var seriesNameforTreemeasure2;
        var keyvalformeasure1;
        var keyvalformeasure2;
        var scalingFactorinDSform1;
        var scalingFactorinDSform2;
        var unitValinDSform1;
        var unitValinDSform2;
        if (component.dataRes !== undefined && component.dataRes !== null && component.dataRes !== '') {
            for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                if ('containsMeasures' in component.dataRes.dimensions[i]) {
                    $.each(component.dataRes.dimensions[i].members, function(key, value) {
                        if (component.treecolormeasure() == value.key) {
                            unitValinDSform1 = value.unitOfMeasure;
                            scalingFactorinDSform1 = value.scalingFactor;
                            seriesNameforTreemeasure1 = value.text;
                            keyvalformeasure1 = value.key;
                        }
                        if (component.treesizemeasure() == value.key) {

                            unitValinDSform2 = value.unitOfMeasure;
                            scalingFactorinDSform2 = value.scalingFactor;
                            seriesNameforTreemeasure2 = value.text;
                            keyvalformeasure2 = value.key;
                        }
                    });
                }
            }
        }

        if (component.showunit()) {
            if (unitValinDSform1 !== '' && unitValinDSform1 !== undefined) {
                unitValinDSform1 = '(in ' + unitValinDSform1 + ')';
            } else {
                unitValinDSform1 = '';
            }
        } else {
            unitValinDSform1 = '';
        }

        if (component.scalingfactorenable()) {
            scalingFactorinDSform1 = '(* ' + Math.pow(10, scalingFactorinDSform1) + ' )';
        } else {
            scalingFactorinDSform1 = '';
        }

        return [scalingFactorinDSform1, unitValinDSform1];
    };

   component.componentDeleted = function() {
        $('#dsui_' + componentID).remove();
    };

  }

}