function WaterfallChartUtil(){
  componentUtil.call(this);
  
  this.getSampleDataSeries = function() {
    var seriesData = [
      {
        name: "Start",
        y: 120000
      },
      {
        name: "Product Revenue",
        y: 569000
      },
      {
        name: "Service Revenue",
        y: 231000
      },
      {
        name: "Positive Balance",
        isIntermediateSum: true,
        color: Highcharts.getOptions().colors[1]
      },
      {
        name: "Fixed Costs",
        y: -342000
      },
      {
        name: "Variable Costs",
        y: -233000
      },
      {
        name: "Final Balance",
        isSum: true,
        color: Highcharts.getOptions().colors[1]
      }
    ];
    return seriesData;
  };
  
  this.getDefaultValue=function(that,options){
    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary; // jshint ignore:line
    var vbiCharts =dependencyObject.VbiCharts;//jshint ignore:line
    var vbiHighchartsDefault = dependencyObject.vbiHighchartsDefaultValue; // jshint ignore:line
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line
    var vbiContextMenu = dependencyObject.VBIContextMenuLibray; //jshint ignore:line
    var lassoObj = SeriesLibrary.prototype.lasso;
    //To stop loading the fireeven twice - 1200 -- Vignesh G.
    var isLoad = false;
    var component = that.$();
    //To Avoid offset working even after disabling tile in axis
    var offsetaxis = function(titledisplay, titleoffset, titletext) {
      if (titleoffset == "" || titletext == " ") {
        //jshint ignore:line
        return null;
      } else if (titledisplay === true) {
        return titleoffset;
      } else {
        return null;
      }
    };
    var defaultValue = {
      chart: {
        type: "waterfall",
        inverted:  that.waterfallcharttype()=="vertical",
        //inverted:that.chartinverted(),//shouldn't expose this property to user
        //alignTicks:that.chartalignticks(),//applicable in multiple axes
        className: that.chartcssclassname(),
        events: {
          click: function(event) {
            lassoObj.unselectByClick.call(this, that);
            if (event.target.textContent === "") {
              that.fireEvent("chartonclick");
            }
          },

          drillup: function(event) {
            var parent = that.drillupArr.pop();
            var currentSeries = event.seriesOptions.data;
            var i = 0; // Index to consider for getting the level value.
            seriesLibrary.trackActionFunc(that, "drillup");
            if (that.parentondrill()) {
              i = that.parentnodeplacement() == "before" ? 1 : 0;
            }

            //VBX141-5322: Occurs when parent node has only one member.
            if (!currentSeries[i] && i == 1) {
              i = 0;
            }

            if (
              currentSeries[i] &&
              typeof currentSeries[i].level != "undefined"
            ) {
              var currentLevel = currentSeries[i].level;
              that.drilldownlevel(Number(currentLevel));
            }

            if (that.chartondrillup() !== "") {
              try {
                var ztlPointJson = {};
                ztlPointJson = $.extend(
                  true,
                  {},
                  that.ztlSelectedColumnJson[parent.column]
                );
                $.extend(true, ztlPointJson, that.ztlSelectedRowJson[parent.row]);
                that.drillupmember(JSON.stringify(ztlPointJson));
              } catch (e) {
                seriesLibrary.DSXalert(e.message);
              }

              that.columncolorChanged++;
              that.firePropertiesChangedAndEvent(
                ["drilldownlevel", "drillupmember"],
                "chartondrillup"
              );
            } else {
              that.columncolorChanged++;
              that.firePropertiesChanged(["drilldownlevel"]);
            }
          },

          load: function() {
            if (vbiContextMenu) {
              vbiContextMenu.highchartsPostProcess();
            }
            /*var contextMenuOptions={event:event,
                                      enableContextMenu:that.enableContextMenu(),
                                      enableDisplayDataButton:that.enableDisplayDataButton(),
                                      enableMaximizeButton:that.enableMaximizeButton(),
                                      enableMoreActionsButton:that.enableMoreActionsButton()};

                //The If condition is fire the charafterload event only once - Fix 1200
                vbiContextMenu.attachContextMenu(contextMenuOptions);*/

            //The If condition is fire the charafterload event only once - Fix 1200
            if (!isLoad) {
              that.fireEvent("chartafterload");
              isLoad = true;
            }

            if (that.creditsenabled() === true) {
              this.credits.element.onclick = function() {
                window.open(
                  that.creditshref(),
                  "_blank" // <- This is what makes it open in a new window.
                );
              };
            }
          },

          selection: function(e) {
            var retVal = lassoObj.selectPointsByDrag.call(this, e, that);
            if (this.lasso == "lasso" || this.lasso == "rlasso") {
              that.fireEvent("chartonpointclick");
            } else {
              if (e.xAxis) {
                that.fireEvent("chartonselect");
              } //disabling the fireEvent while zoom out.
            }

            return retVal;
          }
        },
        ignoreHiddenSeries: that.ignorehiddenseries(),
        marginBottom:
          that.chartmarginbottom() == "auto"
            ? null
            : Number(that.chartmarginbottom()),
        marginLeft:
          that.chartmarginleft() == "auto"
            ? null
            : Number(that.chartmarginleft()),
        marginRight:
          that.chartmarginright() == "auto"
            ? null
            : Number(that.chartmarginright()),
        marginTop:
          that.chartmargintop() == "auto" ? null : Number(that.chartmargintop()),
        spacingBottom:
          that.chartpaddingbottom() == "auto"
            ? null
            : Number(that.chartpaddingbottom()),
        spacingLeft:
          that.chartpaddingleft() == "auto"
            ? null
            : Number(that.chartpaddingleft()),
        spacingRight:
          that.chartpaddingright() == "auto"
            ? null
            : Number(that.chartpaddingright()),
        spacingTop:
          that.chartpaddingtop() == "auto"
            ? null
            : Number(that.chartpaddingtop()),
        pinchType: that.chartpinchtype(),
        zoomType: that.chartzoomtype(),
        panning: true,
        panKey: that.chartpankey(),
        plotShadow: that.plotshadow(),
        reflow: that.chartflow() || false,
        shadow: that.chartshadow(),
        showaxes: that.showaxes(),
        resetZoomButton: {
          position: {
            align: that.zoombuttonalign(),
            verticalAlign: that.zoombuttonverticalalign()
          },
          theme: {
            fill: that.resetzoombuttonbackgroundcolor(),
            r: that.resetzoombuttonradius(),
            style: { color: that.resetzoombuttontextcolor() },
            states: {
              hover: {
                fill: that.resetzoombuttonhoverbackgroundcolor(),
                style: { color: that.resetzoombuttonhovertextcolor() }
              }
            }
          }
        },
        backgroundColor: that.chartbackgroundcolor(),
        borderColor: that.chartbordercolor(),
        borderRadius: that.chartborderradius(),
        borderWidth: that.chartborderwidth(),
        plotBackgroundColor:
          that.plotbackgroundcolor().charAt(0) == "#"
            ? "rgba(" +
              vbiCharts.colorToRGBA(
                that.plotbackgroundcolor(),
                that.plottransparency() == "false" ||
                that.plottransparency() === false
                  ? 1
                  : 0
              ) +
              ")"
            : that.plotbackgroundcolor(),
        plotBackgroundImage: that.plotbackgroundimage().replace(/ /g, ""),
        plotBorderColor: that.plotbordercolor(),
        plotBorderWidth: that.plotborderwidth(),
        selectionMarkerFill: that.zoomselectionareabackgroundcolor()
      },
      title: vbiHighchartsDefault.createDefaultObjects("commonTitle", that),
      subtitle: vbiHighchartsDefault.createDefaultObjects("commonSubtitle", that),
      credits: vbiHighchartsDefault.createDefaultObjects("commonCredits", that),
      exporting: vbiHighchartsDefault.createDefaultObjects(
        "commonExporting",
        that
      ),
      loading: vbiHighchartsDefault.createDefaultObjects("commonLoading", that),
      navigation: vbiHighchartsDefault.createDefaultObjects(
        "commonNavigation",
        that
      ),
      tooltip: vbiHighchartsDefault.createDefaultObjects("commonTooltip", that),
      xAxis: {
        type: "category",
        allowDecimals: that.xaxisallowdecimals(),
        alternateGridColor: that.xaxisalternategridcolor(),
        gridLineColor: that.xaxisgridlinecolor(),
        gridLineDashStyle: that.xaxisgridlinedashstyle(),
        gridLineWidth: that.xaxisgridlinewidth(),
        gridZIndex: that.xaxisgridzindex(),
        ceiling:
          that.xaxisceiling() === "" ? null : _.parseInt(that.xaxisceiling()),
        floor: that.xaxisfloor() === "" ? null : _.parseInt(that.xaxisfloor()),
        lineColor: that.xaxislinecolor(),
        lineWidth: that.xaxislinewidth(),
        minRange: that.xaxisminrange(),
        min: that.xaxismin() === "" ? null : _.parseInt(that.xaxismin()),
        max: that.xaxismax() === "" ? null : _.parseInt(that.xaxismax()),
        maxPadding:
          that.xaxismaxpadding() === ""
            ? null
            : parseFloat(that.xaxismaxpadding()),
        minPadding:
          that.xaxisminpadding() === ""
            ? null
            : parseFloat(that.xaxisminpadding()),
        opposite: that.xaxisopposite(),
        offset: that.xaxisoffset(),
        reversed: that.xaxisreversed() === true,
        showEmpty: that.xaxisshowempty(),
        showFirstLabel: that.xaxisshowfirstlabel(),
        showLastLabel: that.xaxisshowlastlabel(),
        dateTimeLabelFormats: {},

        minTickInterval: that.xaxismintickinterval(),
        tickColor: that.xaxistickcolor(),
        tickInterval: that.xaxistickinterval(),
        tickLength: that.xaxisticklength(),
        tickPosition: that.xaxistickposition(),
        tickWidth: that.xaxistickwidth(),
        tickmarkPlacement: that.xaxistickmarkplacement(),
        labels: {
          align: that.xaxislabelalign(),
          enabled: that.xaxislabelenabled(),
          format:
            that.xaxislabelprefix() +
            that.xaxislabelformat() +
            that.xaxislabelsuffix(),
          //overflow:that.xaxislabeloverflow(),
          rotation: that.xaxislabelrotation(),
          //distance:that.xaxislabeldistance(),
          staggerLines:
            that.xaxislabelstaggerline() === ""
              ? null
              : _.parseInt(that.xaxislabelstaggerline()),
          maxStaggerLines:
            that.xaxislabelmaxstaggerline() === ""
              ? null
              : _.parseInt(that.xaxislabelmaxstaggerline()),
          step: that.xaxislabelstep() === 0 ? null : that.xaxislabelstep(),
          x: that.xaxislabelx(),
          y: that.xaxislabely(),
          zIndex: that.xaxislabelzindex(),
          style: {
            color: that.xaxislabelcolor(),
            fontWeight: that.xaxislabelfontweight(),
            textDecoration: that.xaxislabelfontweight(),
            fontSize: that.xaxislabelfontsize() + "px",
            fontFamily: that.xaxislabelfontfamily()
          },
          events: {
            click: function() {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        title: {
          text: that.xaxistitletext(),
          align: that.xaxistitlealign(),
          rotation: that.xaxistitlerotation(),
          offset: offsetaxis(
            that.xaxistitleenabled(),
            that.xaxistitleoffset(),
            that.xaxistitletext()
          ),
          margin: that.xaxistitlemargin(),
          style: {
            color: that.xaxistitlecolor(),
            fontWeight: that.xaxistitlefontweight(),
            textDecoration: that.xaxistitlefontweight(),
            fontSize: that.xaxistitlefontsize() + "px",
            fontFamily: that.xaxistitlefontfamily(),
            display: that.xaxistitleenabled() === true ? "block" : "none"
          }
        },
        plotBands: [
          {
            color:
              that.xaxisplotbandenabled() === true
                ? that.xaxisplotbandcolor()
                : null,
            borderColor:
              that.xaxisplotbandenabled() === true
                ? that.xaxisplotbandbordercolor()
                : null,
            borderWidth: that.xaxisplotbandborderwidth(),
            from: that.xaxisplotbandfrom(),
            to: that.xaxisplotbandto(),
            zIndex: that.xaxisplotbandzindex(),
            events: {
              click: function() {
                that.fireEvent("xaxisplotbandonclick");
              },

              mouseover: function() {
                that.fireEvent("xaxisplotbandmousemove");
              }
            },
            label: {
              style: {
                color: that.xaxisplotbandlabelcolor(),
                fontWeight: that.xaxisplotbandlabelfontweight(),
                textDecoration: that.xaxisplotbandlabelfontweight(),
                fontSize: that.xaxisplotbandlabelfontsize() + "px",
                fontFamily: that.xaxisplotbandlabelfontfamily(),
                display:
                  that.xaxisplotbandlabelenabled() === true ? "block" : "none"
              },
              text: that.xaxisplotbandlabeltext(),
              align: that.xaxisplotbandlabelalign(),
              rotation: that.xaxisplotbandlabelrotation(),
              textAlign: that.xaxisplotbandlabeltextalign(),
              verticalAlign: that.xaxisplotbandlabelverticalalign(),
              x:
                that.xaxisplotbandlabelxposition() === ""
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelxposition()),
              y:
                that.xaxisplotbandlabelyposition() === ""
                  ? null
                  : _.parseInt(that.xaxisplotbandlabelyposition())
            }
          }
        ],
        plotLines: [
          {
            color:
              that.xaxisplotlineenabled() === true
                ? that.xaxisplotlinecolor()
                : null,
            dashStyle: that.xaxisplotlinedashstyle(),
            width: that.xaxisplotlinewidth(),
            value: that.xaxisplotlinevalue(),
            zIndex: that.xaxisplotlinezindex(),
            label: {
              style: {
                color: that.xaxisplotlinelabelcolor(),
                fontWeight: that.xaxisplotlinelabelfontweight(),
                textDecoration: that.xaxisplotlinelabelfontweight(),
                fontSize: that.xaxisplotlinelabelfontsize() + "px",
                fontFamily: that.xaxisplotlinelabelfontfamily(),
                display:
                  that.xaxisplotlinelabelenabled() === true ? "block" : "none"
              },
              text: that.xaxisplotlinelabeltext(),
              align: that.xaxisplotlinelabelalign(),
              rotation: that.xaxisplotlinelabelrotation(),
              textAlign: that.xaxisplotlinelabeltextalign(),
              verticalAlign: that.xaxisplotlinelabelverticalalign(),
              x:
                that.xaxisplotlinelabelxposition() == "null"
                  ? null
                  : _.parseInt(that.xaxisplotlinelabelxposition()),
              y:
                that.xaxisplotlinelabelyposition() == "null"
                  ? null
                  : _.parseInt(that.xaxisplotlinelabelyposition())
            }
          }
        ]
      },
      yAxis: {
        allowDecimals: that.yaxisallowdecimals(),
        alternateGridColor: that.yaxisalternategridcolor(),
        gridLineColor: that.yaxisgridlinecolor(),
        gridLineDashStyle: that.yaxisgridlinedashstyle(),
        gridLineWidth: that.yaxisgridlinewidth(),
        gridZIndex: that.yaxisgridzindex(),
        lineColor: that.yaxislinecolor(),
        lineWidth: that.yaxislinewidth(),
        minorGridLineColor: that.yaxisminorgridlinecolor(),
        minorGridLineDashStyle: that.yaxisminorgridlinedashstyle(),
        minorGridLineWidth: that.yaxisminorgridlinewidth(),
        minorTickColor: that.yaxisminortickcolor(),
        minorTickInterval:
          that.yaxisminortickinterval() === ""
            ? "auto"
            : _.parseInt(that.yaxisminortickinterval()),
        minorTickLength: that.yaxisminorticklength(),
        minorTickPosition: that.yaxisminortickposition(),
        minorTickWidth: that.yaxisminortickwidth(),
        tickColor: that.yaxistickcolor(),
        tickInterval:
          that.yaxistickinterval() === "" || that.yaxistickinterval() === 0
            ? null
            : _.parseInt(that.yaxistickinterval()),
        tickLength: that.yaxisticklength(),
        tickPosition: that.yaxistickposition(),
        tickWidth: that.yaxistickwidth(),
        tickmarkPlacement: that.yaxistickmarkplacement(),
        dateTimeLabelFormats: {},
        ceiling:
          that.yaxisceiling() === "" ? null : _.parseInt(that.yaxisceiling()),
        floor: that.yaxisfloor() === "" ? null : _.parseInt(that.yaxisfloor()),
        min: that.yaxismin() === "" ? null : _.parseInt(that.yaxismin()),
        max: that.yaxismax() === "" ? null : _.parseInt(that.yaxismax()),
        maxPadding:
          that.yaxismaxpadding() === ""
            ? null
            : parseFloat(that.yaxismaxpadding()),
        minPadding:
          that.yaxisminpadding() === ""
            ? null
            : parseFloat(that.yaxisminpadding()),
        minRange: that.yaxisminrange(),
        offset: that.yaxisoffset(),
        opposite: that.yaxisopposite(),
        reversed: that.yaxisreversed() === true,
        showEmpty: that.yaxisshowempty(),
        showFirstLabel: that.yaxisshowfirstlabel(),
        showLastLabel: that.yaxisshowlastlabel(),
        //          startOnTick: that.yaxisstartontick(),
        //          endOnTick: that.yaxisendontick(),
        title: {
          text: that.yaxistitletext(),
          align: that.yaxistitlealign(),
          rotation: that.yaxistitlerotation(),
          offset: offsetaxis(
            that.yaxistitleenabled(),
            that.yaxistitleoffset(),
            that.yaxistitletext()
          ),
          margin: that.yaxistitlemargin(),
          style: {
            color: that.yaxistitlecolor(),
            fontWeight: that.yaxistitlefontweight(),
            textDecoration: that.yaxistitlefontweight(),
            fontSize: that.yaxistitlefontsize() + "px",
            fontFamily: that.yaxistitlefontfamily(),
            display: that.yaxistitleenabled() === true ? "block" : "none"
          }
        },
        labels: {
          align: that.yaxislabelalign(),
          enabled: that.yaxislabelenabled(),
          formatter: function() {
            return vbiHighchartsDefault["Yaxis_autoscale_formatter"](that, this);
          },
          rotation: that.yaxislabelrotation(),
          staggerLines:
            that.yaxislabelstaggerline() === ""
              ? null
              : _.parseInt(that.yaxislabelstaggerline()),
          maxStaggerLines:
            that.yaxislabelmaxstaggerline() === ""
              ? null
              : _.parseInt(that.yaxislabelmaxstaggerline()),
          step: that.yaxislabelstep() === 0 ? null : that.yaxislabelstep(),
          x: that.yaxislabelx(),
          y: that.yaxislabely(),
          zIndex: that.yaxislabelzindex(),
          style: {
            color: that.yaxislabelcolor(),
            fontWeight: that.yaxislabelfontweight(),
            textDecoration: that.yaxislabelfontweight(),
            fontSize: that.yaxislabelfontsize() + "px",
            fontFamily: that.yaxislabelfontfamily()
          },
          events: {
            click: function() {
              seriesLibrary.axisClickEvent(this, that);
            }
          }
        },
        plotBands: [
          {
            color:
              that.yaxisplotbandenabled() === true
                ? that.yaxisplotbandcolor()
                : null,
            borderColor:
              that.yaxisplotbandenabled() === true
                ? that.yaxisplotbandbordercolor()
                : null,
            borderWidth: that.yaxisplotbandborderwidth(),
            from: that.yaxisplotbandfrom(),
            to: that.yaxisplotbandto(),
            zIndex: that.yaxisplotbandzindex(),
            events: {
              click: function() {
                that.fireEvent("yaxisplotbandonclick");
              },

              mouseover: function() {
                that.fireEvent("yaxisplotbandmousemove");
              }
            },
            label: {
              style: {
                color: that.yaxisplotbandlabelcolor(),
                fontWeight: that.yaxisplotbandlabelfontweight(),
                textDecoration: that.yaxisplotbandlabelfontweight(),
                fontSize: that.yaxisplotbandlabelfontsize() + "px",
                fontFamily: that.yaxisplotbandlabelfontfamily(),
                display:
                  that.yaxisplotbandlabelenabled() === true ? "block" : "none"
              },
              text: that.yaxisplotbandlabeltext(),
              align: that.yaxisplotbandlabelalign(),
              rotation: that.yaxisplotbandlabelrotation(),
              textAlign: that.yaxisplotbandlabeltextalign(),
              verticalAlign: that.yaxisplotbandlabelverticalalign(),
              x:
                that.yaxisplotbandlabelxposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotbandlabelxposition()),
              y:
                that.yaxisplotbandlabelyposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotbandlabelyposition())
            }
          }
        ],
        plotLines: [
          {
            color:
              that.yaxisplotlineenabled() === true
                ? that.yaxisplotlinecolor()
                : null,
            dashStyle: that.yaxisplotlinedashstyle(),
            width: that.yaxisplotlinewidth(),
            value: that.yaxisplotlinevalue(),
            zIndex: that.yaxisplotlinezindex(),
            label: {
              style: {
                color: that.yaxisplotlinelabelcolor(),
                fontWeight: that.yaxisplotlinelabelfontweight(),
                textDecoration: that.yaxisplotlinelabelfontweight(),
                fontSize: that.yaxisplotlinelabelfontsize() + "px",
                fontFamily: that.yaxisplotlinelabelfontfamily(),
                display:
                  that.yaxisplotlinelabelenabled() === true ? "block" : "none"
              },
              text: that.yaxisplotlinelabeltext(),
              align: that.yaxisplotlinelabelalign(),
              rotation: that.yaxisplotlinelabelrotation(),
              textAlign: that.yaxisplotlinelabeltextalign(),
              verticalAlign: that.yaxisplotlinelabelverticalalign(),
              x:
                that.yaxisplotlinelabelxposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotlinelabelxposition()),
              y:
                that.yaxisplotlinelabelyposition() == "null"
                  ? null
                  : _.parseInt(that.yaxisplotlinelabelyposition())
            }
          }
        ]
      },
      legend: { enabled: false },
      plotOptions: {
        waterfall: {
          cursor: "pointer",
          point: {
            events: {
              click: function(event) {
                //try {
                if (that.enableexpandcollapse()) {
                  if (that.customAction === null) {
                    seriesLibrary._pointClickEvent(event, that);
                  } else {
                    seriesLibrary.pointTriggeredClick(event, that);
                  }
                } else {
                  that.selectedvalue(
                    seriesLibrary.createMemberData(
                      that,
                      that.categoriesIndex[event.point.index],
                      event.point.series.options.key
                    )
                  ); //that.changed = 1;
                }
                /*}
                    catch (e) {
                    }*/
              },
              //Commented below line, becoz on expand/colpase it reloads the chart with default data
              /**
                *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
              **/

              select: function() {
                if (!that.enableexpandcollapse()) {
                  if (!this.series.chart.lassoFlag) {
                    //try {
                    that.columncolorChanged = component.highcharts().getSelectedPoints();
                    that.columncolorChanged.push(this);
                    that.selectedvalues(
                      seriesLibrary
                        .createMembersData(
                          that,
                          that.categoriesIndex,
                          that.columncolorChanged
                        )
                        .toString()
                    );
                    seriesLibrary.onSelectFunction(that);
                    /*} catch (e) {   seriesLibrary.DSXalert(e.message);
                      }*/
                  }
                }
              },
              unselect: function() {
                if (!this.series.chart.lassoFlag) {
                  try {
                    //var unselectedPoints = component.highcharts().getSelectedPoints();
                    var index = that.columncolorChanged.indexOf(this);
                    if (index > -1) {
                      that.columncolorChanged.splice(index, 1);
                    }

                    that.selectedvalues(
                      seriesLibrary
                        .createMembersData(
                          that,
                          that.categoriesIndex,
                          that.columncolorChanged
                        )
                        .toString()
                    );
                    if (that.selectedvalues() === "") {
                      that.selectedvalue("");
                    } else {
                      var select = seriesLibrary.createMembersData(
                        that,
                        that.categoriesIndex,
                        that.columncolorChanged
                      );
                      that.selectedvalue(select[0]);
                    }
                    /**
                         *Selectedvalue fix in all charts
                         *Multiple Selection getting the last selected value.
                        **/
                    if (that.clearSelect) {
                      if (that.selectedvalues() === "") {
                        that.clearSelect = false;
                      }
                    } else {
                      seriesLibrary.onSelectFunction(that);
                    } //clearselection callback issue on Onselect.
                  } catch (e) {
                    seriesLibrary.DSXalert(e.message);
                  }
                  /**
                      *Onselect event is trigged at many times in unselect so handling it with a common callback checker event.
                      **/
                }
              }
            }
          },
          allowPointSelect: that.enableexpandcollapse()
            ? false
            : that.allowpointselect(),
          connectNulls: that.connectnulls(),
          cropThreshold: that.cropthreshold(),
          turboThreshold: that.turbothreshold(),
          dataLabels: {
            enabled: that.datalabelenabled(),
            align: that.datalabelalign(),
            crop: that.datalabelcrop(),
            //defer: that.datalabeldefer(),
            backgroundColor: that.datalabelbackgroundcolor(),
            useHTML: false,
            borderColor: that.datalabelbordercolor(),
            borderRadius: that.datalabelborderradius(),
            borderWidth: that.datalabelborderwidth(),
            padding: that.datalabelpadding(),
            rotation: that.datalabelrotation(),
            shadow: that.datalabelshadow(),
            overflow: "justify",
            verticalAlign: that.datalabelverticalalign(),
            x: that.datalabelx(),
            y: that.datalabely(),
            formatter: function() {
              that.customdatalabelFamily = "pie";
              if (
                that.customdatalabel() !== "" &&
                Object.keys(JSON.parse(that.customdatalabel() || "{}")).length
              ) {
                return vbiNumberFormat.barFamilyFormatterDataLabel(
                  this,
                  that,
                  that.progressdecimalseparator(),
                  that.progressthousandseparator(),
                  false
                );
              } else {
                return vbiNumberFormat.pieFamilyDataLabelFormatter(
                  this,
                  that,
                  that.progressdecimalseparator(),
                  that.progressthousandseparator(),
                  false
                );
              }
            },

            style: {
              textShadow: false,
              color: that.datalabeltextcolor(),
              fontWeight: that.datalabelfontweight(),
              textDecoration: that.datalabelfontweight(),
              fontSize: that.datalabelfontsize() + "px",
              fontFamily:
                that.globalfont() === true
                  ? this.fontfamily()
                  : that.datalabelfontfamily()
            }
          },
          marker: {}
        }
      },
      drilldown: {
        activeAxisLabelStyle: {
          color: that.xaxislabelcolor(),
          fontWeight: that.xaxislabelfontweight(),
          textDecoration: that.xaxislabelfontweight(),
          fontSize: that.xaxislabelfontsize() + "px",
          fontFamily:
            that.globalfont() === true
              ? that.fontfamily()
              : that.xaxislabelfontfamily()
        }
      },
      series: [
        {
          //            upColor: Highcharts.getOptions().colors[2],
          //            color: Highcharts.getOptions().colors[3],
          data: options.seriesData,
          pointPadding: 0
        }
      ]
    };
    return defaultValue;
  };

  this.attachGetters=function(component,options){
    this.attachBaseGetters(component,options);

    var dependencyObject = options.dependencyObject;
    var seriesLibrary = dependencyObject.SeriesLibrary;
    var vbiNumberFormat = dependencyObject.VbiNumberFormat; //jshint ignore:line

    component.isDataSourceStructureModified = function () {
      if (component.result() && component.oldResultSet) {
        var ds = component.result(),
        dsOld = component.oldResultSet,
        dsDimensions = ds.dimensions,
        dsOldDimensions = dsOld.dimensions;
        if (dsDimensions.length !== dsOldDimensions.length) {
          return true;
        } else {
          for (var i = 0, len = dsDimensions.length; i < len; i++) {
            if (dsDimensions[i].key != dsOldDimensions[i].key || dsDimensions[i].axis != dsOldDimensions[i].axis) {
              return true;
            }
          }
        }

        return false;
      }
      return 'NA';
    };

    component.countRowDimensions = function() {
      var count = 0;
      var totalDimensions = component.result().dimensions.length;
      for (var i = 0; i < totalDimensions; i++) {
        if (component.result().dimensions[i].axis == 'ROWS') {
          count++;
        }
      }

      return count;
    };


    component.getMeasuresNamesForFormatter = function(){
        return vbiNumberFormat.getMeasuresNamesForFormatter(component);
    };

    component.setDataUtilityFormattedResultSet = function(){
      component.dataRes = DataUtilityLib.CallUtility();
      component.dataRes = component.dispKeyTextResultSet();
    };

    component.dataUtilityAggregation = function(dataArray){
        var data = [];
        var aggregationType = DataUtilityLib.getAggregationType() || 'sum';
        data.push(dataArray);
        return DataUtilityLib.aggregationResult(data, aggregationType)[0];
    };

    component.getDataSeries = function(value) {

    if (!component.dataRes) { return null; }
      var seriesName = [];
      var seriesKey = [];
      try {
        if (component.dataRes !== undefined && component.dataRes !== '') {
          if (component.dataRes.dimensions.length == 1 && component.dataRes.dimensions[0].containsMeasures === true) {
            for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {
              seriesName.push(component.dataRes.dimensions[0].members[i]["picker_text"]);
              seriesKey.push(component.dataRes.dimensions[0].members[i].key);
            }
          } else {
            var checkArray = [];
            var measureDimIndex = -1;
            for (var i = 0; i < component.dataRes.dimensions.length; i++) {
              if (component.dataRes.dimensions[i].containsMeasures === true) {
                measureDimIndex = i;
                break;
              }
            }

            var dimMesJson = {};
            var memIndexArray = [];
            var measureIndex = 0;
            if (component.measurelist() === '' || component.measurelist() === undefined || component.measurelist() === null) {
               measureIndex = 0;
            } else {
              var measureMembersArr = component.getMeasureMembersKeyAndText();
              var measureIndex = measureMembersArr[1].indexOf(component.measurelist());
              if (measureIndex == -1) {
                measureIndex = component.measurelist();
              }
            }

              measureIndex = 0;
              var rowIndex = component.dataRes["axis_columns"][0].indexOf(-1);
              if (rowIndex !== -1) {
                for (var i = rowIndex; i < component.dataRes.dimensions.length; i++) {
                  if (!component.dataRes.dimensions[i].containsMeasures) {
                    memIndexArray.push(i);
                  }
                }
              } else {
                rowIndex = component.dataRes.dimensions.length;
              }

              if (memIndexArray.length === 0) {
                for (var i = 0; i < rowIndex; i++) {
                  if (!component.dataRes.dimensions[i].containsMeasures) {
                    memIndexArray.push(i);
                  }
                }
              }

              dimMesJson = {
                'mesIndex': 0,
                'dimIndexArray': memIndexArray,
                'dimensionAxis': 'rows'
              };
            

            var dimMesIndexJson = dimMesJson;
            for (var i = 0; i < component.dataRes.data.length; i++) {
              var y = '';
              var categories = [];
              var categoriesKey = [];
              var execute = true;
              if (component.dataRes.tuples[i][measureDimIndex] == dimMesIndexJson.mesIndex) {
                for (var j = 0; j < dimMesIndexJson.dimIndexArray.length; j++) {
                  y = y + '' + component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]];
                  categories.push(component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]].members[component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]]]["picker_text"]);
                  categoriesKey.push(component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]].members[component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]]].key);
                  for (var k = 0; k < component.dataRes.dimensions.length; k++) {

                          if (component.dataRes.dimensions[k].members[component.dataRes.tuples[i][k]].type == 'RESULT') {
                            execute = false;
                          }
                  }
                }


                if (execute) {
                  if (checkArray.indexOf(y) == -1) {
                    seriesName.push(categories.join('/'));
                    seriesKey.push(categoriesKey.join('/'));
                   // x = y;
                    checkArray.push(y);
                  }
                }
              }
            }
          }
          // VBX141-7471 fix
          if(value == "nointerimfinal"){

          }
          else{
             seriesName.push('Intermediate Sum','Final Balance');
             seriesKey.push('Intermediate Sum','Final Balance');

          }
        }
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return [
        seriesName,
        seriesKey
      ];
    };

    component.getNewLabels = function() {
      var newLabels = [];
      newLabels.push(component.intermediatesumLabel);
      newLabels.push(component.finalbalanceLabel);
      return newLabels;
    };

    component.getDataSeriesColor = function() {
      var dataseriescolor = '';
      try {
        dataseriescolor = component.dataseriescolor();
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return dataseriescolor;
    };

    component.getDatUtility = function() {
      var datautility = '';
      try {
        datautility = component.datautility();
      } catch (e) {   seriesLibrary.DSXalert(e.message);
      }

      return datautility;
    };

    component.getChartType = function() {
      if(component.enableexpandcollapse()){
        return "piedd";
      }
      else{
        return 'waterfall';
      }

    };

    component.getDimensionAndMeasure = function() {

      var dimensionAndMeasure = [];
      if (component.dataRes !== undefined && component.dataRes !== '')
        // if (component.dataRes !== undefined && component.dataRes != "")
        {
        for (var i = 1; i < component.dataRes.dimensions.length; i++) {
          dimensionAndMeasure.push(component.dataRes.dimensions[i].text);
        }
      }

      return dimensionAndMeasure;
    };

    component.getMeasureMembersKeyAndText = function() {
      var measureMemberKeys = [];
      var measureMemberText = [];
      if (component.dataRes !== undefined && component.dataRes !== '') {
        try {
          var mesIndex = component.getMeasureIndex();
          for (var i = 0; i < component.dataRes.dimensions[mesIndex].members.length; i++) {
            measureMemberKeys.push(component.dataRes.dimensions[mesIndex].members[i].key);
            measureMemberText.push(component.dataRes.dimensions[mesIndex].members[i]["picker_text"]);
          }
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return [
        measureMemberText,
        measureMemberKeys
      ];
    };

    component.isMeasureOnly = function() {
      var len = 0;
      if (component.result() !== undefined && component.result() !== '') {
        try {
          len = component.result().dimensions.length;
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return len;
    };

    component.getDimensionList = function() {
      // var dimlist =[];
      var dimname = [];
      var dimindex = [];
      if (component.result() !== undefined && component.result() !== '') {
        try {
          for (var i = 0; i < component.result().dimensions.length; i++) {
            if (component.dataRes.dimensions[i].containsMeasures !== true) {
              dimname.push(component.result().dimensions[i].text);
              dimindex.push(i);
            }
          }
        } catch (e) {   seriesLibrary.DSXalert(e.message);
        }
      }

      return [
        dimname,
        dimindex
      ];
    };

    component.getMeasureMembers = function() {
      return seriesLibrary.getMeasureMembers(component);
    };

    component.componentDeleted = function() {
      $('#dsui_' + componentID).remove();
    };

    component.getChartFamily = function() {
      return 'pie';
    };

    component.lassoFireProp = function(selectedPoints) {
      var selectedValues = seriesLibrary.createMembersData(component, component.categoriesIndex, selectedPoints).toString();
      if(component.intermediatesum()){
         selectedValues =  selectedValues.replace(",{}","");
         selectedValues =  selectedValues.replace("{},","");
      }
      component.selectedvalues(selectedValues);
     // component.changed++;
      component.firePropertiesChanged(['selectedvalues']);
    };
  }

}