(function() {
'use strict';

var app = angular.module('gridstack-angular');

app.directive('gridstack', ['$timeout','$compile', function($timeout,$compile) {

  return {
    restrict: 'A',
    controller: 'GridstackController',
    scope: {
      onChange: '&',
      onDragStart: '&',
      onDragStop: '&',
      onResizeStart: '&',
      onResizeStop: '&',
      //  onComponentsDragged: '&',
     //  onComponentsRemoved: '&',
      gridstackHandler: '=?',
      options: '='
    },
    link: function(scope, element, attrs, controller, ngModel) {
      var gridstack = controller.init(element, scope.options);

      scope.gridstackHandler = gridstack;

      element.on('change', function(e, items) {
        $timeout(function() {
          scope.$apply();
          scope.onChange({event: e, items: items});
        });
      });

      // element.on('mousedown',function(e){
      //   if(angular.element(event.target).hasClass('removebutton')){
      //     var componentName=angular.element(event.target).attr('data-name');
      //     if(componentName == ''){
      //       angular.element(event.target).parent().parent().remove();
      //     }else{
      //     angular.element(document.getElementById(componentName)).remove();
      //     }
      //     scope.onComponentsRemoved({comp:componentName});
      //   }
      // })

      element.on('dragstart', function(e, ui) {
         scope.onDragStart({event: e, ui: ui});
      });

      element.on('dragstop', function(e, ui) {
        $timeout(function() {
          scope.$apply();
          scope.onDragStop({event: e, ui: ui});
        });
      });

      element.on('resizestart', function(e, ui) {
        scope.onResizeStart({event: e, ui: ui});
      });

      element.on('resizestop', function(e, ui) {
        $timeout(function() {
          scope.$apply();
          scope.onResizeStop({event: e, ui: ui});
        });
      });

    }
  };

}]);
})();
