/**
 * Creates an instance of Scripting.
 *
 * @author Vignesh Gopalakrishnan
 * @constructor
 * @this {Scripting}
 */
 /* global LocDS */
function Scripting() {
}
/**
 * Method will be called when a marker is clicked on the map
 *
 * @return Marker / aggregate / redirected to opendoc URL based on requirement.
 */
Scripting.prototype.callDSScripting = function(mk) {
  var index;
  var component;
  var currentMarkerText;
  var currentMarkerkey;
  var aggregateArray;
  var dsTextName;
  var datasource = LocDS.getInstance();
  var data;
  var latIndex;
  var lngIndex;
  if (this.geoJSON) {
    component = this.self;
  } else if (mk.options) {
    component = this.options.self;
    index = this.options.index;
    data = this.options.data;
    latIndex = this.options.lat;
    lngIndex = this.options.lng;
    currentMarkerText = datasource.getDMKV(data, 'text')[index];
    currentMarkerkey = datasource.getDMKV(data, 'key')[index];
    dsTextName = datasource.getDimensionAndMeasureObj(data);
    aggregateArray = component.aggregateResults;
  }else if (mk) {
    var e = mk.target.options;
    if(e.distanceToHeight && e.mode === 'C'){ //flow layer
    component = mk.target.options.self;
    index = mk.target.options.index;
    data = mk.target.options.data;
    latIndex = mk.target.options.source[0];
    lngIndex = mk.target.options.source[1];
    currentMarkerText = datasource.getDMKV(data, 'text')[index];
    currentMarkerkey = datasource.getDMKV(data, 'key')[index];
    dsTextName = datasource.getDimensionAndMeasureObj(data);
    aggregateArray = component.aggregateResults;  
    
    }
    else{
    component = mk.target.options.self;
    index = mk.target.options.index;
    data = mk.target.options.data;
    latIndex = mk.target.options.lat;
    lngIndex = mk.target.options.lng;
    currentMarkerText = datasource.getDMKV(data, 'text')[index];
    currentMarkerkey = datasource.getDMKV(data, 'key')[index];
    dsTextName = datasource.getDimensionAndMeasureObj(data);
    aggregateArray = component.aggregateResults;  
    }
    
  }

  if(currentMarkerkey){
    for(var f in currentMarkerkey){
      if(f.indexOf('format')!=-1){
        delete currentMarkerkey[f];
      }
    }
  }

  if (component.scriptingType() == 'scripting') {
    //When we expose the object as string via scripting, Changing the value.
    var currentMarkerTextValue = {};
    for (var key in currentMarkerText) {
	  if(dsTextName[key]){
	  currentMarkerTextValue[dsTextName[key]] = currentMarkerText[key];}
    }

    currentMarkerText = currentMarkerTextValue;
    if (this.geoJSON) {
      component.isOnClick = true;
      var layerObj = this.row;
      var geoJSONProps = this.feature.properties;
      if (layerObj) {
        var aggregatedMeasure = this.aggregatedMeasure;
        var selectedProperty = geoJSONProps[layerObj.properties];
        var usableData = {};
        usableData[layerObj.properties] = selectedProperty;
        usableData[layerObj.dimension] = selectedProperty;
        usableData['aggregatedMeasure'] = aggregatedMeasure;
        var obj = {
          'internalKey': selectedProperty,
          'text': selectedProperty
        };

        var selectedMem = {};
        selectedMem[layerObj.dimension] = obj;

        component.mapSelectedMember(JSON.stringify(selectedMem));
        component.markerOnClick(JSON.stringify(usableData));
        component.firePropertiesChangedAndEvent([
                'markerOnClick',
                          'mapZoomLevel',
                'mapSelectedMember'
                     ], 'onClick');
      }
    } else {
      component.isOnClick = true;
      var filterKey = parseFloat(currentMarkerText[dsTextName[latIndex]]) + '_' + parseFloat(currentMarkerText[dsTextName[lngIndex]]);
      //If tooltip chosen is a measure then aggregate array will be greater than 0
      if (Object.keys(aggregateArray).length > 0) {
        component.markerOnClick(JSON.stringify({
          'key': currentMarkerkey,
          'text': currentMarkerText,
          'aggregate': aggregateArray[filterKey]
        }));
      } else {
        component.markerOnClick(JSON.stringify({
          'key': currentMarkerkey,
          'text': currentMarkerText
        }));
      }

      var getSelectMemKeyTxt = {};
      //Logic to iterate two objects using index in single loop
      var keys = Object.keys(currentMarkerkey);
      var text = Object.keys(currentMarkerText);
      var len = keys.length;
      var count = 0;
      //var prop, value;
      //Populating for text
      while (count < len) {
        var obj = {
          'internalKey': currentMarkerkey[keys[count]],
          'text': currentMarkerText[text[count]]
        };
        getSelectMemKeyTxt[text[count]] = obj;
        count += 1;
      }

      count = 0;
      //Populating for key
      while (count < len) {
        var obj = {
          'internalKey': currentMarkerkey[keys[count]],
          'text': currentMarkerText[text[count]]
        };
        getSelectMemKeyTxt[keys[count]] = obj;
        count += 1;
      }
      //console.log(getSelectMemKeyTxt);
      component.mapSelectedMember(JSON.stringify(getSelectMemKeyTxt));
      component.firePropertiesChangedAndEvent([
		  'markerOnClick',
       'mapSelectedMember',
       'mapZoomLevel'
    ], 'onClick');
    }
  } else {
    var openDocURL = component.openDocURL();
    var params, outputURL = '';
    if (component.openDocLayerAdd()) {
      params = JSON.parse(component.openDocLayerAdd());
      //var paramLength = Object.keys(params).length;
      for (var par in params) {
        if(params[par].isDataProvider && mk.target.options.ds!=params[par].datasource){
          continue;
        }
        var name;
        if (component.openDocScriptingType() == 'ds') {
          name = '&' + params[par].name + '=';
        } else {
          name = '&' + params[par].paramType + params[par].name + '=';
        }
        //Setting the paramerter value if its null. Supporting for migration too.
        if (params[par].keyText === undefined || params[par].keyText === null || params[par].keyText === '') {
          params[par].keyText = 'text';
        }

        if (this.geoJSON) {
          if (this.dimension == params[par].keyName){
          outputURL = outputURL + name + this.dimValue;}
        }else {
          if (params[par].keyText == 'text') {
            if (currentMarkerText && currentMarkerText[params[par].keyName]) {
              outputURL = outputURL + name + currentMarkerText[params[par].keyName];
            } else {
              outputURL = outputURL + name + params[par].dimension;
            }
          } else {
            if (currentMarkerkey && currentMarkerkey[params[par].keyName] !== undefined && currentMarkerkey[params[par].keyName] !== '') {
              outputURL = outputURL + name + currentMarkerkey[params[par].keyName];
            } else {
              outputURL = outputURL + name + params[par].keyName;
            }
          }
        }
      }
    }

    var url;
    if (component.openDocAdditionalParameter()) {
      url = openDocURL + outputURL + component.openDocAdditionalParameter().trim();
    } else {
      url = openDocURL + outputURL;
    }

    if (typeof component.isOpenInNewTab() == 'boolean' && component.isOpenInNewTab()) {
      window.open(url, '_blank');
    } else {
      //VBX141-8189
      window.open(url,"_self");
      //window.open(url, 'Open Document', 'height=600,width=1000');
    }
  }
};
