/**
 * Creates an instance of WaterMark.
 *
 * @author Vignesh Gopalakrishnan
 * @constructor
 * @param {map, props} Map Instance and Addt prop object..
 * @this {WaterMark}
 */
  /* global L */
function WaterMark(map, props) {
  var mapContainer = map;
  var addProps = props;
  var vbiTrail = new L.control({position: 'bottomleft'});
  this.getMapContainer = function() {
    return mapContainer;
  };

  this.getProps = function() {
    return addProps;
  };

  this.getVbiTrail = function() {
    return vbiTrail;
  };
}
/**
 * If user have trail version then Visualbi Logo will be displayed on the map.
 * If user doesn't activate then a infobox will be shown saying activate the map.
 *
 * @return {null} .
 */
WaterMark.prototype.load = function() {
  var self = this;
  self.getVbiTrail().onAdd = function() {
    this._div = L.DomUtil.create('div', 'leaflet-bottom leaflet-left');
    this.update();
    return this._div;
  };

  self.getVbiTrail().update = function() {
    this._div.innerHTML = '<a href=\'http://visualbi.com/sap-design-studio/dsx-extensions/\' target=\'_blank\'style=\'outline:none;border:0px solid black;position:absolute;bottom:3px;left:3px;\'><img src=\'zen/mimes/sdk_include/com.visualbi.vbilibrary/res/library/visualbi.png\' style=\'outline:none;border:0px; height:22px;width:72px;\'></a>';
  };
  //To show a vbi logo says its trail - Ends
  //var ComponentName = 'Location Analyzer';
  var rightnow = new Date();
  var userdate = self.getProps().dateexp();
  userdate = userdate.split('-');
  var enddate = new Date(_.parseInt(userdate[0]), _.parseInt(userdate[1]) - 1, _.parseInt(userdate[2]));
  var deaddate = self.getProps().harddate();
  deaddate = deaddate.split('-');
  var deadenddate = new Date(_.parseInt(deaddate[0]), _.parseInt(deaddate[1]) - 1, _.parseInt(deaddate[2]));
  var component = self.getProps().$();
  self.responseData = {"response":"ok","date":self.getProps().dateexp(),"utc":"true"};
  if (self.getProps().codestate() === 'pro') {
    self.responseCall(self.responseData, enddate);
    /*try {
      var serviceURL = 'cdn.visualbis.com/time/dsx-licence-check.php?licence_key=';
      var proto = 'http://';
      if (window.location.protocol == 'https:') {
        proto = 'https://';
      }

      $.ajax({
        type: 'GET',
        dataType: 'jsonp',
        cache: false,
        timeout: 2000,
        url: proto + serviceURL + self.getProps().regkey() + '&browser=' + self.getProps().browser,
        success: function(data) {
          if (data) {
            self.responseData = data;
            try {
              if (data.response == 'ok') {
                self.responseCall(self.responseData, enddate);
              } else {
              }
            } catch (e) {
              if (window.console) {
                console.log(e); // jshint ignore:line
              }
            }
          } else {
          }
        },

        error: function() {
        }
      });
      self.getProps().isResponseCalled = true;
    } catch (e) {
      if (window.console) {
        console.log(e); // jshint ignore:line
      }
    }*/
  } else if (self.getProps().codestate() === 'enabled') {
	  if(sap.zen.designmode=== undefined){
    component.empty();
    component.append(self.blockActivateDiv());  //Asking user to activate
	  }else{
		  self.getVbiTrail().addTo(self.getMapContainer());
	  }
  } else {
    if (rightnow > deadenddate && self.getProps().codestate() != 'pro') {
      component.empty();
      component.append(self.hardDateExpireDiv());
    } else if (rightnow > enddate && self.getProps().codestate() === 'active') {
      component.empty();
      component.append(self.blockDiv());  //expired
    } else {
      /*if (!self.getProps().isResponseCalled) {
        var serviceURL = 'cdn.visualbis.com/time/dsx-licence-check.php?licence_key=';
        var proto = 'http://';
        if (window.location.protocol == 'https:') {
          proto = 'https://';
        }

        try {
          $.ajax({
            type: 'GET',
            dataType: 'jsonp',
            cache: false,
            timeout: 2000,
            url: proto + serviceURL + self.getProps().regkey() + '&browser=' + self.getProps().browser,
            success: function(data) {
              if (data) {
                self.responseData = data;
                try {
                  if (data.response == 'ok') {
                    self.responseCall(self.responseData, enddate);
                  } else {
                  }
                } catch (e) {
                  if (window.console) {
                    console.log(e); // jshint ignore:line
                  }
                }
              } else {
              }
            },

            error: function() {
            }
          });
          self.getProps().isResponseCalled = true;
        } catch (e) {
          if (window.console) {
            console.log(e); // jshint ignore:line
          }
        }
      } else {*/
        self.responseCall(self.responseData, enddate);
      //}
    }
  }
};
/**
 * If user have trail version then Visualbi Logo will be displayed on the map.
 *
 * @param {val, enddate} Val is the data we get from visualbi cdn server, enddate is what we get from our component.
 * @return {null} .
 */
WaterMark.prototype.responseCall = function(val, enddate) {
  var self = this;
  var component = self.getProps().$();
  try {
    var data = val.date.split('-');
    var endserverdate = new Date(data[0], data[1] - 1, data[2]);
    var blockFlag = val.utc;
    if (self.getProps().codestate() === 'active' && endserverdate > enddate) {
      component.empty();
      component.append(self.blockDiv());  //expired
    } else {
      //ADD callBackFunction
      if (self.getProps().codestate() === 'pro' && blockFlag == 'false' || self.getProps().codestate() === 'active') {
        //add water mark
        if (self.getProps().imglog() != 'True') {
          self.getVbiTrail().addTo(self.getMapContainer());
        }
      }
    }
  } catch (err) {
  }
};
/**
 * Div which contains html code to block the compnent saying the component is expired.
 *
 * @return {div} .
 */
WaterMark.prototype.blockDiv = function() {
  var div = document.createElement('div');
  div.style.border = '2px solid black';
  div.style.width = '300px';
  div.style.height = '150px';
  div.style.borderRadius = '10px';
  div.style.backgroundColor = '#CEF3FF';
  div.style.textAlign = 'center';
  div.style.verticalAlign = 'middle';
  div.style.lineHeight = '30px';
  div.style.color = 'red';
  div.style.fontSize = '14px';
  div.innerHTML = ' The trial version for the custom add-on, Location Analyzer has expired. <br>Please contact: <a href=\'mailto:support@visualbi.com\' target=\'_blank\'>support@visualbi.com</a><a href=\'http://visualbi.com/sap-design-studio/dsx-extensions/\' target=\'_blank\'><img src=\'zen/mimes/sdk_include/com.visualbi.vbilibrary/res/library/visualbi.png\' style=\'outline:none;border:0px; height:22px;width:72px;\'></img></a>';
  return div;
};
/**
 * Div which contains html code to block the compnent saying the component is expired because of Harddate.
 *
 * @return {div} .
 */
WaterMark.prototype.hardDateExpireDiv = function() {
  var div = document.createElement('div');
  div.style.border = '2px solid black';
  div.style.width = '300px';
  div.style.height = '150px';
  div.style.borderRadius = '10px';
  div.style.backgroundColor = '#CEF3FF';
  div.style.textAlign = 'center';
  div.style.verticalAlign = 'middle';
  div.style.lineHeight = '30px';
  div.style.color = 'red';
  div.style.fontSize = '14px';
  div.innerHTML = ' The VBX Version is not supported for custom add-on, Location Analyzer. <br>Please contact: <a href=\'mailto:support@visualbi.com\' target=\'_blank\'>support@visualbi.com</a><a href=\'http://visualbi.com/sap-design-studio/dsx-extensions/\' target=\'_blank\'><img src=\'zen/mimes/sdk_include/com.visualbi.vbilibrary/res/library/visualbi.png\' style=\'outline:none;border:0px; height:22px;width:72px;\'></img></a>';
  return div;
};
/**
 * Div which contains html code to block the compnent saying the activate the component.
 *
 * @return {div} .
 */
WaterMark.prototype.blockActivateDiv = function() {
  var div = document.createElement('div');
  div.style.border = '2px solid black';
  div.style.width = '300px';
  div.style.height = '150px';
  div.style.borderRadius = '10px';
  div.style.backgroundColor = '#CEF3FF';
  div.style.textAlign = 'center';
  div.style.verticalAlign = 'middle';
  div.style.lineHeight = '30px';
  div.style.color = 'red';
  div.style.fontSize = '14px';
  div.innerHTML = ' Please activate using VBXInstaller for the custom add-on, Location Analyzer. <br>Please contact: <a href=\'mailto:support@visualbi.com\' target=\'_blank\'>support@visualbi.com</a><a href=\'http://visualbi.com/sap-design-studio/dsx-extensions/\' target=\'_blank\'><img src=\'zen/mimes/sdk_include/com.visualbi.vbilibrary/res/library/visualbi.png\' style=\'outline:none;border:0px; height:22px;width:72px;\'></img></a>';
  return div;
};
