    //COMPONENT GENERATE RESULT CONFIG
    var componentGenerateResultConfig = function(component) {
      var typeConfig = {
        'between': {
          fields: [{
            name: 'fromdate',
            selector: $("#" + component.componentId + "_fromdatepicker")
          }, {
            name: 'todate',
            selector: $("#" + component.componentId + "_todatepicker")
          }]
        },
        'after': {
          fields: [{
            name: 'afterdate',
            selector: $("#" + component.componentId + "_afterdatepicker")
          }]
        },
        'before': {
          fields: [{
            name: 'beforedate',
            selector: $("#" + component.componentId + "_beforedatepicker")
          }]
        },
        'last': {
          specialCase:true,          
          fields: [{
            name: 'lastactive',
            selector: [$("#" + component.componentId + "_last").find("input"),$("#" + component.componentId + "_last").find("select")]
          }]
        },
        'next': {
          specialCase:true,
          fields: [{
            name: 'nextactive',
            selector: [$("#" + component.componentId + "_next").find("input"),$("#" + component.componentId + "_next").find("select")]
          }]
        },
        'this': {
          specialCase:true,
          fields: [{
            name: 'currentactive',
            selector: [$("#" + component.componentId + "_this").find("select")]
          }]
        },
        'period': {
          specialCase:true,
          fields: [{
            name: 'period',
            selector: [$("#" + component.componentId + "_period").find("select")]
          }]
        }
      }
      return typeConfig;
    };


    //INIT GET DEFAULT VALUES
    var getdefaultValues=function(component){
        var defaultValues={
        "currentType":_.isEmpty(component.periodslidercurrenttype()) ? 'between': component.periodslidercurrenttype(),
        "from":_.isEmpty(component.fromdate()) ? moment().format('DD/MM/YYYY'): component.fromdate(),
        "to":_.isEmpty(component.todate()) ? moment().format('DD/MM/YYYY'): component.todate(),
        "after":_.isEmpty(component.afterdate()) ? moment().format('DD/MM/YYYY'): component.afterdate(),
        "before":_.isEmpty(component.beforedate()) ? moment().format('DD/MM/YYYY'): component.beforedate(),
        "lastactive":_.isEmpty(component.lastactive()) ?component.periodslidernumberofintervals()+'&'+component.periodsliderlastrangeactive():component.lastactive(),
        "nextactive":_.isEmpty(component.nextactive())? component.periodslidernumberofintervals()+'&'+component.periodslidernextrangeactive(): component.nextactive(),
        "thisactive":_.isEmpty(component.currentactive())? component.periodsliderthisrangeactive() : component.currentactive(),
        "period":_.isEmpty(component.period()) ? component.periodsliderperiodrange() : component.period(),
        "weekstart":_.isEmpty(component.periodsliderweekstart()) ?'1' : component.periodsliderweekstart()
        };
        return defaultValues;
    };

    //default value setter
    var defaultValueSetter=function(component,defaultComponentValues){
      $("#"+component.componentId+"_fromdatepicker").val(defaultComponentValues.from);
      $("#"+component.componentId+"_todatepicker").val(defaultComponentValues.to);
      $("#"+component.componentId+"_afterdatepicker").datepicker({dateFormat: 'dd-mm-yy'});
      $("#"+component.componentId+"_beforedatepicker").datepicker({dateFormat: 'dd-mm-yy'});
      $("#"+component.componentId).find('div.ui-datepicker').css({ fontSize: '12px' });
      $("#"+component.componentId+"_afterdatepicker").val(defaultComponentValues.after);
      $("#"+component.componentId+"_beforedatepicker").val(defaultComponentValues.before);
      $("#"+component.componentId+"_last").find('input').val(defaultComponentValues.lastactive.split('&')[0]);
      $("#"+component.componentId+"_last").find('select').val(defaultComponentValues.lastactive.split('&')[1]);
      $("#"+component.componentId+"_next").find('input').val(defaultComponentValues.nextactive.split('&')[0]);
      $("#"+component.componentId+"_next").find('select').val(defaultComponentValues.nextactive.split('&')[1]);
      $("#"+component.componentId+"_this").find('select').val(defaultComponentValues.thisactive);
      $("#"+component.componentId+"_period").find('select').val(defaultComponentValues.period);
    }
    





    //INITIALIZE THE component WITH THE GIVEN DEFAULT SECTION
    var initComponent = function(value,component) {
        $("#"+component.componentId).find('.hiddensection').hide();
        $("#"+component.componentId+"_"+ value).show();
    };



    /**
     * SWAP FOOTER DISPLAY
     *
     * @method calculateDate
     * @param values {String}  result array values
     * @return void
     */
    var outputFormat=function(values,component){
      values[0]=values[0].format(component.periodsliderdefaultdateformat());
      $("#"+component.componentId+"_dv1").show().html(values[0]);
      if(values[1] !== undefined){
        values[1]=values[1].format(component.periodsliderdefaultdateformat());
        if(values[1].indexOf('Invalid') === -1){
          $("#"+component.componentId+"_dv2").show().html(values[1]);
          $("#"+component.componentId).find(".seperator").show();
        }
      }
    };

    /**
     * Return the date array based on the type user selected
     *
     * @method calculateDate
     * @param type {String}  operator type
     * @param value1 {String} no.of.days or this
     * @param value2 {String} range interval days,weeks,months
     * @return {Array}
     */
    var calculateDate=function(type,value1,value2){
        var resultArray=[];
        if(type === "last"){
          var intervalType=value2+'s';
          resultArray.push(moment().add(-value1, intervalType));
          resultArray.push(moment());
        }
        if(type === "next"){
            var intervalType=value2+'s';
            resultArray.push(moment());
            resultArray.push(moment().add(value1, intervalType));        
        }
        if(type === "this"){
            resultArray.push(moment().add(value1, value2));
            resultArray.push(moment());
        }
        if(type === "period"){
             switch(value1){
               case 'ytd':
               resultArray.push(moment().startOf('year'));//jshint ignore:line
               break;
               case 'mtd':
               resultArray.push(moment().startOf('month')); //jshint ignore:line
               break;
               case 'qtd':
               resultArray.push(moment().startOf('quarters')); //jshint ignore:line
               break;
               case 'lyytd':
               resultArray.push(moment().add(-1, 'years')); //jshint ignore:line
               break;
               case 'lymtd':
               resultArray.push(moment().startOf('month').add(-1, 'years')); //jshint ignore:line
               break;
               case 'lyqtd':
               resultArray.push(moment().startOf('quarters').add(-1, 'years')); //jshint ignore:line
               break;
             }
          resultArray.push(moment());
        }
        return resultArray;
    };

      

    var generateResult=function(component){
        var type = $("#"+component.componentId+"_operator").val();
        initComponent(type,component);
        $("#"+component.componentId+"_dv1").hide();
        $("#"+component.componentId+"_dv2").hide();
        $("#"+component.componentId).find(".seperator").hide();


        var componentResultConfig=componentGenerateResultConfig(component)[type];
        var resultsArray=[];

        
        _.each(componentResultConfig.fields,function(field){
          if(_.isArray(field.selector)){
              if(field.selector.length > 1){
                var count=field.selector[0].val();
                var interval=field.selector[1].val();
                resultsArray=calculateDate(type,count,interval);
                component[field.name](count+"&"+interval);
              }else{
                var fieldValue=field.selector[0].val();
                resultsArray=calculateDate("this",fieldValue);
                component[field.name](fieldValue);
              }
          }else{
            var fieldValue=field.selector.val();
            resultsArray.push(moment(fieldValue,'DD-MM-YYYY'));
            component[field.name](fieldValue);
          }          
        });
  
        outputFormat(resultsArray,component);
        component.resultoutputArray(resultsArray);
        component.periodslidercurrenttype(type);
        component.firePropertiesChanged(["periodslidercurrenttype","fromdate","todate","afterdate","beforedate","lastactive","nextactive","currentactive","period","resultoutputArray"]);

        


        // switch (type) {
        //   case "between":
        //     var from=$("#"+component.componentId+"_fromdatepicker").val();
        //     var to=$("#"+component.componentId+"_todatepicker").val();
        //     var resultArray=[moment(from,'DD-MM-YYYY'),moment(to,'DD-MM-YYYY')];
        //     component.fromdate(from);
        //     component.todate(to);
        //     outputFormat(resultArray,component);
        //     component.resultoutputArray(resultArray);
        //     break;
        //   case "after":
        //     var after=$("#"+component.componentId+"_afterdatepicker").val();
        //     var resultArray=[moment(after,'DD-MM-YYYY')];
        //     component.afterdate(after);
        //     outputFormat(resultArray,component);
        //     component.resultoutputArray(resultArray);
        //     break;
        //   case "before":
        //     var before=$("#"+component.componentId+"_beforedatepicker").val();
        //     var resultArray=[moment(before,'DD-MM-YYYY')];//jshint ignore:line
        //     component.beforedate(before);
        //     outputFormat(resultArray,component);
        //     component.resultoutputArray(resultArray);
        //     break;
        //  case  "last":
        //      var count=$("#"+component.componentId+"_last").find("input").val();
        //      var interval=$("#"+component.componentId+"_last").find("select").val();
        //      var resultArray=calculateDate("last",count,interval);//jshint ignore:line
        //      outputFormat(resultArray,component);
        //      component.lastactive(count+"&"+interval);
        //      component.resultoutputArray(resultArray);
        //     break;
        //  case  "next":
        //      var count=$("#"+component.componentId+"_next").find("input").val();
        //      var interval=$("#"+component.componentId+"_next").find("select").val();
        //      var resultArray=calculateDate("next",count,interval); //jshint ignore:line
        //      outputFormat(resultArray,component);
        //      component.nextactive(count+"&"+interval);
        //      component.resultoutputArray(resultArray);
        //     break;
        //  case  "this":
        //     var interval=$("#"+component.componentId+"_this").find("select").val();
        //     var resultArray=calculateDate("this",interval); //jshint ignore:line
        //     component.currentactive(interval);
        //     outputFormat(resultArray,component);
        //     component.resultoutputArray(resultArray);
        //     break;
        //  case  "period":
        //      var interval=$("#"+component.componentId+"_period").find("select").val();
        //      var resultArray=calculateDate("period",interval); //jshint ignore:line
        //      component.period(interval);
        //      outputFormat(resultArray,component);
        //      component.resultoutputArray(resultArray);
        //     break;
        // }
      };