/* global  sap */
/*global $:false */
/*jshint unused:false*/
function combinationSeries() {
  var that = this;
  /**
 * Map data from JSON Tuple to Highchart
 * @override
 * @param {object} component - Reference to component
 * @param {string} type - type of the chart
 * @param {object} defaultValue - HighCharts values
 * @return {Array} seriesNames
 */
  that.createSeriesData = function(component, type, defaultValue, cfStatus) {
    // new combination1 implementation from main SL
    var self = this;
    //	var seriesColor = component.dataseriescolor().split(",");
    component.categoriesIndex = [];
    /*	var columnCount=0;
    		//console.log("Series Data");
    		var DMchange = false;
    		var dimName = component.getDimensionAndMeasure();
    		if(component.oldDimname=== undefined || component.oldDimname == "")
    			component.oldDimname = dimName.toString();
    		if(component.oldDimname != dimName.toString())
    		{
    		DMchange = true;
    		if(sap.zen.designmode)
    			component.oldDimname = dimName.toString();
    		}*/
    //		 alert('overridden');
    var ruleInfo = '';
    if (cfStatus != 'ncf') {
      if (component.ruletable() !== undefined && component.ruletable() != '') {   //jshint ignore:line
        that.updateRuleInfo(component, 'bar');
        ruleInfo = JSON.parse(component.ruletable());
      }
    }

    var noOfColumns = 0;
    var noOfCellsInRow = 1;
    var noOfRows = 0;
    var seriesNamesinAdditionalProp = [];
    var measureColorPair;
    var measureTypePair;
    var seriesData = [];
    var markerarray = component.addmarkers().split(',');
    var displayunit = '';
    var seriesType = component.dataseriestype().split(',');
    defaultValue.xAxis.categories = [];
    var xAxisCategories = [];
    /*jshint ignore:start*/
    if (!(component.measurecolorpair() === undefined || component.measurecolorpair() == '')) {
      measureColorPair = JSON.parse(component.measurecolorpair());
    }
    if (!(component.measuretypepair() === undefined || component.measuretypepair() == '')) {
      measureTypePair = JSON.parse(component.measuretypepair());
    }

    var measureMarkerPair;
    if (!(component.measuremarkerpair() === undefined || component.measuremarkerpair() == '')) {
      measureMarkerPair = JSON.parse(component.measuremarkerpair());
    }

    if (component.hasOwnProperty('measuretypepair')) {
      var measureTypePair;
      if (!(component.measuretypepair() === undefined || component.measuretypepair() == '')) {
        measureTypePair = JSON.parse(component.measuretypepair());
      }
    }

    if (component.dataRes === undefined || component.dataRes == '') {
      return '';
    }

    for (var i = 0; i < component.dataRes.dimensions.length; i++) {
      if (component.dataRes.dimensions[i].axis == 'COLUMNS') {
        noOfColumns++;
      }
    }
    /*jshint ignore:end*/
    noOfRows = component.dataRes.dimensions.length - noOfColumns;
    var selectedDimensions = [];
    var selectedColumndim = [];
    var selectedRowdim = [];
    var selectedColumndimIndexes = [];
    var selectedRowdimIndexes = [];
    var measureDimIndex = component.getMeasureIndex();
    var measureInRow = component.dataRes.dimensions[measureDimIndex].axis == 'ROWS' ? true : false;
    if (measureInRow) {
      selectedRowdimIndexes.push(measureDimIndex);
    } else {
      selectedColumndimIndexes.push(measureDimIndex);
    }

    var bardatacustomizationJson = {
      'COLUMNS': [],
      'ROWS': []
    };
    if (component.bardatacustomization() !== '') {
      bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
    }

   if (component.datautility() == true && (bardatacustomizationJson['COLUMNS'].length == 0 && bardatacustomizationJson['ROWS'].length == 0)) {    /*jshint ignore:line*/
      this.createSmokeScreen(component.$(), 'Please select Dimension in Data Utility');
    } else {
      for (var i = 0; i < noOfColumns; i++) {
        if (i != measureDimIndex) {
          selectedColumndimIndexes.push(i);
        }
      }

      for (var i = noOfColumns; i < component.dataRes.dimensions.length; i++) {
        if (i != measureDimIndex) {
          selectedRowdimIndexes.push(i);
        }
      }
    }

    var cellCount = 0;
    var seriesNames = [];
    var categoryNames = [];
    var seriesTypeCount = 0;
    var ruleMeasure = false;
    var ruleDimension = false;
    for (var i = 0; i < selectedColumndimIndexes.length; i++) {
      if (component.dataRes.dimensions[selectedColumndimIndexes[i]].containsMeasures == true) {   /*jshint ignore:line*/
        ruleMeasure = true;
      } else {
        ruleDimension = true;
      }
      //finalCategoryNames//selectedColumndimIndexes
      component.selectedColumndimIndexes = selectedColumndimIndexes;
      component.selectedRowdimIndexes = selectedRowdimIndexes;
      var defaultColor = [
        '#B586DA',
        '#FF6657',
        '#F3A730',
        '#946B66',
        '#B0AD53',
        '#7AC1DE',
        '#F1C337',
        '#566C6C',
        '#A1CC54',
        '#543F1E'
      ];
      var seriesColor = [];
      if (component.dataseriescolor() == '' || component.dataseriescolor() === undefined) {   /*jshint ignore:line*/
        seriesColor = [];
      } else {
        seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
      }

      var tuplesInARow = component.dataRes.tuples.slice(0, component.dataRes.columnCount);
      // Getting tuples for all Columns in first row of crosstab.
      var colRowIndexJson = {};
      var colNamesJson = {};
      var seriesData = [];
      var scalingValues = [];
      component.measureInOriginalSeries = {};
      component.categoryInOriginalSeries = {};
      component.columnInOriginalSeries = {};
	  var hasResultIntupleCol = {};
	  var showtotaldatabase = component.showtotaldatabase();
	  var datautility = component.datautility();
      for (var i = 0; i < component.dataRes.dimensions[measureDimIndex].members.length; i++) {
        if (typeof component.dataRes.dimensions[measureDimIndex].members[i].scalingFactor == 'undefined') {
          scalingValues.push('');
        } else {
          scalingValues.push(component.scalingfactorenable() === true ? component.dataRes.dimensions[measureDimIndex].members[i].scalingFactor : '');
        }
      }

      for (var i = 0; i < tuplesInARow.length; i++) {
        var tempTuple = tuplesInARow[i].slice(0, noOfColumns);
        if (self.vbiCharts.eliminateResult(component.dataRes, tempTuple,undefined,component.showtotaldatabase()) == true) { /*jshint ignore:line*/
          var colKey = [];
          var colName = [];
          var ColumnKey = [];
          for (var j = 0; j < selectedColumndimIndexes.length; j++) {
            var tempCol = selectedColumndimIndexes[j];
            colName.push(component.dataRes.dimensions[tempCol].members[tempTuple[tempCol]].text);
            ColumnKey.push(component.dataRes.dimensions[tempCol].members[tempTuple[tempCol]].key);
            colKey.push(tempCol + ':' + tempTuple[tempCol]);
          }

          var newKey = colKey.join('-');
          colName = _.filter(colName, function(x) {              
            return (x != '' && x!= null && x!=" ");
          });
          var seriesName = colName.join('-');
          if (!measureInRow) {
            seriesName = that.formatSeriesName(component, seriesName, measureDimIndex + ':' + tempTuple[measureDimIndex], {});
          }

          /*if (colName.join('-').indexOf('(* ') == -1) {
            var seriesName = colName.join('-') + (typeof tempTuple[measureDimIndex] == 'undefined' || scalingValues[tempTuple[measureDimIndex]] == '' ? '' : ' (* ' + Math.pow(10, scalingValues[tempTuple[measureDimIndex]]) + ' )');
          } else {
            var seriesName = colName.join('-');
          }*/

          if (typeof colRowIndexJson[newKey] == 'undefined') {
            colRowIndexJson[newKey] = [];
            var colorvalue = self.getSeriesColors(component, seriesColor, seriesData.length, defaultColor);

            var markerarray = {
              enabled: true,
              fillColor: self.getSeriesColors(component, seriesColor, seriesData.length, defaultColor)
            };
            if (measureColorPair && measureColorPair[ColumnKey.join('-')] !== undefined) {   /*jshint ignore:line*/
              colorvalue = measureColorPair[ColumnKey.join('-')].color;
            }

            if (component.hasOwnProperty('measuremarkerpair')) {
              if (measureMarkerPair && measureMarkerPair[ColumnKey.join('-')] !== undefined) {  // jshint ignore:line
                markerarray = {
                  enabled: measureMarkerPair[ColumnKey.join('-')].enabled,// jshint ignore:line
                  radius: parseFloat(measureMarkerPair[ColumnKey.join('-')].size),// jshint ignore:line
                  symbol: measureMarkerPair[ColumnKey.join('-')].symbol,// jshint ignore:line
                  fillColor: component.defaultmarkercolor() == false ? measureMarkerPair[ColumnKey.join('-')].color : colorvalue,   /*jshint ignore:line*/
                  states: {
                    hover: {
                      enabled: measureMarkerPair[ColumnKey.join('-')].hoverenable,// jshint ignore:line
                      radius: parseFloat(measureMarkerPair[ColumnKey.join('-')].size)// jshint ignore:line
                    }
                  }
                };
              }
            }

            if (component.hasOwnProperty('enablemarker') && !component.enablemarker()){
              	markerarray = {};
              }
            // used for storing all the position of particular measure  in the series.
            if (!measureInRow) {
              if (component.measureInOriginalSeries[ColumnKey[0]] === undefined) {
                component.measureInOriginalSeries[ColumnKey[0]] = selectedColumndimIndexes.length > 1 ? {} : seriesData.length;
              }

              if (typeof component.measureInOriginalSeries[ColumnKey[0]] == 'object') {
                component.measureInOriginalSeries[ColumnKey[0]][ColumnKey.slice(1).join('-')] = seriesData.length;
              }
            } else {
              component.columnInOriginalSeries[ColumnKey.join('-')] = seriesData.length;
            }
          var typeValue = "column";
          if (measureTypePair && measureTypePair[ColumnKey.join('-')] !== undefined) {
              typeValue = measureTypePair[ColumnKey.join('-')].type;
            }
            seriesData.push({
              name: seriesName,
              key: newKey,
              type:typeValue,
              uniquekey: ColumnKey[0],
              color: colorvalue,
              marker: markerarray,
              data: [],
              regression: component.trendlineenable !== undefined ? component.trendlineenable() : false,
              regressionSettings: {}
            });
          }

          colRowIndexJson[newKey].push(i);
		  /*#VBX141-4729*/
		 if(datautility && showtotaldatabase){
		  	  hasResultIntupleCol[i] = [];
			  for(var j=0, jLen = tempTuple.length; j<jLen; j++){
				  if(component.dataRes.dimensions[j].members[tempTuple[j]].type == "RESULT"){					  
					  hasResultIntupleCol[i].push(j);
				  }
			  }
		  }
          colNamesJson[newKey] = seriesName;
        }
      }
      // console.log("seriesData="+JSON.stringify(seriesData));
      //console.log("colNamesJson="+JSON.stringify(colNamesJson));
      seriesColor.splice(seriesData.length, seriesColor.length);
      component.dataseriescolor(seriesColor.join());
      var tupleToSkip = 0;
      var tuplesInColumn = [];
      var rowNames = {};
      var rowDataJson = {};
	  var rowDataJsonWithInfo = {};
      var measureKeyforScaling = [];
      for (var i = 0; i < component.dataRes.dimensions.length; i++) {
        if (component.dataRes.dimensions[i].containsMeasures === true) {
          for (var j = 0; j < component.dataRes.dimensions[i].members.length; j++) {
            measureKeyforScaling.push(component.dataRes.dimensions[i].members[j].key);
          }
        }
      }
      //alert("that.dataRes.rowCount="+that.dataRes.rowCount);
      for (var i = 0; i < component.dataRes.rowCount; i++) {
        //rowDataArr.push([]);
        tupleToSkip = component.dataRes.columnCount * i;
        tuplesInColumn.push(component.dataRes.tuples[tupleToSkip]);
        var tempTuple = tuplesInColumn[i];
		/*#VBX141-4729*/
		var hasResultIntuple = [];
		if(datautility && showtotaldatabase){
			for(var j=noOfColumns, tLen = tempTuple.length; j< tLen; j++){
				if(component.dataRes.dimensions[j].members[tempTuple[j]].type == "RESULT"){
					hasResultIntuple.push(tempTuple[j]);
				}
			}
		}
        if (self.vbiCharts.eliminateResult(component.dataRes, tempTuple, 'ROWS',component.showtotaldatabase()) == true) {   //jshint ignore:line
          var rowKey = 0;
          var rowHeader = 'Dimensions';
          var rowHeaderKey = 'Dimensions';
          if (selectedRowdimIndexes.length >= 1) {
            rowKey = selectedRowdimIndexes[0] + ':' + tempTuple[selectedRowdimIndexes[0]];
            rowHeaderKey = component.dataRes.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].key;
            rowHeader = component.dataRes.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].text;

            for (var j = 1; j < selectedRowdimIndexes.length; j++) {
              //rowKey+=":"+temp_tuple[component.selectedRowIndex[j]];
              rowKey += '-' + selectedRowdimIndexes[j] + ':' + tempTuple[selectedRowdimIndexes[j]];
              // jscs:disable
              // Code here will be ignored by JSCS.
              if(component.dataRes.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].text !== ''){
                rowHeader += (rowHeader !=="" ? '\\' : '') + component.dataRes.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].text;
              }
              rowHeaderKey += '\\' + component.dataRes.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].key;  // jscs:enable
            }

            if (measureInRow) {
              rowHeader = self.formatSeriesName(component, rowHeader, selectedRowdimIndexes[0] + ':' + tempTuple[selectedRowdimIndexes[0]], {});
            }
          }

          if (typeof rowNames[rowKey] == 'undefined') {
            //rowDataJson[rowKey]=[];
            rowNames[rowKey] = {
              key: rowHeaderKey,
              text: rowHeader
            };
            //defaultValuexAxiscategories.push(rowHeader);
            component.categoriesIndex.push(rowKey);
          }

          $.each(colRowIndexJson, function(key, value) {
            $.each(value, function(index, newval) {
              var curIndex = newval + tupleToSkip;
              var keygen = key + '_' + rowKey;
              if (rowDataJson[keygen] === undefined) {
                rowDataJson[keygen] = [];
				rowDataJsonWithInfo[keygen] = [];
              }

              if (component.connectnulls()) {
            	  rowDataJson[keygen].push(component.dataRes.data[curIndex] || 0);
              }else{
            	  rowDataJson[keygen].push(component.dataRes.data[curIndex]);
              }
			  
			  /*#VBX141-4729*/
				if(datautility && showtotaldatabase && (hasResultIntuple.length || hasResultIntupleCol[newval].length)){	
					var lastTempStore, lastTempstoreLen = 0;
					var totalLen = hasResultIntupleCol[newval].length + hasResultIntuple.length;
					if(rowDataJsonWithInfo[keygen].length){
						lastTempStore = rowDataJsonWithInfo[keygen][rowDataJsonWithInfo[keygen].length - 1];
						lastTempstoreLen = lastTempStore[0];
					}
					if(lastTempstoreLen < totalLen){
						rowDataJsonWithInfo[keygen].length = 0;						
					}					
					rowDataJsonWithInfo[keygen].push([totalLen , (component.dataRes.data[curIndex] === null ? 0 : component.dataRes.data[curIndex])]);
				}	
            });
          });
        }
      }
	  
	  /*#VBX141-4729*/
	if(datautility && showtotaldatabase){
		  $.each(rowDataJsonWithInfo, function(k, v){
			  if(v.length){
				  rowDataJson[k].length = 0;
					for(var i=0, len=v.length; i<len; i++){
						rowDataJson[k].push(Number(v[i][1]));
					}
			  }
		  });
	  }
      //			alert(JSON.stringify(rowNames))
      var categoryDataRowAggr = [];
      var finalCategoryNames = [];
      var finalCategorykeys = [];
      $.each(rowNames, function(key, names) {
        if (measureInRow) {
          // jscs:disable
          // Code here will be ignored by JSCS.
          var rowKeyArr = names.key.split('\\');
          // jscs:enable
          for (var i = 0; i < rowKeyArr.length; i++) {
            if (component.measureInOriginalSeries[rowKeyArr[0]] === undefined) {
              component.measureInOriginalSeries[rowKeyArr[0]] = rowKeyArr.length > 1 ? {} : finalCategoryNames.length;
            }

            if (typeof component.measureInOriginalSeries[rowKeyArr[0]] == 'object') {
              // jscs:disable
              // Code here will be ignored by JSCS.
              component.measureInOriginalSeries[rowKeyArr[0]][rowKeyArr.slice(1).join('\\')] = finalCategoryNames.length;  // jscs:enable
            }
          }
        }

        component.categoryInOriginalSeries[names.key] = finalCategoryNames.length;
        for (var i = 0; i < seriesData.length; i++) {
          var genKey = seriesData[i].key + '_' + key;
          var yVal = that.barValueAggregation(component, rowDataJson[genKey]);
          if (component.hasOwnProperty('measuremarkerpair') && component.enablemarker()) {
          if(component.ruletable() === "" || component.ruletable() === "{}"){ //VBX141-4372
              seriesData[i].data.push({
                y: yVal
              });
            }else{
              seriesData[i].data.push({
                y: yVal,
                color: seriesData[i].marker.fillColor
              });
            }
          } else {
            seriesData[i].data.push({y: yVal});
          }
        }

        finalCategoryNames.push(names.text);
        finalCategorykeys.push(names.key);
      });

      categoryDataRowAggr = seriesData;
      that.defaultvalueseriesdata = seriesData;
      component.categoryNames = finalCategoryNames;
      var cfdataCalled = !1;
      //errorbar enable need the complete cfdata
      if (component.hasOwnProperty('errorbarenable')) {
        if (component.errorbarenable() === true) {
          if (component.erroramount() === 'Custom') {
            that.createCFData(component, 'bar', component.fulljson());
          }
        }
      }
      //************************ new code ends ****************/

      var totalData = [];
      var entireData = [];
      var categoryDataRowAggrNew = [];
      if (component.showtotal() === true) {
        for (var i in categoryDataRowAggr) {
          if (categoryDataRowAggrNew[i] === undefined) {
            categoryDataRowAggrNew[i] = [];
          }

          for (var j = 0; j < categoryDataRowAggr[i].data.length; j++) {
            categoryDataRowAggrNew[i].push(categoryDataRowAggr[i].data[j].y);
          }
        }
        /*
        			* Creating New Array to check for data.y value.
        			* need to change it but now Creating newArray().
        			*/
        for (var i in categoryDataRowAggr) {
          var total = categoryDataRowAggrNew[i].reduce(function(a, b) {
            return a + b;
          });

          categoryDataRowAggr[i].data.push({y: total});
        }

        finalCategoryNames.push('Total Result');
      }
      /*
      		 * Total logic is true
      		 * Getting the values and addding those values in that same array
      		 * Adding Total-Result in xaxis catagory
      		 */

      /*
      		 * sub Total Logic is true
      		 * getting the value and putting in the seperate array
      		 * adding those value in into the series tab.
      		 */
      if (component.trendlineenable !== undefined) {
        if (component.trendlineenable()) {
          var glovalLength;
          var GlobalValCheck = [];
          for (var i = 0; i < categoryDataRowAggr.length; i++) {
            for (var j = 0; j < categoryDataRowAggr[i].data.length; j++) {
              if (GlobalValCheck[i] === undefined) {
                GlobalValCheck[i] = [];
              }

              GlobalValCheck[i].push(categoryDataRowAggr[i].data[j].y);
              categoryDataRowAggr[i].data[j].x = j;
            }

            categoryDataRowAggr[i].regressionSettings = {
              type: '',
              color: categoryDataRowAggr[i].color
            };
            glovalLength = i;
          }
          /**
  				*Adding Trendline to the charts
  				* implementation for adding regressionSettings ends here
  				**/
          function isMax(value) {//jshint ignore:line
            return function(element, index, array) {    /*jshint ignore:line*/
              return element > value;
            };
          }
          /**
  				*creating this function to check weather the array has more than 0 in it.
  				* Trendline won't work if more than tow 0 in a array.
  				**/
          for (var i = 0; i < GlobalValCheck.length; i++) {
            var finalValue = GlobalValCheck[i].filter(isMax(1));
            if (finalValue.length < 2) {
              categoryDataRowAggr[i].regression = false;
            }
          }

          component.trendlinelength(glovalLength);
        }
      }

      defaultValue.xAxis.categories = [];
      defaultValue.xAxis.key = [];
      defaultValue.xAxis.categorieskey = [];
      defaultValue.xAxis.categories = defaultValue.xAxis.categories.concat(finalCategoryNames);
      defaultValue.xAxis.categorieskey = defaultValue.xAxis.categorieskey.concat(finalCategorykeys);
      try {
        if (component.enablehierarchylabels() === true) {
          defaultValue.xAxis.categories = this.createHierarchyLabels(component.dataRes, selectedRowdimIndexes, component);
         // console.log(JSON.stringify(component.dataRes));
          //defaultValue.xAxis.categories = this.createHierarchyLabels(component.dataRes);
          /* Following code is required to manipulate the series according to the order of xAxis categories.
          			   This case will occur when the row Dimension selected in Data Utility is not in the same order as in Initial View.
          			*/
          var selRowInd = [];
          selRowInd = selRowInd.concat(selectedRowdimIndexes);
          selRowInd.sort(function(a, b) {
            return a - b;
          });

          if (selRowInd.join(',') != selectedRowdimIndexes.join(',')) {
            var newCategoriesOrder = [];
            $.each(defaultValue.xAxis.categories, function(i, v) {
              that.createFlatCategory(v, newCategoriesOrder, [v.name]);
            });

            var newcategoryDataRowAggr = [];
            $.extend(true, newcategoryDataRowAggr, categoryDataRowAggr);
            $.each(newCategoriesOrder, function(i, v) {
              var k = finalCategoryNames.indexOf(v);
              $.each(newcategoryDataRowAggr, function(ind, ele) {
                var val = ele.data[k];
                categoryDataRowAggr[ind].data[i] = val;
              });
            });
          }
        }
      } catch (e) {
      }
      //	defaultValue.xAxis.key=[];
      //defaultValue.xAxis.key=defaultValue.xAxis.key.concat(finalCategoryNamesKey);
      defaultValue.series = categoryDataRowAggr;
      //alert(JSON.stringify(categoryDataRowAggr));
      /*
      		 * Following code included for adding stacking feature. Loop thru the
      		 * series and identify the chart type & stacking from getter. If getter
      		 * return undefined, assign default chart type and stack index as
      		 * 'column' and current series index respectively, else cache the return
      		 * value. Extract the chart type information and assign it to current
      		 * series. Check if the cahce value has any information for stacking. If
      		 * yes, check if that particular stacking already exists in variable
      		 * 'stacking'. If so, assign the same to stack index else set the
      		 * stacking index for the current type to current series index and
      		 * assign same to series stacking index. If the cache value do not
      		 * contain any stacking information set the stack index for series to
      		 * series index
      		 */
      var stacking = {
        column: undefined,
        area: undefined,
        areaspline: undefined
      };
      var trendlinelength;
      if (component.trendlineenable()) {
        trendlinelength = defaultValue.series.length / 2;
      } else {
        trendlinelength = defaultValue.series.length;
      }
      // console.log('seriesType:'+seriesType);
      for (var i = 0, iLimit = trendlinelength; i < iLimit; ++i) {
        var tempType = defaultValue.series[i].type;
        if (tempType === undefined || tempType === '') {
          defaultValue.series[i].stack = i;
          defaultValue.series[i].type = 'column';
          defaultValue.series[i].stacking = '';

        } else {
          var splitTempType = tempType.split('-');
          defaultValue.series[i].type = splitTempType[0];
          if (splitTempType.length > 1) {
            if (stacking[splitTempType[0]] === undefined) {
              stacking[splitTempType[0]] = i;
            }

            defaultValue.series[i].stacking = 'normal';
            defaultValue.series[i].stack = stacking[splitTempType[0]];
          } else {
            defaultValue.series[i].stacking = '';
            defaultValue.series[i].stack = i;
          }
        }

        if(component.ruletable()!=="" && component.ruletable() !== "{}"){
            if (defaultValue.series[i].type.indexOf('line') !== -1 && defaultValue.series[i].type.indexOf('area') !== -1) {
              for (var j = 0; j < defaultValue.series[i].data.length; j++) {
                defaultValue.series[i].data[j].color = seriesData[i].marker.fillColor;
              }
            } else {
              for (var j = 0; j < defaultValue.series[i].data.length; j++) {
                defaultValue.series[i].data[j].color = seriesData[i].color;
              }
            }
        }

    }

      if (ruleInfo != '' && cfStatus != 'ncf'  /* && DMchange == false*/) {   /*jshint ignore:line*/
        if (!cfdataCalled) {
          that.createCFData(component, 'bar', component.fulljson());
        }

        that.processConditionalFormatting(component, categoryDataRowAggr, ruleInfo, 'bar');
      }
      /*
      		 * Set the stacking type in the plotOptions to make stacking work
      		 */
      for (var i in stacking) {
        if (stacking[i] !== undefined) {
          defaultValue.plotOptions.series.stacking = 'normal';
          break;
        }
      }
      //		console.log('JSON:'+JSON.stringify(defaultValue.series));
      return seriesNamesinAdditionalProp;
    }
  };

  that.createCFData = function(component, type) {
    var self = this;
    var completeJSONCF=component.dataRes;
    //console.log("in cfdata");
    var seriesColor = component.dataseriescolor().split(',');
    component.categoriesIndex = [];
    var noOfColumns = 0;
    // if(!(component.measurecolorpair()=== undefined || component.measurecolorpair() == '')){
    //  measureColorPair = JSON.parse(component.measurecolorpair());
    // }
    //alert("Component.dataRes==="+ JSON.stringify(component.dataRes));
    if (completeJSONCF === undefined || completeJSONCF === '') {
      return '';
    }

    for (var i = 0; i < completeJSONCF.dimensions.length; i++) {
      if (completeJSONCF.dimensions[i].axis == 'COLUMNS') {
        noOfColumns++;
      }
    }

    var selectedColumndimIndexes = [];
    var selectedRowdimIndexes = [];
    var measureDimensionIndex = component.getMeasureIndex();
    var measureInRow = component.dataRes.dimensions[measureDimensionIndex].axis == 'ROWS' ? true : false;
    if (measureInRow) {
      selectedRowdimIndexes.push(measureDimensionIndex);
    } else {
      selectedColumndimIndexes.push(measureDimensionIndex);
    }

    var bardatacustomizationJson = {
      'COLUMNS': [],
      'ROWS': []
    };
    if (component.bardatacustomization() !== '') {
      bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
    }

    // if (component.datautility() === true && (bardatacustomizationJson['COLUMNS'].length !== 0 || bardatacustomizationJson['ROWS'].length !== 0)) {
    //   if (bardatacustomizationJson['COLUMNS'].length !== 0) {
    //     //selectedColumndim=bardatacustomizationJson['COLUMNS'][0].text;
    //     //selectedColumndimIndexes=selectedColumndimIndexes.concat(bardatacustomizationJson['COLUMNS'][0].index.split("-"));
    //     $.each(bardatacustomizationJson['COLUMNS'], function(index, value) {
    //       selectedColumndimIndexes.push(_.parseInt(value.index));
    //     });
    //   }

    //   if (bardatacustomizationJson['ROWS'].length !== 0) {
    //     $.each(bardatacustomizationJson['ROWS'], function(index, value) {
    //       selectedRowdimIndexes.push(_.parseInt(value.index));
    //     });
    //   } else {
    //     this.createSmokeScreen(component.$(), 'Please select Dimension in Data Utility');
    //   }
    // } else 
    if (component.datautility() === true && (bardatacustomizationJson['COLUMNS'].length === 0 && bardatacustomizationJson['ROWS'].length === 0)) {
      this.createSmokeScreen(component.$(), 'Please select Dimension in Data Utility');
    } else {
      for (var i = 0; i < noOfColumns; i++) {
        if (i != measureDimensionIndex) {
          selectedColumndimIndexes.push(i);
        }
      }

      for (var i = noOfColumns; i < component.dataRes.dimensions.length; i++) {
        if (i != measureDimensionIndex) {
          selectedRowdimIndexes.push(i);
        }
      }
    }

    var scalingValues = [];
    for (var i = 0; i < completeJSONCF.dimensions[measureDimensionIndex].members.length; i++) {
      scalingValues.push(Math.pow(10, completeJSONCF.dimensions[measureDimensionIndex].members[i].scalingFactor || 0));
    }
    // **************** Please don't delete the code below. new code begins : Amit *********************/
    var defaultColor = [
      '#B586DA',
      '#FF6657',
      '#F3A730',
      '#946B66',
      '#B0AD53',
      '#7AC1DE',
      '#F1C337',
      '#566C6C',
      '#A1CC54',
      '#543F1E'
    ];
    var seriesColor = [];
    if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
      seriesColor = [];
    } else {
      seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
    }

    var tuplesInARow = completeJSONCF.tuples.slice(0, completeJSONCF.columnCount);
    // Getting tuples for all Columns in first row of crosstab.
    var colRowIndexJson = {};
    var colNamesJson = {};
    var seriesData = [];
    component.measureInCFSeries = {};
    component.columnInCFSeries = {};
	var hasResultIntupleCol = {};
	var showtotaldatabase = component.showtotaldatabase();
	var datautility = component.datautility();
    for (var i = 0; i < tuplesInARow.length; i++) {
      var tempTuple = tuplesInARow[i].slice(0, noOfColumns);
      if (self.vbiCharts.eliminateResult(completeJSONCF, tempTuple,undefined,component.showtotaldatabase()) === true) {
        var colKey = [];
        var colName = [];
        var ColumnKey = [];
        for (var j = 0; j < selectedColumndimIndexes.length; j++) {
          var tempCol = selectedColumndimIndexes[j];
          colName.push(completeJSONCF.dimensions[tempCol].members[tempTuple[tempCol]].text);
          ColumnKey.push(completeJSONCF.dimensions[tempCol].members[tempTuple[tempCol]].key);
          colKey.push(tempCol + ':' + tempTuple[tempCol]);
        }

        var newKey = colKey.join('-');
        if (typeof colRowIndexJson[newKey] == 'undefined') {
          colRowIndexJson[newKey] = [];
          if (!measureInRow) {
            if (component.measureInCFSeries[ColumnKey[0]] === undefined) {
              component.measureInCFSeries[ColumnKey[0]] = selectedColumndimIndexes.length > 1 ? {} : seriesData.length;
            }

            if (typeof component.measureInCFSeries[ColumnKey[0]] == 'object') {
              component.measureInCFSeries[ColumnKey[0]][ColumnKey.slice(1).join('-')] = seriesData.length;
            }
          } else {
            component.columnInCFSeries[ColumnKey.join('-')] = seriesData.length;
          }

          seriesData.push({
            name: colName.join('-'),
            uniquekey: ColumnKey[0],
            key: newKey,
            color: self.getSeriesColors(component, seriesColor, seriesData.length, defaultColor),
            data: [],
            regression: component.trendlineenable !== undefined ? component.trendlineenable() : false,
            regressionSettings: {}
          });
        }

        colRowIndexJson[newKey].push(i);
		/*#VBX141-4729*/
		if(datautility && showtotaldatabase){
		  	  hasResultIntupleCol[i] = [];
			  for(var j=0, jLen = tempTuple.length; j<jLen; j++){
				  if(completeJSONCF.dimensions[j].members[tempTuple[j]].type == "RESULT"){					  
					  hasResultIntupleCol[i].push(j);
				  }
			  }
		  }
        colNamesJson[newKey] = colName.join('-');
      }
    }
    //console.log("seriesData="+JSON.stringify(seriesData));
    //console.log("colNamesJson="+JSON.stringify(colNamesJson));
    seriesColor.splice(seriesData.length, seriesColor.length);
    component.dataseriescolor(seriesColor.join());
    var tupleToSkip = 0;
    var tuplesInColumn = [];
    var rowNames = {};
    var rowDataJson = {};
	var rowDataJsonWithInfo = {};
    //alert("that.dataRes.rowCount="+that.dataRes.rowCount);
    for (var i = 0; i < completeJSONCF.rowCount; i++) {
      //rowDataArr.push([]);
      tupleToSkip = completeJSONCF.columnCount * i;
      tuplesInColumn.push(completeJSONCF.tuples[tupleToSkip]);
      var tempTuple = tuplesInColumn[i];
	  /*#VBX141-4729*/
		var hasResultIntuple = [];
		if(datautility && showtotaldatabase){
			for(var j=noOfColumns, tLen = tempTuple.length; j< tLen; j++){
				if(completeJSONCF.dimensions[j].members[tempTuple[j]].type == "RESULT"){
					hasResultIntuple.push(tempTuple[j]);
				}
			}
		}
      if (self.vbiCharts.eliminateResult(completeJSONCF, tempTuple, 'ROWS',component.showtotaldatabase()) === true) {
        var rowKey = 0;
        var rowHeader = 'Dimensions';
        var rowHeaderKey = 'Dimensions';
        if (selectedRowdimIndexes.length >= 1) {
          rowKey = selectedRowdimIndexes[0] + ':' + tempTuple[selectedRowdimIndexes[0]];
          rowHeader = completeJSONCF.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].text;
          rowHeaderKey = completeJSONCF.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].key;
          for (var j = 1; j < selectedRowdimIndexes.length; j++) {
            rowKey += '-' + selectedRowdimIndexes[j] + ':' + tempTuple[selectedRowdimIndexes[j]];
            // jscs:disable
            // Code here will be ignored by JSCS.
            rowHeader += '\\' + completeJSONCF.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].text;
            rowHeaderKey += '\\' + completeJSONCF.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].key;  // jscs:enable
          }
        }

        if (typeof rowNames[rowKey] == 'undefined') {
          //rowDataJson[rowKey]=[];
          rowNames[rowKey] = {
            key: rowHeaderKey,
            text: rowHeader
          };
          //defaultValuexAxiscategories.push(rowHeader);
          component.categoriesIndex.push(rowKey);
        }

        var curScalingValue = 1;
        $.each(colRowIndexJson, function(key, value) {
          $.each(value, function(index, newval) {
            var curIndex = newval + tupleToSkip;
            var keygen = key + '_' + rowKey;
            if (measureDimensionIndex != -1) {
              curScalingValue = scalingValues[completeJSONCF.tuples[curIndex][measureDimensionIndex]] || 1;
            }

            if (rowDataJson[keygen] === undefined) {
              rowDataJson[keygen] = [];
			  rowDataJsonWithInfo[keygen] = [];
            }

            rowDataJson[keygen].push(completeJSONCF.data[curIndex] * curScalingValue);
			/*#VBX141-4729*/
				if(datautility && showtotaldatabase && (hasResultIntuple.length || hasResultIntupleCol[newval].length)){	
					var lastTempStore, lastTempstoreLen = 0;
					var totalLen = hasResultIntupleCol[newval].length + hasResultIntuple.length;
					if(rowDataJsonWithInfo[keygen].length){
						lastTempStore = rowDataJsonWithInfo[keygen][rowDataJsonWithInfo[keygen].length - 1];
						lastTempstoreLen = lastTempStore[0];
					}
					if(lastTempstoreLen < totalLen){
						rowDataJsonWithInfo[keygen].length = 0;						
					}					
					rowDataJsonWithInfo[keygen].push([totalLen , (completeJSONCF.data[curIndex] === null ? 0 : completeJSONCF.data[curIndex] * curScalingValue)]);
				}
          });
        });
      }
    }
	
	/*#VBX141-4729*/
	if(datautility && showtotaldatabase){
		  $.each(rowDataJsonWithInfo, function(k, v){
			  if(v.length){
				  rowDataJson[k].length = 0;
					for(var i=0, len=v.length; i<len; i++){
						rowDataJson[k].push(Number(v[i][1]));
					}
			  }
		  });
	  }

    var categoryDataRowAggr = [];
    var finalCategoryNames = [];
    component.categoryInCFSeries = {};
    $.each(rowNames, function(key, names) {
      if (measureInRow) {
        // jscs:disable
        // Code here will be ignored by JSCS.
        var rowKeyArr = names.key.split('\\');
        // jscs:enable
        for (var i = 0; i < rowKeyArr.length; i++) {
          if (component.measureInCFSeries[rowKeyArr[0]] === undefined) {
            component.measureInCFSeries[rowKeyArr[0]] = rowKeyArr.length > 1 ? {} : finalCategoryNames.length;
          }

          if (typeof component.measureInCFSeries[rowKeyArr[0]] == 'object') {
            // jscs:disable
            // Code here will be ignored by JSCS.
            component.measureInCFSeries[rowKeyArr[0]][rowKeyArr.slice(1).join('\\')] = finalCategoryNames.length;  // jscs:enable
          }
        }
      }

      component.categoryInCFSeries[names.key] = finalCategoryNames.length;
      finalCategoryNames.push(names.text);
      for (var i = 0; i < seriesData.length; i++) {
        var genKey = seriesData[i].key + '_' + key;
        var yVal = that.barValueAggregation(component, rowDataJson[genKey]);
        seriesData[i].data.push(yVal);
      }
    });

    categoryDataRowAggr = seriesData;
    component.conditionalFormattingData = categoryDataRowAggr;
    // code for changing the measure name when measure name is changed by the user
    if (component.chartmeasurechange() !== undefined && component.chartmeasurechange() !== '' && component.chartmeasurechange() !== null) {
      var xaxisname = JSON.parse(component.chartmeasurechange());
      for (var i = 0; i < component.conditionalFormattingData.length; i++) {
        if (xaxisname[component.conditionalFormattingData[i].uniquekey] !== '') {
          component.conditionalFormattingData[i].name = xaxisname[component.conditionalFormattingData[i].uniquekey];
        }
      }
    }

    that.fullseriesData = component.conditionalFormattingData;  //  console.log(that.fullseriesData);
    //console.log("component.measureInCFSeries="+JSON.stringify(component.measureInCFSeries));
    //Adding error bar functionality for measure here
    //      alert(JSON.stringify(xAxisCategories));
    //      alert(JSON.stringify(categoryDataRowAggr));
  };

  this.createErrorbar = function() {
    return that.fullseriesData;
  };

  this.defaultvalueseries = function() {
    return that.defaultvalueseriesdata;
  };

  that.createMeasuresData = function(component, type, defaultValue) {
    var self = this;
    var seriesType = component.dataseriestype().split(',');
    var defaultColor = [
      '#B586DA',
      '#FF6657',
      '#F3A730',
      '#946B66',
      '#B0AD53',
      '#7AC1DE',
      '#F1C337',
      '#566C6C',
      '#A1CC54',
      '#543F1E'
    ];
    var seriesColor = [];
    if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
      seriesColor = [];
    } else {
      seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
    }

    var categoryDataRowAggr = [];
    component.categoriesIndex = [];
    if (component.hasOwnProperty('measuretypepair')) {
      var measureTypePair;
      if (!(component.measuretypepair() === undefined || component.measuretypepair() === '')) {
        measureTypePair = JSON.parse(component.measuretypepair());
      }
    }

    var measureColorPair;
    if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
      measureColorPair = JSON.parse(component.measurecolorpair());
    }

    var measureMarkerPair;
    if (!(component.measuremarkerpair() === undefined || component.measuremarkerpair() === '')) {
      measureMarkerPair = JSON.parse(component.measuremarkerpair());
    }

    for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {
      var markerarray = {fillColor: seriesColor[i]};
      if (measureColorPair && measureColorPair[component.dataRes.dimensions[0].members[i].text] !== undefined) {
        seriesColor[i] = measureColorPair[component.dataRes.dimensions[0].members[i].text].color;
      }

      if (component.hasOwnProperty('measuremarkerpair')) {
        if (measureMarkerPair && measureMarkerPair[component.dataRes.dimensions[0].members[i].key] !== undefined) {
          markerarray = {
            enabled: measureMarkerPair[component.dataRes.dimensions[0].members[i].key].enabled,
            radius: parseFloat(measureMarkerPair[component.dataRes.dimensions[0].members[i].key].size),
            symbol: measureMarkerPair[component.dataRes.dimensions[0].members[i].key].symbol,
            fillColor: component.defaultmarkercolor() === false ? measureMarkerPair[component.dataRes.dimensions[0].members[i].key].color : measureColorPair[component.dataRes.dimensions[0].members[i].key].color,
            states: {
              hover: {
                enabled: measureMarkerPair[component.dataRes.dimensions[0].members[i].key].hoverenable,
                radius: parseFloat(measureMarkerPair[component.dataRes.dimensions[0].members[i].key].size)
              }
            }
          };
        }
      }

      if (component.hasOwnProperty('enablemarker') && !component.enablemarker()){
          markerarray = {};        
      }
      if (component.hasOwnProperty('measuretypepair')) {
        if (measureTypePair && measureTypePair[component.dataRes.dimensions[0].members[i].key] !== undefined) {// jshint ignore:line
          seriesType[i] = measureTypePair[component.dataRes.dimensions[0].members[i].key].type;// jshint ignore:line
        }
      }

      categoryDataRowAggr.push({
        name: that.formatSeriesName(component, component.dataRes.dimensions[0].members[i].text, 0 + ':' + i, {}),
        keyvalue: component.dataRes.dimensions[0].members[i].key,
        key: '0' + ':' + i,
        type: seriesType[i],
        color: self.getSeriesColors(component, seriesColor, categoryDataRowAggr.length, defaultColor),
        marker: markerarray,
        id: '' + i,
        data: [{y: component.dataRes.data[i]}]
      });
      component.categoriesIndex.push('0' + ':' + i);
    }

    seriesColor.splice(categoryDataRowAggr.length, seriesColor.length);
    component.dataseriescolor(seriesColor.join());
    defaultValue.xAxis.categories = [' '];
    defaultValue.series = categoryDataRowAggr;
    /*
    			 * Following code included for adding stacking feature. Loop thru the
    			 * series and identify the chart type & stacking from getter. If getter
    			 * return undefined, assign default chart type and stack index as
    			 * 'column' and current series index respectively, else cache the return
    			 * value. Extract the chart type information and assign it to current
    			 * series. Check if the cahce value has any information for stacking. If
    			 * yes, check if that particular stacking already exists in variable
    			 * 'stacking'. If so, assign the same to stack index else set the
    			 * stacking index for the current type to current series index and
    			 * assign same to series stacking index. If the cache value do not
    			 * contain any stacking information set the stack index for series to
    			 * series index
    			 */
    var stacking = {
      column: undefined,
      area: undefined,
      areaspline: undefined
    };
    // console.log('seriesType:'+seriesType);
    for (var i = 0, iLimit = defaultValue.series.length; i < iLimit; ++i) {
      var tempType = seriesType[i];
      if (tempType === undefined || tempType === '') {
        defaultValue.series[i].stack = i;
        defaultValue.series[i].type = 'column';
      } else {
        var splitTempType = tempType.split('-');
        defaultValue.series[i].type = splitTempType[0];
        if (splitTempType.length > 1) {
          if (stacking[splitTempType[0]] === undefined) {
            stacking[splitTempType[0]] = i;
          }

          defaultValue.series[i].stack = stacking[splitTempType[0]];
        } else {
          defaultValue.series[i].stack = i;
        }
      }
    }
    /*
	 * Set the stacking type in the plotOptions to make stacking work
	 */
    for (var i in stacking) {
      if (stacking[i] !== undefined) {
        defaultValue.plotOptions.series.stacking = 'normal';
        break;
      }
    }
  };
}
