/* global  sap */
function familyPie(args) {//jshint ignore: line
  var that = this;
  /*
     * *********************************************************************
     * -Template for defining definition in familySeries -All function
     * definition need to be within the scope of familyXYZ -Each definition of
     * property should be based on the validation of method
     * validateImplementMethod(args, [[function name string]])
     *
     * Example: if (validateImplementMethod(args, 'cds')) { <-- Actual Function
     * definition goes here --> that.cds = function() {
     *  // Your own implementation starts here either extend or // write
     * complete new implementation
     *  // var result = SeriesLibrary.prototype.cds.call(that); // some specific
     * implementation
     *  }; }
     *
     * -If function definition is defined without validateImplementMethod then
     * particular method is included by default in all components that include
     * this file!
     * *********************************************************************
     */
  // alert('[[Executed familyPie]]');
  if (validateImplementMethod(args, 'cds')) {//jshint ignore: line
    that.cds = function() {
      alert('function cds "hasOwnProperty" accessed'); // jshint ignore:line
    };
  }

  if (validateImplementMethod(args, 'createSeriesData')) {//jshint ignore: line
    /**
         * Map data from JSON Tuple to Highchart
         *
         * @override
         * @param {object}
         *            component - Reference to component
         * @param {string}
         *            type - type of the chart
         * @param {object}
         *            defaultValue - HighCharts values
         * @return {Array} seriesNames
         */
    that.createSeriesData = function(component, type, defaultValue, cfStatus) {
      // alert('overriden');
      var self = this;
      var seriesColor = component.dataseriescolor().split(',');
      component.categoriesIndex = [];
      //var columnCount = 0;
      var mesDimListIndex = [];
      //var displayunit = '';
      //var ruleapplied = 0;
      component.measureInOriginalSeries = {};
      component.categoryInOriginalSeries = {};
      component.columnInOriginalSeries = {};
      component.selectedRowdimIndexes = [];
      component.selectedColumndimIndexes = [];
      /*var rule = component.conditionalformatting();
            var rulearray = component.conditionalformatting() == "" ? "" : rule
                .split(",");*/
      var ruleInfo = '';
      if (cfStatus != 'ncf') {
        if (component.ruletable() !== undefined && component.ruletable() !== '' && component.ruletable() !== '{}') {
          that.updateRuleInfo(component, 'pie');
          //alert("ruletable="+component.ruletable());
          ruleInfo = JSON.parse(component.ruletable());
        }
      }

      var count = 0;
      // <START 1.0> Added Following code to remove overall result in
      // chart
      var dimensionsInJSON = component.dataRes.dimensions;
      //var tupleMatrixInJSON = component.dataRes.tuples;
      var resultIndex = [];
      /*
             * Get the Result Member of all dimension and update the resultIndex
             * Array with the index position of the result in the order
             * Dimensions appear in the JSON
             */
      //var mesDimNameList = [];
      var measureColorPair;
      var DMchange = false;
      var dimName = component.getDimensionAndMeasure();
      if (component.oldDimname === undefined || component.oldDimname === '') {
        component.oldDimname = dimName.toString();
      }

      if (component.oldDimname != dimName.toString()) {
        DMchange = true;
        if (sap.zen.designmode) {
          component.oldDimname = dimName.toString();
        }
      }

      //var conditionalformattingapplied = [];
      var measureDimIndex = -1;
      for (var i = 0; i < component.dataRes.dimensions.length; i++) {
        if (component.dataRes.dimensions[i].containsMeasures === true) {
          measureDimIndex = i;
          break;
        }
      }

      for (var i = 0, iLimit = dimensionsInJSON.length; i < iLimit; ++i) {
        for (var j = 0, jLimit = dimensionsInJSON[i].members.length; j < jLimit; ++j) {
          if (dimensionsInJSON[i].members[j].type == 'RESULT' ) {
            resultIndex.push(i);
            break;
          }
        }

        if (resultIndex[i] === undefined) {
          resultIndex.push(-1);
        }
      }
      /*  if (component.scalingfactorenable() == true) {
              for (var i = 0; i < component.dataRes.dimensions.length; i++) {
                if (component.dataRes.dimensions[i].containsMeasures == true) {
                  for (var j = 0; j < component.dataRes.dimensions[i].members.length; j++) {
                    component.dataRes.dimensions[i].members[j].text += " (* "+ Math.pow(10,component.dataRes.dimensions[i].members[j].scalingFactor)+ " )";
                  }
                }
              }
            }*/
      ///// NEW Implementation
      var sortedArray = [];
      var dimMesIndexJson = that.getDimMesJson(component, self);
      //if (bardatacustomizationJson['COLUMNS'].length >= 0 || bardatacustomizationJson['ROWS'].length >= 0) {
      if (dimMesIndexJson.dimIndexArray.length > 0 && dimMesIndexJson.mesIndex != -1) {
        //var measureKey = component.dataRes.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].key;
        component.measureInOriginalSeries[component.dataRes.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].key] = 0;
        var dataArray = [];
        var mesDimListIndex = [];
        var categoriesArray = [];
        var categoriesKeyArray = [];
        var aggregationCountArray = [];
        component.tempAggregationArray = [];
        var execute = true;
        var x;
        var checkArray = [];
        var count = -1;
        var pieName = '';

        var data = component.dataRes.data;
        var isMeasureAllZero =true;
        for (var i = 0; i < data.length; i++) {
          if (component.dataRes.tuples[i][measureDimIndex] == dimMesIndexJson.mesIndex) {
            if(data[i] !== null){
              isMeasureAllZero = false;
            }
          }
        }

        if(isMeasureAllZero)
    {
          return 7; // create smoke screen showing invalid data
    }

        for (var i = 0; i < component.dataRes.data.length; i++) {
          var y = '';
          var categories = [];
          var categoriesKey = [];
          var tempKey = '';
          mesDimListIndex[i] = '';
          var execute = true;
          var overAllResult = false;
          if (component.dataRes.tuples[i][measureDimIndex] == dimMesIndexJson.mesIndex) {
            for (var j = 0; j < dimMesIndexJson.dimIndexArray.length; j++) {
              pieName = component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]].text;
              y = y + '' + component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]];
              tempKey = tempKey + '-' + dimMesIndexJson.dimIndexArray[j] + ':' + component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]];
              if(component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]].members[component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]]].text){
                categories.push(component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]].members[component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]]].text);
              }
              categoriesKey.push(component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]].members[component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]]].key);
              for (var k = 0; k < component.dataRes.dimensions.length; k++) {
                if (component.dataRes.dimensions[k].members[component.dataRes.tuples[i][k]].type == 'RESULT') {
                  execute = false;
                  if(component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]-1] && component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]-1].members[component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]-1]].type == "RESULT"){
                    overAllResult = true;
          }
                }
              }
            }
            tempKey = tempKey.substr(1);
            if ((execute  || component.showtotaldatabase())) {
              if (checkArray.indexOf(y) == -1) {
                count++;
                aggregationCountArray[count] = 0;
                this.valueAggregation(component, component.dataRes.data[i], dataArray[checkArray.indexOf(y)], aggregationCountArray, count);
                //
                // jscs:disable
                // Code here will be ignored by JSCS.
                categoriesArray[count] = categories.join('\\');
                categoriesKeyArray[count] = categoriesKey.join('\\');
                // jscs:enable
                //  component.categoryInOriginalSeries[categoriesKeyArray[count]] = count;
                mesDimListIndex[count] = tempKey;
                x = y;
                checkArray.push(y);
                dataArray[count] = component.dataRes.data[i];
              } else {
                //console.log("here"+categoriesKeyArray[y])
                //console.log("here"+categoriesArray[y]+component.dataRes.data[i])
                 //&& categoriesArray[y].indexOf("Overall Result") == -1
                //  alert(this.valueAggregation(component,component.dataRes.data[i],dataArray[checkArray.indexOf(y)],aggregationCountArray[checkArray.indexOf(y)]));
                if (execute || (categoriesKeyArray[y].indexOf("SUMME")!=-1))
                  {
                aggregationCountArray[checkArray.indexOf(y)]++;
                dataArray[checkArray.indexOf(y)] = this.valueAggregation(component, component.dataRes.data[i], dataArray[checkArray.indexOf(y)], aggregationCountArray, checkArray.indexOf(y));
                  }
              }
            }
          }
        }

        for (var i = 0; i < dataArray.length; i++) {
          sortedArray.push({
            name: categoriesArray[i],
            keyName: categoriesKeyArray[i],
            color: seriesColor[i],
            data: dataArray[i],
            key: mesDimListIndex[i]
          });
          component.categoriesIndex.push(mesDimListIndex[i]);
        }
    var measureColorPair;
        if (component.measurecolorpair()) {
          measureColorPair = JSON.parse(component.measurecolorpair());
        }
        /// Arrange in descending order for Funnel Chart - Runs when dimension length is greater than 2
        //var datasourcechange = jQuery.extend(true, [],sortedArray);
        //Shollow copy of the sortedArray.
        if (type == 'funnel') {
          switch (component.funnelsort()){
          case 'Initial View':
            for (var i = 0; i < sortedArray.length; i++) {
              for (var j = 0; j < sortedArray.length - 1; j++) {
                if (sortedArray[i].data > sortedArray[j].data) {
                  var temp = sortedArray[i];
                  sortedArray[i] = sortedArray[j];
                  sortedArray[j] = temp;  //  component.categoryInOriginalSeries[sortedArray[i].keyName] = i;
                }
              }
            }

            break;
          case 'Dimensiontext-Ascending':
            sortedArray.sort(function(a, b) {
              var firstText = a.name.toUpperCase();
              var secondText = b.name.toUpperCase();
              return (firstText < secondText) ? -1 : (firstText > secondText) ? 1 : 0;
            });

            break;
          case 'Dimensiontext-Descending':
            sortedArray.sort(function(a, b) {
              var firstText = a.name.toUpperCase();
              var secondText = b.name.toUpperCase();
              return (firstText > secondText) ? -1 : (firstText < secondText) ? 1 : 0;
            });

            break;
          case 'Dimensionkey-Ascending':
            sortedArray.sort(function(a, b) {
              var firstText = a.keyName.toUpperCase();
              var secondText = b.keyName.toUpperCase();
              return (firstText < secondText) ? -1 : (firstText > secondText) ? 1 : 0;
            });

            break;
          case 'Dimensionkey-Descending':
            sortedArray.sort(function(a, b) {
              var firstText = a.keyName.toUpperCase();
              var secondText = b.keyName.toUpperCase();
              return (firstText > secondText) ? -1 : (firstText < secondText) ? 1 : 0;
            });

            break;
          }

        }

        if (type == 'funnel') {
          component.categoriesIndex = [];
        }
        /**
         *overriding the categoriesIndex of the funnel_Chart because of the sorting
         *modified categoriesIndex is applied below.
        **/

        var seriesData = [];
        seriesData = [{}];
        seriesData[0].data = [];
        seriesData[0].name = component.dataRes.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].text;
        seriesData[0].uniquekey = component.dataRes.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].key;
        seriesData[0].scalingFactor = component.dataRes.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].scalingFactor;
        seriesData[0].unitOfMeasure = component.dataRes.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].unitOfMeasure;
        seriesData[0].index = dimMesIndexJson.mesIndex;
        seriesData[0].key = measureDimIndex + ":" + dimMesIndexJson.mesIndex;
        for (var i = 0; i < sortedArray.length; i++) {
          if (measureColorPair && measureColorPair[sortedArray[i].keyName] !== undefined) {
            sortedArray[i].color = measureColorPair[sortedArray[i].keyName].color;
          }

          sortedArray[i].name = self.formatSeriesName(component, sortedArray[i].name , measureDimIndex + ':' + dimMesIndexJson.mesIndex,{});

          /*if (component.scalingfactorenable()) {
            sortedArray[i].name = sortedArray[i].name + '(*' + Math.pow(10, component.dataRes.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].scalingFactor) + ')';
          }

          if (component.showunit() && component.dataRes.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].unitOfMeasure != undefined) {
            sortedArray[i].name = sortedArray[i].name + ' (in ' + component.dataRes.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].unitOfMeasure + ')';
          }*/
          seriesData[0].data.push({
            name: sortedArray[i].name,
            y: sortedArray[i].data,
            color: '#' + sortedArray[i].color.replace('#', '')
          });
          if (type == 'funnel') {
            component.categoriesIndex.push(sortedArray[i].key);
          }
          /**
          *modified categoriesIndex of the funnel because of sorting
          **/
          component.categoryInOriginalSeries[sortedArray[i].keyName] = i;
        }

        //var cfdataCalled = !1;
        component.selectedRowdimIndexes = dimMesIndexJson.dimIndexArray;
        component.selectedColumndimIndexes[0] = measureDimIndex;
        //Conditional formatting
        //***************New Implementation Conditional Formatting*************
        if (ruleInfo) {
          try {
            that.createCFData(component, 'pie', component.fulljson());
            that.processConditionalFormatting(component, seriesData, ruleInfo, 'pie');
          } catch (e) {
          }
        }

        var localtotalpie = [];
        if (component.showtotal() === true) {
          for (var k = 0; k < seriesData[0].data.length; k++) {
            localtotalpie.push(seriesData[0].data[k].y);
          }

          var total = localtotalpie.reduce(function(a, b) {
            return a + b;
          });

          if (measureColorPair && measureColorPair['Total Result'] !== undefined) {
            seriesColor[seriesData[0].data.length] = measureColorPair['Total Result'].color;
          }

          seriesData[0].data.push({
            name: 'TotalResult',
            y: total,
            color: seriesColor[seriesData[0].data.length]
          });
        }
        //    console.log(JSON.stringify(seriesData));
        component.columnInOriginalSeries = component.measureInOriginalSeries;
        defaultValue.series = seriesData;
      }
    };
  }

  that.getDimMesJson = function(component) {
    var dimMesJson = {};
    var memIndexArray = [];
    var measureIndex = 0;
    if (component.datautility() === true && typeof component.measurelist() !== undefined && component.measurelist() !== '') {      
      var measureMembersArr = component.getMeasureMembersKeyAndText();
      measureIndex = measureMembersArr[1].indexOf(component.measurelist());
      if (measureIndex == -1) {
        if (measureMembersArr[0].indexOf(component.measurelist()) !== -1) {
          measureIndex = measureMembersArr[0].indexOf(component.measurelist());
        } else {
          measureIndex = 0;
        }
      }
    }

    var rowIndex = component.dataRes.axis_columns[0].indexOf(-1);//jshint ignore: line
    if (rowIndex !== -1) {
      for (var i = rowIndex; i < component.dataRes.dimensions.length; i++) {
        if (!component.dataRes.dimensions[i].containsMeasures) {
          memIndexArray.push(i);
        }
      }
    } else {
      rowIndex = component.dataRes.dimensions.length;
    }

    if (memIndexArray.length === 0) {
      for (var i = 0; i < rowIndex; i++) {
        if (!component.dataRes.dimensions[i].containsMeasures) {
          memIndexArray.push(i);
        }
      }
    }

    dimMesJson = {
      'mesIndex': measureIndex,
      'dimIndexArray': memIndexArray,
      'dimensionAxis': 'rows'
    };

    return dimMesJson;
  };

  if (validateImplementMethod(args, 'createCFData')) {//jshint ignore: line
    that.createCFData = function(component) {
      var self = this;
      var measureDimIndex = component.getMeasureIndex();
      var completeJSONCF=component.dataRes;
      /*var measuresinRule = [
        0,
        1,
        2,
        3
      ];
      $.each(component.measuresInRules,function(k,v){
              measuresinRule.push(v);
            });*/
      if (!completeJSONCF) {
        return '';
      }

      var seriesColor = component.dataseriescolor().split(',');
      component.categoryInCFSeries = {};
      component.measureInCFSeries = {};
      ///// NEW Implementation
      var sortedArray = [];
      var dimMesIndexJson = that.getDimMesJson(component, self);
      //var measureKey = completeJSONCF.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].key;
      for (var z = 0; z < completeJSONCF.dimensions[measureDimIndex].members.length; z++) {
        component.measureInCFSeries[completeJSONCF.dimensions[measureDimIndex].members[z].key] = z;
      }
      //component.measureInCFSeries [completeJSONCF.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].key] =  dimMesIndexJson.mesIndex;
      //if (bardatacustomizationJson['COLUMNS'].length >= 0 || bardatacustomizationJson['ROWS'].length >= 0) {
       var CFseriesData = [];
      if (dimMesIndexJson.dimIndexArray.length > 0) {
        var dataArray = [];
        var mesDimListIndex = [];
        var categoriesArray = [];
        var categoriesKeyArray = [];
        var aggregationCountArray = [];
        component.tempAggregationArray = [];
        var measureIndexArray = [];
        var execute = true;
        var x;
        var checkArray = [];
        var count = [];
        var scalingFactor = [];
        var pieName = '';
        var catName = [];
        var catKey = [];
        for (var i = 0; i < completeJSONCF.data.length; i++) {
          var y = '';
          var categories = [];
          var categoriesKey = [];
          var tempKey = '';
          mesDimListIndex[i] = '';
          var execute = true;
          var highlightedMesIndex = dimMesIndexJson.mesIndex;
          var currentTuple = completeJSONCF.tuples[i][measureDimIndex];
          if (measureIndexArray.indexOf(currentTuple) == -1) {
            measureIndexArray.push(currentTuple);
            categoriesArray[currentTuple] = [];
            categoriesKeyArray[currentTuple] = [];
            dataArray[currentTuple] = [];
            checkArray[currentTuple] = [];
            scalingFactor[currentTuple] = completeJSONCF.dimensions[measureDimIndex].members[currentTuple].scalingFactor;
            count[currentTuple] = -1;
          }

          for (var j = 0; j < dimMesIndexJson.dimIndexArray.length; j++) {
            pieName = completeJSONCF.dimensions[dimMesIndexJson.dimIndexArray[j]].text;
            y = y + '' + completeJSONCF.tuples[i][dimMesIndexJson.dimIndexArray[j]];
            tempKey = tempKey + '-' + dimMesIndexJson.dimIndexArray[j] + ':' + completeJSONCF.tuples[i][dimMesIndexJson.dimIndexArray[j]];
            categories.push(completeJSONCF.dimensions[dimMesIndexJson.dimIndexArray[j]].members[completeJSONCF.tuples[i][dimMesIndexJson.dimIndexArray[j]]].text);
            categoriesKey.push(completeJSONCF.dimensions[dimMesIndexJson.dimIndexArray[j]].members[completeJSONCF.tuples[i][dimMesIndexJson.dimIndexArray[j]]].key);
            for (var k = 0; k < completeJSONCF.dimensions.length; k++) {
              if (completeJSONCF.dimensions[k].members[completeJSONCF.tuples[i][k]].type == 'RESULT' && !component.showtotaldatabase()) {
                execute = false;
              }
            }
          }

          tempKey = tempKey.substr(1);
          if (execute) {
            if (checkArray[currentTuple].indexOf(y) == -1) {
              count[currentTuple]++;
              aggregationCountArray[count[currentTuple]] = [];
              if (highlightedMesIndex == currentTuple) {
                this.valueAggregation(component, completeJSONCF.data[i] * Math.pow(10, scalingFactor[currentTuple]), dataArray[checkArray.indexOf(y)], aggregationCountArray, count[currentTuple]);
              }
              //
              // jscs:disable
              // Code here will be ignored by JSCS.
              categoriesArray[currentTuple] = categories.join('\\');
              categoriesKeyArray[currentTuple] = categoriesKey.join('\\');
              // jscs:enable
              catKey[count[currentTuple]] = categoriesKeyArray[currentTuple];
              catName[count[currentTuple]] = categoriesArray[currentTuple];
              component.categoryInCFSeries[categoriesKeyArray[currentTuple]] = count[currentTuple];
              mesDimListIndex[count[currentTuple]] = tempKey;
              x = y;
              checkArray[currentTuple].push(y);
              dataArray[currentTuple][count[currentTuple]] = completeJSONCF.data[i] * Math.pow(10, scalingFactor[currentTuple]);
            } else {
              if (highlightedMesIndex == currentTuple) {
                //  alert(this.valueAggregation(component,completeJSONCF.data[i],dataArray[checkArray.indexOf(y)],aggregationCountArray[checkArray.indexOf(y)]));
                aggregationCountArray[checkArray[currentTuple].indexOf(y)]++;
                dataArray[currentTuple][checkArray[currentTuple].indexOf(y)] = this.valueAggregation(component, completeJSONCF.data[i] * Math.pow(10, scalingFactor[currentTuple]), dataArray[currentTuple][checkArray[currentTuple].indexOf(y)], aggregationCountArray, checkArray[currentTuple].indexOf(y));
              } else {
                dataArray[currentTuple][checkArray[currentTuple].indexOf(y)] = dataArray[currentTuple][checkArray[currentTuple].indexOf(y)] + completeJSONCF.data[i] * Math.pow(10, scalingFactor[currentTuple]);
              }
            }
          }
        }
        component.categoriesIndex = [];
        for (var j = 0; j < dataArray.length; j++) {
          sortedArray[j] = [];
          for (var i = 0; i < dataArray[j].length; i++) {
            sortedArray[j].push({
              name: catName[i],
              keyName: catKey[i],
              color: seriesColor[i],
              data: dataArray[j][i],
              key: mesDimListIndex[i]
            });
            if(j === 0){ //VBX141-4690 To avoid repeated dimension index;it causing issue while selecting;selection member is incorrect for totals;
               component.categoriesIndex.push(mesDimListIndex[i]);
            }
          }
        }
  var measureColorPair;
        if (component.measurecolorpair()) {
          measureColorPair = JSON.parse(component.measurecolorpair());
        }
        // Arrange in descending order for Funnel Chart Loop3
        //        if (type == "funnel"){
        //          for(var k=0;k<sortedArray.length;k++){
        //          for (var i = 0; i < sortedArray[k].length; i++) {
        //            for (var j = 0; j < sortedArray[k].length - 1; j++) {
        //              if (sortedArray[k][i].data > sortedArray[k][j].data) {
        //                var temp = sortedArray[k][i];
        //                sortedArray[k][i] = sortedArray[k][j];
        //                sortedArray[k][j] = temp;
        //
        //                temp = component.categoryInCFSeries[sortedArray[k][i].keyName];
        //                component.categoryInCFSeries[sortedArray[k][i].keyName] =   component.categoryInCFSeries[sortedArray[k][j].keyName];
        //                component.categoryInCFSeries[sortedArray[k][j]] = temp;
        //              }
        //
        //            }
        //          }
        //          }
        //
        //    $.each(col_row_index_json,function(key,value){
        //            $.each(value,function(index,newval){
        //              var curIndex=newval+tupleToSkip;
        //              var keygen=key+"_"+rowKey;
        //              if(rowDataJson[keygen]==undefined){
        //                rowDataJson[keygen]=[];
        //              }
        //              rowDataJson[keygen].push(completeJSONCF.data[curIndex]);
        //            });
        //
        //
        //          });
        //
        //
        //        }
       
        //CFseriesData = [];
        for (var j = 0; j < sortedArray.length; j++) {
          CFseriesData.push({
            name: completeJSONCF.dimensions[measureDimIndex].members[j].key,
            data: []
          });
          for (var i = 0; i < sortedArray[j].length; i++) {
            CFseriesData[j].data = dataArray[j];  //component.categoryInCFSeries[sortedArray[j][i].keyName] = j;
          }
        }

        var localtotalpie = [];
        if (component.showtotal() === true) {
          for (var k = 0; k < CFseriesData[0].data.length; k++) {
            localtotalpie.push(CFseriesData[0].data[k].y);
          }

          var total = localtotalpie.reduce(function(a, b) {
            return a + b;
          });

          if (measureColorPair && measureColorPair['Total Result'] !== undefined) {
            seriesColor[CFseriesData[0].data.length] = measureColorPair['Total Result'].color;
          }

          CFseriesData[0].data.push({
            name: 'TotalResult',
            y: total  //  color : seriesColor[CFseriesData[0].data.length]
          });
        }
      }

      component.columnInCFSeries = component.measureInCFSeries;
      component.conditionalFormattingData = CFseriesData;
    };
  }

  if (validateImplementMethod(args, 'createMeasuresData')) {//jshint ignore: line
    that.createMeasuresData = function(component, type, defaultValue, cfStatus) {
      //var self = this;
      component.categoriesIndex = [];
      //var columnCount = 0;
      //var displayunit = '';
      component.measureInOriginalSeries = {};
      component.categoryInOriginalSeries = {};
      component.columnInOriginalSeries = {};
      var seriesColor = component.dataseriescolor().split(',');
      //var count = 0;
      var dimensionsName = [];
      var dimensionsKey = [];
      var dimensionData = [];
      var dimensionNameKeys = [];
      var seriesData = [{}];
      seriesData[0].data = [];
      var measureScaling = [];
      var ruleInfo = '';
      if (cfStatus !== 'ncf') {
        if (component.ruletable()&& component.ruletable() !== '{}') {
          that.updateRuleInfo(component, 'pie');
          ruleInfo = JSON.parse(component.ruletable());
        }
      }

      var measureColorPair;
      if (component.measurecolorpair()) {
        measureColorPair = JSON.parse(component.measurecolorpair());
      }

      var mesDimIndex = 0;
      if (component.dataRes.dimensions.length === 2 && component.dataRes.dimensions[0].axis === 'COLUMNS' && component.dataRes.dimensions[1].axis === 'ROWS' && component.dataRes.dimensions[1].containsMeasures === true && component.dataRes.dimensions[1].members.length === 1) {
        mesDimIndex = 1;
      }

      for (var i = 0; i < component.dataRes.dimensions[mesDimIndex].members.length; i++) {
        dimensionsName[i] = component.dataRes.dimensions[mesDimIndex].members[i].text;
        dimensionNameKeys[i] = component.dataRes.dimensions[mesDimIndex].members[i].key;
        dimensionData[i] = component.dataRes.data[i];
        if (measureColorPair && measureColorPair[dimensionNameKeys[i]] !== undefined) {
          seriesColor[i] = measureColorPair[dimensionNameKeys[i]].color;
        }
        seriesData[0].data.push({
          keyName: dimensionNameKeys[i],
          name: dimensionsName[i],
          y: dimensionData[i],
          color: seriesColor[i]
        });
        component.measureInOriginalSeries[dimensionNameKeys[i]] = i;
        dimensionsKey[i] = '0' + ':' + i;
        measureScaling.push(Number(component.dataRes.dimensions[mesDimIndex].members[i].scalingFactor));
       if (component.showunit() === true && component.dataRes.dimensions[mesDimIndex].members[i].unitOfMeasure !== undefined)
     {
        seriesData[0].data[i].name = seriesData[0].data[i].name+ "(in "+ component.dataRes.dimensions[mesDimIndex].members[i].unitOfMeasure+ ")";
     }
        if (component.scalingfactorenable() === true) {
          seriesData[0].data[i].name = seriesData[0].data[i].name + ' (* ' + Math.pow(10, component.dataRes.dimensions[mesDimIndex].members[i].scalingFactor) + ' )';
        }

        component.categoriesIndex.push(dimensionsKey[i]);
      }

      component.categoryInOriginalSeries = component.measureInOriginalSeries;
      //var units = displayunit.split(',');
      // Arrange in descending order for Funnel Chart - Runs when dimension length is less than 2
      if (type == 'funnel' && component.funnelsort() == 'Initial View') {
        for (var i = 0; i < seriesData[0].data.length; i++) {
          for (var j = 0; j < seriesData[0].data.length - 1; j++) {
            if (seriesData[0].data[i].y > seriesData[0].data[j].y) {
              var temp = seriesData[0].data[i];
              seriesData[0].data[i] = seriesData[0].data[j];
              seriesData[0].data[j] = temp;
              temp = component.categoriesIndex[i];
              component.categoriesIndex[i] = component.categoriesIndex[j];
              component.categoriesIndex[j] = temp;
              temp = component.categoryInOriginalSeries[seriesData[0].data[i].keyName];
              component.categoryInOriginalSeries[seriesData[0].data[i].keyName] = component.categoryInOriginalSeries[seriesData[0].data[j].keyName];
              component.categoryInOriginalSeries[seriesData[0].data[j].keyName] = temp;
            }
          }
        }
      }

      component.columnInOriginalSeries['dimension'] = 0;
      var originalSeriesData = seriesData;
      if (ruleInfo && cfStatus !== 'ncf') {
        that.createCFMeasureData(component, 'pie', component.fulljson());
        that.processConditionalFormatting(component, originalSeriesData, ruleInfo, 'pie');
      }

      seriesData[0].scalingFactor = measureScaling[0];
      defaultValue.series = seriesData;
    };
  }

  if (validateImplementMethod(args, 'createCFMeasureData')) {//jshint ignore: line
    that.createCFMeasureData = function(component, type, completeJSONCF) {
      component.measureInCFSeries = {};
      component.categoryInCFSeries = {};
      component.columnInCFSeries = {};
      //var self = this;
      component.categoriesIndex = [];
      //var columnCount = 0;
      //var displayunit = '';
     // var seriesColor = component.dataseriescolor().split(',');
      //var count = 0;
      var dimensionsName = [];
      var dimensionsKey = [];
      var dimensionData = [];
      var dimensionKeyNames = [];
      var mesSeriesData = [{}];
      mesSeriesData[0].data = [];
      var measureScaling = [];
      var mesDimIndex = 0;
      for (var i = 0; i < completeJSONCF.dimensions[mesDimIndex].members.length; i++) {
        dimensionsName[i] = completeJSONCF.dimensions[mesDimIndex].members[i].text;
        dimensionData[i] = completeJSONCF.data[i];
        dimensionKeyNames[i] = completeJSONCF.dimensions[mesDimIndex].members[i].key;
        component.categoryInCFSeries[dimensionKeyNames[i]] = i;
        dimensionsKey[i] = '0' + ':' + i;
        component.categoriesIndex.push(dimensionsKey[i]);
      }

      mesSeriesData[0].data = completeJSONCF.data;
      //var units = displayunit.split(',');
      component.measureInCFSeries = component.categoryInCFSeries;
      //        if (type == "funnel"){
      //          for (var i = 0; i < mesSeriesData[0].data.length; i++) {
      //            for (var j = 0; j < mesSeriesData[0].data.length - 1; j++) {
      //              if (mesSeriesData[0].data[i].y > mesSeriesData[0].data[j].y) {
      //                var temp = mesSeriesData[0].data[i];
      //                mesSeriesData[0].data[i] = mesSeriesData[0].data[j];
      //                mesSeriesData[0].data[j] = temp;
      //
      //                temp = component.categoriesIndex[i];
      //                component.categoriesIndex[i] = component.categoriesIndex[j];
      //                component.categoriesIndex[j] = temp;
      //
      //                temp = component.categoryInCFSeries[seriesData[0].keyName[i]];
      //                component.categoryInCFSeries[seriesData[0].keyName[i]] =  component.categoryInCFSeries[seriesData[0].keyName[j]];
      //                component.categoryInCFSeries[seriesData[0].keyName[j]] = temp;
      //              }
      //            }
      //          }
      //        }
      mesSeriesData[0].scalingFactor = measureScaling[0];
      component.columnInCFSeries['dimension'] = 0;
      component.conditionalFormattingData = mesSeriesData;
    };
  }
}
