/* globals validateImplementMethod,piefamilyDrilldown */
/*jshint unused:false*/
function piefamilyDrilldown(args) {
  var that = this;
  /*
     * *********************************************************************
     * -Template for defining definition in familySeries
     * -All function definition need to be within the scope of familyXYZ
     * -Each definition of property should be based on the validation of
     *  method validateImplementMethod(args, [[function name string]])
     *
     *  Example:
       *  if (validateImplementMethod(args, 'cds')) {
       *    <-- Actual Function definition goes here -->
       *    that.cds = function() {
       *
       *      // Your own implementation starts here either extend or
       *      // write complete new implementation
       *
       *      // var result = SeriesLibrary.prototype.cds.call(that);
       *      // some specific implementation
       *
       *    };
       *  }
     *
     * -If function definition is defined without validateImplementMethod
     *  then particular method is included by default in all components that
     *  include this file!
     * *********************************************************************
     */
  //   alert('[[Executed familyDrilldown]]');
  if (validateImplementMethod(args, 'cds')) {
    that.cds = function () {
      window.alert('function cds "hasOwnProperty" accessed');
    };
  }

  /**
   * Get bardatacustomization object which is compatible with previous version. It returns only those dimensions whose 'show' property is set to 'true'
   * @param {object} component - Reference to component object
   * @returns {object} 
   */
    that.getBarDataCustomization = function(component){
        var barData = component.bardatacustomization();
        var dataSourceDefinition = typeof component.dataSourceDefinition !== 'undefined' ? component.dataSourceDefinition() : 'technicalId';
        var resultSet = component.result();
        var duConfig = {
            COLUMNS: [],
            ROWS: []
        };

        if(barData !== '' && barData !== undefined && barData !== null){
          try{
            barData = JSON.parse(barData);
          }catch(e){}
        }

        if(resultSet !== '' && resultSet !== undefined && resultSet !== null){
          try{
            resultSet = JSON.parse(resultSet);
          }catch(e){}
        }


        if(barData && typeof barData === 'object'){
          if(dataSourceDefinition === 'technicalId'){
            _.each(duConfig, function(config, key){
              _.each(barData[key], function(dimension){
                if(dimension.show === true || typeof dimension.show === 'undefined'){
                      config.push(dimension);
                }
              });
            });
          }
          else if(dataSourceDefinition === 'index' && resultSet){
            _.each(duConfig, function(config, key){
              _.each(barData[key], function(index){
                index = parseInt(index, 10);
                if(!_.isNaN(index)){
                  var dimension = resultSet.dimensions[index];
                  config.push({
                    key: dimension.key,
                    text: dimension.text,
                    index: index,
                    show: true
                  });
                }
              });
            });
          }
        }
        return duConfig;    
    };

  if (validateImplementMethod(args, 'createDrilldownMultilevelData')) {
    that.createDrilldownMultilevelData = function (component, selectedDimensions, selectedMeasure, type/*, colorSeries*/) {
      var self = this;
      var measureMembers = component.dataRes.columnCount, tupleStringArray = [], /*DrilldownData = [],*/ SeriesData = [{}], currentTuplePos = -1, tupleStringArr = [], tupleString = '', tempMemberCollection = {}, pos = 0;
      var tempMemberCollectionDataIndex = {};
      SeriesData[0].backButton = component.dataRes.dimensions[selectedDimensions[0]]["picker_text"];
      SeriesData[0].data = [];
      var seriesDataJson = {};
      var tempSeriesKeyIndexes = [];
      var tempSeriesKeyNames = [];
      var tempSeriesNames = [];
      var curTuple = component.dataRes.tuples[selectedMeasure];
      var noOfColumns = component.dataRes['axis_columns'][0].indexOf(-1) == -1 ? component.dataRes['axis_columns'][0].length : component.dataRes['axis_columns'][0].indexOf(-1);
      var tempZtlColJson = {};
      var unitOfMeasure = '';
      var scalingFactor = 0;
      var measureDimString = '';
      for (var i = 0; i < noOfColumns; i++) {
        if (component.dataRes.dimensions[i].hasOwnProperty('containsMeasures')) {

          measureDimString = i + ':' + curTuple[i];
          if (component.unitcurrency()) {
            unitOfMeasure = component.dataRes.dimensions[i].members[curTuple[i]].unitOfMeasure || '';
          }

          if (component.scalingfactorenable()) {
            scalingFactor = component.dataRes.dimensions[i].members[curTuple[i]].scalingFactor || 0;
          }
        }

        tempSeriesKeyIndexes.push(i + ':' + curTuple[i]);
        tempSeriesKeyNames.push(component.dataRes.dimensions[i].members[curTuple[i]].key);
        tempSeriesNames.push(component.dataRes.dimensions[i].members[curTuple[i]].text);
        tempZtlColJson[component.dataRes.dimensions[i].key] = {
          'internalKey': component.dataRes.dimensions[i].members[curTuple[i]].key,
          'text': component.dataRes.dimensions[i].members[curTuple[i]]["picker_text"]
        };
      }

      var seriesKeyIndexes = tempSeriesKeyIndexes.join('-');
      var seriesKeyNames = tempSeriesKeyNames.join('-');
      var seriesNames = tempSeriesNames.join('-');
      component.ztlSelectedColumnJson[seriesKeyNames] = $.extend(true, {}, tempZtlColJson);
      SeriesData[0].columnIndexKey = seriesKeyIndexes;
      SeriesData[0].id = 'Series-' + seriesKeyIndexes;
      SeriesData[0].seriesname = seriesNames;
      SeriesData[0].seriesKeyName = seriesKeyNames;
      SeriesData[0].unitOfMeasure = unitOfMeasure;
      SeriesData[0].scalingFactor = Math.pow(10, scalingFactor);
      var scalingText = component.scalingfactorenable() ? '(*' + SeriesData[0].scalingFactor + ')' : '';
      if (type == 'bardd') {
        SeriesData[0].name = seriesNames + '' + scalingText + ' ' + SeriesData[0].unitOfMeasure;
      } else {
        SeriesData[0].name = component.dataRes.dimensions[selectedDimensions[0]].text;
        //self.formatSeriesName(component, , measureDimString, {'showunit' : 'unitcurrency'});
      }

      var totalForChart = [];
      for (var selDim = 0; selDim < selectedDimensions.length; selDim++) {
        for (var j = selectedMeasure; j < component.dataRes.data.length; j += measureMembers) {
          tupleString = '';
          tupleStringArr = [];
          //var containResult = false;
          for (var i = 0; i <= selDim; i++) {
            //tupleStringArr.push(selectedDimensions[i] + ':' + component.dataRes.tuples[j][selectedDimensions[i]]);  
            tupleStringArr.push(component.dataRes.dimensions[selectedDimensions[i]].key.replace(/-/g, '_') + ':' + component.dataRes.dimensions[selectedDimensions[i]].members[component.dataRes.tuples[j][selectedDimensions[i]]].key.replace(/-/g, '_'));
          }

          if (self.vbiCharts.eliminateResult(component.dataRes, component.dataRes.tuples[j], undefined, component.showtotaldatabase()) === true) {
            tupleString = tupleStringArr.join('-');
            currentTuplePos = tupleStringArray.indexOf(tupleString);
            if (selDim === 0) {
              if (currentTuplePos === -1) {
                tupleStringArray.push(tupleString);
                if (!seriesDataJson[tupleString]) {
                  seriesDataJson[tupleString] = {};
                  seriesDataJson[tupleString].drilldown = tupleString;
                  seriesDataJson[tupleString].Namekey = tupleString;
                  seriesDataJson[tupleString].columnKey = seriesKeyNames;
                  seriesDataJson[tupleString].columnIndexKey = seriesKeyIndexes;
                  if (typeof component.ztlSelectedRowJson[tupleString] == 'undefined') {
                    var dimKey = component.dataRes.dimensions[selectedDimensions[selDim]].key;
                    component.ztlSelectedRowJson[tupleString] = {};
                    component.ztlSelectedRowJson[tupleString][dimKey] = {
                      internalKey: component.dataRes.dimensions[selectedDimensions[selDim]].members[component.dataRes.tuples[j][selectedDimensions[selDim]]].key,
                      text: component.dataRes.dimensions[selectedDimensions[selDim]].members[component.dataRes.tuples[j][selectedDimensions[selDim]]]["picker_text"]
                    };
                  }

                  seriesDataJson[tupleString].nodeState = 'collapsed';
                  seriesDataJson[tupleString].level = 0;
                  seriesDataJson[tupleString].parentKey = 'none';
                  //seriesDataJson[tupleString].color = colorSeries[tupleString]||colorSeries[0];
                  seriesDataJson[tupleString].name = component.dataRes.dimensions[selectedDimensions[selDim]].members[component.dataRes.tuples[j][selectedDimensions[selDim]]].text;
                  seriesDataJson[tupleString].name = self.formatSeriesName(component, seriesDataJson[tupleString].name, measureDimString, { 'showunit': 'unitcurrency' });
                  seriesDataJson[tupleString].yArr = [component.dataRes.data[j]];
                  seriesDataJson[tupleString].y = 0;
                }
              } else {
                seriesDataJson[tupleString].yArr.push(component.dataRes.data[j]);
              }

              totalForChart.push(component.dataRes.data[j]);
            } else {
              var tsKey = tupleString.slice(0, tupleString.lastIndexOf('-'));
              if (currentTuplePos === -1) {
                tupleStringArray.push(tupleString);
                if (!tempMemberCollection[tsKey]) {
                  tempMemberCollection[tsKey] = {};
                  tempMemberCollectionDataIndex[tsKey] = {};
                  //tempMemberCollection[tsKey].id = tupleString;
                  tempMemberCollection[tsKey].columnIndexKey = seriesKeyIndexes;
                  tempMemberCollection[tsKey].seriesname = seriesNames;
                  tempMemberCollection[tsKey].unitOfMeasure = unitOfMeasure;
                  tempMemberCollection[tsKey].scalingFactor = Math.pow(10, scalingFactor);
                  tempMemberCollection[tsKey].backButton = component.dataRes.dimensions[selectedDimensions[selDim]]["picker_text"];
                  scalingText = component.scalingfactorenable() ? '(*' + tempMemberCollection[tsKey].scalingFactor + ')' : '';
                  if (type == 'bardd') {
                    tempMemberCollection[tsKey].name = seriesNames + '' + scalingText + ' ' + tempMemberCollection[tsKey].unitOfMeasure;
                  } else {
                    tempMemberCollection[tsKey].name = component.dataRes.dimensions[selectedDimensions[selDim]].text;
                  }

                  tempMemberCollection[tsKey].seriesKeyName = seriesKeyNames;
                  tempMemberCollection[tsKey].value = 0;
                  // need attention!!!
                  tempMemberCollection[tsKey].data = [];
                }

                var parentKey = tsKey;
                tempMemberCollectionDataIndex[tsKey][tupleString] = tempMemberCollection[tsKey].data.length;
                tempMemberCollection[tsKey].data.push({
                  'drilldown': selDim < selectedDimensions.length - 1 ? true : false,
                  'name': self.formatSeriesName(component, component.dataRes.dimensions[selectedDimensions[selDim]].members[component.dataRes.tuples[j][selectedDimensions[selDim]]].text, measureDimString, { 'showunit': 'unitcurrency' }),
                  'Namekey': tupleString,
                  'parentKey': parentKey,
                  'level': parentKey.split('-').length,
                  'nodeState': 'collapsed',
                  'columnKey': seriesKeyNames,
                  'columnIndexKey': seriesKeyIndexes,
                  'y': 0,
                  'yArr': [component.dataRes.data[j]]
                });
                if (typeof component.ztlSelectedRowJson[tupleString] === 'undefined') {
                  var dimKey = component.dataRes.dimensions[selectedDimensions[selDim]].key;
                  component.ztlSelectedRowJson[tupleString] = {};
                  component.ztlSelectedRowJson[tupleString][dimKey] = {
                    internalKey: component.dataRes.dimensions[selectedDimensions[selDim]].members[component.dataRes.tuples[j][selectedDimensions[selDim]]].key,
                    text: component.dataRes.dimensions[selectedDimensions[selDim]].members[component.dataRes.tuples[j][selectedDimensions[selDim]]]["picker_text"]
                  };
                }

                tempMemberCollection[tsKey].value += component.dataRes.data[j];
              } else {
                pos = tempMemberCollectionDataIndex[tsKey][tupleString];
                tempMemberCollection[tsKey].data[pos].yArr.push(component.dataRes.data[j]);
                tempMemberCollection[tsKey].value += component.dataRes.data[j];
              }
            }
          }
        }
      }

      for (var x in tempMemberCollection) {
        //DrilldownData.push(tempMemberCollection[x]);
        $.each(tempMemberCollection[x].data, function (i, v) {
          v.y = component.dataUtilityAggregation(v.yArr);
          delete v.yArr;
        });

        component.drilldownjson[x + '-' + seriesKeyNames] = tempMemberCollection[x];
      }

      for (var x in seriesDataJson) {
        seriesDataJson[x].y = component.dataUtilityAggregation(seriesDataJson[x].yArr);
        delete seriesDataJson[x].yArr;
        SeriesData[0].data.push(seriesDataJson[x]);
      }

      if (component.showtotals()) {
        var tempTotal = {};
        tempTotal.drilldown = false;
        tempTotal.Namekey = 'total';
        tempTotal.columnKey = seriesKeyNames;
        tempTotal.columnIndexKey = seriesKeyIndexes;
        tempTotal.nodeState = 'collapsed';
        tempTotal.level = 0;
        tempTotal.parentKey = 'none';
        tempTotal.name = 'Total';
        tempTotal.y = component.dataUtilityAggregation(totalForChart);
        SeriesData[0].data[component.totalnodeplacement() == 'before' ? 'unshift' : 'push'](tempTotal);
      }
      //seriesDataJson[tupleString].color = colorSeries[tupleString]||colorSeries[0];
      tempMemberCollection = null;
      seriesDataJson = null;
      return [SeriesData  /*,DrilldownData*/];
    };
  }

  /*if (validateImplementMethod(args, 'createMembersPieDataDrilldown')) {
    that.createMembersPieDataDrilldown = function(component, categoriesIndex, selectedPoints) {
      component.memberDatasCollection = [];
      var vbiCharts = new VbiCharts(component);
      var seriesLibrary = new SeriesLibrary(vbiCharts);
      $.each(selectedPoints, function(i, currentpoint) {
        component.memberDatasCollection.push(seriesLibrary.createMemberDataDrilldown(component, categoriesIndex[currentpoint.name], columnSelected));
      });

      return component.memberDatasCollection;
    };
  }*/

  if (validateImplementMethod(args, 'createMemberDataDrilldown')) {
    that.createMemberDataDrilldown = function (component, categoryName, serieskey) {
      component.memberDataCollection = {};
      var catArr = {};
      if (component.drilldownMemberjson.hasOwnProperty(categoryName)) {
        catArr = component.drilldownMemberjson[categoryName];
        component.memberDataCollection[catArr.dimension] = catArr;
      }

      catArr = [];
      if (serieskey !== undefined) {
        catArr = catArr.concat(serieskey.split('-'));
        for (var i = 0; i < catArr.length; i++) {
          var dimMemIndex = catArr[i].split(':');
          component.memberDataCollection[component.dataRes.dimensions[dimMemIndex[0]].key] = {
            'internalKey': component.dataRes.dimensions[dimMemIndex[0]].members[dimMemIndex[1]].key,
            'text': component.dataRes.dimensions[dimMemIndex[0]].members[dimMemIndex[1]]["picker_text"]
          };
        }
      }

      return JSON.stringify(component.memberDataCollection);
    };
  }
  // ****Component.JS
  if (validateImplementMethod(args, 'createHierarchySeriesData')) {
    that.createHierarchySeriesData = function (component, type, defaultValue) {
      //      alert('override')
      var self = this;
      //var count = 0;
      var defaultColor = [
        '#B586DA',
        '#FF6657',
        '#F3A730',
        '#946B66',
        '#B0AD53',
        '#7AC1DE',
        '#F1C337',
        '#566C6C',
        '#A1CC54',
        '#543F1E'
      ];
      var seriesColor = [];
      if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
        seriesColor = [];
      } else {
        seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
      }

      component.drilldownMemberjson = {};
      //var ColumnDimensionCount = component.dataRes['axis_columns'][0].indexOf(-1);
      var selectedMember = 0;
      var sortedarray = [];
      var MemberText, MemberKey;
      var rootNodes = [];
      var categories = [];
      var categoriesKey = [];
      //var noOfColumns = component.dataRes['axis_columns'][0].indexOf(-1);
      var noOfColumns = self.getNumberOfRowsColumns(component, 'COLUMNS');
      //var seriesNames;
      var seriesData = [];
      //var seriesColor = [];
      var measureColorPair = {};
      if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
        measureColorPair = JSON.parse(component.measurecolorpair());
      }

      component.ztlSelectedColumnJson = {};
      component.ztlSelectedRowJson = {};
      component.categoriesIndex = [];
      component.selectedColumnIndex = 0;
      component.selectedDimension = component.dataRes['axis_columns'][0].indexOf(-1);
      component.nodeAlignment = 'top';
      
      if (component.enablehierarchydrilldown() === true) {
          for (var i = 0; i < component.dataRes.dimensions.length; i++) {
              if (component.dataRes.dimensions[i].hasOwnProperty('hierarchy')) {
                  component.selectedDimension = i;
                  component.nodeAlignment = component.dataRes.dimensions[i].hierarchy.nodeAlignment;
                  break;
              }
          }
      }

      if (component.dataRes.dimensions[component.selectedDimension].axis == 'COLUMNS') {
        return 4;
      }

      function createSeriesData(colRowIndexJson, seriesKeyNames, tempSeriesKeyIndexes) {
        sortedarray = [];
        selectedMember = 0;
        var totalForChart = 0;
        var measureDimString = '';
        var isBottom = component.nodeAlignment === 'bottom' ? true : false;
        var len = component.dataRes.dimensions[component.selectedDimension].members.length;

        for (var i = 0; i < component.dataRes.dimensions.length; i++) {
          if (component.dataRes.dimensions[i].containsMeasures) {
            for (var j = 0; j < component.dataRes.dimensions[i].members.length; j++) {
              if (component.dataRes.dimensions[i].members[j].key == seriesKeyNames) {
                //var scalingFactor = component.dataRes.dimensions[i].members[j].scalingFactor;
                //var unitOfMeasure = component.dataRes.dimensions[i].members[j].unitOfMeasure;
                measureDimString = i + ':' + j;
              }
            }

            break;
          }
        }

        for (var i = isBottom ? len-1 : 0; (isBottom ? i >= 0 : i<len) ; isBottom ? i-- : i++) {
          if (component.showtotaldatabase() || component.dataRes.dimensions[component.selectedDimension].members[i].type != 'RESULT') {
            if (typeof component.dataRes.dimensions[component.selectedDimension].members[i].level === 'undefined' && rootNodes.indexOf(component.dataRes.dimensions[component.selectedDimension].members[i].key) == -1) {
              rootNodes.push(component.dataRes.dimensions[component.selectedDimension].members[i].key);
            }

            if (component.includerootnodes() === true && typeof component.dataRes.dimensions[component.selectedDimension].members[i].level === 'undefined' || component.includerootnodes() === false && typeof component.dataRes.dimensions[component.selectedDimension].members[i].level !== 'undefined' && component.dataRes.dimensions[component.selectedDimension].members[i].level == 1) {
              MemberText = component.dataRes.dimensions[component.selectedDimension].members[i].text;
              MemberKey = component.dataRes.dimensions[component.selectedDimension].members[i].key;
              sortedarray[selectedMember] = {};
              if (MemberText.indexOf('|') != -1) {
                var newTempCatName = MemberText.replace(/\|/g, ' ');
                //component.categoriesIndex[newTempCatName] = MemberText;
                MemberText = newTempCatName;
              } else {
              }

              var memberTextAfter = self.formatSeriesName(component, MemberText, measureDimString, { 'showunit': 'unitcurrency' });
              /*if(component.scalingfactorenable()){
                memberTextAfter += " (*" + Math.pow(10,scalingFactor) + " )";
              }
              if((component.unitcurrency() || component.showunit())&& unitOfMeasure!=""){
                memberTextAfter += " (in " + unitOfMeasure + " )";
              }*/
              sortedarray[selectedMember].name = memberTextAfter;
              sortedarray[selectedMember].Namekey = component.dataRes.dimensions[component.selectedDimension].members[i].originalKey || component.dataRes.dimensions[component.selectedDimension].members[i].key;
              sortedarray[selectedMember].keyname = sortedarray[selectedMember].Namekey;
              if (typeof component.ztlSelectedRowJson[sortedarray[selectedMember].Namekey] === 'undefined') {
                var dimKey = component.dataRes.dimensions[component.selectedDimension].key;
                component.ztlSelectedRowJson[sortedarray[selectedMember].Namekey] = {};
                component.ztlSelectedRowJson[sortedarray[selectedMember].Namekey][dimKey] = {
                  internalKey: component.dataRes.dimensions[component.selectedDimension].members[i].key,
                  text: component.dataRes.dimensions[component.selectedDimension].members[i]["picker_text"]
                };
              }

              sortedarray[selectedMember].color = measureColorPair[sortedarray[selectedMember].Namekey] ? measureColorPair[sortedarray[selectedMember].Namekey].color : self.getSeriesColors(component, seriesColor, selectedMember, defaultColor);
              sortedarray[selectedMember].columnKey = seriesKeyNames;
              sortedarray[selectedMember].columnIndexKey = tempSeriesKeyIndexes;
              sortedarray[selectedMember].parentKey = 'none';
              sortedarray[selectedMember].nodeState = 'collapsed';
              sortedarray[selectedMember].level = typeof component.dataRes.dimensions[component.selectedDimension].members[i].level == 'undefined' ? 0 : 1;
              if (categoriesKey.indexOf(MemberKey) == -1) {
                categories.push(MemberText);
              }

              sortedarray[selectedMember].drilldown = component.dataRes.dimensions[component.selectedDimension].members[i].type == 'RESULT' ? false : true;

              sortedarray[selectedMember].y = 0;
              //var aggregationCount = 0;
              var valArr = colRowIndexJson[tempSeriesKeyIndexes];
              var yArr = [];
              $.each(valArr, function (ind, k) {
                for (var j = k; j < component.dataRes.data.length; j += component.dataRes.columnCount) {
                  if (i == component.dataRes.tuples[j][component.selectedDimension] && self.vbiCharts.eliminateResult(component.dataRes, component.dataRes.tuples[j], undefined, component.showtotaldatabase()) === true) {
                    yArr.push(component.dataRes.data[j]);
                  }
                }
              });

              sortedarray[selectedMember].y = component.dataUtilityAggregation(yArr);
              totalForChart += sortedarray[selectedMember].y;
              selectedMember++;
            }
          }
        }

        if (component.showtotals()) {
          var tempTotal = {};
          tempTotal.name = 'Total';
          tempTotal.Namekey = 'total';
          tempTotal.keyname = 'total';
          tempTotal.columnKey = seriesKeyNames;
          tempTotal.color = measureColorPair[tempTotal.Namekey] ? measureColorPair[tempTotal.Namekey].color : self.getSeriesColors(component, seriesColor, selectedMember, defaultColor);
          tempTotal.columnIndexKey = tempSeriesKeyIndexes;
          tempTotal.parentKey = 'none';
          tempTotal.nodeState = 'collapsed';
          tempTotal.level = typeof component.dataRes.dimensions[component.selectedDimension].members[0].level === 'undefined' ? 0 : 1;
          tempTotal.drilldown = false;
          tempTotal.y = totalForChart;
          sortedarray[component.totalnodeplacement() == 'before' ? 'unshift' : 'push'](tempTotal);
          /* jshint expr:true */
          categories.indexOf('Total') == -1 ? categories[component.totalnodeplacement() == 'before' ? 'unshift' : 'push']('Total') : '';
        }

        return sortedarray;
      }

      if (component.datautility() /*self.globalDataUtility*/) {
        return 5;
      } else {
        var self = this;
        var measureDimensionIndex = component.getMeasureIndex();
        var measureInRow = component.dataRes.dimensions[measureDimensionIndex].axis == 'ROWS' ? true : false;
        if (measureInRow) {
          return 4;
        }

        //var selectedRowdimIndexes = [];
        //var selectedColumndimIndexes = [];
        var noOfColumns = component.dataRes['axis_columns'][0].indexOf(-1);
        //var columnsInTable = component.dataRes.columnCount;
        var scalingValues = [], unitOfMeasure = [];
        for (var i = 0; i < component.dataRes.dimensions[measureDimensionIndex].members.length; i++) {
          scalingValues.push(component.scalingfactorenable() ? component.dataRes.dimensions[measureDimensionIndex].members[i].scalingFactor || '' : '');
          unitOfMeasure.push((component.unitcurrency() || component.showunit()) ? component.dataRes.dimensions[measureDimensionIndex].members[i].unitOfMeasure || '' : '');
        }

        var seriesColor = component.dataseriescolor().split(',');
        var defaultColor = [
          '#B586DA',
          '#FF6657',
          '#F3A730',
          '#946B66',
          '#B0AD53',
          '#7AC1DE',
          '#F1C337',
          '#566C6C',
          '#A1CC54',
          '#543F1E'
        ];
        if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
          seriesColor = [];
        } else {
          seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
        }

        component.measureJson = {};
        $.each(component.dataRes.dimensions[measureDimensionIndex].members, function (key, value) {
          component.measureJson[value.key] = {
            text: value.text,
            index: key,
            indexKey: i + ':' + key,
            unitOfMeasure: value.unitOfMeasure || '',
            scalingFactor: value.scalingFactor || 0
          };
        });

        var selectedMeasureIndex = 0;
        var selectedMeasureKey = component.dataRes.dimensions[measureDimensionIndex].members[selectedMeasureIndex].key;
        if (component.hasOwnProperty('measurelist') && component.measurelist() !== undefined && component.measurelist() !== null && component.measurelist() !== "null" && component.measurelist() !== '') {
          $.each(component.measureJson, function (key, jsonVal) {
            if (jsonVal.text == component.measurelist()) {
              selectedMeasureKey = key;
              selectedMeasureIndex = jsonVal.index;
              return;
            }
          });

          component.measurelist('');
        } else if (component.selectedmeasures() !== undefined && component.selectedmeasures() !== null && component.selectedmeasures() !== '') {
          selectedMeasureKey = component.selectedmeasures();
          selectedMeasureIndex = component.measureJson[selectedMeasureKey].index;
        }

        component.selectedmeasures(selectedMeasureKey);
        var seriesData = [];
        var colRowIndexJson = {}, colNamesJson = {};
        var tempTuple = [];
        //var tuplesInARow = component.dataRes.tuples.slice(0, component.dataRes.columnCount);
        // Getting tuples for all Columns in first row of crosstab.
        for (var i = 0; i < component.dataRes['columnCount']; i++) {
          tempTuple = component.dataRes.tuples[i].slice(0, noOfColumns);
          if (self.vbiCharts.eliminateResult(component.dataRes, tempTuple, undefined, component.showtotaldatabase()) === true) {
            var colKey = '';
            var colName = '';
            var columnKey = '';
            var tempZtlColJson = {};
            if (tempTuple[measureDimensionIndex] == selectedMeasureIndex) {
              colName = component.dataRes.dimensions[measureDimensionIndex].members[selectedMeasureIndex].text;
              columnKey = component.dataRes.dimensions[measureDimensionIndex].members[selectedMeasureIndex].key;
              colKey = measureDimensionIndex + ':' + selectedMeasureIndex;
              tempZtlColJson[component.dataRes.dimensions[measureDimensionIndex].key] = {
                'internalKey': columnKey,
                'text': colName
              };
              component.ztlSelectedColumnJson[columnKey] = $.extend({}, tempZtlColJson);
              var scalingText = scalingValues[selectedMeasureIndex] === '' ? '' : ' (* ' + Math.pow(10, scalingValues[selectedMeasureIndex]) + ' )';
              var uintOfMeasureText = unitOfMeasure[selectedMeasureIndex];
              var seriesName = colName; /*+ '' + scalingText;
              seriesName = seriesName + ' ' + uintOfMeasureText;*/
              var sereisColumnKey = columnKey;
              if (typeof colRowIndexJson[colKey] == 'undefined') {
                colRowIndexJson[colKey] = [];
                seriesData.push({
                  name: seriesName,
                  backButton: component.dataRes.dimensions[component.selectedDimension]["picker_text"],
                  key: colKey,
                  id: 'Series-' + colKey,
                  columnIndexKey: colKey,
                  columnKey: columnKey,
                  seriesname: colName,
                  seriesKeyName: sereisColumnKey,
                  unitOfMeasure: uintOfMeasureText,
                  scalingFactor: scalingText,
                  data: []
                });
              }

              colRowIndexJson[colKey].push(i);
              colNamesJson[colKey] = {
                'text': seriesName,
                'key': sereisColumnKey,
                'unitOfMeasure': uintOfMeasureText,
                'scalingFactor': scalingText
              };
            }
          }
        }

        component['col_row_index_json'] = {};
        component['col_row_index_json'] = colRowIndexJson;
        seriesData[0].data = createSeriesData(colRowIndexJson, seriesData[0].seriesKeyName, seriesData[0].key);
        if (type == 'funneldd') {
          self.getSortedDimMembers(component, seriesData);
        }
        defaultValue.series = seriesData;
      }
      //console.log("seriesData="+JSON.stringify(seriesData));
      component.rootnodes(rootNodes.join());
      component.selecteddimension(component.dataRes.dimensions[component.selectedDimension].key);
      if (!component.includerootnodes() && (component.showtotals() && seriesData[0].data.length == 1 || !component.showtotals() && seriesData[0].data.length === 0)) {
        component.firePropertiesChangedAndEvent([
          'rootnodes',
          'selecteddimension'
        ], 'onHRootExpand');
      }

      return 0;  //defaultValue.drilldown.series = ddsortedarray;
    };
  }

  if (validateImplementMethod(args, 'getSortedDimMembers')) {
    this.getSortedDimMembers = function (component, seriesData) {
      $.each(seriesData, function (key, json) {
        switch (component.funnelsort()) {
          case 'Initial View':
            for (var i = 0; i < json.data.length; i++) {
              for (var j = 0; j < json.data.length - 1; j++) {
                if (json.data[i].data > json.data[j].data) {
                  var temp = json.data[i];
                  json.data[i] = json.data[j];
                  json.data[j] = temp;  //  component.categoryInOriginalSeries[json.data[i].keyName] = i;
                }
              }
            }
            break;
          case 'Dimensiontext-Ascending':
            json.data.sort(function (a, b) {
              var firstText = a.name.toUpperCase();
              var secondText = b.name.toUpperCase();
              return firstText.localeCompare(secondText);
            });
            break;
          case 'Dimensiontext-Descending':
            json.data.sort(function (a, b) {
              var firstText = a.name.toUpperCase();
              var secondText = b.name.toUpperCase();
              return secondText.localeCompare(firstText);
            });
            break;
          case 'Dimensionkey-Ascending':
            json.data.sort(function (a, b) {
              var firstText = a.keyname.toUpperCase();
              var secondText = b.keyname.toUpperCase();
              return firstText.localeCompare(secondText);
            });
            break;
          case 'Dimensionkey-Descending':
            json.data.sort(function (a, b) {
              var firstText = a.keyname.toUpperCase();
              var secondText = b.keyname.toUpperCase();
              return secondText.localeCompare(firstText);
            });
            break;
        }
      });
    };
  }

  if (validateImplementMethod(args, 'createSeriesData')) {
    /**
         * Map data from JSON Tuple to Highchart
         * @param {object} component - Reference to component
         * @param {string} type - type of the chart
         * @param {object} defaultValue - HighCharts values
         * @return {Array} seriesNames
         */
    that.createSeriesData = function (component, type, defaultValue) {
      //      alert('overriden');
      var self = this;
      var measureDimensionIndex = component.getMeasureIndex();
      var measureInRow = component.dataRes.dimensions[measureDimensionIndex].axis == 'ROWS' ? true : false;
      var selectedRowdimIndexes = [];
      var selectedColumndimIndexes = [];
      var noOfColumns = component.dataRes['axis_columns'][0].indexOf(-1);
      var columnsInTable = component.dataRes.columnCount;
      var scalingValues = [], unitOfMeasure = [];
      for (var i = 0; i < component.dataRes.dimensions[measureDimensionIndex].members.length; i++) {
        scalingValues.push(component.scalingfactorenable() ? component.dataRes.dimensions[measureDimensionIndex].members[i].scalingFactor || '' : '');
        unitOfMeasure.push((component.unitcurrency() || component.showunit()) ? component.dataRes.dimensions[measureDimensionIndex].members[i].unitOfMeasure || '' : '');
      }

      var seriesColor = component.dataseriescolor().split(',');
      var defaultColor = [
        '#B586DA',
        '#FF6657',
        '#F3A730',
        '#946B66',
        '#B0AD53',
        '#7AC1DE',
        '#F1C337',
        '#566C6C',
        '#A1CC54',
        '#543F1E'
      ];
      if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
        seriesColor = [];
      } else {
        seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
      }

      var measureColorPair = {};
      if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
        measureColorPair = JSON.parse(component.measurecolorpair());
      }

      component.categoriesIndex = [];
      var bardatacustomizationJson = self.getBarDataCustomization(component);
      var dimensionInRow = true;
      var alldimTogether = false;
      component.ztlSelectedColumnJson = {};
      component.ztlSelectedRowJson = {};
      if (measureInRow) {
        selectedRowdimIndexes.push(measureDimensionIndex);
        // if (component.datautility()) {
        //   if (bardatacustomizationJson['COLUMNS'].length !== 0) {
        //     $.each(bardatacustomizationJson['COLUMNS'], function (index, value) {
        //       selectedColumndimIndexes.push(_.parseInt(value.index));
        //     });

        //     dimensionInRow = false;
        //   } else if (bardatacustomizationJson['ROWS'].length !== 0) {
        //     alldimTogether = true;
        //     $.each(bardatacustomizationJson['ROWS'], function (index, value) {
        //       selectedColumndimIndexes.push(_.parseInt(value.index));
        //     });
        //   }

        //   if (selectedColumndimIndexes.length < 2) {
        //     return 1;
        //   }
        // } else 
        {
          for (var i = 0; i < component.dataRes.dimensions.length; i++) {
            if (component.dataRes.dimensions[i].axis == 'COLUMNS') {
              selectedColumndimIndexes.push(i);
            }
          }

          if (selectedColumndimIndexes.length === 0) {
            dimensionInRow = true;
            alldimTogether = true;
            for (var i = 0; i < component.dataRes.dimensions.length; i++) {
              if (component.dataRes.dimensions[i].axis == 'ROWS' && !component.dataRes.dimensions[i].hasOwnProperty('containsMeasures')) {
                selectedColumndimIndexes.push(i);
              }
            }
          } else {
            dimensionInRow = false;
          }

          if (selectedColumndimIndexes.length < 2) {
            return 1;
          }
        }
      } else {
        selectedColumndimIndexes.push(measureDimensionIndex);
        if (component.datautility()) {
          if (bardatacustomizationJson['ROWS'].length !== 0) {
            $.each(bardatacustomizationJson['ROWS'], function (index, value) {
              selectedRowdimIndexes.push(_.parseInt(value.index));
            });
          } else if (bardatacustomizationJson['COLUMNS'].length !== 0) {
            dimensionInRow = false;
            alldimTogether = true;
            $.each(bardatacustomizationJson['COLUMNS'], function (index, value) {
              selectedRowdimIndexes.push(_.parseInt(value.index));
            });
          }

          if (selectedRowdimIndexes.length < 2) {
            return 1;
          }
        } else {
          for (var i = noOfColumns; i < component.dataRes.dimensions.length; i++) {
            if (!component.dataRes.dimensions[i].hasOwnProperty('containsMeasures')) {
              selectedRowdimIndexes.push(i);
            }
          }

          if (selectedRowdimIndexes.length === 0) {
            dimensionInRow = false;
            alldimTogether = true;
            for (var i = 0; i < noOfColumns; i++) {
              if (!component.dataRes.dimensions[i].hasOwnProperty('containsMeasures')) {
                selectedRowdimIndexes.push(i);
              }
            }
          }

          if (selectedRowdimIndexes.length < 2) {
            return 1;
          }
        }
      }

      component.measureJson = {};
      $.each(component.dataRes.dimensions[measureDimensionIndex].members, function (key, value) {
        component.measureJson[value.key] = {
          text: value.text,
          index: key,
          indexKey: i + ':' + key,
          unitOfMeasure: value.unitOfMeasure || '',
          scalingFactor: value.scalingFactor || 0
        };
      });

      var selectedMeasureIndex = 0;
      var selectedMeasureKey = component.dataRes.dimensions[measureDimensionIndex].members[selectedMeasureIndex].key;
      if (component.hasOwnProperty('measurelist') && component.measurelist() !== undefined && component.measurelist() !== null && component.measurelist() !== "null" && component.measurelist() !== '') {
        $.each(component.measureJson, function (key, jsonVal) {
          if (jsonVal.text == component.measurelist()) {
            selectedMeasureKey = key;
            selectedMeasureIndex = jsonVal.index;
            return;
          }
        });

        component.measurelist('');
      } else if (component.selectedmeasures() !== undefined && component.selectedmeasures() !== null && component.selectedmeasures() !== '') {
        selectedMeasureKey = component.selectedmeasures();
        selectedMeasureIndex = component.measureJson[selectedMeasureKey].index;
      }

      component.selectedmeasures(selectedMeasureKey);
      var seriesData = [];
      var colRowIndexJson = {}, colNamesJson = {};
      var tempTuple = [];
      var showtotaldatabase = component.showtotaldatabase();
      var hasResultIntupleCol = {};
      //var tuplesInARow = component.dataRes.tuples.slice(0, component.dataRes.columnCount);
      var measureDimString = "";
      // Getting tuples for all Columns in first row of crosstab.
      for (var i = 0; i < component.dataRes[measureInRow ? 'rowCount' : 'columnCount']; i++) {
        if (measureInRow) {
          tempTuple = component.dataRes.tuples[i * columnsInTable];
        } else {
          tempTuple = component.dataRes.tuples[i].slice(0, noOfColumns);
        }

        if (self.vbiCharts.eliminateResult(component.dataRes, tempTuple, measureInRow ? 'ROWS' : 'COLUMNS', component.showtotaldatabase()) === true) {
          var colKey = '';
          var colName = '';
          var columnKey = '';
          var tempZtlColJson = {};
          if (tempTuple[measureDimensionIndex] == selectedMeasureIndex) {
            colName = component.dataRes.dimensions[measureDimensionIndex].members[selectedMeasureIndex].text;
            columnKey = component.dataRes.dimensions[measureDimensionIndex].members[selectedMeasureIndex].key;
            colKey = measureDimensionIndex + ':' + selectedMeasureIndex;

            tempZtlColJson[component.dataRes.dimensions[measureDimensionIndex].key] = {
              'internalKey': columnKey,
              'text': colName
            };
            component.ztlSelectedColumnJson[columnKey] = $.extend({}, tempZtlColJson);

            var scalingText = scalingValues[selectedMeasureIndex] === '' ? '' : ' (* ' + Math.pow(10, scalingValues[selectedMeasureIndex]) + ' )';
            var uintOfMeasureText = unitOfMeasure[selectedMeasureIndex];
            measureDimString = measureDimensionIndex + ':' + selectedMeasureIndex;
            var seriesName = colName; /*+ '' + scalingText;
            seriesName = seriesName + ' ' + uintOfMeasureText;*/
            var sereisColumnKey = columnKey;
            if (typeof colRowIndexJson[colKey] == 'undefined') {
              colRowIndexJson[colKey] = [];
              seriesData.push({
                name: seriesName,
                key: colKey,
                id: 'Series-' + colKey,
                columnIndexKey: colKey,
                columnKey: columnKey,
                seriesname: colName,
                seriesKeyName: sereisColumnKey,
                unitOfMeasure: uintOfMeasureText,
                scalingFactor: scalingText,
                data: []
              });
            }

            colRowIndexJson[colKey].push(i);
            if (showtotaldatabase) {
              hasResultIntupleCol[i] = [];
              for (var j = 0, jLen = tempTuple.length; j < jLen; j++) {
                if (component.dataRes.dimensions[j].members[tempTuple[j]].type == "RESULT") {
                  hasResultIntupleCol[i].push(j);
                }
              }
            }
            colNamesJson[colKey] = {
              'text': seriesName,
              'key': sereisColumnKey,
              'unitOfMeasure': uintOfMeasureText,
              'scalingFactor': scalingText
            };
          }
        }
      }

      var tupleToSkip = 0;
      var tuplesInColumn = [];
      var rowNames = {};
      var rowDataJson = {};
      var rowDataJsonWithInfo = {};
      var rowDataJsonWithInfoDrilldown = {};
      var drilldownSeries = {};
      var positionJson = {};
      var dimToBeConsideredForRow = measureInRow ? selectedColumndimIndexes : selectedRowdimIndexes;
      //console.log("dimToBeConsideredForRow="+dimToBeConsideredForRow);
      //var dimensionInRow = (selectedRowdimIndexes.length>=2 ? true : false );
      var hasResultIntuple = {};

      if (alldimTogether) {
        var indexesToConsider = [];
        if (measureInRow) {
          for (var i = 0; i < component.dataRes.columnCount; i++) {
            if (self.vbiCharts.eliminateResult(component.dataRes, component.dataRes.tuples[i].slice(0, noOfColumns), undefined, component.showtotaldatabase()) === true) {
              indexesToConsider.push(i);
              /*#VBX141-4729*/
              if (showtotaldatabase) {
                var tempTuple = component.dataRes.tuples[i];
                hasResultIntuple[i] = [];
                for (var j = 0, tLen = noOfColumns; j < tLen; j++) {
                  if (component.dataRes.dimensions[j].members[tempTuple[j]].type == "RESULT") {
                    hasResultIntuple[i].push(tempTuple[j]);
                  }
                }
              }
            }
          }
        } else {
          for (var i = 0; i < component.dataRes.rowCount; i++) {
            var tempIndex = i * component.dataRes.columnCount;
            if (self.vbiCharts.eliminateResult(component.dataRes, component.dataRes.tuples[tempIndex], 'ROWS', component.showtotaldatabase()) === true) {
              indexesToConsider.push(i);
              /*#VBX141-4729*/
              if (showtotaldatabase) {
                var tempTuple = component.dataRes.tuples[tempIndex];
                hasResultIntuple[i] = [];
                for (var j = noOfColumns, tLen = tempTuple.length; j < tLen; j++) {
                  if (component.dataRes.dimensions[j].members[tempTuple[j]].type == "RESULT") {
                    hasResultIntuple[i].push(tempTuple[j]);
                  }
                }
              }
            }
          }
        }

        $.each(colRowIndexJson, function (key, value) {
          var yArr = [];
          var yArrTotal = [];
          var curIndex = 0;
          $.each(value, function (index, newval) {
            if (measureInRow) {
              curIndex = newval * columnsInTable + tupleToSkip;
            } else {
              curIndex = newval + tupleToSkip;
            }
            //yArr.push(component.dataRes.data[curIndex] || 0 );
            var tempTuple = component.dataRes.tuples[curIndex];

            var rowKey = 0;
            var rowHeader = '';
            var rowKeyArr = [];
            for (var j = 0; j < dimToBeConsideredForRow.length; j++) {
              if (j === 0) {
                //rowKey = dimToBeConsideredForRow[j] + ':' + tempTuple[dimToBeConsideredForRow[j]];
                rowKey = component.dataRes.dimensions[dimToBeConsideredForRow[j]].key.replace(/-/g, '_') + ':' + component.dataRes.dimensions[dimToBeConsideredForRow[j]].members[tempTuple[dimToBeConsideredForRow[j]]].key.replace(/-/g, '_');
              } else {
                //rowKey += '-' + dimToBeConsideredForRow[j] + ':' + tempTuple[dimToBeConsideredForRow[j]];
                rowKey += '-' + component.dataRes.dimensions[dimToBeConsideredForRow[j]].key.replace(/-/g, '_') + ':' + component.dataRes.dimensions[dimToBeConsideredForRow[j]].members[tempTuple[dimToBeConsideredForRow[j]]].key.replace(/-/g, '_');
              }
              rowHeader = component.dataRes.dimensions[dimToBeConsideredForRow[j]].members[tempTuple[dimToBeConsideredForRow[j]]].text;

              rowKeyArr.push(rowKey);
              if (typeof rowNames[rowKey] === 'undefined') {
                //rowDataJson[rowKey]=[];
                rowNames[rowKey] = rowHeader;
                if (typeof component.ztlSelectedRowJson[rowKey] === 'undefined') {
                  var dimKey = component.dataRes.dimensions[dimToBeConsideredForRow[j]].key;
                  component.ztlSelectedRowJson[rowKey] = {};
                  component.ztlSelectedRowJson[rowKey][dimKey] = {
                    internalKey: component.dataRes.dimensions[dimToBeConsideredForRow[j]].members[tempTuple[dimToBeConsideredForRow[j]]].key,
                    text: component.dataRes.dimensions[dimToBeConsideredForRow[j]].members[tempTuple[dimToBeConsideredForRow[j]]]["picker_text"]
                  };
                }
              }
            }

            $.each(rowKeyArr, function (rowInd, ele) {
              var seriesKeyName = colNamesJson[key].key;
              var keygen = ele + '-' + seriesKeyName;
              yArr = [];
              yArrTotal = [];
              if (rowDataJson[keygen] === undefined) {
                rowDataJson[keygen] = [];
                rowDataJsonWithInfo[keygen] = [];
              }


              var parsedData;
              if (measureInRow) {
                $.each(indexesToConsider, function (arrIndex, colIndex) {
                  parsedData = /*component.dataRes.data[curIndex + colIndex] === null ? 0 : */component.dataRes.data[curIndex + colIndex];
                  rowDataJson[keygen].push(parsedData);
                  yArr.push(parsedData);

                  if (showtotaldatabase && (hasResultIntuple[colIndex].length || hasResultIntupleCol[newval].length)) {
                    var lastTempStore, lastTempstoreLen = 0;
                    var totalLen = hasResultIntupleCol[newval].length + hasResultIntuple[colIndex].length;
                    if (rowDataJsonWithInfo[keygen].length) {
                      lastTempStore = rowDataJsonWithInfo[keygen][rowDataJsonWithInfo[keygen].length - 1];
                      lastTempstoreLen = Number(lastTempStore[0]);
                    }
                    if (lastTempstoreLen < totalLen) {
                      rowDataJsonWithInfo[keygen].length = 0;
                    }
                    rowDataJsonWithInfo[keygen].push([totalLen, parsedData]);

                    // processing yArrTotal
                    lastTempstoreLen = 0;
                    if (yArrTotal.length) {
                      lastTempStore = yArrTotal[yArrTotal.length - 1];
                      lastTempstoreLen = Number(lastTempStore[0]);
                    }
                    if (lastTempstoreLen < totalLen) {
                      yArrTotal.length = 0;
                    }
                    yArrTotal.push([totalLen, parsedData]);
                  }
                });
              } else {
                $.each(indexesToConsider, function (arrIndex, rowIndex) {
                  parsedData = /*component.dataRes.data[curIndex + rowIndex * columnsInTable] === null ? 0 : */component.dataRes.data[curIndex + rowIndex * columnsInTable];
                  rowDataJson[keygen].push(parsedData);
                  yArr.push(parsedData);

                  if (showtotaldatabase && (hasResultIntuple[rowIndex].length || hasResultIntupleCol[newval].length)) {
                    var lastTempStore, lastTempstoreLen = 0;
                    var totalLen = hasResultIntupleCol[newval].length + hasResultIntuple[rowIndex].length;
                    if (rowDataJsonWithInfo[keygen].length) {
                      lastTempStore = rowDataJsonWithInfo[keygen][rowDataJsonWithInfo[keygen].length - 1];
                      lastTempstoreLen = Number(lastTempStore[0]);
                    }
                    if (lastTempstoreLen < totalLen) {
                      rowDataJsonWithInfo[keygen].length = 0;
                    }
                    rowDataJsonWithInfo[keygen].push([totalLen, parsedData]);

                    // processing yArrTotal
                    lastTempstoreLen = 0;
                    if (yArrTotal.length) {
                      lastTempStore = yArrTotal[yArrTotal.length - 1];
                      lastTempstoreLen = Number(lastTempStore[0]);
                    }
                    if (lastTempstoreLen < totalLen) {
                      yArrTotal.length = 0;
                    }
                    yArrTotal.push([totalLen, parsedData]);
                  }
                });
              }

              if (rowInd != rowKeyArr.length - 1) {
                if (!drilldownSeries[keygen]) {
                  drilldownSeries[keygen] = {
                    id: ele,
                    name: colNamesJson[key].text,
                    columnIndexKey: key,
                    seriesname: colNamesJson[key].text,
                    seriesKeyName: seriesKeyName,
                    unitOfMeasure: colNamesJson[key].unitOfMeasure,
                    scalingFactor: colNamesJson[key].scalingFactor,
                    columnKey: seriesKeyName,
                    value: [],
                    data: []
                  };
                  positionJson[keygen] = {};  // all the sereis details
                }
              }

              if (rowInd > 0) {
                var parentKey = ele.slice(0, ele.lastIndexOf('-'));
                var parentKeygen = parentKey + '-' + seriesKeyName;
                if (positionJson[parentKeygen].hasOwnProperty(ele)) {
                  var currentYArr = drilldownSeries[parentKeygen].data[positionJson[parentKeygen][ele]].y;
                  currentYArr = currentYArr.concat(yArr);
                  drilldownSeries[parentKeygen].data[positionJson[parentKeygen][ele]].y = currentYArr;
                } else {
                  var temNam = rowNames[ele];
                  temNam = self.formatSeriesName(component, temNam, measureDimString, { 'showunit': 'unitcurrency' });

                  var keyEle = ele.slice(ele.lastIndexOf('-') + 1);
                  var KeyEleArr = keyEle.split(":");
                  var keyname = KeyEleArr[0];
                  //var keyname = component.dataRes.dimensions[KeyEleArr[0]].members[KeyEleArr[1]].key;

                  /*if(component.scalingfactorenable())
                  {
                    if(colNamesJson[key].scalingFactor)
                      temNam +=colNamesJson[key].scalingFactor;
                    else
                      temNam +=" (* 1)";
                  }
                  if((component.unitcurrency() || component.showunit()) && colNamesJson[key].unitOfMeasure!="")
                  {
                      temNam += " (in " +  colNamesJson[key].unitOfMeasure + ")";
                  }*/
                  positionJson[parentKeygen][ele] = drilldownSeries[parentKeygen].data.length;
                  //drilldownSeries[parentKeygen].backButton = component.dataRes.dimensions[ele.slice(ele.lastIndexOf('-') + 1, ele.length).split(':')[0]].text;
                  var backButtonText = _.find(component.dataRes.dimensions, {'key' : keyname});
                  drilldownSeries[parentKeygen].backButton = backButtonText ? backButtonText["picker_text"] : '';
                  drilldownSeries[parentKeygen].data.push({
                    drilldown: rowInd < rowKeyArr.length - 1 ? true : false,
                    name: temNam,
                    Namekey: ele,
                    keyname: keyname,
                    parentKey: parentKey,
                    level: rowInd,
                    nodeState: 'collapsed',
                    columnKey: colNamesJson[key].key,
                    columnIndexKey: key,
                    y: yArr
                  });
                }

                drilldownSeries[parentKeygen].value = drilldownSeries[parentKeygen].value.concat(yArr);

                if (typeof rowDataJsonWithInfoDrilldown[parentKeygen] === "undefined") {
                  rowDataJsonWithInfoDrilldown[parentKeygen] = {
                    "value": [],
                    "data": []
                  };
                }

                var pos = positionJson[parentKeygen][ele];
                rowDataJsonWithInfoDrilldown[parentKeygen].data[pos] = [];
                /*#VBX141-4729*/
                if (showtotaldatabase && yArrTotal.length) {
                  var lastTempStore, lastTempstoreLen = 0;
                  var totalLen = Number(yArrTotal[0][0]);

                  // do for value
                  if (rowDataJsonWithInfoDrilldown[parentKeygen].value.length) {
                    lastTempStore = rowDataJsonWithInfoDrilldown[parentKeygen].value[rowDataJsonWithInfoDrilldown[parentKeygen].value.length - 1];
                    lastTempstoreLen = Number(lastTempStore[0]);
                  }
                  if (lastTempstoreLen < totalLen) {
                    rowDataJsonWithInfoDrilldown[parentKeygen].value.length = 0;
                  }
                  rowDataJsonWithInfoDrilldown[parentKeygen].value = rowDataJsonWithInfoDrilldown[parentKeygen].value.concat(yArrTotal);

                  // do for data
                  lastTempstoreLen = 0;

                  if (rowDataJsonWithInfoDrilldown[parentKeygen].data[pos].length) {
                    lastTempStore = rowDataJsonWithInfoDrilldown[parentKeygen].data[pos][rowDataJsonWithInfoDrilldown[parentKeygen].data[pos].length - 1];
                    lastTempstoreLen = Number(lastTempStore[0]);
                  }
                  if (lastTempstoreLen < totalLen) {
                    rowDataJsonWithInfoDrilldown[parentKeygen].data[pos].length = 0;
                  }
                  rowDataJsonWithInfoDrilldown[parentKeygen].data[pos] = rowDataJsonWithInfoDrilldown[parentKeygen].data[pos].concat(yArrTotal);
                }


              }
            });
          });
        });
      } else {
        try {
          for (var i = 0; i < component.dataRes[dimensionInRow ? 'rowCount' : 'columnCount']; i++) {
            //rowDataArr.push([]);
            if (measureInRow) {
              tupleToSkip = i;
            } else {
              tupleToSkip = component.dataRes.columnCount * i;
            }

            tuplesInColumn.push(component.dataRes.tuples[tupleToSkip]);
            var tempTuple = tuplesInColumn[i];
            var curTuple;

            if (showtotaldatabase) {
              hasResultIntuple[i] = [];
              if (dimensionInRow) {
                for (var j = noOfColumns, jLen = tempTuple.length; j < jLen; j++) {
                  if (component.dataRes.dimensions[j].members[tempTuple[j]].type == "RESULT") {
                    hasResultIntuple[i].push(j);
                  }
                }
              }
              else {
                for (var j = 0, jLen = noOfColumns; j < jLen; j++) {
                  if (component.dataRes.dimensions[j].members[tempTuple[j]].type == "RESULT") {
                    hasResultIntuple[i].push(j);
                  }
                }
              }
            }

            if (self.vbiCharts.eliminateResult(component.dataRes, tempTuple, dimensionInRow ? 'ROWS' : 'COLUMNS', component.showtotaldatabase()) === true) {
              var rowKey = 0;
              var rowHeader = 'Dimensions';
              var rowKeyArr = [];
              for (var j = 0; j < dimToBeConsideredForRow.length; j++) {
                if (j === 0) {
                  rowKey = component.dataRes.dimensions[dimToBeConsideredForRow[0]].key.replace(/-/g, '_') + ':' + component.dataRes.dimensions[dimToBeConsideredForRow[0]].members[tempTuple[dimToBeConsideredForRow[0]]].key.replace(/-/g, '_');
                  rowHeader = component.dataRes.dimensions[dimToBeConsideredForRow[0]].members[tempTuple[dimToBeConsideredForRow[0]]].text;
                } else {
                  rowKey += '-' + component.dataRes.dimensions[dimToBeConsideredForRow[j]].key.replace(/-/g, '_') + ':' + component.dataRes.dimensions[dimToBeConsideredForRow[j]].members[tempTuple[dimToBeConsideredForRow[j]]].key.replace(/-/g, '_');
                  // jscs:disable
                  rowHeader /*+= '\\'*/ = component.dataRes.dimensions[dimToBeConsideredForRow[j]].members[tempTuple[dimToBeConsideredForRow[j]]].text;  // jscs:enable
                }

                rowKeyArr.push(rowKey);
                if (typeof rowNames[rowKey] === 'undefined') {
                  //rowDataJson[rowKey]=[];
                  rowNames[rowKey] = rowHeader;
                  if (typeof component.ztlSelectedRowJson[rowKey] === 'undefined') {
                    var dimKey = component.dataRes.dimensions[dimToBeConsideredForRow[j]].key;
                    component.ztlSelectedRowJson[rowKey] = {};
                    component.ztlSelectedRowJson[rowKey][dimKey] = {
                      internalKey: component.dataRes.dimensions[dimToBeConsideredForRow[j]].members[tempTuple[dimToBeConsideredForRow[j]]].key,
                      text: component.dataRes.dimensions[dimToBeConsideredForRow[j]].members[tempTuple[dimToBeConsideredForRow[j]]]["picker_text"]
                    };
                  }
                }
              }

              $.each(colRowIndexJson, function (key, value) {
                $.each(rowKeyArr, function (rowInd, ele) {
                  var seriesKeyName = colNamesJson[key].key;
                  var keygen = ele + '-' + seriesKeyName;
                  if (rowDataJson[keygen] === undefined) {
                    rowDataJson[keygen] = [];
                    rowDataJsonWithInfo[keygen] = [];
                  }

                  if (rowInd != rowKeyArr.length - 1) {
                    if (!drilldownSeries[keygen]) {
                      drilldownSeries[keygen] = {
                        id: ele,
                        name: colNamesJson[key].text,
                        columnIndexKey: key,
                        seriesname: colNamesJson[key].text,
                        seriesKeyName: seriesKeyName,
                        unitOfMeasure: colNamesJson[key].unitOfMeasure,
                        scalingFactor: colNamesJson[key].scalingFactor,
                        columnKey: seriesKeyName,
                        value: [],
                        data: []
                      };
                      positionJson[keygen] = {};  // all the sereis details
                    }
                  }

                  var yArr = [];
                  var yArrTotal = [];
                  var curIndex = 0;
                  var parsedData;
                  $.each(value, function (index, newval) {
                    if (measureInRow) {
                      curIndex = newval * columnsInTable + tupleToSkip;
                    } else {
                      curIndex = newval + tupleToSkip;
                    }

                    yArr.push(component.dataRes.data[curIndex] /*|| 0*/);
                    rowDataJson[keygen].push(component.dataRes.data[curIndex] /*|| 0*/);
                    parsedData = /*component.dataRes.data[curIndex] === null ? 0 : */component.dataRes.data[curIndex];
                    if (showtotaldatabase && (hasResultIntuple[i].length || hasResultIntupleCol[newval].length)) {
                      var lastTempStore, lastTempstoreLen = 0;
                      var totalLen = hasResultIntupleCol[newval].length + hasResultIntuple[i].length;
                      if (rowDataJsonWithInfo[keygen].length) {
                        lastTempStore = rowDataJsonWithInfo[keygen][rowDataJsonWithInfo[keygen].length - 1];
                        lastTempstoreLen = Number(lastTempStore[0]);
                      }
                      if (lastTempstoreLen < totalLen) {
                        rowDataJsonWithInfo[keygen].length = 0;
                      }
                      rowDataJsonWithInfo[keygen].push([totalLen, parsedData]);

                      // processing yArrTotal
                      lastTempstoreLen = 0;
                      if (yArrTotal.length) {
                        lastTempStore = yArrTotal[yArrTotal.length - 1];
                        lastTempstoreLen = Number(lastTempStore[0]);
                      }
                      if (lastTempstoreLen < totalLen) {
                        yArrTotal.length = 0;
                      }
                      yArrTotal.push([totalLen, parsedData]);
                    }
                  });

                  if (rowInd > 0) {
                    var parentKey = ele.slice(0, ele.lastIndexOf('-'));
                    var parentKeygen = parentKey + '-' + seriesKeyName;
                    if (positionJson[parentKeygen].hasOwnProperty(ele)) {
                      var currentYArr = drilldownSeries[parentKeygen].data[positionJson[parentKeygen][ele]].y;
                      currentYArr = currentYArr.concat(yArr);
                      drilldownSeries[parentKeygen].data[positionJson[parentKeygen][ele]].y = currentYArr;
                    } else {

                      var temNam = rowNames[ele];
                      temNam = self.formatSeriesName(component, temNam, measureDimString, { 'showunit': 'unitcurrency' });

                      var keyEle = ele.slice(ele.lastIndexOf('-') + 1);
                      var KeyEleArr = keyEle.split(":");
                      var keyname = KeyEleArr[0];
                      //var keyname = component.dataRes.dimensions[KeyEleArr[0]].members[KeyEleArr[1]].key;

                      /*if(component.scalingfactorenable())
                      {
                        if(colNamesJson[key].scalingFactor)
                          temNam +=colNamesJson[key].scalingFactor;
                        else
                          temNam +=" (* 1)";
                      }
                      if((component.unitcurrency() || component.showunit()) && colNamesJson[key].unitOfMeasure!="")
                      {
                          temNam += " (in " +  colNamesJson[key].unitOfMeasure + ")";
                      }*/
                      positionJson[parentKeygen][ele] = drilldownSeries[parentKeygen].data.length;
                      //drilldownSeries[parentKeygen].backButton = component.dataRes.dimensions[ele.slice(ele.lastIndexOf('-') + 1, ele.length).split(':')[0]].text;
                      var backButtonText = _.find(component.dataRes.dimensions, { 'key' : keyname});
                      drilldownSeries[parentKeygen].backButton = backButtonText ? backButtonText["picker_text"] : '';
                      drilldownSeries[parentKeygen].data.push({
                        drilldown: rowInd < rowKeyArr.length - 1 ? true : false,
                        name: temNam,
                        Namekey: ele,
                        keyname: keyname,
                        parentKey: parentKey,
                        level: rowInd,
                        nodeState: 'collapsed',
                        columnKey: colNamesJson[key].key,
                        columnIndexKey: key,
                        y: yArr
                      });
                    }

                    drilldownSeries[parentKeygen].value = drilldownSeries[parentKeygen].value.concat(yArr);

                    if (typeof rowDataJsonWithInfoDrilldown[parentKeygen] === "undefined") {
                      rowDataJsonWithInfoDrilldown[parentKeygen] = {
                        "value": [],
                        "data": []
                      };
                    }
                    var pos = positionJson[parentKeygen][ele];
                    rowDataJsonWithInfoDrilldown[parentKeygen].data[pos] = [];

                    /*#VBX141-4729*/
                    if (showtotaldatabase && yArrTotal.length) {
                      var lastTempStore, lastTempstoreLen = 0;
                      var totalLen = Number(yArrTotal[0][0]);

                      // do for value
                      if (rowDataJsonWithInfoDrilldown[parentKeygen].value.length) {
                        lastTempStore = rowDataJsonWithInfoDrilldown[parentKeygen].value[rowDataJsonWithInfoDrilldown[parentKeygen].value.length - 1];
                        lastTempstoreLen = Number(lastTempStore[0]);
                      }
                      if (lastTempstoreLen < totalLen) {
                        rowDataJsonWithInfoDrilldown[parentKeygen].value.length = 0;
                      }
                      rowDataJsonWithInfoDrilldown[parentKeygen].value = rowDataJsonWithInfoDrilldown[parentKeygen].value.concat(yArrTotal);

                      // do for data
                      lastTempstoreLen = 0;

                      if (rowDataJsonWithInfoDrilldown[parentKeygen].data[pos].length) {
                        lastTempStore = rowDataJsonWithInfoDrilldown[parentKeygen].data[pos][rowDataJsonWithInfoDrilldown[parentKeygen].data[pos].length - 1];
                        lastTempstoreLen = Number(lastTempStore[0]);
                      }
                      if (lastTempstoreLen < totalLen) {
                        rowDataJsonWithInfoDrilldown[parentKeygen].data[pos].length = 0;
                      }
                      rowDataJsonWithInfoDrilldown[parentKeygen].data[pos] = rowDataJsonWithInfoDrilldown[parentKeygen].data[pos].concat(yArrTotal);
                    }
                  }
                });
              });
            }
          }
        } catch (e) {
          console.log(e); // jshint ignore:line
        }
      }

      if (showtotaldatabase) {
        $.each(rowDataJsonWithInfo, function (k, val) {
          if (val.length) {
            rowDataJson[k].length = 0;
            for (var i = 0, iLen = val.length; i < iLen; i++) {
              rowDataJson[k].push(Number(val[i][1]));
            }
          }
        });

        $.each(rowDataJsonWithInfoDrilldown, function (k, val) {
          if (val.value.length) {
            drilldownSeries[k].value.length = 0;
            for (var i = 0, iLen = val.value.length; i < iLen; i++) {
              drilldownSeries[k].value.push(Number(val.value[i][1]));
            }
          }


          $.each(val.data, function (index, d) {
            if (d.length) {
              drilldownSeries[k].data[index].y.length = 0;
              for (var i = 0, iLen = d.length; i < iLen; i++) {
                drilldownSeries[k].data[index].y.push(Number(d[i][1]));
              }
            }
          });

        });
      }





      //console.log("rowDataJson="+JSON.stringify(rowDataJson));
      $.each(drilldownSeries, function (key, json) {
        json.value = component.dataUtilityAggregation(json.value);
        $.each(json.data, function (i, v) {
          v.y = component.dataUtilityAggregation(v.y);
        });
      });

      if (type === 'funneldd') {
        self.getSortedDimMembers(component, drilldownSeries);
      }


      //console.log("drilldownSeries="+JSON.stringify(drilldownSeries));

      component.drilldownjson = drilldownSeries;
      //var categoryDataRowAggr = [];
      var finalCategoryNames = [];
      var srkey = '';
      var totalArr = [];
      var isAllZero = true;
      var rowDimIndex = measureInRow ? selectedColumndimIndexes[0] : selectedRowdimIndexes[0];
      //console.log("rowDimIndex="+rowDimIndex +"  selectedRowdimIndexes[0]="+selectedRowdimIndexes[0]+"  selectedColumndimIndexes[0]="+selectedColumndimIndexes[0]);
      for (var i = 0; i < component.dataRes.dimensions[rowDimIndex].members.length; i++) {
        if (component.showtotaldatabase() || component.dataRes.dimensions[rowDimIndex].members[i].type != 'RESULT') {
          //srkey = rowDimIndex + ':' + i;
          srkey =  component.dataRes.dimensions[rowDimIndex].key.replace(/-/g, '_') + ':' +  component.dataRes.dimensions[rowDimIndex].members[i].key.replace(/-/g, '_');
          var colorvalue = self.getSeriesColors(component, seriesColor, finalCategoryNames.length, defaultColor);
          if (measureColorPair && measureColorPair[component.dataRes.dimensions[rowDimIndex].members[i].key] !== undefined) {
            colorvalue = measureColorPair[component.dataRes.dimensions[rowDimIndex].members[i].key].color;
          }

          for (var j = 0; j < seriesData.length; j++) {
            var genKey = srkey + '-' + seriesData[j].columnKey;
            if (totalArr[j] === undefined) {
              totalArr[j] = rowDataJson[genKey];
            } else {
              totalArr[j] = totalArr[j].concat(rowDataJson[genKey]);
            }

            var yVal = component.dataUtilityAggregation(rowDataJson[genKey]);
            rowDataJson[genKey] = yVal;
            var tempName = component.dataRes.dimensions[rowDimIndex].members[i].text;
            tempName = self.formatSeriesName(component, tempName, measureDimString, { 'showunit': 'unitcurrency' });
            if(isAllZero && yVal !== null){
              isAllZero = false;
            }
            /*if(component.scalingfactorenable())
            {
              if(scalingText)
                tempName +=scalingText;
              else
                tempName +=" (* 1)";
            }
            if((component.unitcurrency() || component.showunit())&& uintOfMeasureText!="")
            {
                tempName += " (in " +  uintOfMeasureText + ")";
            }*/
            seriesData[j].backButton = component.dataRes.dimensions[rowDimIndex]["picker_text"];
            seriesData[j].data.push({
              Namekey: srkey,
              color: colorvalue,
              drilldown: true,
              columnKey: seriesData[j].columnKey,
              columnIndexKey: seriesData[j].columnIndexKey,
              nodeState: 'collapsed',
              level: 0,
              parentKey: 'none',
              name: tempName,
              keyname: component.dataRes.dimensions[rowDimIndex].members[i].key,
              y: yVal
            });
          }

          finalCategoryNames.push(component.dataRes.dimensions[rowDimIndex].members[i].text);
        }
      }

      if (component.showtotals()) {
        var colorvalue = self.getSeriesColors(component, seriesColor, finalCategoryNames.length, defaultColor);
        if (measureColorPair && measureColorPair['total'] !== undefined) {
          colorvalue = measureColorPair['total'].color;
        }

        for (var j = 0; j < seriesData.length; j++) {
          var tempTotal = {};
          tempTotal.drilldown = false;
          tempTotal.Namekey = 'total';
          tempTotal.columnKey = seriesData[j].columnKey;
          tempTotal.columnIndexKey = seriesData[j].columnIndexKey;
          tempTotal.nodeState = 'collapsed';
          tempTotal.level = 0;
          tempTotal.parentKey = 'none';
          tempTotal.name = 'Total';
          tempTotal.color = colorvalue;
          tempTotal.keyname = 'total';
          tempTotal.y = component.dataUtilityAggregation(totalArr[j]);
          /* jshint expr:true */
          seriesData[j].data[component.totalnodeplacement() == 'before' ? 'unshift' : 'push'](tempTotal);
        }

        finalCategoryNames[component.totalnodeplacement() == 'before' ? 'unshift' : 'push']('Total');
      }

      if (type == 'funneldd' && seriesData.length) {
        self.getSortedDimMembers(component, seriesData);
      }

      //Commented below code ,as will revist this later.-Do not Remove
/*      if(component.CID == "waterfall"){
        var finalbalanceLabel = 'Final Balance';
              var mesColor;
      if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
        mesColor = JSON.parse(component.measurecolorpair());
      }
      if (component.finalbalancechange() !== '' && component.finalbalancechange() != ' ' && component.finalbalancechange() !== undefined && component.finalbalancechange() !== null) {
        finalbalanceLabel = component.finalbalancechange();
      }

      if (component.waterfallfinalbalance() && component.waterfallfinalbalance() !== undefined && component.waterfallfinalbalance() !== '' && component.waterfallfinalbalance() !== null && !component.enablecustominterimsum())  {
        var finalColor;
        if (mesColor && mesColor['Final Balance'] !== undefined) {
            finalColor=mesColor['Final Balance'].color;
        }
        else{
            finalColor=seriesColor[originalCategoriesLength+1];
        }
        seriesData[0].data.push({
          name: finalbalanceLabel,
          isSum: true,
          color:finalColor
        });
      }
      }*/

      //defaultValue.xAxis.categories = finalCategoryNames;
      defaultValue.series = seriesData;
      //console.log("seriesData="+JSON.stringify(seriesData));
      if(isAllZero){
        return -1; // No Data Available
      }
      else{
        return 0;
      }      
    };
  }

  that.createDynamicDrilldownData = function (component, nodeKey) {
    var self = this;
    var level = 0, nextLevel = 0;
    var dimension = component.selectedDimension;
    component.setDataUtilityFormattedResultSet();
    var selectedMember = 0;
    var parentIndex = 0;
    var isParentSet = false;
    var sortedarray = [];
    //var noOfColumns = component.dataRes['axis_columns'][0].indexOf(-1);
    var seriesNames;
    var seriesKeyNames;
    var seriesData = [];
    var dispKeyText = component.dispkeytext();
    var dispKeyTextNameJson = {};
    var allowednooflevels = Number(component.allowednooflevels());
    var type = component.getChartType();
    if (isNaN(allowednooflevels) || allowednooflevels < 2) {
      allowednooflevels = 1000;
    }

    if (component.includerootnodes()) {
      allowednooflevels = allowednooflevels - 1;
    }
    //setTimeout(function(){
    //console.log("**Result = "+ JSON.stringify(component.dataRes.dimensions));
    //},500);
    function getHierarchyDrilldownData(colRowIndexJson, seriesKeyNames, tempSeriesKeyIndexes) {
      var series = {};
      var total = 0;
      var scalingFactor = "";
      var unitOfMeasure = "";
      var isBottom = component.nodeAlignment === 'bottom' ? true : false;
      var len = component.dataRes.dimensions[dimension].members.length;
      var memberKey;

      sortedarray = [];
      selectedMember = 0;
      series.nameKey = nodeKey;
      for (var i = 0; i < component.dataRes.dimensions.length; i++) {
        if (component.dataRes.dimensions[i].containsMeasures) {
          for (var j = 0; j < component.dataRes.dimensions[i].members.length; j++) {
            if (component.dataRes.dimensions[i].members[j].key == seriesKeyNames) {
              scalingFactor = component.dataRes.dimensions[i].members[j].scalingFactor;
              unitOfMeasure = component.dataRes.dimensions[i].members[j].unitOfMeasure;
            }
          }

          break;
        }
      }

      for (var i = isBottom ? len-1 : 0; (isBottom ? i >= 0 : i<len) ; isBottom ? i-- : i++) {
        memberKey = component.dataRes.dimensions[dimension].members[i].originalKey || component.dataRes.dimensions[dimension].members[i].key;
        if (memberKey == nodeKey && component.dataRes.dimensions[dimension].members[i].type != 'HIERARCHY_NODE') {
          return null;
        } else if (memberKey == nodeKey && component.dataRes.dimensions[dimension].members[i].type == 'HIERARCHY_NODE') {
          /*if(!dispKeyTextNameJson[component.dataRes.dimensions[dimension].members[i].key])
                    {
                      var nameObj = $.extend(true,{},component.dataRes.dimensions[dimension].members[i]);
                      var name = that.dispKeyText(nameObj,disp_key_text,false);
                      dispKeyTextNameJson[component.dataRes.dimensions[dimension].members[i].key] = name;
                    }
                    series.name=dispKeyTextNameJson[component.dataRes.dimensions[dimension].members[i].key];*/
          series.backButton = component.dataRes.dimensions[dimension].members[i]["picker_text"];
          if (type != 'bardd') {
            series.name = component.dataRes.dimensions[dimension].members[i].text;
          }
          //else
          //{
          //}
          series.columnKey = seriesKeyNames;
          series.columnIndexKey = tempSeriesKeyIndexes;
          parentIndex = i;
          if (typeof component.dataRes.dimensions[dimension].members[i].level != 'undefined') {
            level = component.dataRes.dimensions[dimension].members[i].level;
          }

          nextLevel = level + 1;
          isParentSet = true;
        } else if (( isBottom ? i < parentIndex : i > parentIndex) && isParentSet && (typeof component.dataRes.dimensions[dimension].members[i].level == 'undefined' ? 0 : component.dataRes.dimensions[dimension].members[i].level) == nextLevel) {
          sortedarray[selectedMember] = {};
          if (!dispKeyTextNameJson[component.dataRes.dimensions[dimension].members[i].key]) {
            var nameObj = $.extend(true, {}, component.dataRes.dimensions[dimension].members[i]);
            var name = nameObj.text;
            dispKeyTextNameJson[component.dataRes.dimensions[dimension].members[i].key] = name;
          }

          var memberTextAfter = dispKeyTextNameJson[component.dataRes.dimensions[dimension].members[i].key];
          if (component.scalingfactorenable()) {
            memberTextAfter += ' (*' + Math.pow(10, scalingFactor) + ' )';
          }

          if ((component.unitcurrency() || component.showunit()) && unitOfMeasure !== '') {
            memberTextAfter += ' (in ' + unitOfMeasure + ' )';
          }

          sortedarray[selectedMember].name = memberTextAfter;
          //sortedarray[selectedMember].name = component.dataRes.dimensions[dimension].members[i].text;
          sortedarray[selectedMember].Namekey = component.dataRes.dimensions[dimension].members[i].originalKey || component.dataRes.dimensions[dimension].members[i].key;
          sortedarray[selectedMember].keyname = sortedarray[selectedMember].Namekey;
          sortedarray[selectedMember].columnKey = seriesKeyNames;
          sortedarray[selectedMember].columnIndexKey = tempSeriesKeyIndexes;
          if (typeof component.ztlSelectedRowJson[sortedarray[selectedMember].Namekey] == 'undefined') {
            var dimKey = component.dataRes.dimensions[dimension].key;
            component.ztlSelectedRowJson[sortedarray[selectedMember].Namekey] = {};
            component.ztlSelectedRowJson[sortedarray[selectedMember].Namekey][dimKey] = {
              internalKey: component.dataRes.dimensions[dimension].members[i].key,
              text: component.dataRes.dimensions[dimension].members[i]["picker_text"]
            };
          }

          sortedarray[selectedMember].parentKey = nodeKey;
          sortedarray[selectedMember].nodeState = 'collapsed';
          sortedarray[selectedMember].level = nextLevel;
          sortedarray[selectedMember].drilldown = component.dataRes.dimensions[dimension].members[i].type == 'HIERARCHY_NODE' && allowednooflevels > nextLevel ? true : false;
          sortedarray[selectedMember].y = 0;
          //sortedarray[selectedMember].selectedColumnIndex=selectedColumnIndex;
          //var aggregationCount = 0;
          var yArr = [];
          var valArr = colRowIndexJson[tempSeriesKeyIndexes];
          $.each(valArr, function (ind, k) {
            for (var j = k; j < component.dataRes.data.length; j += component.dataRes.columnCount) {
              if (i == component.dataRes.tuples[j][dimension] && self.vbiCharts.eliminateResult(component.dataRes, component.dataRes.tuples[j], undefined, component.showtotaldatabase()) === true) {
                yArr.push(component.dataRes.data[j]);
              }
            }
          });

          sortedarray[selectedMember].y = component.dataUtilityAggregation(yArr);
          total += sortedarray[selectedMember].y;
          selectedMember++;
        } else if (( isBottom ? i < parentIndex : i > parentIndex) && isParentSet && level == (typeof component.dataRes.dimensions[dimension].members[i].level == 'undefined' ? 0 : component.dataRes.dimensions[dimension].members[i].level)) {
          break;
        }
      }

      series.value = total;
      series.data = sortedarray;
      //console.log("series="+JSON.stringify(series));
      return series;
    }

    seriesData = [];
    var measureMember = Object.keys(component['col_row_index_json'])[0];
    var measureMemberArr = measureMember.split(':');
    var tempSeriesNames = component.dataRes.dimensions[measureMemberArr[0]].members[measureMemberArr[1]].text;
    var tempSeriesKeys = component.dataRes.dimensions[measureMemberArr[0]].members[measureMemberArr[1]].key;
    var tempSeriesKeyIndexes = measureMember;
    var unitOfMeasure = '';
    var scalingFactor = 0;
    if (component.unitcurrency() || component.showunit()) {
      unitOfMeasure = component.dataRes.dimensions[measureMemberArr[0]].members[measureMemberArr[1]].unitOfMeasure || '';
    }

    if (component.scalingfactorenable()) {
      scalingFactor = component.dataRes.dimensions[measureMemberArr[0]].members[measureMemberArr[1]].scalingFactor || 0;
    }

    seriesNames = tempSeriesNames;
    seriesKeyNames = tempSeriesKeys;
    var returnedSeries = getHierarchyDrilldownData(component['col_row_index_json'], seriesKeyNames, tempSeriesKeyIndexes);
    returnedSeries.seriesname = seriesNames;
    returnedSeries.name = seriesNames;
    returnedSeries.seriesKeyName = seriesKeyNames;
    returnedSeries.unitOfMeasure = unitOfMeasure;
    returnedSeries.scalingFactor = Math.pow(10, scalingFactor);
    seriesData.push(returnedSeries);
    if (type == 'funneldd') {
      self.getSortedDimMembers(component, seriesData);
    }
    /*if (type == 'funneldd') {
        for (var i = 0; i < seriesData[0].data.length; i++) {
          for (var j = 0; j < seriesData[0].data.length - 1; j++) {
            if (seriesData[0].data[i].y > seriesData[0].data[j].y) {
              var temp = seriesData[0].data[i];
              seriesData[0].data[i] = seriesData[0].data[j];
              seriesData[0].data[j] = temp;
            }
          }
        }
      }*/
    return seriesData;
  };

  if (validateImplementMethod(args, 'expandCollapseHandler')) {
    that.expandCollapseHandler = function (component) {
      var expandORCollapse = '';
      if (component.isHierarchy) {
        if (component.eventPoint.drilldown !== false) {
          if (component.eventPoint.nodeState == 'collapsed') {
            if (typeof component.drilldownjson[component.nodeKey + '-' + component.seriesColumnkey] === 'undefined') {
              component.selectednode(component.nodeKey);
              component.selecteddimension(component.dataRes.dimensions[component.selectedDimension].key);          
              component.firePropertiesChangedAndEvent([
                  'selectednode',
                  'selecteddimension'
                ], 'onHExpand');              
              component.expandflag = 1;
            } else {
              that.expandNode(component);
            }
            expandORCollapse = 'expand';
          } else {
            that.collapseNode(component);
            expandORCollapse = 'collapse';
          }
        }
      } else {
        if (component.eventPoint.drilldown !== false) {
          if (component.eventPoint.nodeState == 'collapsed') {
            that.expandNode(component);
            expandORCollapse = 'expand';
          } else {
            that.collapseNode(component);
            expandORCollapse = 'collapse';
          }
        }
      }

      var eventToTrigger = expandORCollapse == 'expand' ? 'chartonexpand' : 'chartoncollapse';

      if (expandORCollapse == 'expand') {
          that.trackActionFunc(component, "expand");
      } else {
          that.trackActionFunc(component, "collapse");
      }


      if (component.customAction === null && component[eventToTrigger]() !== '') {
          if (component.nodeKey != 'total') {
              try {
                  var ztlPointJson = {};
                  //var prevSelectedVal = component.selectedvalue;
                  ztlPointJson = $.extend(true, {}, component.ztlSelectedColumnJson[component.seriesColumnkey]);
                  $.extend(true, ztlPointJson, component.ztlSelectedRowJson[component.nodeKey]);
                  component.selectedvalue(JSON.stringify(ztlPointJson));
              } catch (e) {}
          }
          component.columncolorChanged++;
          component.firePropertiesChangedAndEvent([
              'selectedvalue',
              'selectedlevel'
          ], eventToTrigger);
      }


      /*if (expandORCollapse == 'expand') {
        component.fireEvent('chartonexpand');
      } else if (expandORCollapse == 'collapse') {
        component.fireEvent('chartoncollapse');
      }*/
    };
  }

  if (validateImplementMethod(args, 'hierarchyDrilldownFromJson')) {
    that.hierarchyDrilldownFromJson = function (component) {
      var groupedCategories = [];
      var mainseriesWithParents = {};
      var currentSeriesIndex = component.eventPoint.columnIndexKey;
      var allSeriesData = [];
      var allSeries = [];
      var seriesWithParents = {};
      component.eventPoint.select(!1, !1);
      that.trackActionFunc(component, "drilldown");
      var chartType = component.getChartType();
      if (chartType == 'bardd') {
        $.extend(true, allSeriesData, component.eventPoint.series.chart.series);
        $.each(component.drilldownjson[component.nodeKey + '-' + component.seriesColumnkey].data, function (i, v) {
          groupedCategories.push(v.name);
        });
      }

      if (component.parentondrill()) {
        $.extend(true, mainseriesWithParents, component.drilldownjson[component.nodeKey + '-' + component.seriesColumnkey]);
        mainseriesWithParents.data[component.parentnodeplacement() == 'before' ? 'unshift' : 'push']({
          name: component.eventPoint.name,
          columnIndexKey: component.eventPoint.columnIndexKey,
          columnKey: component.seriesColumnkey,
          Namekey: component.eventPoint.Namekey,
          parentKey: component.eventPoint.parentKey,
          nodeState: component.eventPoint.nodeState,
          level: component.eventPoint.level,
          drilldown: false,
          y: component.eventPoint.y
        });
        if (chartType == 'bardd') {
          groupedCategories[component.parentnodeplacement() == 'before' ? 'unshift' : 'push'](component.eventPoint.name);
        }
      } else {
        $.extend(true, mainseriesWithParents, component.drilldownjson[component.nodeKey + '-' + component.seriesColumnkey]);
      }

      if (chartType == 'bardd') {
        allSeries = [];
        component.eventPoint.series.xAxis.setCategories(groupedCategories);
        if (component.showallmeasures()) {
          //console.log(JSON.stringify(allSeriesData));
          for (var k = 0; k < allSeriesData.length; k++) {
            seriesWithParents = {};
            if (allSeriesData[k].columnIndexKey != currentSeriesIndex) {
              var seriesKeyName = allSeriesData[k].options.seriesKeyName;
              if (component.parentondrill()) {
                $.extend(true, seriesWithParents, component.drilldownjson[component.nodeKey + '-' + seriesKeyName]);
                seriesWithParents.color = allSeriesData[k].color;
                for (var i = 0; i < allSeriesData[k].data.length; i++) {
                  //console.log("in for = "+i+"  allSeriesData[k].data[i].Namekey="+allSeriesData[k].data[i].Namekey+"  component.eventPoint.Namekey="+component.eventPoint.Namekey);
                  if (allSeriesData[k].data[i].Namekey == component.eventPoint.Namekey) {
                    //console.log("allSeriesData[k].data[i].Namekey="+allSeriesData[k].data[i].Namekey + " seriesKeyName="+seriesKeyName);
                    seriesWithParents.data[component.parentnodeplacement() == 'before' ? 'unshift' : 'push']({
                      name: component.eventPoint.name,
                      columnKey: seriesKeyName,
                      columnIndexKey: allSeriesData[k].data[i].columnIndexKey,
                      Namekey: component.eventPoint.Namekey,
                      parentKey: allSeriesData[k].data[i].parentKey,
                      nodeState: allSeriesData[k].data[i].nodeState,
                      level: allSeriesData[k].data[i].level,
                      drilldown: false,
                      y: component.drilldownjson[component.nodeKey + '-' + seriesKeyName].value
                    });
                    break;
                  }
                }

                allSeries.push(seriesWithParents);
              } else {
                $.extend(true, seriesWithParents, component.drilldownjson[component.nodeKey + '-' + seriesKeyName]);
                seriesWithParents.color = allSeriesData[k].color;
                allSeries.push(seriesWithParents);
              }
            } else if (allSeriesData[k].columnIndexKey == currentSeriesIndex) {
              allSeries.push(mainseriesWithParents);
            }
          }

          component.chartRef.addMultipleSeriesAsDrilldown(component.eventPoint, allSeries);
        } else {
          component.chartRef.addSeriesAsDrilldown(component.eventPoint, mainseriesWithParents);
        }
      } else {
        component.chartRef.addSeriesAsDrilldown(component.eventPoint, mainseriesWithParents);
      }

      allSeries = null;
      groupedCategories = null;
      seriesWithParents = null;
      component.clickEvent = ""; // clearing the event
      if (component.customAction !== null) {
          that.rebuildActionsRecursive(component);
      }
    };
  }

  if (validateImplementMethod(args, 'getAllChildren')) {
    that.getAllChildren = function (component, node, seriesColumnkey, gpc, nodeState) {
      if (typeof component.drilldownjson[node + '-' + seriesColumnkey] != 'undefined') {
        $.each(component.drilldownjson[node + '-' + seriesColumnkey].data, function (i, v) {
          if (typeof component.drilldownjson[v.Namekey + '-' + seriesColumnkey] !== 'undefined' && (v.Namekey != component.nodeKey && v.nodeState == 'expanded' || v.Namekey == component.nodeKey && nodeState == 'expanded')) {
            gpc.categories.push({
              name: v.name,
              level: v.level,
              categories: [v.name]
            });
          } else {
            gpc.categories.push(v.name);
          }

          var parentgpc = gpc;
          gpc = gpc.categories[gpc.categories.length - 1];
          if (typeof gpc == 'object') {
            that.getAllChildren(component, v.Namekey, seriesColumnkey, gpc, nodeState);
            if (component.parentnodeplacement() == 'after') {
              var categories = gpc.categories;
              var parentNode = categories.shift();
              categories.push(parentNode);
            }
          }

          gpc = parentgpc;
        });
      }
    };
  }

  if (validateImplementMethod(args, 'createFlatCategory')) {
    that.createFlatCategory = function (flat, gpc) {
      if (flat.categories) {
        $.each(flat.categories, function (i, v) {
          if (typeof v == 'object') {
            that.createFlatCategory(v, gpc);
          } else {
            gpc.push(v);
          }
        });
      } else {
        gpc.push(flat);
      }
    };
  }

  if (validateImplementMethod(args, 'expandNode')) {
    that.expandNode = function (component) {
      var currentSeries = component.eventPoint.series.data;
      var allSeriesData = component.eventPoint.series.chart.series;
      var currentSeriesIndex = component.eventPoint.columnIndexKey;
      var chartType = component.getChartType();
      var measureColorPair = {};
      if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
        measureColorPair = JSON.parse(component.measurecolorpair());
      }
      //var currentIndex = eventPoint.index;
      var newSeries = [];
      var groupedCategories = [];
      function getNodeChildren(nodeKey, columnKey){
          var parentNode;
          if (component.parentnodeplacement() == 'after') {
              parentNode = newSeries.pop();
          }
          $.each(component.drilldownjson[nodeKey + '-' + columnKey].data, function(i, v) {
              newSeries.push(v);
              if(v.nodeState === 'expanded'){
                  getNodeChildren(v.Namekey, columnKey);
              }
          });
          if (parentNode) {
              newSeries.push(parentNode);
          }               
      }
      setTimeout(function () {
        $.each(currentSeries, function (index, value) {
          var colorvalue;
          if (measureColorPair && measureColorPair[value.keyname] !== undefined) {
            colorvalue = measureColorPair[value.keyname].color;
          }

          newSeries.push({
            Namekey: value.Namekey,
            columnKey: value.columnKey,
            columnIndexKey: value.columnIndexKey,
            drilldown: value.drilldown,
            parentKey: value.parentKey,
            name: value.name,
            keyname: value.keyname,
            y: value.y,
            color: colorvalue,
            nodeState: value.nodeState,
            level: value.level
          });
          if (value.parentKey == 'none' && chartType == 'bardd') {
            if (value.nodeState == 'expanded' || component.nodeKey == value.Namekey) {
              groupedCategories.push({
                name: value.name,
                level: value.level,
                categories: [value.name]
              });
              that.getAllChildren(component, value.Namekey, component.seriesColumnkey, groupedCategories[groupedCategories.length - 1], 'expanded');
              if (component.parentnodeplacement() == 'after') {
                var categories = groupedCategories[groupedCategories.length - 1].categories;
                var parentNode = categories.shift();
                categories.push(parentNode);
              }
            } else {
              groupedCategories.push(value.name);
            }
          }

          if (component.nodeKey == value.Namekey) {
            newSeries[newSeries.length - 1].nodeState = 'expanded';
            if (value.parentKey != 'none') {
              $.each(component.drilldownjson[value.parentKey + '-' + component.seriesColumnkey].data, function (i, v) {
                if (v.Namekey == component.nodeKey && component.seriesColumnkey == v.columnKey) {
                  v.nodeState = 'expanded';
                }
              });
            }

            /**
             * #VBX141-8191
             */
            getNodeChildren(component.nodeKey, component.seriesColumnkey);
          }
        });
        // setting data in other series
        if (chartType == 'bardd') {
          if (!component.activatehierarchylabeling()) {
            var flatCategories = $.extend(true, {}, groupedCategories);
            groupedCategories = [];
            $.each(flatCategories, function (i, v) {
              that.createFlatCategory(v, groupedCategories);
            });
          }

          for (var k = 0; k < allSeriesData.length; k++) {
            if (allSeriesData[k].userOptions.columnIndexKey != currentSeriesIndex) {
              var seriesObjData = allSeriesData[k].data;
              var seriesKeyName = allSeriesData[k].userOptions.seriesKeyName;
              var tempSeries = [];
              $.each(seriesObjData, function (index, value) {
                tempSeries.push({
                  Namekey: value.Namekey,
                  columnKey: value.columnKey,
                  columnIndexKey: value.columnIndexKey,
                  drilldown: value.drilldown,
                  parentKey: value.parentKey,
                  name: value.name,
                  y: value.y,
                  nodeState: value.nodeState,
                  level: value.level
                });
                if (component.nodeKey == value.Namekey) {
                  if (tempSeries[tempSeries.length - 1].nodeState == 'collapsed') {
                    tempSeries[tempSeries.length - 1].nodeState = 'expanded';
                    if (value.parentKey != 'none') {
                      $.each(component.drilldownjson[value.parentKey + '-' + seriesKeyName].data, function (i, v) {
                        if (v.Namekey == component.nodeKey && seriesKeyName == v.columnKey) {
                          v.nodeState = 'expanded';
                        }
                      });
                    }

                    var localMemberjson = [];
                    $.extend(true, localMemberjson, component.drilldownjson[component.nodeKey + '-' + seriesKeyName].data);
                    if (component.parentnodeplacement() == 'after') {
                      var parentNode = tempSeries.pop();
                      $.each(localMemberjson, function (i, v) {
                        if (!component.showallmeasures()) {
                          v.y = 0;
                        }

                        tempSeries.push(v);
                      });

                      tempSeries.push(parentNode);
                    } else {
                      $.each(localMemberjson, function (i, v) {
                        if (!component.showallmeasures()) {
                          v.y = 0;
                        }

                        tempSeries.push(v);
                      });
                    }
                  }
                }
              });

              allSeriesData[k].setData(tempSeries, false);
            }
          }

          component.eventPoint.series.xAxis.setCategories(groupedCategories);
        }

        component.eventPoint.series.setData(newSeries);
      }, 200);
      component.clickEvent = ""; // clearing the event
      if (component.customAction !== null) {
        that.rebuildActionsRecursive(component);
      }
    };
  }

  if (validateImplementMethod(args, 'collapseNode')) {
    that.collapseNode = function (component) {
      var currentSeries = component.eventPoint.series.data;
      //var currentIndex = component.eventPoint.index;
      //var seriesObj = component.eventPoint.series;
      var groupedCategories = [];
      var seriesKeyName = component.seriesColumnkey;
      var allSeriesData = component.eventPoint.series.chart.series;
      var currentSeriesIndex = component.eventPoint.columnIndexKey;
      var chartType = component.getChartType();
      var measureColorPair = {};
      if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
        measureColorPair = JSON.parse(component.measurecolorpair());
      }

      function collapseAllChildren(nodesJsonArr, seriesKeyName) {
        $.each(nodesJsonArr, function (i, v) {
          v.nodeState = 'collapsed';
          if (typeof component.drilldownjson[v.Namekey + '-' + seriesKeyName] !== 'undefined') {
            collapseAllChildren(component.drilldownjson[v.Namekey + '-' + seriesKeyName].data, seriesKeyName);
          }
        });
      }

      function collpaseSeriesBySeries(seriesObj) {
        var removeFlag = 0;
        var newSeries = [];
        currentSeries = seriesObj.data;
        if (component.parentnodeplacement() == 'after') {
          currentSeries.reverse();
        }

        seriesKeyName = seriesObj.userOptions.seriesKeyName;
        $.each(currentSeries, function (index, value) {
          if (removeFlag === 0 || removeFlag == 1 && component.nodeLevel >= value.level) {
            removeFlag = 0;
            var colorvalue;
            if (measureColorPair && measureColorPair[value.keyname] !== undefined) {
              colorvalue = measureColorPair[value.keyname].color;
            }

            newSeries.push({
              Namekey: value.Namekey,
              columnKey: value.columnKey,
              columnIndexKey: value.columnIndexKey,
              drilldown: value.drilldown,
              parentKey: value.parentKey,
              name: value.name,
              keyname: value.keyname,
              y: value.y,
              color: colorvalue,
              nodeState: value.nodeState,
              level: value.level
            });

            if (chartType == 'bardd' && value.parentKey == 'none' && seriesObj.userOptions.columnIndexKey == currentSeriesIndex) {
              if (value.nodeState == 'expanded' && value.Namekey != component.nodeKey) {
                groupedCategories.push({
                  name: value.name,
                  level: value.level,
                  categories: [value.name]
                });
                that.getAllChildren(component, value.Namekey, seriesKeyName, groupedCategories[groupedCategories.length - 1], 'collapsed');
                if (component.parentnodeplacement() == 'after') {
                  var categories = groupedCategories[groupedCategories.length - 1].categories;
                  var parentNode = categories.shift();
                  categories.push(parentNode);
                }
              } else {
                groupedCategories.push(value.name);
              }
            }
          }

          if (component.nodeKey == value.Namekey && seriesKeyName == value.columnKey) {
            if (value.parentKey != 'none') {
              $.each(component.drilldownjson[value.parentKey + '-' + seriesKeyName].data, function (i, v) {
                if (v.Namekey == component.nodeKey && seriesKeyName == v.columnKey) {
                  v.nodeState = 'collapsed';
                  if (typeof component.drilldownjson[component.nodeKey + '-' + seriesKeyName] !== 'undefined') {
                    collapseAllChildren(component.drilldownjson[component.nodeKey + '-' + seriesKeyName].data, seriesKeyName);
                  }
                }
              });
            } else {
              if (typeof component.drilldownjson[component.nodeKey + '-' + seriesKeyName] !== 'undefined') {
                collapseAllChildren(component.drilldownjson[component.nodeKey + '-' + seriesKeyName].data, seriesKeyName);
              }
            }

            newSeries[newSeries.length - 1].nodeState = 'collapsed';
            removeFlag = 1;
          }
        });

        if (component.parentnodeplacement() == 'after') {
          newSeries.reverse();
          groupedCategories.reverse();
        }

        if (seriesObj.userOptions.columnIndexKey != currentSeriesIndex) {
          seriesObj.setData(newSeries, false);
        } else {
          if (chartType == 'bardd') {
            if (!component.activatehierarchylabeling()) {
              var flatCategories = $.extend(true, {}, groupedCategories);
              groupedCategories = [];
              $.each(flatCategories, function (i, v) {
                that.createFlatCategory(v, groupedCategories);
              });
            }

            seriesObj.xAxis.setCategories(groupedCategories);
          }

          seriesObj.setData(newSeries);
        }
      }

      if (chartType == 'bardd') {
        for (var k = 0; k < allSeriesData.length; k++) {
          if (allSeriesData[k].userOptions.columnIndexKey != currentSeriesIndex) {
            collpaseSeriesBySeries(allSeriesData[k]);
          }
        }
      }

      collpaseSeriesBySeries(component.eventPoint.series);
      component.clickEvent = ""; // clearing the event
    };
  }

  /* that.decideEventType = function(event, component){
         var eventMap = {
               'ondblclickevent' : 'ondbltapevent',
               'onclickevent' : 'ontapevent'
         }
         if(component.configuremobileevent() && component._isIOS){
             return eventMap[event];
         }
         return event;
   };
   */
  /* modify highchart default single click and implement double click*/
  that._pointClickEvent = function (event, component) {
    component.eventPoint = event.point;
    component.nodeLevel = event.point.level;
    component.selectedlevel(Number(component.nodeLevel));
    component.seriesColumnkey = event.point.columnKey;
    component.nodeKey = event.point.Namekey;
    component.parentKey = event.point.parentKey;
    component.clickEvent = 'ondblclickevent'; //that.decideEventType('ondblclickevent', component);


    var singleClick = function () {
      var clickEvent = component.clickEvent;
      if (component[clickEvent]() == 'none') {
        return;
      } else if (component[clickEvent]() == 'expand_collapse' && component.CID != "waterfall") {//Disabling Expand/Collapse(Single click) Functionality for Waterfall Drilldown
        if (event.point.Namekey) {
          component.eventPoint.select(!1, !1);
          that.expandCollapseHandler(component);
        }
      } else if (component[clickEvent]() == 'select') {
        var chartType = component.getChartType();
        if (chartType == 'bardd' || component.CID == "waterfall") { //VBX141-7719-to support waterfall drilldown
          component.eventPoint.select(null, !0);
        }

        var selectedPoints = component.chartRef.getSelectedPoints();
        if (component.nodeKey != 'total') {
          try {
            var ztlPointJson = {};
            if (component.eventPoint.selected) {              
              that.trackActionFunc(component, "select");              
              ztlPointJson = $.extend(true, {}, component.ztlSelectedColumnJson[component.seriesColumnkey]);
              $.extend(true, ztlPointJson, component.ztlSelectedRowJson[component.nodeKey]);
              component.selectedvalue(JSON.stringify(ztlPointJson));
            } else {
              that.trackActionFunc(component, "deselect");
              component.selectedvalue('');
            }

            var pointMemberJson = [];
            $.each(selectedPoints, function (i, v) {
              ztlPointJson = {};
              ztlPointJson = $.extend(true, {}, component.ztlSelectedColumnJson[v.columnKey]);
              $.extend(true, ztlPointJson, component.ztlSelectedRowJson[v.Namekey]);
              pointMemberJson.push(JSON.stringify(ztlPointJson));
            });

            component.selectedvalues(pointMemberJson.toString());
            component.columncolorChanged++;
          } catch (e) {
          }
        }

        component.firePropertiesChangedAndEvent([
          'selectedvalue',
          'selectedvalues',
          'selectedlevel'
        ], 'chartonpointclick');
      } else if (component[clickEvent]() == 'drilldown' && component.eventPoint.drilldown !== false) {
        if (!event.seriesOptions && component.isHierarchy) {
          if (typeof component.drilldownjson[component.nodeKey + '-' + component.seriesColumnkey] === 'undefined') {
            component.selectednode(component.nodeKey);
            component.selecteddimension(component.dataRes.dimensions[component.selectedDimension].key);
            /*if (component.chartondrilldown() === '') {
              component.firePropertiesChangedAndEvent([
                'selectednode',
                'selecteddimension', 'selectedlevel', 'drilldownlevel'
              ], 'onHExpand');

            } else {*/
              component.firePropertiesChangedAndEvent([
                'selectednode',
                'selecteddimension'
              ], 'onHExpand');
            //}
            component.drilldownflag = 1;
          } else {
            that.hierarchyDrilldownFromJson(component);
          }
        } else {
          that.hierarchyDrilldownFromJson(component);
        }

        //condition for updating the drilldown level when datasource is changed and chart is in 0th level
        if (component.drilldownlevel() == 1 && Number(component.nodeLevel) === 0) {
            component.drilldownlevel(0);
        } else {
            component.drilldownlevel(Number(component.nodeLevel) + 1);
        }

        component.drillupArr.push({ 'column': component.seriesColumnkey, 'row': component.nodeKey });
        if (component.customAction === null) {
          if (component.chartondrilldown() !== '') {
            try {
                var ztlPointJson = {};
                ztlPointJson = $.extend(true, {}, component.ztlSelectedColumnJson[component.seriesColumnkey]);
                $.extend(true, ztlPointJson, component.ztlSelectedRowJson[component.nodeKey]);
                component.selectedvaluedrilldown(JSON.stringify(ztlPointJson));
                component.columncolorChanged++;

            } catch (e) {}

            component.firePropertiesChangedAndEvent([
                'selectedvaluedrilldown',
                'selectedlevel',
                'drilldownlevel'
            ], 'chartondrilldown');
          } else {
              component.columncolorChanged++;
              component.firePropertiesChanged(['selectedlevel', 'drilldownlevel']);
          }
        }
      }
    };

    var setClickevent = function () {
      component.clickEvent = 'onclickevent'; //that.decideEventType('onclickevent', component);
      if (event.ctrlKey || event.metaKey || event.shiftKey) {
        component.clickEvent = 'onctrlclickevent';
      }

      component.clicks = 0;
      singleClick();
    };

    var setDblClickEvent = function () {
      component.clickEvent = 'ondblclickevent'; //that.decideEventType('ondblclickevent', component);
      singleClick();
    };

    component.clicks++;
    //count clicks
    if (component.clicks === 1) {
      component.previousPoint = component.nodeKey;
      component.timer = setTimeout(setClickevent, component.DELAY);
      return;
    } else if (component.clicks > 1 && component.previousPoint == component.nodeKey) {
      clearTimeout(component.timer);
      //prevent single-click action
      setDblClickEvent();
      component.clicks = 0;
      //after action performed, reset counter
      return;
    }
  };

  that.trackActionFunc = function (component, type) { //VBX141-7719-to support waterfall drilldown

    if (component.customAction !== null) {
      return;
    }

    var isValid = true;
    // precautionary condtion
    // if the action (drilldown, expand, select) already exist for a node in trackAction then don't track;
    if (component.trackAction.length && ['drilldown', 'expand', 'select'].indexOf(type) !== -1) {
      var lastAction = component.trackAction[component.trackAction.length - 1];
      isValid = false;
      for (var key in lastAction) {
        if (lastAction[key] != component[key]) {
          isValid = true;
          break;
        }
      }
    }

    if (isValid) {
      var typeFunc = {
        "drilldown": function () {
          component.trackAction.push({
            "nodeKey": component.nodeKey,
            "seriesColumnkey": component.seriesColumnkey,
            "parentKey": component.parentKey,
            "nodeLevel": component.nodeLevel,
            "action": 'drilldown'
          });
        },
        "drillup": function () {
          // Remove all the actions in trackAction untill drilldown is encountered.
          while (component.trackAction.length) {
            var act = component.trackAction.pop();
            if (act["action"] == "drilldown") {
              break;
            }
          }
        },
        "expand": function () {
          component.trackAction.push({
            "nodeKey": component.nodeKey,
            "seriesColumnkey": component.seriesColumnkey,
            "nodeLevel": component.nodeLevel,
            "parentKey": component.parentKey,
            "action": 'expand'
          });
        },
        "collapse": function () {
          // Remove all the actions of children of collapsed member in trackAction untill collapsed member is encountered.
          var i = component.trackAction.length - 1;
          while (i >= 0) {
            var act = component.trackAction[i];
            if (act["parentKey"] == component.nodeKey || (act["action"] == "expand" && act["nodeKey"] == component.nodeKey)) {
              component.trackAction.splice(i, 1);
              if (act["nodeKey"] == component.nodeKey) {
                break;
              }
            }
            i--;
          }
        },
        "select": function () {
          component.trackAction.push({
            "nodeKey": component.nodeKey,
            "seriesColumnkey": component.seriesColumnkey,
            "parentKey": component.parentKey,
            "nodeLevel": component.nodeLevel,
            "action": 'select'
          });

        },
        "deselect": function () {
          // Remove action that correspond to deselected node
          var act = component.trackAction.pop();
          if (act["nodeKey"] != component.nodeKey || act["action"] != "select" || act["seriesColumnkey"] !== component.seriesColumnkey) {
            component.trackAction.push(act);
          }
        }
      };

      typeFunc[type]();
      //console.log(component.trackAction);
    }
  };

  // rebuildActionsRecursive is made recursive by calling it from hierarchyDrilldownFromJson() & expandNode()
  that.rebuildActionsRecursive = function (component) {
    if (!component.trackActionBkp) {
      component.trackActionBkp = [];
      component.trackActionBkp = component.trackActionBkp.concat(component.trackAction);
    }

    var trackActionBkp = component.trackActionBkp;
    if (trackActionBkp.length) {
      var act = trackActionBkp.shift(),
        chart = component.chartRef,
        series = chart.series,
        seriesRef = "",
        pointRef = "";

      for (var j = 0, len = series.length; j < len; j++) {
        if (series[j].data[0] && series[j].data[0].columnKey == act['seriesColumnkey']) {
          seriesRef = series[j];
          break;
        }
      }
      if (seriesRef) {
        for (var j = 0, len = seriesRef.data.length; j < len; j++) {
          if (seriesRef.data[j].Namekey == act['nodeKey']) {
            pointRef = seriesRef.data[j];
            break;
          }
        }

        if (pointRef) {
          component.customAction = act['action'];
          pointRef.firePointEvent('click');
        }
      }

    } else {
      component.customAction = null;
      component.trackActionBkp = null;
      //component.chartRef.redraw();
    }
  };

  that.pointTriggeredClick = function (event, component) {
    component.eventPoint = event.target;
    component.nodeLevel = component.eventPoint.level;
    component.selectedlevel(Number(component.nodeLevel));
    component.seriesColumnkey = component.eventPoint.columnKey;
    component.nodeKey = component.eventPoint.Namekey;
    component.parentKey = component.eventPoint.parentKey;
    if (component.customAction == "expand") {
      if (component.eventPoint.Namekey) {
        component.eventPoint.select(!1, !1);
        that.expandCollapseHandler(component);
      }
    } else if (component.customAction == "drilldown") {
      if (!component.eventPoint.seriesOptions && component.isHierarchy) {
        if (typeof component.drilldownjson[component.nodeKey + '-' + component.seriesColumnkey] == 'undefined') {
          component.selectednode(component.nodeKey);
          component.selecteddimension(component.dataRes.dimensions[component.selectedDimension].key);
          component.firePropertiesChangedAndEvent([
            'selectednode',
            'selecteddimension'
          ], 'onHExpand');
          component.drilldownflag = 1;
        } else {
          that.hierarchyDrilldownFromJson(component);
        }
      } else {
        that.hierarchyDrilldownFromJson(component);
      }
    } else if (component.customAction == "select") {
      component.eventPoint.select(!0, !0);
      that.rebuildActionsRecursive(component);
    }
  };

  /**
     * @param {Object} obj - The object which needs to be augmented with properties
     * @param {string} path - The string which represents the '.' separated properties to access the value Eg. 'title.text' or 'xAxis.labels.enabled'
     * @param {*} value - Value to set at the mentioned path
     */
    that.addProperty = function addProperty(obj, path, value){
        var self = this;
        if(!obj){
            return;
        }
        var keys = path.split('.');
        var lastKey = keys.pop();
        var parent = obj;
        _.each(keys, function(key){
            parent =  self.assignValue(parent, key);   
        });
        self.assignValue(parent, lastKey, value);
    };


    that.assignValue = function assignValue(parent, key, value){
        var regex = /([\w\d]*)\[(\d*)\]/g;
        var val = regex.exec(key);
        var index;
        if(val){ // is Array Reference
        key = val[1];
        index = Number(val[2]);
        if(typeof parent[key] === 'undefined' || !_.isArray(parent[key])){
                parent[key] = [];
            }        
            if(typeof parent[key][index] === 'undefined'){
                parent[key][index] = typeof value !== 'undefined' ? value : {}; //Object.create(null,{});
            } 
            parent = parent[key][index];        
        }
        else{
            if(typeof parent[key] === 'undefined'){
                parent[key] = typeof value !== 'undefined' ? value : {}; //Object.create(null,{});
            }
            parent = parent[key];
        }
        return parent;
    };
    /**
     * This function serves dual purpose of providing 
     * 1) All the highcharts related scriptable properties
     * 2) Custum function for each property to update Highcharts Object
     * @return {Object | Array} If function is provided with parameters then hcprops object will be returned otherwise only keys in hcprops will be returned
     */
    that.getScriptableProperties = function(params){
        var self = this;
        var component;
        var hcOptions;
        var vbiHighchartsDefault;
        var vbiNumberFormat;
        var decimalsep;
        var thousandsep;
        var thousandseptool;
        var decimalseptool;
        var cid;
        if(params){
            component = params.component;
            hcOptions = params.hcOptions;
            vbiHighchartsDefault = params.vbiHighchartsDefault;
            vbiNumberFormat = params.vbiNumberFormat;
            decimalsep = component.bulletdecimalseparator();
	          thousandsep = component.bulletthousandseparator();
            thousandseptool = component.tooltipthousandseparator();
            decimalseptool = component.tooltipdecimalseparator();
            cid  = component.CID;
        }
        var hcprops = {
            'piecharttype': function () {
                var chartType = component.piecharttype().toLowerCase();
                var options3d = false;
                var depth = that.piedepth();
                var alpha = that.piealpha();
                if (chartType === 'pie3d') {
                  options3d = true;
                  // depth
                  if (depth < 25) {
                    depth = 40;
                  }
                  // alpha
                  if (alpha < 35) {
                    alpha = 35;
                  } else if (that.piealpha() > 85) {
                    alpha = 85;
                  }
                  self.addProperty(hcOptions, 'plotOptions.pie.depth', depth);
                  self.addProperty(hcOptions, 'chart.options3d.alpha', alpha);
                }                
                self.addProperty(hcOptions, 'chart.options3d.enabled', options3d);
            },

            'funnelcharttypedd': function(){
              var chartType = component.funnelcharttypedd().toLowerCase();
              chartType = chartType.split('-')[0];
              self.addProperty(hcOptions, 'chart.type', chartType);
            },

                      
            // Title
            'titletext': function () {
                var newVal = component.titletext() === undefined ? '' : component.titletext();
                self.addProperty(hcOptions, 'title.text', newVal);
            },

            'titleenable': function () {
                var newVal = component.titleenable() === true ? 'block' : 'none';
                self.addProperty(hcOptions, 'title.style.display', newVal);
            },

            // Subtitle
            'subtitletext': function () {
                var newVal = component.subtitletext() === undefined ? '' : component.subtitletext();
                self.addProperty(hcOptions, 'subtitle.text', newVal);
            },

            'subtitleenable': function () {
                var newVal = component.subtitleenable() === true ? 'block' : 'none';			
                self.addProperty(hcOptions, 'subtitle.style.display', newVal);			
            },

            //Tooltip
            'tooltipenable': function () {
                self.addProperty(hcOptions, 'tooltip.formatter', tooltipFormatter);
            },

            'tooltipvaluedecimals': function () {
                self.addProperty(hcOptions, 'tooltip.formatter', tooltipFormatter);
            },

            'tooltipvalueprefix': function () {
                self.addProperty(hcOptions, 'tooltip.formatter', tooltipFormatter);
            },

            'tooltipvaluesuffix': function () {
                self.addProperty(hcOptions, 'tooltip.formatter', tooltipFormatter);
            },

            // Export
            //'exportedfilename': function () {},

            // DataLabel
            'datalabelenabled': function () {
                var newVal = component.datalabelenabled();
                var objectPath;
                if(cid === 'pieDD'){
                  objectPath = 'plotOptions.pie.dataLabels.enabled';
                }
                else{
                  objectPath = 'plotOptions.series.dataLabels.enabled';
                }			
                self.addProperty(hcOptions, objectPath, newVal);
            },
            'datalabelprefix': function () {
                var objectPath;
                if(cid === 'pieDD'){
                  objectPath = 'plotOptions.pie.dataLabels.formatter';
                }
                else{
                  objectPath = 'plotOptions.series.dataLabels.formatter';
                }	
                self.addProperty(hcOptions, objectPath, dataLabelFormatter);
            },
            'datalabelsuffix': function () {
                var objectPath;
                if(cid === 'pieDD'){
                  objectPath = 'plotOptions.pie.dataLabels.formatter';
                }
                else{
                  objectPath = 'plotOptions.series.dataLabels.formatter';
                }	
                self.addProperty(hcOptions, objectPath, dataLabelFormatter);
            },
            'bulletdecimalseparator': function () {
                var objectPath;
                if(cid === 'pieDD'){
                  objectPath = 'plotOptions.pie.dataLabels.formatter';
                }
                else{
                  objectPath = 'plotOptions.series.dataLabels.formatter';
                }	
                self.addProperty(hcOptions, objectPath, dataLabelFormatter);
            },
            'bulletthousandseparator': function () {
                var objectPath;
                if(cid === 'pieDD'){
                  objectPath = 'plotOptions.pie.dataLabels.formatter';
                }
                else{
                  objectPath = 'plotOptions.series.dataLabels.formatter';
                }	
                self.addProperty(hcOptions, objectPath, dataLabelFormatter);
            },
            'decimal': function () {
                var objectPath;
                if(cid === 'pieDD'){
                  objectPath = 'plotOptions.pie.dataLabels.formatter';
                }
                else{
                  objectPath = 'plotOptions.series.dataLabels.formatter';
                }	
                self.addProperty(hcOptions, objectPath, dataLabelFormatter);
            }

        };

        return params ? hcprops : Object.keys(hcprops);
        
        // formatter functions        
        function tooltipFormatter() {
            if(component.customtooltip() !== ""  && Object.keys(JSON.parse(component.customtooltip()||'{}')).length){
                return vbiNumberFormat.DrillDownFamilyTooltipFormatter(this,component,decimalseptool,thousandseptool,false);
            }else {
                return vbiNumberFormat.piedrilldownFamilyTooltip(this,component,decimalseptool,thousandseptool);
            }
        }
        function dataLabelFormatter() {
            try {
                if (component.customdatalabel() !== "" && Object.keys(JSON.parse(component.customdatalabel() || '{}')).length) {
                    return vbiNumberFormat.drillDownFamilyFormatterDataLabel(this, component, decimalsep, decimalsep, false);
                } else {
                    return vbiNumberFormat.piedrilldownFamilyDataLabelFormatter(this, component, decimalsep, thousandsep);
                }
            } catch (e) {}
        }
    };

    /**
     * function to update oControlPropertiesHcProps object with the values in oControlProperties.
     * oControlPropertiesHcProps will be used in updateHighchartsProp function to check if a value of property has changed.
     * This function should be executed at the end of afterUpdate becuase updateHighchartsProp will be called somewhere in the middle.
     * 
     */
    that.updateOcontrolPropertiesHcProps = function(component){
        var self = this;
        var properties = self.getScriptableProperties();
        if(!component.oControlPropertiesHcProps){
            component.oControlPropertiesHcProps = {};
        }
        _.each(properties, function(props){
              component.oControlPropertiesHcProps[props] = component.oControlProperties[props];
        });
    };


    /**
     * Function to update the chart without refresh/reload. The feature is limited to highchart related properties
     */
    that.updateHighchartsProp = function (component, vbiNumberFormat, vbiHighchartsDefault) {
        var self = this;
        var chart = component.chartRef;
        var options = chart.options;
        var hasChanged = 0;
        var hcOptions = {}; //Object.create(null,{});
        var highchartProperties = [];
        var hcprops = self.getScriptableProperties({
            component: component,
            hcOptions: hcOptions,
            vbiHighchartsDefault: vbiHighchartsDefault,
            vbiNumberFormat: vbiNumberFormat
        });        
        try{
            _.each(Object.keys(hcprops), function(props){
                if(component.oControlPropertiesHcProps && typeof component.oControlProperties[props] !== "undefined" && component.oControlProperties[props] !== component.oControlPropertiesHcProps[props]){
                    hcprops[props]();
                }
            });
        }catch(e){
            //console.log(e);
        }

        if (Object.keys(hcOptions).length) {
            setTimeout(function(){
                chart.update(hcOptions);
            },500); //Timeout is added so that the update is smooth after drilldown or expand/collapse
            
            //component.afterUpdate();
        }
    };
}
