function riskPrototype(that) {
  this.self = that;
  this.vbiNumberFormat = new VbiNumberFormat();//jshint ignore:line
}

riskPrototype.prototype.legends = function(data) {
  this.self.$().find('.chartLegend').append('<div class="legendLabel"><text class="legendTitle">' + this.self.legendtitletext() + '</text></div>');
  var legendTopval;
  if (this.self.legendverticalalign() == 'top') {
    legendTopval = 5;
  }else if (this.self.legendverticalalign() == 'middle') {
    legendTopval = this.self.$().find('.chartLegend').height() / 2 - 25;
  }else if(this.self.legendverticalalign() == 'bottom'){ // for the issue VBX141-3730
    legendTopval = this.self.$().find('.chartLegend').height() -60;
  }

  this.self.$().find('.legendLabel').css({
    'box-shadow': this.self.legendshadow() === true ? '1px 1px 10px 1px #bbbbbb' : '',
    'padding': '0 ' + this.self.legendpadding() + 'px',
    'width': '100%',
    'height': 'auto',
    'margin-top': legendTopval,
    'margin-right': '5px'
  });

  this.self.$().find('.legendTitle').css({
    'color': this.self.legendtitlecolor(),
    'font-weight': this.self.legendtitlefontweight(),
    'font-size': this.self.legendtitlefontsize(),
    'font-family': this.self.globalfontfamily === '' ? this.self.legendtitlefontfamily() : this.self.globalfontfamily
  });

  var textFloat = this.self.legendsymboltoright() === true ? 'left' : 'right',
      symbolFloat = this.self.legendsymboltoright() === true ? 'right' : 'left',
      dataLegend = data,
      legendDist = 0,
      calculateIndex;

  for (var i in dataLegend) {
    // 'legenditemdistance',legenditemwidth',
    if (this.self.legendreversed()){
      var calculateIndex = (Object.keys(dataLegend).length + 1) - i;
    } else {
      var calculateIndex = i;
    }
    
    if(this.self.legendlayout() != 'horizontal'){
       this.self.$().find('.legendLabel').append('<div class="' + dataLegend[calculateIndex].colorrange + i + '" style="width:100%;height:20px;margin-top:' + this.self.legenditemmargintop() + 'px;margin-bottom:' + this.self.legenditemmarginbottom() + 'px"><span class="' + dataLegend[calculateIndex].colorrange + i + ' legendLabelBox" style=\'width:10px;height:10px;float:' + symbolFloat + ';margin: 0 5px;margin-right:' + this.self.legendsymbolpadding() + 'px;border-radius:5px;background-color:' + dataLegend[calculateIndex].colorValue + '\'></span><span class="' + dataLegend[calculateIndex].colorrange + i + ' legendLabelBox legendText">' + dataLegend[calculateIndex].colorrange + ' ( ' + dataLegend[calculateIndex].startValue + ' - ' + dataLegend[calculateIndex].endValue + ' )</span></div>');
    }
    else{
      this.self.$().find('.legendLabel').append('<div class="' + dataLegend[calculateIndex].colorrange + i + '" style="width:100%;position:absolute;left:'+  legendDist + 'px;right:'+  legendDist + 'px;height:20px;margin-top:' + this.self.legenditemmargintop() + 'px;margin-bottom:' + this.self.legenditemmarginbottom() + 'px"><span class="' + dataLegend[calculateIndex].colorrange + i + ' legendLabelBox" style=\'width:10px;height:10px;float:' + symbolFloat + ';margin: 0 5px;margin-right:' + this.self.legendsymbolpadding() + 'px;border-radius:5px;background-color:' + dataLegend[calculateIndex].colorValue + '\'></span><span class="' + dataLegend[calculateIndex].colorrange + i + ' legendLabelBox legendText">' + dataLegend[calculateIndex].colorrange + ' ( ' + dataLegend[calculateIndex].startValue + ' - ' + dataLegend[calculateIndex].endValue + ' )</span></div>');
    }
    
     legendDist  += this.self.$().find('.legendLabelBox').width() + 2 * this.self.$().find('.legendText').width();
  }

  this.self.$().find('.legendText').css({
    'color': this.self.legenditemstylecolor(),
    'cursor': 'pointer',
    'font-size': this.self.legenditemfontsize() + 'px',
    'font-family': this.self.globalfontfamily === '' ? this.self.legenditemfontfamily() : this.self.globalfontfamily,
    'font-weight': this.self.legenditemfontweight(),
    'text-decoration': this.self.legenditemfontweight(),
    'float': textFloat,
    'width': '85%',
    'white-space': 'nowrap',
    'text-align': 'left'
  });

  var hoverColor = this.self.legenditemhoverstylecolor(),
      normalColor = this.self.legenditemstylecolor(),
      hiddenColor = this.self.legenditemhiddenstylecolor();

  this.self.$().find('.legendText').hover(function() {
    $(this).css('color', hoverColor);
  }, function() {
    $(this).css('color', normalColor);
  });

  this.self.$().find('.legendLabelBox').click(function() {
    if ($('.matrixContainer').find('.' + $(this).parent().attr('class')).css('visibility') == 'hidden') {
      $('.matrixContainer').find('.' + $(this).parent().attr('class')).css('visibility', 'visible');
      $(this).css('color', normalColor);
    }else {
      $('.matrixContainer').find('.' + $(this).parent().attr('class')).css('visibility', 'hidden');
      $(this).css('color', hiddenColor);
    }
  });

  this.self.$().find('.legendLabel').css({
    	'border': this.self.legendborderwidth() + 'px solid ' + this.self.legendbordercolor(),
    	'border-radius': this.self.legendborderradius(),
    	'background-color': this.self.legendbackgroundcolor()
  });
};

riskPrototype.prototype.datalabelprocess = function(data, measure) {
  var formattedDataValue = '';
  if(this.self.numberFormatDefinition() === 'initialView'){
    formattedDataValue = this.vbiNumberFormat.processDataLabelInitialView(null, this.self, measure, data);
  }else{
    formattedDataValue = this.vbiNumberFormat.processDataLabel(this.self, null, measure, false, this.self.progressdecimalseparator(), this.self.progressthousandseparator(), false, data);
  }
  if(formattedDataValue){
    formattedDataValue = formattedDataValue.replace(/(<([^>]+)>)/ig,'');
  }
  var measures = measure ? this.self.measures[this.self.keys.indexOf(measure)] + ' ': '';
  return  measures + formattedDataValue;
};

riskPrototype.prototype.tooltip = function(data) {
  var risktooltipObj;

  this.self.$().find('.tooltip').html('');

  if(this.self.risktooltipdisplay()){
    risktooltipObj = JSON.parse(this.self.risktooltipdisplay());
  }else{
    risktooltipObj = {
      'x-axis': true,
      'y-axis': false,
      'size-axis': false
    };
  }

  var pHtml = '<p>' + data.dimensions + '<br/>';

  function appendTooltip(comp, measure, value, type){
    var tooltipData = '';
    if(comp.self.numberFormatDefinitionTooltip() === 'initialView'){
      tooltipData = comp.vbiNumberFormat.processTooltipInitialView(null, comp.self, measure, false, value);
    }else{
      tooltipData = comp.vbiNumberFormat.processData(comp.self, null, measure, false, comp.self.tooltipdecimalseparator(), comp.self.tooltipthousandseparator(), false, value);
    }
    pHtml += (comp.self.measures[comp.self.keys.indexOf(measure)]) ? comp.self.measures[comp.self.keys.indexOf(measure)] +  ' (' + type + ') : ' + tooltipData + '<br/>' : '';

  }

  if (risktooltipObj["x-axis"]){
    appendTooltip(this, this.self.xaxismeasure(), data.xValue, 'x');
  }

  if (risktooltipObj["y-axis"]){
    appendTooltip(this, this.self.yaxismeasure(), data.yValue, 'y');
  }

  if (this.self.enablesize() && this.self.sizemeasure() && risktooltipObj["size-axis"]){
    appendTooltip(this, this.self.sizemeasure(), data.zValue, 'z');
  }

  this.self.$().find('.tooltip').append(pHtml).css('visibility', 'visible');
};

riskPrototype.prototype.setCredits = function() {
  $('#' + this.self.$()[0].id).append('<div class=\'creditClass\'></div>');
  this.self.$().find('.creditClass').append('<a href=\'' + this.self.creditshref() + '\' style="color: '+ this.self.creditstextcolor() +'">' + this.self.creditstext() + '</a>');

  var xPos = this.self.creditsalign(),
      yPos = this.self.creditsverticalalign();
  var cssProp = {
    'z-index': 2,
    'position': 'absolute',
    'font-size': this.self.creditsfontsize() + 'px',
    'cursor': this.self.creditscursor(),
    'font-family': this.self.globalfontfamily === '' ? this.self.creditsfontfamily() : this.self.globalfontfamily,
    'font-weight': this.self.creditsfontweight()
  };
  if (xPos == 'center') {
    cssProp['left'] = (this.self.$().width()/2) - this.self.creditsxposition();
  }else {
    cssProp[xPos] =  -this.self.creditsxposition();
  }

  if (yPos == 'middle') {
    cssProp['top'] = (this.self.$().height()/2) + this.self.creditsyposition();
  }else {
    cssProp[yPos] = this.self.creditsyposition();
  }

  this.self.$().find('.creditClass').css(cssProp);

};
