function superCombinationSeries() {// jshint ignore:line
  var that = this;
  /**
  	 * Map data from JSON Tuple to Highchart
  	 * @override
  	 * @param {object} component - Reference to component
  	 * @param {string} type - type of the chart
  	 * @param {object} defaultValue - HighCharts values
  	 * @return {Array} seriesNames
  	 */
  that.createSeriesData = function(component, type, defaultValue, cfStatus) {
    var self = this, ruleInfo = '', noOfColumns = 0, /*noOfCellsInRow = 1, noOfRows = 0,*/ selectedColumndimIndexes = [], selectedRowdimIndexes = [], measureDimensionIndex = component.getMeasureIndex(), measureInRow = component.dataRes.dimensions[measureDimensionIndex].axis === 'ROWS' ? true : false, seriesData = [];
    defaultValue.xAxis.categories = [];
    //alert("Component.dataRes==="+ JSON.stringify(component.dataRes));
    if (component.dataRes === undefined || component.dataRes === '') {
      return '';
    }

    for (var i = 0; i < component.dataRes.dimensions.length; i++) {
      if (component.dataRes.dimensions[i].axis == 'COLUMNS') {
        noOfColumns++;
      }
    }
    measureDimensionIndex = _.parseInt(measureDimensionIndex);
    if (measureInRow) {
      selectedRowdimIndexes.push(measureDimensionIndex);
    } else {
      selectedColumndimIndexes.push(measureDimensionIndex);
    }

    var bardatacustomizationJson = {
      'COLUMNS': [],
      'ROWS': []
    };
    if (component.bardatacustomization() !== '') {
      bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
    }

   if (component.datautility() === true && (bardatacustomizationJson['COLUMNS'].length === 0 && bardatacustomizationJson['ROWS'].length === 0)) {
      this.createSmokeScreen(component.$(), 'Please select Dimension in Data Utility');
    } else {
      for (var i = 0; i < noOfColumns; i++) {
        if (i != measureDimensionIndex) {
          selectedColumndimIndexes.push(i);
        }
      }

      for (var i = noOfColumns; i < component.dataRes.dimensions.length; i++) {
        if (i != measureDimensionIndex) {
          selectedRowdimIndexes.push(i);
        }
      }
    }

    var ruleInfo = '';
    if (cfStatus != 'ncf') {
      if (component.ruletable() !== undefined && component.ruletable() !== '' && component.ruletable() != '{}') {
        that.updateRuleInfo(component, 'bar');
        //alert("ruletable="+component.ruletable());
        ruleInfo = JSON.parse(component.ruletable());
      }
    }

    component.selectedColumndimIndexes = selectedColumndimIndexes;
    component.selectedRowdimIndexes = selectedRowdimIndexes;
    var defaultColor = [
      '#B586DA',
      '#FF6657',
      '#F3A730',
      '#946B66',
      '#B0AD53',
      '#7AC1DE',
      '#F1C337',
      '#566C6C',
      '#A1CC54',
      '#543F1E'
    ];
    var seriesColor = [];
    if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
      seriesColor = [];
    } else {
      seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
    }

    var tuplesInaRow = component.dataRes.tuples.slice(0, component.dataRes.columnCount);
    // Getting tuples for all Columns in first row of crosstab.
    var colRowIndexJson = {};
    var colNamesJson = {};
    var scalingValues = [];
    var unitValues = [];
    component.measureInOriginalSeries = {};
    component.categoryInOriginalSeries = {};
    component.columnInOriginalSeries = {};
    component.categoriesIndex = [];
    for (var i = 0; i < component.dataRes.dimensions[measureDimensionIndex].members.length; i++) {
      if (typeof component.dataRes.dimensions[measureDimensionIndex].members[i].scalingFactor == 'undefined') {
        scalingValues.push('');
      } else {
        scalingValues.push(component.scalingfactorenable() === true ? Math.pow(10, component.dataRes.dimensions[measureDimensionIndex].members[i].scalingFactor || '') : '');
      }
    }

    for (var i = 0; i < component.dataRes.dimensions[measureDimensionIndex].members.length; i++) {
      if (typeof component.dataRes.dimensions[measureDimensionIndex].members[i].unitOfMeasure == 'undefined') {
        unitValues.push('');
      } else {
        unitValues.push(component.showunit() === true ? component.dataRes.dimensions[measureDimensionIndex].members[i].unitOfMeasure || '' : '');
      }
    }

    //var displayunit = '';
    var seriesType = component.dataseriestype().split(',');
    // Checking for measureColorPair
    var measureColorPair;
    if (component.hasOwnProperty('measurecolorpair')) {
      if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
        measureColorPair = JSON.parse(component.measurecolorpair());
      }
    }
    //Checking for measuretypepair
      var measureTypePair;
    if (component.hasOwnProperty('measuretypepair')) {
      if (!(component.measuretypepair() === undefined || component.measuretypepair() === '')) {
        measureTypePair = JSON.parse(component.measuretypepair());
      }
    }
    //Checking for measureMarkerPair
    var measureMarkerPair;
    if (component.hasOwnProperty('measuremarkerpair')) {
      if (!(component.measuremarkerpair() === undefined || component.measuremarkerpair() === '')) {
        measureMarkerPair = JSON.parse(component.measuremarkerpair());
      }
    }

    var measureDimIndex;
    for (var i = 0; i < component.dataRes.dimensions.length; i++) {
      if (component.dataRes.dimensions[i].containsMeasures === true) {
        measureDimIndex = i;
        break;
      }
    }

    var markerarray={};
	var hasResultIntupleCol = {};
	var showtotaldatabase = component.showtotaldatabase();
	var datautility = component.datautility();
    for (var i = 0; i < tuplesInaRow.length; i++) {
      var tempTuple = tuplesInaRow[i].slice(0, noOfColumns);
      if (self.vbiCharts.eliminateResult(component.dataRes, tempTuple,undefined,true) === true) {
        var colKey = [];
        var colName = [];
        var ColumnKey = [];
        for (var j = 0; j < selectedColumndimIndexes.length; j++) {
          var tempCol = selectedColumndimIndexes[j];
          colName.push(component.dataRes.dimensions[tempCol].members[tempTuple[tempCol]].text);
          ColumnKey.push(component.dataRes.dimensions[tempCol].members[tempTuple[tempCol]].key);
          colKey.push(tempCol + ':' + tempTuple[tempCol]);
        }

        var newKey = colKey.join('-');
        colName = _.filter(colName, function(x) {              
            return (x != '' && x!= null && x!=" ");
        });
        var seriesName = colName.join('-');
        if (!measureInRow) {
          seriesName = self.formatSeriesName(component, seriesName, measureDimensionIndex + ':' + tempTuple[measureDimensionIndex], {});
        }

        /*if (component.scalingfactorenable() && colName.join('-').indexOf('(* ') === -1) {
          seriesName += (typeof tempTuple[measureDimensionIndex] === 'undefined' || scalingValues[measureDimensionIndex] === '' ? '' : ' (* ' + scalingValues[tempTuple[measureDimensionIndex]] + ' )');
        }
        if(component.showunit() && colName.join('-').indexOf('(in ') === -1){
          seriesName += (typeof tempTuple[measureDimensionIndex] === 'undefined' || unitValues[measureDimensionIndex] === '' ? '' : ' (in ' + unitValues[tempTuple[measureDimensionIndex]] + ' )');
        }*/

        if (typeof colRowIndexJson[newKey] == 'undefined') {
          colRowIndexJson[newKey] = [];
          var colorvalue = self.getSeriesColors(component, seriesColor, seriesData.length, defaultColor);
          markerarray = {
            enabled: true,
            fillColor: self.getSeriesColors(component, seriesColor, seriesData.length, defaultColor)
          };
          var ColumnKeyStr = ColumnKey.join('-');
          var typearray = seriesType[seriesData.length % seriesType.length];
          if (measureColorPair && measureColorPair[ColumnKeyStr] !== undefined) {
            colorvalue = measureColorPair[ColumnKeyStr].color;
          }
          //alert("yes111");
          if (measureMarkerPair && measureMarkerPair[ColumnKeyStr] !== undefined) {//alert("yes");
            markerarray = {
              enabled: measureMarkerPair[ColumnKeyStr].enabled,
              radius:parseFloat( measureMarkerPair[ColumnKeyStr].size),
              symbol: measureMarkerPair[ColumnKeyStr].symbol,
              fillColor: measureMarkerPair[ColumnKeyStr].color,
              states: {
                hover: {
                  enabled: measureMarkerPair[ColumnKeyStr].hoverenable,
                  radius: parseFloat(measureMarkerPair[ColumnKeyStr].size)
                }
              }
            };
          //  alert("yes211");
          }

          if (component.hasOwnProperty('enablemarker') && !component.enablemarker()){
          	markerarray = {};
          }
          if (measureTypePair && measureTypePair[ColumnKeyStr] !== undefined) {
            typearray = measureTypePair[ColumnKeyStr];
          }
          // used for storing all the position of particular measure  in the series.
          if (!measureInRow) {
            if (component.measureInOriginalSeries[ColumnKey[0]] === undefined) {
              component.measureInOriginalSeries[ColumnKey[0]] = selectedColumndimIndexes.length > 1 ? {} : seriesData.length;
            }

            if (typeof component.measureInOriginalSeries[ColumnKey[0]] == 'object') {
              component.measureInOriginalSeries[ColumnKey[0]][ColumnKey.slice(1).join('-')] = seriesData.length;
            }
          } else {
            component.columnInOriginalSeries[ColumnKey.join('-')] = seriesData.length;
          }

          seriesData.push({
            name: seriesName,
            key: newKey,
            uniquekey: ColumnKey[0],
            color: colorvalue,
            type: typearray.type,
            marker: markerarray,
            data: []
          });
        }

        colRowIndexJson[newKey].push(i);
		/*#VBX141-4729*/

        colNamesJson[newKey] = seriesName;
      }
    }

    seriesColor.splice(seriesData.length, seriesColor.length);
    component.dataseriescolor(seriesColor.join());
    //console.log("col_row_index_json="+JSON.stringify(col_row_index_json));
    var tupleToSkip = 0;
    var tuplesInColumn = [];
    var rowNames = {};
    var rowDataJson = {};
	var rowDataJsonWithInfo = {};
    for (var i = 0; i < component.dataRes.rowCount; i++) {
      //rowDataArr.push([]);
      tupleToSkip = component.dataRes.columnCount * i;
      tuplesInColumn.push(component.dataRes.tuples[tupleToSkip]);
      var tempTuple = tuplesInColumn[i];
	  
	  /*#VBX141-4729*/
	  var hasResultIntuple = [];
	
		
      if (self.vbiCharts.eliminateResult(component.dataRes, tempTuple, 'ROWS',true) === true) {
        var rowKey = 0;
        var rowHeader = 'Dimensions';
        var rowHeaderKey = 'Dimensions';
        if (selectedRowdimIndexes.length >= 1) {
          rowKey = selectedRowdimIndexes[0] + ':' + tempTuple[selectedRowdimIndexes[0]];
          rowHeaderKey = component.dataRes.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].key;
          rowHeader = component.dataRes.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].text;
          if (measureInRow) {

            if (component.scalingfactorenable() && rowHeader.indexOf('(* ') === -1) {
              rowHeader += typeof tempTuple[measureDimensionIndex] == 'undefined' || scalingValues[tempTuple[measureDimensionIndex]] === '' ? '' : ' (* ' + scalingValues[tempTuple[measureDimensionIndex]] + ' )';
            }

            if (component.showunit() && rowHeader.indexOf('(in ') === -1) {
              rowHeader += typeof tempTuple[measureDimensionIndex] == 'undefined' || unitValues[tempTuple[measureDimensionIndex]] === '' ? '' : ' (in ' + unitValues[tempTuple[measureDimensionIndex]] + ' )';
            }
            //            rowHeader += typeof tempTuple[measureDimensionIndex] === 'undefined' || scalingValues[tempTuple[measureDimensionIndex]] === '' ? '' : ' (* ' + scalingValues[tempTuple[measureDimensionIndex]] + ' )';

          }

          for (var j = 1; j < selectedRowdimIndexes.length; j++) {
            //rowKey+=":"+temp_tuple[component.selectedRowIndex[j]];
            rowKey += '-' + selectedRowdimIndexes[j] + ':' + tempTuple[selectedRowdimIndexes[j]];
            // jscs:disable
            if(component.dataRes.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].text !== ''){
              rowHeader += (rowHeader !=="" ? '\\' : '') + component.dataRes.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].text;
            }
            rowHeaderKey += '\\' + component.dataRes.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].key;  // jscs:enable
          }

          if (measureInRow) {
            rowHeader = self.formatSeriesName(component, rowHeader, measureDimensionIndex + ':' + tempTuple[measureDimensionIndex], {});
          }
        }

        if (typeof rowNames[rowKey] == 'undefined') {
          //rowDataJson[rowKey]=[];
          rowNames[rowKey] = {
            key: rowHeaderKey,
            text: rowHeader
          };
          //defaultValuexAxiscategories.push(rowHeader);
          component.categoriesIndex.push(rowKey);
        }

        $.each(colRowIndexJson, function(key, value) {
          $.each(value, function(index, newval) {
				var curIndex = newval + tupleToSkip;
				var keygen = key + '_' + rowKey;
				if (rowDataJson[keygen] === undefined) {
					rowDataJson[keygen] = [];
					rowDataJsonWithInfo[keygen] = [];
				}

				rowDataJson[keygen].push(component.dataRes.data[curIndex]);//VBX141-4827
				/*#VBX141-4729*/
				if(datautility && showtotaldatabase && (hasResultIntuple.length || hasResultIntupleCol[newval].length)){	
					var lastTempStore, lastTempstoreLen = 0;
					var totalLen = hasResultIntupleCol[newval].length + hasResultIntuple.length;
					if(rowDataJsonWithInfo[keygen].length){
						lastTempStore = rowDataJsonWithInfo[keygen][rowDataJsonWithInfo[keygen].length - 1];
						lastTempstoreLen = lastTempStore[0];
					}
					if(lastTempstoreLen < totalLen){
						rowDataJsonWithInfo[keygen].length = 0;						
					}					
					rowDataJsonWithInfo[keygen].push([totalLen , (component.dataRes.data[curIndex] === null ? 0 : component.dataRes.data[curIndex])]);
				}
          });
        });
      }
    }
	
	/*#VBX141-4729*/
	if(datautility && showtotaldatabase){
		$.each(rowDataJsonWithInfo, function(k, v){
			if(v.length){
				rowDataJson[k].length = 0;
				for(var i=0, len=v.length; i<len; i++){
					rowDataJson[k].push(Number(v[i][1]));
				}
			}
		});
	}
    //			alert(JSON.stringify(rowNames))
    var categoryDataRowAggr = [];
    var finalCategoryNames = [];
    var finalCategorykeys = [];
    $.each(rowNames, function(key, names) {
      if (measureInRow) {
        // jscs:disable
        var rowKeyArr = names.key.split('\\');
        // jscs:enable
        for (var i = 0; i < rowKeyArr.length; i++) {
          if (component.measureInOriginalSeries[rowKeyArr[0]] === undefined) {
            component.measureInOriginalSeries[rowKeyArr[0]] = rowKeyArr.length > 1 ? {} : finalCategoryNames.length;
          }

          if (typeof component.measureInOriginalSeries[rowKeyArr[0]] == 'object') {
            // jscs:disable
            component.measureInOriginalSeries[rowKeyArr[0]][rowKeyArr.slice(1).join('\\')] = finalCategoryNames.length;  // jscs:enable
          }
        }
      }

      component.categoryInOriginalSeries[names.key] = finalCategoryNames.length;
      for (var i = 0; i < seriesData.length; i++) {
        var genKey = seriesData[i].key + '_' + key;
        var yVal = that.barValueAggregation(component, rowDataJson[genKey]);
        if (component.hasOwnProperty('measuremarkerpair')) {
          if(component.ruletable() === "" || component.ruletable() === "{}"){ //VBX141-4372
            seriesData[i].data.push({
              y: yVal
            });
          }else{
            seriesData[i].data.push({
              y: yVal,
              color: seriesData[i].marker.fillColor
            });
          }
        } else {
          seriesData[i].data.push({y: yVal});
        }
      }

      finalCategoryNames.push(names.text);
      finalCategorykeys.push(names.key);
    });

    categoryDataRowAggr = seriesData;
    that.defaultvalueseriesdata = seriesData;
    component.categoryNames = finalCategoryNames;
    /*if(ruleInfo !== "")
    			{
    				try{
    						that.createCFData(component, 'bar', component.fulljson());
    						that.processConditionalFormatting(component,categoryDataRowAggr,ruleInfo,"bar");
    				}catch(e){}


    			}*/
    /*for(var i =0;i<categoryDataRowAggr.length;i++){
    			for(var j=0;j<categoryDataRowAggr[i].data.length;j++){
    			if(categoryDataRowAggr[i].type.indexOf("line") === -1 && categoryDataRowAggr[i].type.indexOf("area") === -1 )
    				categoryDataRowAggr[i].data[j] ={y:Number(categoryDataRowAggr[i].data[j])} ;
    			else
    				categoryDataRowAggr[i].data[j] ={y:Number(categoryDataRowAggr[i].data[j]),color:categoryDataRowAggr[i].marker.fillColor} ;

    			}

    		}*/
    //new code for super comb
    //code to find the average data for spline
    var columnDataLength = categoryDataRowAggr.length;
    var averageDataJson={};
    if (component.seriesaverage() && columnDataLength) {
      var averageData = [];
      for (var i = 0; i < categoryDataRowAggr[0].data.length; i++) {
        var total = 0;
        for (var j = 0; j < categoryDataRowAggr.length; j++) {
          total += categoryDataRowAggr[j].data[i].y;
        }

        total /= categoryDataRowAggr.length;
        averageData.push(total);
      }

      markerarray = {fillColor: seriesColor[columnDataLength]};
      if (measureColorPair && measureColorPair['Average'] !== undefined) {
        seriesColor[columnDataLength] = measureColorPair['Average'].color;
      }

      if (component.hasOwnProperty('measuremarkerpair')) {
        if (measureMarkerPair && measureMarkerPair['Average'] !== undefined) {
          markerarray = {
            enabled: measureMarkerPair['Average'].enabled,
            radius: parseFloat(measureMarkerPair['Average'].size),
            symbol: measureMarkerPair['Average'].symbol,
            fillColor: measureMarkerPair['Average'].color,
            states: {
              hover: {
                enabled: measureMarkerPair['Average'].hoverenable,
                radius: parseFloat(measureMarkerPair['Average'].size)
              }
            }
          };
        }
      }

      if (component.hasOwnProperty('enablemarker') && !component.enablemarker()){
        markerarray = {};
      }
      if (component.hasOwnProperty('measuretypepair')) {
        if (measureTypePair && measureTypePair['Average'] !== undefined) {
          seriesType[columnDataLength] = measureTypePair['Average'].type;
        }
      }

      var colorIndex = seriesData.length % 10;
      var averageColor = seriesColor[colorIndex];

      if (seriesType[columnDataLength] !== undefined) {
         averageDataJson = {
          type: seriesType[columnDataLength],
          name: 'Average',
          data: averageData,
          marker: markerarray,
          color: averageColor
        };
      } else {
         averageDataJson = {
          type: seriesType[0],
          name: 'Average',
          data: averageData,
          marker: markerarray,
          color: averageColor
        };
      }

      component.dataseriescolor(seriesColor.join());
    }
    //code to generate the pie chart
    var pieData = [];
    for (var i = 0; i < categoryDataRowAggr.length; i++) {
      var total = 0;
      for (var j = 0; j < categoryDataRowAggr[i].data.length; j++) {
        total += categoryDataRowAggr[i].data[j].y;
      }

      pieData.push({
        name: categoryDataRowAggr[i].name,
        y: total,
        color: seriesColor[i]
      });
    }

    var pieDataJson = {
      type: 'pie',
      name: 'Total',
      data: pieData,
      center: [
        component.supercombinationPieChartOffsetx(),
        component.supercombinationPieChartOffsety()
      ],
      size: component.supercombinationPieChartSize(),
      showInLegend: false
    };
    //adding averageData and pie data
    if (component.seriesaverage() && columnDataLength) {
      //seriesNamesinAdditionalProp.push("Average");
      categoryDataRowAggr.push(averageDataJson);
    }

    categoryDataRowAggr.push(pieDataJson);
    /*
    		 * Adding Total Logic in Combination-Chart.
    		 */
    defaultValue.xAxis.categories = [];
    defaultValue.xAxis.categories = defaultValue.xAxis.categories.concat(finalCategoryNames);
    defaultValue.xAxis.categorieskey = [];
    defaultValue.xAxis.categorieskey = defaultValue.xAxis.categorieskey.concat(finalCategorykeys);
    try {
      if (component.enablehierarchylabels() === true) {
       // defaultValue.xAxis.categories = this.createHierarchyLabels(component.dataRes, selectedRowdimIndexes, component);
       //defaultValue.xAxis.categories = this.createHierarchyLabelsStacked(component.dataRes);
        //following code is for VBX141-4714
        var xAxisDefaultCategories = [];
        xAxisDefaultCategories = xAxisDefaultCategories.concat(defaultValue.xAxis.categories);
        var processedCategories = this.createHierarchyLabelsStacked(component, selectedRowdimIndexes, xAxisDefaultCategories);
        defaultValue.xAxis.categories = processedCategories.withHier;
        defaultValue.xAxis.tickmarkPlacement = "between";//VBX141-5140

        /* Following code is required to manipulate the series according to the order of xAxis categories.
        				   This case will occur when the row Dimension selected in Data Utility is not in the same order as in Initial View.
        				*/
        var selRowInd = [];
        selRowInd = selRowInd.concat(selectedRowdimIndexes);
        selRowInd.sort(function(a, b) {
          return a - b;
        });

        if (selRowInd.join(',') != selectedRowdimIndexes.join(',')) {
          var newCategoriesOrder = [];
          $.each(defaultValue.xAxis.categories, function(i, v) {
            that.createFlatCategory(v, newCategoriesOrder, [v.name]);
          });

          var newcategoryDataRowAggr = [];
          $.extend(true, newcategoryDataRowAggr, categoryDataRowAggr);
          $.each(newCategoriesOrder, function(i, v) {
            var k = finalCategoryNames.indexOf(v);
            $.each(newcategoryDataRowAggr, function(ind, ele) {
              var val = ele.data[k];
              categoryDataRowAggr[ind].data[i] = val;
            });
          });
        }
      }
    } catch (e) {
    }

    defaultValue.xAxis.key = [];
    //defaultValue.xAxis.key=defaultValue.xAxis.key.concat(finalCategoryNamesKey);
    component.xaxisMinVal = 0;
    component.yaxisMinVal = 0;
    component.xaxisMaxVal = finalCategoryNames.length;
    component.yaxisMaxVal = Math.max.apply(Math, categoryDataRowAggr);
    defaultValue.series = categoryDataRowAggr;
    /*
    		 * Following code included for adding stacking feature. Loop thru the
    		 * series till second last and identify the chart type & stacking from
    		 * getter. If getter return undefined, assign default chart type and
    		 * stack index as 'column' and current series index respectively, else
    		 * cache the return value. Extract the chart type information and assign
    		 * it to current series. Check if the cahce value has any information
    		 * for stacking. If yes, check if that particular stacking already
    		 * exists in variable 'stacking'. If so, assign the same to stack index
    		 * else set the stacking index for the current type to current series
    		 * index and assign same to series stacking index. If the cache value do
    		 * not contain any stacking information set the stack index for series
    		 * to series index
    		 */
    var stacking = {
      column: undefined,
      area: undefined,
      areaspline: undefined
    };
    for (var i = 0, iLimit = defaultValue.series.length - 1; i < iLimit; ++i) {
      var tempType = defaultValue.series[i].type;
      if (tempType === undefined || tempType === '') {
        defaultValue.series[i].stack = i;
        defaultValue.series[i].type = 'column';
      } else {
        tempType =tempType.toString();
        var splitTempType = tempType.split('-');
        defaultValue.series[i].type = splitTempType[0];
        if (splitTempType.length > 1) {
          if (stacking[splitTempType[0]] === undefined) {
            stacking[splitTempType[0]] = i;
          }

          defaultValue.series[i].stack = stacking[splitTempType[0]];
        } else {
          defaultValue.series[i].stack = i;
        }
      }
      if(component.ruletable()!=="" && component.ruletable() !== "{}"){
        if (defaultValue.series[i].type.indexOf('line') !== -1 && defaultValue.series[i].type.indexOf('area') !== -1) {
            for (var j = 0; j < defaultValue.series[i].data.length; j++) {
              defaultValue.series[i].data[j].color = seriesData[i].marker.fillColor;
            }
          } else {
            for (var j = 0; j < defaultValue.series[i].data.length; j++) {
              defaultValue.series[i].data[j].color = seriesData[i].color;
            }
          }
      }
    }

    if (ruleInfo !== '') {
      try {
        that.createCFData(component, 'bar', component.fulljson());
        that.processConditionalFormatting(component, categoryDataRowAggr, ruleInfo, 'bar');
      } catch (e) {
      }
    }
    /*
    		 * Set the stacking type in the plotOptions to make stacking work
    		 */
    for (var i in stacking) {
      if (stacking[i] !== undefined) {
        defaultValue.plotOptions.series.stacking = 'normal';
        break;
      }
    }

    return 0;  //return seriesNamesinAdditionalProp;
  };

  that.createMeasuresData = function(component, type, defaultValue) {
    var self = this;
    component.categoriesIndex = [];
    var defaultColor = [
      '#B586DA',
      '#FF6657',
      '#F3A730',
      '#946B66',
      '#B0AD53',
      '#7AC1DE',
      '#F1C337',
      '#566C6C',
      '#A1CC54',
      '#543F1E'
    ];
    var seriesColor = [];
    component.measureInOriginalSeries = {};
    component.categoryInOriginalSeries = {};
    component.columnInOriginalSeries = {};
    if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
      seriesColor = [];
    } else {
      seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
    }

    var ruleInfo = '';
    if (component.ruletable() !== undefined && component.ruletable() !== '' && component.ruletable() !== '{}') {
      that.updateRuleInfo(component, 'bar');
      //alert("ruletable="+component.ruletable());
      ruleInfo = JSON.parse(component.ruletable());
    }

    var categoryDataRowAggr = [];
    defaultValue.xAxis.categories = [' '];
    var measureColorPair;
    if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
      measureColorPair = JSON.parse(component.measurecolorpair());
    }

    var seriesColor = component.dataseriescolor().split(',');
    var seriesType = component.dataseriestype().split(',');
    if (component.dataRes.dimensions[0].axis == 'COLUMNS') {
      for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {
        //var markerarray = {fillColor: seriesColor[i]};
        component.categoriesIndex.push('0' + ':' + i);
        if (measureColorPair && measureColorPair[component.dataRes.dimensions[0].members[i].key] !== undefined) {
          seriesColor[i] = measureColorPair[component.dataRes.dimensions[0].members[i].key].color;
        }

        component.measureInOriginalSeries[component.dataRes.dimensions[0].members[i].key] = categoryDataRowAggr.length;
        categoryDataRowAggr.push({
          name: self.formatSeriesName(component, component.dataRes.dimensions[0].members[i].text, 0 + ':' + i, {}) ,
          type: seriesType[i],
          uniquekey: component.dataRes.dimensions[0].members[i].key,
          keyvalue: component.dataRes.dimensions[0].members[i].key,
          key: '0' + ':' + i,
          color: self.getSeriesColors(component, seriesColor, categoryDataRowAggr.length, defaultColor),
          id: +'' + i + '',
          data: [{y: component.dataRes.data[i]}]
        });
        defaultValue.xAxis.categories = [' '];
        defaultValue.xAxis.key = [' '];
        component.categoryInOriginalSeries['dimension'] = 0;
      }
    } else {
      var seriesName = [];
      var seriesKey = [];
      var seriesData = [];
      for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {
        seriesName.push(self.formatSeriesName(component, component.dataRes.dimensions[0].members[i].text, 0 + ':' + i, {}));
        seriesKey.push(component.dataRes.dimensions[0].members[i].key);
        component.measureInOriginalSeries[component.dataRes.dimensions[0].members[i].key] = seriesData.length;
        seriesData.push({y: component.dataRes.data[i]});
        component.categoriesIndex.push('0' + ':' + i);
      }

      defaultValue.xAxis.categories = seriesName;//alert("s");
      defaultValue.xAxis.categorieskey = seriesKey;
      defaultValue.xAxis.key = seriesKey;
      defaultValue.legend.enabled = false;
      categoryDataRowAggr.push({
        name: '',
        uniquekey: 'dimension',
        key: '0' + ':' + i,
        type: seriesType[i],
        color: self.getSeriesColors(component, seriesColor, categoryDataRowAggr.length, defaultColor),
        id: +'' + 0 + '',
        data: []
      });
      component.columnInOriginalSeries['dimension'] = 0;
      categoryDataRowAggr[0].data = seriesData;
    }

    if (ruleInfo !== '') {
      //try{
      that.createCFMeasureData(component, 'bar', component.fulljson());
      that.processConditionalFormatting(component, categoryDataRowAggr, ruleInfo, 'bar');  //}catch(e){}
    }

    if (component.seriesaverage()) {
      var averageData = [];
      var columnDataLength = categoryDataRowAggr.length;
      for (var i = 0; i < categoryDataRowAggr[0].data.length; i++) {
        var total = 0;
        for (var j = 0; j < categoryDataRowAggr.length; j++) {
          total += categoryDataRowAggr[j].data[i].y;
        }

        total /= categoryDataRowAggr.length;
        averageData.push(total);
      }

      if (measureColorPair && measureColorPair['Average'] !== undefined) {
        seriesColor[columnDataLength] = measureColorPair['Average'].color;
      }
      var averageDataJson={};
      if (seriesType[columnDataLength] !== undefined) {
          averageDataJson = {
          type: seriesType[columnDataLength],
          name: 'Average',
          data: averageData,
          marker: {
            lineWidth: 2,
            lineColor: seriesColor[columnDataLength],
            fillColor: 'white'
          },
          color: seriesColor[columnDataLength]
        };
      } else {
         averageDataJson = {
          type: seriesType[0],
          name: 'Average',
          data: averageData,
          marker: {
            lineWidth: 2,
            lineColor: seriesColor[columnDataLength],
            fillColor: 'white'
          },
          color: seriesColor[columnDataLength]
        };
      }

      categoryDataRowAggr.push(averageDataJson);
    }

    var pieData = [];
    for (var i = 0; i < component.dataRes.dimensions[0].members.length; i++) {
      pieData.push({
        name: component.dataRes.dimensions[0].members[i].text,
        y: component.dataRes.data[i],
        color: seriesColor[i]
      });
    }

    var pieDataJson = {
      type: 'pie',
      name: 'Total',
      data: pieData,
      center: [
        component.supercombinationPieChartOffsetx(),
        component.supercombinationPieChartOffsety()
      ],
      size: component.supercombinationPieChartSize(),
      showInLegend: false
    };
    categoryDataRowAggr.push(pieDataJson);
    defaultValue.series = categoryDataRowAggr;
    /*
    		 * Following code included for adding stacking feature. Loop thru the
    		 * series till second last and identify the chart type & stacking from
    		 * getter. If getter return undefined, assign default chart type and
    		 * stack index as 'column' and current series index respectively, else
    		 * cache the return value. Extract the chart type information and assign
    		 * it to current series. Check if the cahce value has any information
    		 * for stacking. If yes, check if that particular stacking already
    		 * exists in variable 'stacking'. If so, assign the same to stack index
    		 * else set the stacking incdex for the current type to current series
    		 * index and assign same to series stacking index. If the cache value do
    		 * not contain any stacking information set the stack index for series
    		 * to series index
    		 */
    var stacking = {
      column: undefined,
      area: undefined,
      areaspline: undefined
    };
    for (var i = 0, iLimit = defaultValue.series.length - 1; i < iLimit; ++i) {
      var tempType = seriesType[i];
      if (tempType === undefined || tempType === '') {
        defaultValue.series[i].stack = i;
        defaultValue.series[i].type = 'column';
      } else {
        var splitTempType = tempType.split('-');
        defaultValue.series[i].type = splitTempType[0];
        if (splitTempType.length > 1) {
          if (stacking[splitTempType[0]] === undefined) {
            stacking[splitTempType[0]] = i;
          }

          defaultValue.series[i].stack = stacking[splitTempType[0]];
        } else {
          defaultValue.series[i].stack = i;
        }
      }
    }
    /*
    		 * Set the stacking type in the plotOptions to make stacking work
    		 */
    for (var i in stacking) {
      if (stacking[i] !== undefined) {
        defaultValue.plotOptions.series.stacking = 'normal';
        break;
      }
    }
  };
  //if (validateImplementMethod(args, 'createCFMeasureData')) {
  that.createCFMeasureData = function(component, type, completeJSONCF) {
    component.measureInCFSeries = {};
    component.categoryInCFSeries = {};
    component.columnInCFSeries = {};
    var categoryDataRowAggr = [];
    var seriesData = [];
    var scalingFactor = 1;
    if (completeJSONCF.dimensions[0].axis == 'COLUMNS') {
      for (var i = 0; i < completeJSONCF.dimensions[0].members.length; i++) {
        scalingFactor = Math.pow(10, completeJSONCF.dimensions[0].members[i].scalingFactor || 0);
        component.measureInCFSeries[completeJSONCF.dimensions[0].members[i].key] = categoryDataRowAggr.length;
        categoryDataRowAggr.push({
          name: completeJSONCF.dimensions[0].members[i].text,
          uniquekey: completeJSONCF.dimensions[0].members[i].key,
          key: '0' + ':' + i,
          data: [completeJSONCF.data[i] * scalingFactor]
        });
        component.categoryInCFSeries['dimension'] = 0;
      }
    } else {
      for (var i = 0; i < completeJSONCF.dimensions[0].members.length; i++) {
        component.measureInCFSeries[completeJSONCF.dimensions[0].members[i].key] = seriesData.length;
        scalingFactor = Math.pow(10, completeJSONCF.dimensions[0].members[i].scalingFactor || 0);
        seriesData.push(completeJSONCF.data[i] * scalingFactor);
      }

      categoryDataRowAggr.push({
        name: '',
        uniquekey: 'dimension',
        key: '',
        data: []
      });
      component.columnInCFSeries['dimension'] = 0;
      categoryDataRowAggr[0].data = seriesData;
    }

    component.conditionalFormattingData = categoryDataRowAggr;
  };
  //}
  //if (validateImplementMethod(args, 'createCFData')) {
  /**
  		 * Create conditional formatting data
  		 * @param {object} component - Reference to component
  		 * @param {string} type - type of the chart
  		 * @param {object} Complete JSON data
  		 * @return {Array} Conditional Formatting Data
  		 */
  that.createCFData = function(component) {
    var completeJSONCF = component.dataRes;
    var self = this;
    //console.log("in cfdata");
    var seriesColor = component.dataseriescolor().split(',');
    component.categoriesIndex = [];
    var noOfColumns = 0;
    // if(!(component.measurecolorpair()=== undefined || component.measurecolorpair() === '')){
    // 	measureColorPair = JSON.parse(component.measurecolorpair());
    // }
    //alert("Component.dataRes==="+ JSON.stringify(component.dataRes));
    if (completeJSONCF === undefined || completeJSONCF === '') {
      return '';
    }

    for (var i = 0; i < completeJSONCF.dimensions.length; i++) {
      if (completeJSONCF.dimensions[i].axis == 'COLUMNS') {
        noOfColumns++;
      }
    }

    var selectedColumndimIndexes = [];
    var selectedRowdimIndexes = [];
    var measureDimensionIndex = component.getMeasureIndex();
    var measureInRow = component.dataRes.dimensions[measureDimensionIndex].axis == 'ROWS' ? true : false;
    if (measureInRow) {
      selectedRowdimIndexes.push(measureDimensionIndex);
    } else {
      selectedColumndimIndexes.push(measureDimensionIndex);
    }

    var bardatacustomizationJson = {
      'COLUMNS': [],
      'ROWS': []
    };
    if (component.bardatacustomization() !== '') {
      bardatacustomizationJson = jQuery.parseJSON(component.bardatacustomization());
    }

    // if (component.datautility() === true && (bardatacustomizationJson['COLUMNS'].length !== 0 || bardatacustomizationJson['ROWS'].length !== 0)) {
    //   for (var i = 0; i < noOfColumns; i++) {
    //     if (completeJSONCF.dimensions[i].containsMeasures === true) {
    //       selectedColumndimIndexes.push(i);
    //       break;
    //     }
    //   }

    //   if (bardatacustomizationJson['COLUMNS'].length !== 0) {
    //     //selectedColumndim=bardatacustomizationJson['COLUMNS'][0].text;
    //     //selectedColumndimIndexes=selectedColumndimIndexes.concat(bardatacustomizationJson['COLUMNS'][0].index.split("-"));
    //     $.each(bardatacustomizationJson['COLUMNS'], function(index, value) {
    //       selectedColumndimIndexes.push(_.parseInt(value.index));
    //     });
    //   }

    //   if (bardatacustomizationJson['ROWS'].length !== 0) {
    //     $.each(bardatacustomizationJson['ROWS'], function(index, value) {
    //       selectedRowdimIndexes.push(_.parseInt(value.index));
    //     });
    //   } else {
    //     this.createSmokeScreen(component.$(), 'Please select Dimension in Data Utility');
    //   }
    // } else if (component.datautility() === true && (bardatacustomizationJson['COLUMNS'].length === 0 && bardatacustomizationJson['ROWS'].length === 0)) {
    //   this.createSmokeScreen(component.$(), 'Please select Dimension in Data Utility');
    // } else {
      for (var i = 0; i < noOfColumns; i++) {
        if (i != measureDimensionIndex) {
          selectedColumndimIndexes.push(i);
        }
      }

      for (var i = noOfColumns; i < component.dataRes.dimensions.length; i++) {
        if (i != measureDimensionIndex) {
          selectedRowdimIndexes.push(i);
        }
      }
   // }

    var scalingValues = [];
    for (var i = 0; i < completeJSONCF.dimensions[measureDimensionIndex].members.length; i++) {
      scalingValues.push(Math.pow(10, completeJSONCF.dimensions[measureDimensionIndex].members[i].scalingFactor || 0));
    }
    // **************** Please don't delete the code below. new code begins : Amit *********************/
    var defaultColor = [
      '#B586DA',
      '#FF6657',
      '#F3A730',
      '#946B66',
      '#B0AD53',
      '#7AC1DE',
      '#F1C337',
      '#566C6C',
      '#A1CC54',
      '#543F1E'
    ];
    var seriesColor = [];
    if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
      seriesColor = [];
    } else {
      seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
    }

    var tuplesInaRow = completeJSONCF.tuples.slice(0, completeJSONCF.columnCount);
    // Getting tuples for all Columns in first row of crosstab.
    var colRowIndexJson = {};
    var colNamesJson = {};
    var seriesData = [];
    component.measureInCFSeries = {};
    component.columnInCFSeries = {};
	var hasResultIntupleCol = {};
	var datautility = false;

    for (var i = 0; i < tuplesInaRow.length; i++) {
      var tempTuple = tuplesInaRow[i].slice(0, noOfColumns);
      if (self.vbiCharts.eliminateResult(completeJSONCF, tempTuple,undefined,true) === true) {
        var colKey = [];
        var colName = [];
        var ColumnKey = [];
        for (var j = 0; j < selectedColumndimIndexes.length; j++) {
          var tempCol = selectedColumndimIndexes[j];
          colName.push(completeJSONCF.dimensions[tempCol].members[tempTuple[tempCol]].text);
          ColumnKey.push(completeJSONCF.dimensions[tempCol].members[tempTuple[tempCol]].key);
          colKey.push(tempCol + ':' + tempTuple[tempCol]);
        }

        var newKey = colKey.join('-');
        if (typeof colRowIndexJson[newKey] == 'undefined') {
          colRowIndexJson[newKey] = [];
          if (!measureInRow) {
            if (component.measureInCFSeries[ColumnKey[0]] === undefined) {
              component.measureInCFSeries[ColumnKey[0]] = selectedColumndimIndexes.length > 1 ? {} : seriesData.length;
            }

            if (typeof component.measureInCFSeries[ColumnKey[0]] == 'object') {
              component.measureInCFSeries[ColumnKey[0]][ColumnKey.slice(1).join('-')] = seriesData.length;
            }
          } else {
            component.columnInCFSeries[ColumnKey.join('-')] = seriesData.length;
          }

          seriesData.push({
            name: colName.join('-'),
            uniquekey: ColumnKey[0],
            key: newKey,
            color: self.getSeriesColors(component, seriesColor, seriesData.length, defaultColor),
            data: [],
            regression: component.trendlineenable !== undefined ? component.trendlineenable() : false,
            regressionSettings: {}
          });
        }

        colRowIndexJson[newKey].push(i);
		/*#VBX141-4729*/
		
        colNamesJson[newKey] = colName.join('-');
      }
    }

    seriesColor.splice(seriesData.length, seriesColor.length);
    component.dataseriescolor(seriesColor.join());
    var tupleToSkip = 0;
    var tuplesInColumn = [];
    var rowNames = {};
    var rowDataJson = {};
	var rowDataJsonWithInfo = {};
    //alert("that.dataRes.rowCount="+that.dataRes.rowCount);
    for (var i = 0; i < completeJSONCF.rowCount; i++) {
      //rowDataArr.push([]);
      tupleToSkip = completeJSONCF.columnCount * i;
      tuplesInColumn.push(completeJSONCF.tuples[tupleToSkip]);
      var tempTuple = tuplesInColumn[i];
		/*#VBX141-4729*/
		var hasResultIntuple = [];
	
      if (self.vbiCharts.eliminateResult(completeJSONCF, tempTuple, 'ROWS',true) === true) {
        var rowKey = 0;
        var rowHeader = 'Dimensions';
        var rowHeaderKey = 'Dimensions';
        if (selectedRowdimIndexes.length >= 1) {
          rowKey = selectedRowdimIndexes[0] + ':' + tempTuple[selectedRowdimIndexes[0]];
          rowHeader = completeJSONCF.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].text;
          rowHeaderKey = completeJSONCF.dimensions[selectedRowdimIndexes[0]].members[tempTuple[selectedRowdimIndexes[0]]].key;
          for (var j = 1; j < selectedRowdimIndexes.length; j++) {
            rowKey += '-' + selectedRowdimIndexes[j] + ':' + tempTuple[selectedRowdimIndexes[j]];
            // jscs:disable
            rowHeader += '\\' + completeJSONCF.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].text;
            rowHeaderKey += '\\' + completeJSONCF.dimensions[selectedRowdimIndexes[j]].members[tempTuple[selectedRowdimIndexes[j]]].key;  // jscs:enable
          }
        }

        if (typeof rowNames[rowKey] == 'undefined') {
          //rowDataJson[rowKey]=[];
          rowNames[rowKey] = {
            key: rowHeaderKey,
            text: rowHeader
          };
          //defaultValuexAxiscategories.push(rowHeader);
          component.categoriesIndex.push(rowKey);
        }

        var curScalingValue = 1;
        $.each(colRowIndexJson, function(key, value) {
          $.each(value, function(index, newval) {
            var curIndex = newval + tupleToSkip;
            var keygen = key + '_' + rowKey;
            if (measureDimensionIndex !== -1) {
              curScalingValue = scalingValues[completeJSONCF.tuples[curIndex][measureDimensionIndex]] || 1;
            }

            if (rowDataJson[keygen] === undefined) {
              rowDataJson[keygen] = [];
			  rowDataJsonWithInfo[keygen] = [];
            }

            rowDataJson[keygen].push(completeJSONCF.data[curIndex] * curScalingValue );//VBX141-4827
			/*#VBX141-4729*/
				if(datautility && true && (hasResultIntuple.length || hasResultIntupleCol[newval].length)){	
					var lastTempStore, lastTempstoreLen = 0;
					var totalLen = hasResultIntupleCol[newval].length + hasResultIntuple.length;
					if(rowDataJsonWithInfo[keygen].length){
						lastTempStore = rowDataJsonWithInfo[keygen][rowDataJsonWithInfo[keygen].length - 1];
						lastTempstoreLen = lastTempStore[0];
					}
					if(lastTempstoreLen < totalLen){
						rowDataJsonWithInfo[keygen].length = 0;						
					}					
					rowDataJsonWithInfo[keygen].push([totalLen , (completeJSONCF.data[curIndex] === null ? 0 : completeJSONCF.data[curIndex] * curScalingValue)]);
				}
          });
        });
      }
    }
	
	/*#VBX141-4729*/
	if(datautility && true){
		  $.each(rowDataJsonWithInfo, function(k, v){
			  if(v.length){
				  rowDataJson[k].length = 0;
					for(var i=0, len=v.length; i<len; i++){
						rowDataJson[k].push(Number(v[i][1]));
					}
			  }
		  });
	  }

    var categoryDataRowAggr = [];
    var finalCategoryNames = [];
    var finalCategorykeys = [];
    component.categoryInCFSeries = {};
    $.each(rowNames, function(key, names) {
      if (measureInRow) {
        // jscs:disable
        var rowKeyArr = names.key.split('\\');
        // jscs:enable
        for (var i = 0; i < rowKeyArr.length; i++) {
          if (component.measureInCFSeries[rowKeyArr[0]] === undefined) {
            component.measureInCFSeries[rowKeyArr[0]] = rowKeyArr.length > 1 ? {} : finalCategoryNames.length;
          }

          if (typeof component.measureInCFSeries[rowKeyArr[0]] == 'object') {
            // jscs:disable
            component.measureInCFSeries[rowKeyArr[0]][rowKeyArr.slice(1).join('\\')] = finalCategoryNames.length;  // jscs:enable
          }
        }
      }

      component.categoryInCFSeries[names.key] = finalCategoryNames.length;
      finalCategoryNames.push(names.text);
      finalCategorykeys.push(names.key);
      for (var i = 0; i < seriesData.length; i++) {
        var genKey = seriesData[i].key + '_' + key;
        var yVal = that.barValueAggregation(component, rowDataJson[genKey]);
        seriesData[i].data.push(yVal);
      }
    });

    categoryDataRowAggr = seriesData;
    component.conditionalFormattingData = categoryDataRowAggr;
    // code for changing the measure name when measure name is changed by the user
    that.fullseriesData = component.conditionalFormattingData;  //Adding error bar functionality for measure here
  };

  this.defaultvalueseries = function() {
    return that.defaultvalueseriesdata;
  };

  this.createErrorbar = function() {
    return that.fullseriesData;
  };  //}
}
