function waterfallSeries() {//jshint ignore:line
  var that = this;
  /**
  	 * Map data from JSON Tuple to Highchart
  	 * @override
  	 * @param {object} component - Reference to component
  	 * @param {string} type - type of the chart
  	 * @param {object} defaultValue - HighCharts values
  	 * @return {Array} seriesNames
  	 */
  that.createSeriesDataWaterfall = function(component, type, defaultValue, cfStatus) {
    // alert('overriden');
    var self = this;
    var defaultColor = [
      '#B586DA',
      '#FF6657',
      '#F3A730',
      '#946B66',
      '#B0AD53',
      '#7AC1DE',
      '#F1C337',
      '#566C6C',
      '#A1CC54',
      '#543F1E'
    ];
    var seriesColor = [];

    if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
      seriesColor = defaultColor;
    } else {
      seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
    }
    component.categoriesIndex = [];
    //var columnCount = 0;
    var mesDimListIndex = [];
    //var displayunit = '';
    //var ruleapplied = 0;
    component.measureInOriginalSeries = {};
    component.categoryInOriginalSeries = {};
    component.columnInOriginalSeries = {};
    component.selectedRowdimIndexes = [];
    component.selectedColumndimIndexes = [];
    component.intermediatesumtext = '';
    var ruleInfo = '';
    if (cfStatus != 'ncf') {
      if (component.ruletable() !== undefined && component.ruletable() !== '' && component.ruletable() != '{}') {
        that.updateRuleInfo(component, 'pie');
        //alert("ruletable="+component.ruletable());
        ruleInfo = JSON.parse(component.ruletable());
      }
    }

    var count = 0;
    // <START 1.0> Added Following code to remove overall result in
    // chart
    var dimensionsInJSON = component.dataRes.dimensions;
    //var tupleMatrixInJSON = component.dataRes.tuples;
    var resultIndex = [];
    /*
    		 * Get the Result Member of all dimension and update the resultIndex
    		 * Array with the index position of the result in the order
    		 * Dimensions appear in the JSON
    		 */
    //var mesDimNameList = [];
    var measureColorPair;
    //var conditionalformattingapplied = [];
    var measureDimIndex = -1;
    for (var i = 0; i < component.dataRes.dimensions.length; i++) {
      if (component.dataRes.dimensions[i].containsMeasures === true) {
        measureDimIndex = i;
        break;
      }
    }

    for (var i = 0, iLimit = dimensionsInJSON.length; i < iLimit; ++i) {

      if (resultIndex[i] === undefined) {
        resultIndex.push(-1);
      }
    }

    ///// NEW Implementation
    var sortedArray = [];
    defaultValue.xAxis.categories = [];
    var dimMesIndexJson = that.getDimMesJson(component, self);
    //var measureKey = component.dataRes.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].key;
    component.measureInOriginalSeries[component.dataRes.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].key] = 0;
    //if (bardatacustomizationJson['COLUMNS'].length >= 0 || bardatacustomizationJson['ROWS'].length >= 0) {
    if (dimMesIndexJson.dimIndexArray.length > 0) {
      var dataArray = [];
      var xAxisCategoriesList = [];
      var mesDimListIndex = [];
      var categoriesArray = [];
      var categoriesKeyArray = [];
      var aggregationCountArray = [];
      component.tempAggregationArray = [];
      var execute = true;
      var x;
      var checkArray = [];
      var count = -1;
      var pieName = '';
      for (var i = 0; i < component.dataRes.data.length; i++) {
        var y = '';
        var categories = [];
        var categoriesKey = [];
        var categoriesPicker = [];
        var tempKey = '';
        mesDimListIndex[i] = '';
        var execute = true;
        if (component.dataRes.tuples[i][measureDimIndex] == dimMesIndexJson.mesIndex) {
          for (var j = 0; j < dimMesIndexJson.dimIndexArray.length; j++) {
            pieName = component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]].text;
            y = y + '' + component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]];
            tempKey = tempKey + '-' + dimMesIndexJson.dimIndexArray[j] + ':' + component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]];
            if(component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]].members[component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]]].text){
              categories.push(component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]].members[component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]]].text);
            }
            categoriesKey.push(component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]].members[component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]]].key);
            categoriesPicker.push(component.dataRes.dimensions[dimMesIndexJson.dimIndexArray[j]].members[component.dataRes.tuples[i][dimMesIndexJson.dimIndexArray[j]]]["picker_text"]);

          }


          tempKey = tempKey.substr(1);
          if (execute) {
            if (checkArray.indexOf(y) == -1) {
              count++;
              aggregationCountArray[count] = 0;
              this.valueAggregation(component, component.dataRes.data[i], dataArray[checkArray.indexOf(y)], aggregationCountArray, count);
              //
              categoriesArray[count] = categories.join('\\');
              categoriesKeyArray[count] = categoriesKey.join('\\');
              var  categoriesPickertText = categoriesPicker.join('\\');
              if (component.intermediatesum() == categoriesPickertText || component.intermediatesum() == categoriesKeyArray[count]){
                component.intermediatesumtext = categoriesArray[count];
              }
              //	component.categoryInOriginalSeries[categoriesKeyArray[count]] = count;
              mesDimListIndex[count] = tempKey;
              x = y;
              checkArray.push(y);
              dataArray[count] = component.dataRes.data[i];
            } else {
              //	alert(this.valueAggregation(component,component.dataRes.data[i],dataArray[checkArray.indexOf(y)],aggregationCountArray[checkArray.indexOf(y)]));
              aggregationCountArray[checkArray.indexOf(y)]++;
              dataArray[checkArray.indexOf(y)] = this.valueAggregation(component, component.dataRes.data[i], dataArray[checkArray.indexOf(y)], aggregationCountArray, checkArray.indexOf(y));
            }
          }
        }
      }
      var isMeasureAllZero =true;
      for (var i = 0; i < dataArray.length; i++) {
        if(dataArray[i] !== null){
          isMeasureAllZero = false;
        }
      }
      if(isMeasureAllZero){
        return 1; // create smoke screen showing invalid data
      }

      for (var i = 0; i < dataArray.length; i++) {
        sortedArray.push({
          name: categoriesArray[i],
          keyName: categoriesKeyArray[i],
          color: seriesColor[i],
          data: dataArray[i],
          key: mesDimListIndex[i]
        });

      }
      if(!component.enableexpandcollapse()){
      sortedArray=that.sorting(sortedArray,component);
      }

      sortedArray.forEach(function(item){
        component.categoriesIndex.push(item.key);
        xAxisCategoriesList.push(item.name);
      });


      if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
        measureColorPair = JSON.parse(component.measurecolorpair());
      }

 

      var seriesData = [];
      seriesData = [{}];
      seriesData[0].data = [];
      seriesData[0].name = component.dataRes.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].text;
      seriesData[0].uniquekey = component.dataRes.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].key;
      seriesData[0].scalingFactor = component.dataRes.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].scalingFactor;
      seriesData[0].unitOfMeasure = component.dataRes.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].unitOfMeasure;
      seriesData[0].index = dimMesIndexJson.mesIndex;
      for (var i = 0; i < sortedArray.length; i++) {
        if (measureColorPair && measureColorPair[sortedArray[i].keyName] !== undefined) {
          sortedArray[i].color = measureColorPair[sortedArray[i].keyName].color;
        }

  
          seriesData[0].data.push({
          name: sortedArray[i].name,
          y: sortedArray[i].data,
          color: sortedArray[i].color,
          description:sortedArray[i].keyName//included to support sorting based on key-kavitha
          });
 


        component.categoryInOriginalSeries[sortedArray[i].keyName] = i;
      }

      //var cfdataCalled = !1;
      component.selectedRowdimIndexes = dimMesIndexJson.dimIndexArray;
      component.selectedColumndimIndexes[0] = measureDimIndex;
      //Conditional formatting
      //***************New Implementation Conditional Formatting*************
      if (ruleInfo !== '') {
        try {
          that.createCFData(component, 'pie', component.fulljson());
          that.processConditionalFormatting(component, seriesData, ruleInfo, 'pie');
        } catch (e) {
          if (window.console) {
            console.log(e); // jshint ignore:line
          }
        }
      }

      var localtotalpie = [];
      if (component.showtotal() === true) {
        for (var k = 0; k < seriesData[0].data.length; k++) {
          localtotalpie.push(seriesData[0].data[k].y);
        }

        var total = localtotalpie.reduce(function(a, b) {
          return a + b;
        });

        if (measureColorPair && measureColorPair['Total Result'] !== undefined) {
          seriesColor[seriesData[0].data.length] = measureColorPair['Total Result'].color;
        }

        seriesData[0].data.push({
          name: 'TotalResult',
          y: total,
          color: seriesColor[seriesData[0].data.length]
        });
      }
      component.columnInOriginalSeries = component.measureInOriginalSeries;



  try {
      if(component.activatehierarchylabeling() === true){
                    var xAxisDefaultCategories = [];
                    var processedCategories ;// jshint ignore:line
          xAxisDefaultCategories = xAxisDefaultCategories.concat(defaultValue.xAxis.categories);
        //VBX141-7717 fix
          if(component.selectedRowdimIndexes.length < 1 || (component.selectedRowdimIndexes.length == 1 && !component.dataRes.dimensions[component.selectedRowdimIndexes[0]].hasOwnProperty("hierarchy"))){
         processedCategories = this.createHierarchyLabelsStacked(component, component.selectedRowdimIndexes, categoriesArray);
          
          }
          else{
         processedCategories = this.createHierarchyLabelsStacked(component, component.selectedRowdimIndexes, xAxisDefaultCategories);
          
          }
          defaultValue.xAxis.categories = processedCategories.withHier;

          /* Following code is required to manipulate the series according to the order of xAxis categories.
                       This case will occur when the row Dimension selected in Data Utility is not in the same order as in Initial View.
                    */
          var selRowInd = [];
          selRowInd = selRowInd.concat(component.selectedRowdimIndexes);
          selRowInd.sort(function(a, b) {
            return a - b;
          });

          if (selRowInd.join(',') != component.selectedRowdimIndexes.join(',')) {
            var newCategoriesOrder = [];
            $.each(processedCategories.withoutHier, function(i, v) {
              self.createFlatCategoryLabelsStacked(v, newCategoriesOrder, [v.key]);
            });

            //console.log(JSON.stringify(newCategoriesOrder));

           /* var newcategoryDataRowAggr = [];
            $.extend(true, newcategoryDataRowAggr, categoryDataRowAggr);
            $.each(newCategoriesOrder, function(i, v) {
              var k = finalCategoryNamesKeys.indexOf(v);
              $.each(newcategoryDataRowAggr, function(ind, ele) {
                var val = ele.data[k];
                categoryDataRowAggr[ind].data[i] = val;
              });
            });*/
          }
      
      }
       } catch (e) {
            console.log(e); // jshint ignore:line
      }
     
      var intermediatesumLabel = 'Intermediate Sum';
      var finalbalanceLabel = 'Final Balance';

      /*Disabling Intermediate Sum when hierarchical labelling is enabled.
      As intermediate sum will lead to misinterpreation in the chart when hierarchical labelling is enabled
      But the same is not true for Final Balance*/
      var originalCategoriesLength =xAxisCategoriesList.length;

      var mesColor;
      if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
        mesColor = JSON.parse(component.measurecolorpair());
      }

      if(!component.activatehierarchylabeling()){
          if (component.intermediatesumchange() !== '' && component.intermediatesumchange() != ' ' && component.intermediatesumchange() !== undefined && component.intermediatesumchange() !== null) {
            intermediatesumLabel = component.intermediatesumchange();
          }
          if (component.intermediatesum() != 'none' && component.intermediatesum() !== undefined && component.intermediatesum() !== '' && component.intermediatesum() !== null && !component.enablecustominterimsum()) {
            if (xAxisCategoriesList.indexOf(component.intermediatesumtext) != -1) {
              var intermediateSumIndex = xAxisCategoriesList.indexOf(component.intermediatesumtext) + 1;
              var interColor;
              xAxisCategoriesList.splice(intermediateSumIndex, 0, intermediatesumLabel);
              component.categoriesIndex.splice(intermediateSumIndex, 0, "");
              if (mesColor && mesColor['Intermediate Sum'] !== undefined) {
                interColor=mesColor['Intermediate Sum'].color;
              }
              else{
                interColor=seriesColor[originalCategoriesLength];
              }
              seriesData[0].data.splice(intermediateSumIndex, 0, {
                name: intermediatesumLabel,
                isSum: true,
                color: interColor
              });  //   final_result.splice(intermediateSumIndex,0,{name:intermediatesumLabel,isIntermediateSum: true,color:self.getSeriesColors(component, seriesColor, final_result.length, DefaultColor)});
            }
          }
      }

      if (component.finalbalancechange() !== '' && component.finalbalancechange() != ' ' && component.finalbalancechange() !== undefined && component.finalbalancechange() !== null) {
        finalbalanceLabel = component.finalbalancechange();
      }

      if (component.waterfallfinalbalance() && component.waterfallfinalbalance() !== undefined && component.waterfallfinalbalance() !== '' && component.waterfallfinalbalance() !== null && !component.enablecustominterimsum())  {
        xAxisCategoriesList.push(finalbalanceLabel);
        var finalColor;
        if (mesColor && mesColor['Final Balance'] !== undefined) {
            finalColor=mesColor['Final Balance'].color;
        }
        else{
            finalColor=seriesColor[originalCategoriesLength+1];
        }
        seriesData[0].data.push({
          name: finalbalanceLabel,
          isSum: true,
          color:finalColor
        });
        //VBX141-8208
        if(component.activatehierarchylabeling()){
          defaultValue.xAxis.categories.push(finalbalanceLabel);
        }
      }


        if(!component.activatehierarchylabeling() && !component.enableexpandcollapse()){
           defaultValue.xAxis.categories = xAxisCategoriesList;
        }
        
         
      defaultValue.series = seriesData;
    }
  };

  that.sorting =function(options,component){

      if(component.enablecustomsort()){
        var seriesArray;
        if(component.waterfallcustomsort()){
           seriesArray=JSON.parse(component.waterfallcustomsort());
            var sortedArray=[];
            _.each(seriesArray, function (item) {
            sortedArray.push(_.findWhere(options, {name:item.name}));
            });

            return sortedArray;
        }
        else{
          return options;
        }
           
      }
      else{
           switch(component.waterfallsort()){

            case "Initial View":
            break;

            case "Dimensiontext-Ascending":
            options =_.sortBy(options, 'name');
            break;

            case "Dimensiontext-Descending":
                options.sort( function (a,b) {
                if (a.name.toUpperCase()  > b.name.toUpperCase()){
                return -1;
                 }
                 if (a.name.toUpperCase() < b.name.toUpperCase()){
                 return 1;
                 }
                return 0;
                 });
            break;

            case "Dimensionkey-Ascending":
            options =_.sortBy(options, 'keyName');
            break;

            case "Dimensionkey-Descending":
               options.sort( function (a,b) {
                if (a.keyName.toUpperCase()  > b.keyName.toUpperCase()){
                return -1;
                 }
                 if (a.keyName.toUpperCase() < b.keyName.toUpperCase()){
                 return 1;
                 }
                return 0;
                 });
            break;

          }
        }
        return options;
  };

  that.insertSubTotalInCategory = function(cat){
      var that = this;
      if(cat.categories){
          cat.categories.unshift(cat.name);
          $.each(cat.categories, function(i, val){
              that.insertSubTotalInCategory(val);
          });
      }
  };


  that.getDimMesJson = function(component) {
    var dimMesJson = {};
    var memIndexArray = [];
    var measureIndex;
    if (component.measurelist() === '' || component.measurelist() === undefined || component.measurelist() === null) {
      var measureIndex = 0;
    } else {
      var measureMembersArr = component.getMeasureMembersKeyAndText();
       measureIndex = measureMembersArr[1].indexOf(component.measurelist());
      if (measureIndex == -1) {
        measureIndex = component.measurelist();
      }
    }
      //measureIndex = 0;
      var rowIndex = component.dataRes["axis_columns"][0].indexOf(-1);
      if (rowIndex !== -1) {
        for (var i = rowIndex; i < component.dataRes.dimensions.length; i++) {
          if (!component.dataRes.dimensions[i].containsMeasures) {
            memIndexArray.push(i);
          }
        }
      } else {
        rowIndex = component.dataRes.dimensions.length;
      }

      if (memIndexArray.length === 0) {
        for (var i = 0; i < rowIndex; i++) {
          if (!component.dataRes.dimensions[i].containsMeasures) {
            memIndexArray.push(i);
          }
        }
      }

      dimMesJson = {
        'mesIndex': measureIndex,
        'dimIndexArray': memIndexArray,
        'dimensionAxis': 'rows'
      };
    

    return dimMesJson;
  };
  /**
  	 * Apply google font to all parts of the chart
  	 * @param {object} component - Reference to component
  	 * @param {object} defaultValue - HighCharts values
  	 * @param {object} fonttest - Font Name
  	 * @return {object} defaultValue
  	 */
  that.globalgooglefont = function globalgooglefont(component, defaultValue, fonttest) {
    /*added below code to check whether the call is from "ChartContainer" if so then skip x and y axis styling
        		as chartcontainer only support styling of title,subtitle,legend,tooltip,credits */
    var container = false;
    if (component[0].id.indexOf('CHARTCONTAINER') != -1) {
      container = true;
    }

    defaultValue.title.style.fontFamily = fonttest;
    defaultValue.subtitle.style.fontFamily = fonttest;
    try {
      if (container === false) {
        defaultValue.xAxis.labels.style.fontFamily = fonttest;
        defaultValue.xAxis.title.style.fontFamily = fonttest;
        defaultValue.xAxis.plotLines[0].label.style.fontFamily = fonttest;
        defaultValue.xAxis.plotBands[0].label.style.fontFamily = fonttest;
        defaultValue.yAxis.labels.style.fontFamily = fonttest;
        defaultValue.yAxis.title.style.fontFamily = fonttest;
        defaultValue.yAxis.plotLines[0].label.style.fontFamily = fonttest;
        defaultValue.yAxis.plotBands[0].label.style.fontFamily = fonttest;
      }
      if(container === true){
        if(defaultValue.xAxis){
              defaultValue.xAxis.labels.style={};
              defaultValue.xAxis.labels.style.fontFamily = fonttest;
           
         }
        if(defaultValue.yAxis){
          defaultValue.yAxis.labels={};
          defaultValue.yAxis.labels.style={};
          defaultValue.yAxis.title={};
          defaultValue.yAxis.title.style={};
          defaultValue.yAxis.labels.style.fontFamily = fonttest;
          defaultValue.yAxis.title.style.fontFamily = fonttest;
        }
      }  
      defaultValue.tooltip.style.fontFamily = fonttest;
      defaultValue.credits.style.fontFamily = fonttest;
    } catch (e) {
    }
    //defaultValue.plotOptions.column.dataLabels.style.fontFamily =fonttest;
    return defaultValue;
  };

  that.createCFData = function(component) {
    var completeJSONCF = component.dataRes;
    var self = this;
    var measureDimIndex = component.getMeasureIndex();
/*    var measuresinRule = [
      0,
      1,
      2,
      3
    ];*/
    /*$.each(component.measuresInRules,function(k,v){
    				measuresinRule.push(v);
    			});*/
    if (completeJSONCF === undefined || completeJSONCF === '' || completeJSONCF === null) {
      return '';
    }

    var seriesColor = component.dataseriescolor().split(',');
    var defaultColor = [
      '#B586DA',
      '#FF6657',
      '#F3A730',
      '#946B66',
      '#B0AD53',
      '#7AC1DE',
      '#F1C337',
      '#566C6C',
      '#A1CC54',
      '#543F1E'
    ];
    if (component.dataseriescolor() === undefined || component.dataseriescolor() === null || component.dataseriescolor() === '') {
      seriesColor = defaultColor;
    }

    component.categoryInCFSeries = {};
    component.measureInCFSeries = {};
    ///// NEW Implementation
    var sortedArray = [];
    var CFseriesData = [];
    var dimMesIndexJson = that.getDimMesJson(component, self);
    //var measureKey = completeJSONCF.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].key;
    for (var z = 0; z < completeJSONCF.dimensions[measureDimIndex].members.length; z++) {
      component.measureInCFSeries[completeJSONCF.dimensions[measureDimIndex].members[z].key] = z;
    }
    //component.measureInCFSeries [completeJSONCF.dimensions[measureDimIndex].members[dimMesIndexJson.mesIndex].key] =  dimMesIndexJson.mesIndex;
    //if (bardatacustomizationJson['COLUMNS'].length >= 0 || bardatacustomizationJson['ROWS'].length >= 0) {
    if (dimMesIndexJson.dimIndexArray.length > 0) {
      var dataArray = [];
      var mesDimListIndex = [];
      var categoriesArray = [];
      var categoriesKeyArray = [];
      var aggregationCountArray = [];
      component.tempAggregationArray = [];
      var measureIndexArray = [];
      var execute = true;
      var x;
      var checkArray = [];
      var count = [];
      var scalingFactor = [];
      var pieName = '';
      var catName = [];
      var catKey = [];
      for (var i = 0; i < completeJSONCF.data.length; i++) {
        var y = '';
        var categories = [];
        var categoriesKey = [];
        var tempKey = '';
        mesDimListIndex[i] = '';
        var execute = true;
        var highlightedMesIndex = dimMesIndexJson.mesIndex;
        var currentTuple = completeJSONCF.tuples[i][measureDimIndex];
        if (measureIndexArray.indexOf(currentTuple) == -1) {
          measureIndexArray.push(currentTuple);
          categoriesArray[currentTuple] = [];
          categoriesKeyArray[currentTuple] = [];
          dataArray[currentTuple] = [];
          checkArray[currentTuple] = [];
          scalingFactor[currentTuple] = completeJSONCF.dimensions[measureDimIndex].members[currentTuple].scalingFactor;
          count[currentTuple] = -1;
        }

        for (var j = 0; j < dimMesIndexJson.dimIndexArray.length; j++) {
          pieName = completeJSONCF.dimensions[dimMesIndexJson.dimIndexArray[j]].text;
          y = y + '' + completeJSONCF.tuples[i][dimMesIndexJson.dimIndexArray[j]];
          tempKey = tempKey + '-' + dimMesIndexJson.dimIndexArray[j] + ':' + completeJSONCF.tuples[i][dimMesIndexJson.dimIndexArray[j]];
          if(completeJSONCF.dimensions[dimMesIndexJson.dimIndexArray[j]].members[completeJSONCF.tuples[i][dimMesIndexJson.dimIndexArray[j]]].text){
            categories.push(completeJSONCF.dimensions[dimMesIndexJson.dimIndexArray[j]].members[completeJSONCF.tuples[i][dimMesIndexJson.dimIndexArray[j]]].text);
          }
          categoriesKey.push(completeJSONCF.dimensions[dimMesIndexJson.dimIndexArray[j]].members[completeJSONCF.tuples[i][dimMesIndexJson.dimIndexArray[j]]].key);
        }

        tempKey = tempKey.substr(1);
        if (execute) {
          if (checkArray[currentTuple].indexOf(y) == -1) {
            count[currentTuple]++;
            aggregationCountArray[count[currentTuple]] = [];
            if (highlightedMesIndex == currentTuple) {
              aggregationCountArray[count[currentTuple]] = 0;
              this.valueAggregation(component, completeJSONCF.data[i] * Math.pow(10, scalingFactor[currentTuple]), dataArray[checkArray.indexOf(y)], aggregationCountArray, count[currentTuple]);  //
            }
            //	this.valueAggregation(component,completeJSONCF.data[i],dataArray[checkArray.indexOf(y)],aggregationCountArray[count])	;//
            categoriesArray[currentTuple] = categories.join('\\');
            categoriesKeyArray[currentTuple] = categoriesKey.join('\\');
            catKey[count[currentTuple]] = categoriesKeyArray[currentTuple];
            catName[count[currentTuple]] = categoriesArray[currentTuple];
            component.categoryInCFSeries[categoriesKeyArray[currentTuple]] = count[currentTuple];
            mesDimListIndex[count[currentTuple]] = tempKey;
            x = y;
            checkArray[currentTuple].push(y);
            dataArray[currentTuple][count[currentTuple]] = completeJSONCF.data[i] * Math.pow(10, scalingFactor[currentTuple]);  //	dataArray[currentTuple][count[currentTuple]] = completeJSONCF.data[i];
          } else {
            if (highlightedMesIndex == currentTuple) {
              //	alert(this.valueAggregation(component,completeJSONCF.data[i],dataArray[checkArray.indexOf(y)],aggregationCountArray[checkArray.indexOf(y)]));
              aggregationCountArray[checkArray[currentTuple].indexOf(y)]++;
              dataArray[currentTuple][checkArray[currentTuple].indexOf(y)] = this.valueAggregation(component, completeJSONCF.data[i] * Math.pow(10, scalingFactor[currentTuple]), dataArray[currentTuple][checkArray[currentTuple].indexOf(y)], aggregationCountArray, checkArray[currentTuple].indexOf(y));
            } else {
              dataArray[currentTuple][checkArray[currentTuple].indexOf(y)] = dataArray[currentTuple][checkArray[currentTuple].indexOf(y)] + completeJSONCF.data[i] * Math.pow(10, scalingFactor[currentTuple]);
            }
          }
        }
      }

      for (var j = 0; j < dataArray.length; j++) {
        sortedArray[j] = [];
        for (var i = 0; i < dataArray[j].length; i++) {
          if (seriesColor[i] === undefined) {
            seriesColor = seriesColor.concat(defaultColor);
          }

          sortedArray[j].push({
            name: catName[i],
            keyName: catKey[i],
            color: seriesColor[i],
            data: dataArray[j][i],
            key: mesDimListIndex[i]
          });
          component.categoriesIndex.push(mesDimListIndex[i]);
        }
      }
      var measureColorPair;
      if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
        measureColorPair = JSON.parse(component.measurecolorpair());
      }


      CFseriesData = [];
      for (var j = 0; j < sortedArray.length; j++) {
        CFseriesData.push({
          name: completeJSONCF.dimensions[measureDimIndex].members[j].key,
          data: []
        });
        for (var i = 0; i < sortedArray[j].length; i++) {
          CFseriesData[j].data = dataArray[j];  //component.categoryInCFSeries[sortedArray[j][i].keyName] = j;
        }
      }

          //var localtotalpie = [];
          /*if (component.showtotal() === true) {
      					for (var k = 0; k < CFseriesData[0].data.length; k++) {
      						localtotalpie.push(CFseriesData[0].data[k].y);
      					}
      					var total = localtotalpie.reduce(function(a, b) {
      						return a + b;
      					});
      					if (measureColorPair && (measureColorPair["Total Result"] !== undefined)) {
      						seriesColor[CFseriesData[0].data.length] = measureColorPair["Total Result"].color;
      					}
      					CFseriesData[0].data.push({
      						name : "TotalResult",
      						y : total
      					//	color : seriesColor[CFseriesData[0].data.length]
      					});

      				}*/
    }

    component.columnInCFSeries = component.measureInCFSeries;
    component.conditionalFormattingData = CFseriesData;
  };

  that.createMeasuresData = function(component, type, defaultValue, cfStatus) {
    //var self = this;
    var xAxisCategoriesList = [];
    component.categoriesIndex = [];
   // var columnCount = 0;
    //var displayunit = '';
    component.measureInOriginalSeries = {};
    component.categoryInOriginalSeries = {};
    component.columnInOriginalSeries = {};
   var defaultColor = [ '#B586DA', '#FF6657', '#F3A730', '#946B66', '#B0AD53', '#7AC1DE', '#F1C337', '#566C6C', '#A1CC54', '#543F1E' ]; //jshint ignore:line
    var seriesColor = [];
    if (component.dataseriescolor() === '' || component.dataseriescolor() === undefined) {
      seriesColor = defaultColor;
    } else {
      seriesColor = seriesColor.concat(component.dataseriescolor().split(','));
    }
    //var count = 0;
    var dimensionsName = [];
    var dimensionsKey = [];
    var dimensionData = [];
    var dimensionNameKeys = [];
    var seriesData = [{}];
    seriesData[0].data = [];
    var measureScaling = [];
    var ruleInfo = '';
    if (cfStatus != 'ncf') {
      if (component.ruletable() !== undefined && component.ruletable() !== '' && component.ruletable() != '{}') {
        that.updateRuleInfo(component, 'pie');
        ruleInfo = JSON.parse(component.ruletable());
      }
    }

    var measureColorPair;
    if (!(component.measurecolorpair() === undefined || component.measurecolorpair() === '')) {
      measureColorPair = JSON.parse(component.measurecolorpair());
    }

    var mesDimIndex = 0;
    for (var i = 0; i < component.dataRes.dimensions[mesDimIndex].members.length; i++) {
      dimensionsName[i] = component.dataRes.dimensions[mesDimIndex].members[i]["picker_text"];
      dimensionNameKeys[i] = component.dataRes.dimensions[mesDimIndex].members[i].key;
      dimensionData[i] = component.dataRes.data[i];
      if (measureColorPair && measureColorPair[dimensionsName[i]] !== undefined) {
        seriesColor[i] = measureColorPair[dimensionsName[i]].color;
      }

      xAxisCategoriesList.push(dimensionsName[i]);
      seriesData[0].data.push({
        keyName: dimensionNameKeys[i],
        name: dimensionsName[i],
        y: dimensionData[i],
        color: seriesColor[i]
      });
      component.measureInOriginalSeries[dimensionNameKeys[i]] = i;
      dimensionsKey[i] = '0' + ':' + i;
      measureScaling.push(Number(component.dataRes.dimensions[mesDimIndex].members[i].scalingFactor));
      component.categoriesIndex.push(dimensionsKey[i]);
    }

    component.categoryInOriginalSeries = component.measureInOriginalSeries;
    //var units = displayunit.split(',');
    component.columnInOriginalSeries['dimension'] = 0;
    var originalSeriesData = seriesData;
    if (ruleInfo !== '' && cfStatus != 'ncf') {
      that.createCFMeasureData(component, 'pie', component.fulljson());
      that.processConditionalFormatting(component, originalSeriesData, ruleInfo, 'pie');
    }

    defaultValue.xAxis.categories = xAxisCategoriesList;
    seriesData[0].scalingFactor = measureScaling[0];
    defaultValue.series = seriesData;
  };

  that.createCFMeasureData = function(component, type, completeJSONCF) {
    component.measureInCFSeries = {};
    component.categoryInCFSeries = {};
    component.columnInCFSeries = {};
    //var self = this;
    component.categoriesIndex = [];
    //var columnCount = 0;
    //var displayunit = '';
    //var seriesColor = component.dataseriescolor().split(',');
    //var count = 0;
    var dimensionsName = [];
    var dimensionsKey = [];
    var dimensionData = [];
    var dimensionKeyNames = [];
    var mesSeriesData = [{}];
    mesSeriesData[0].data = [];
    var measureScaling = [];
    var mesDimIndex = 0;
    for (var i = 0; i < completeJSONCF.dimensions[mesDimIndex].members.length; i++) {
      dimensionsName[i] = completeJSONCF.dimensions[mesDimIndex].members[i]["picker_text"];
      dimensionData[i] = completeJSONCF.data[i];
      dimensionKeyNames[i] = completeJSONCF.dimensions[mesDimIndex].members[i].key;
      component.categoryInCFSeries[dimensionKeyNames[i]] = i;
      dimensionsKey[i] = '0' + ':' + i;
      component.categoriesIndex.push(dimensionsKey[i]);
    }

    mesSeriesData[0].data = completeJSONCF.data;
    //var units = displayunit.split(',');
    component.measureInCFSeries = component.categoryInCFSeries;
    mesSeriesData[0].scalingFactor = measureScaling[0];
    component.columnInCFSeries['dimension'] = 0;
    component.conditionalFormattingData = mesSeriesData;
  };

}
